#ifndef LIBDWD_C_INCLUDED
#define LIBDWD_C_INCLUDED

#define MAX_FILES 100
#define MAX_FILENAME_LEN 256

EXTERN int fdes[MAX_FILES];
EXTERN char dateien[MAX_FILES][MAX_FILENAME_LEN];
EXTERN char dat_art[MAX_FILES];
#ifdef FFIO
EXTERN int dateizeiger[MAX_FILES];
#else
EXTERN FILE *dateizeiger[MAX_FILES];
#endif
EXTERN int prevrecl[MAX_FILES];
EXTERN int lastwrite[MAX_FILES];


/* Definition der Makros our_seek, our_read, our_write um im Code
   nicht so viele Fallunterscheidungen machen zu muessen */

#ifdef FFIO
#include <ffio.h>
#define our_seek(a,b,c) ffseek(a,b,c)
#define our_read(a,b,c) ffread(a,b,c)
#define our_write(a,b,c) ffwrite(a,b,c)
#define our_tell(a) ffseek(a,0,SEEK_CUR)
#else
#define our_seek(a,b,c) fseek(a,b,c)
#define our_read(a,b,c) fread(b,1,c,a)
#define our_write(a,b,c) fwrite(b,1,c,a)
#define our_tell(a) ftell(a)
#endif

#endif /* LIBDWD_C_INCLUDED */
