      SUBROUTINE BITCHA (IW, IBT, YP, IRM)
!**** BITCHA   -   UP:VARIABLE (AUSSER CHARACTER) BITWEISE INTERPRETIEREN
!**   AUFRUF:      CALL BITCHA (IW, IBT, YP, IRM)
!**   ZWECK:       INHALT EINES WORTES BITWEISE INTERPRETIEREN
!**   PARAMETER:   IW        ZU INTERPRETIERENDE VARIABLE
!**                IBT       ANZAHL BITS, DIE ALS EIN ZEICHEN AUFZU-
!**                          FASSEN SIND (1, 3, 4)
!**                          1 = BINAER,3 = OKTAL,  4 = HEXADEZIMAL
!**                YP        ERGEBNIS, TYP CHARACTER,
!**                          64-BIT-RECHNER: LAENGE MINDESTENS 64/IBT ;
!**                          32-BIT-RECHNER: LAENGE MINDESTENS 32/IBT ;
!**                          LINKSBUENDIG , BLANK FILLED
!**                          (BEI OKTALER DARSTELLUNG WIRD BEI EINEM 
!**                          64-BIT-RECHNERDAS LINKE BIT UND SONST DIE
!**                          LINKEN 2 BITS FUER SICH INTERPRETIERT)
!**                          FUER SICH INTERPRETIERT)
!**                IRM       FEHLER, WENN UNGL. 0
!**
!**   VERFASSER:   G. BAGINSKI        
!     MODIF.:      A.Zalewsky, TI12, 03/2000, nur noch #ifdef(CRAY),#else;
!                  neu: EXTERNAL SHIFT (nicht CRAY); 
!                       CRAY: X'..' in Z'..' geaendert
!                  B. Loeser, TI14, 10/01, SHIFT --> ISHFTC, AND --> IAND 
!                                          include "machconsts.h",
!                                          IMPLICIT NONE
!
      IMPLICIT NONE                  
#include "machconsts.h"
      INTEGER MAX, IBT, IRM, IBAS, IW, IALL, J2, IZW, MASK, IS, IM, IA, 
     &        IX, J1
      CHARACTER YP*(*), YPL*16, YCH*1
      DATA YPL /'0123456789ABCDEF'/
#if defined(CRAY)
      DATA IALL / Z'FFFFFFFFFFFFFFFF' /
#else
      DATA IALL / Z'FFFFFFFF' /
#endif 

      YP            = ' '
!.....IBMAX/IBT : bei oktaler Darstellung fuer 64-bit-Rechner, Rest = 1
!                                         fuer 32-bit-Rechner, Rest = 2
!                                         siehe unter Sonderfall
      MAX           = IBMAX / IBT 

      IF (IBT  .EQ. 3)                      MAX = MAX + 1

      IF ((IBT.LE.0) .OR. (IBT.GT.4) .OR. (LEN(YP).LT.MAX))   THEN
         IRM        = 1
         RETURN
      ELSE
         IRM        = 0
      ENDIF
      IBAS          = 2 ** IBT 

!.....ABFRAGE, OB ALLE BITS GESETZT
      IF (IW .EQ. IALL)                     THEN
         YCH        = YPL (IBAS:IBAS)

         DO 50 J2   = 1, MAX
   50    YP(J2:J2)  = YCH
#if defined(CRAY)
         IF (IBT .EQ. 3)                    YP(1:1) = '1'
#else
         IF (IBT .EQ. 3)                    YP(1:1) = '3'
#endif 
      ELSE

         IZW        = IW
         MASK       = IBAS - 1

!........SONDERFALL OKTAL
         IF (IBT  .EQ. 3)                   THEN
!...........IS FUER SHIFT, IM ALS MASKE FUER AND
#if defined(CRAY)
            IS      = 1
            IM      = 1
#else 
            IS      = 2
            IM      = 3
#endif 
            IA      = 2
            IZW     = ISHFTC(IZW,IS)
            IX      = IAND(IZW,IM)
            IX      = IX + 1
            YP(1:1) = YPL(IX:IX)
         ELSE
            IA      = 1
         ENDIF

         DO 100  J1 = IA, MAX
         IZW        = ISHFTC(IZW,IBT)
         IX         = IAND(IZW,MASK)
         IX         = IX + 1
         YP(J1:J1)  = YPL(IX:IX)
  100    CONTINUE

      ENDIF

      END
