      SUBROUTINE BITMAP (AR, NRGRP, UNDEF,
     +                   IBMZ, IBMAP, LBMAP, NRGB, IRM)

C**** BITMAP   -   UP:ERMITTELN DER BITMAP EINES FELDES
C**   AUFRUF   :   CALL BITMAP (AR, NRGRP, UNDEF,
C**                             IBMZ, IBMAP, LBMAP, NRGB, IRM)
C**   ZWECK    :   FUER DIE GITTERPUNKTE EINES FELDES PRUEFEN, OB SIE
C**                BESETZT SIND ODER NICHT UND DAS JEWEILIGE BIT
C**                IM BEREICH IBMAP SETZEN.
C**   PARAMETER:   INPUT:
C**                AR        GITTERPUNKT-FELD (FLOATING)
C**                NRGRP     ANZAHL DER GITTERPUNKTE(=LAENGE VON AR)
C**                UNDEF     WERT EINES UNBESETZTEN GITTERPUNKTES;
C**                          DEFAULT: -1E10
C**                IBMZ      VOM BENUTZER DIMENS. LAENGE VON IBMAP
C**                OUTPUT:
C**                IBMAP     ERMITTELTE BITMAP (BEN.-ARRAY)
C**                LBMAP     ERMITTELTE LAENGE VON IBMAP
C**                NRGB      ANZAHL BESETZTER PUNKTE
C**                IRM       FEHLERMELDUNG ( WENN UNGL. 0)
C**
C**   VERFASSER:   G. BAGINSKI
C**                LAST MODIF.: 24.02.94 (ARZ3ZAL)
C     MODIF.:                                     A.Zalewsky TI12 03/2000
C                  nur noch #ifdef(CRAY;TEST) #else-Zweig und universell;
C                  neu: EXTERNAL SHIFT (nicht CRAY);
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER NRGRP, IBMZ, IBMAP, LBMAP, NRGB, IRM
      INTEGER IBZ, NB, J1

      REAL    AR, UNDEF

#include "machconsts.h"

      DIMENSION    AR(*)     ,IBMAP(*)

C.....WERTE VORBESETZEN
      IBZ                    = 0
      IRM                    = 0
      LBMAP                  = 0
      NB                     = 0
      NRGB                   = 0

C.....ANZAHL GITTERPUNKTE PRUEFEN
      IF (NRGRP .LE. 0)                                     THEN
         IRM                 = 1
         PRINT 1100
 1100    FORMAT('0/// UP BITMAP, NRGRP FALSCH')
         RETURN
      ENDIF

C.....LAENGE DER BITMAP PRUEFEN
      IF ((IBMZ*IBMAX) .LT. NRGRP)                          THEN
         IRM                 = 1
         PRINT 1000,IBMZ,NRGRP
 1000    FORMAT('0///UP BITMAP, IBMAP ZU KURZ: IBMZ,NRGRP=',2I5)
         RETURN
      ENDIF

C.....BITMAP ERZEUGEN, FELD PUNKTWEISE UNTERSUCHEN
      DO 100              J1 = 1, NRGRP
      IBZ                    = ISHFT(IBZ,1)
      IF (AR(J1) .NE. UNDEF)                                THEN
C.....BIT IN DER BITMAP SETZEN
         IBZ                    = IOR(IBZ,1)
C.....ANZAHL BES. GITTERPUNKTE
         NRGB                   = NRGB + 1
      ENDIF
      NB                     = NB + 1
C.....VOLLES WORT AUSGEBEN
      IF (NB .EQ. IBMAX)                                    THEN
         LBMAP               = LBMAP + 1
         IBMAP(LBMAP)        = IBZ
         NB                  = 0
         IBZ                 = 0
      ENDIF
  100 CONTINUE

C.....BITMAP ABSCHLIESSEN (RESTWORT AUSGEBEN, LINKSBUENDIG SETZEN)
      IF (NB .NE. 0)                                        THEN
         LBMAP               = LBMAP + 1
         IBMAP(LBMAP)        = ISHFT(IBZ,(IBMAX-NB))
      ENDIF

      END
