      SUBROUTINE BITMEX (YPFAD, NRBMAP, IBMAP, LBMAP, NRGRP, NRGB, IRM)

C**** BITMEX   -   UP:BITMAP MIT KENNDATEN AUF DATEI AUSGEBEN
C**   AUFRUF   :   CALL BITMEX (YPFAD, NRBMAP, IBMAP, LBMAP, NRGRP,
C**                             NRGB, IRM)
C**   ZWECK    :   BITMAP AUF UNFORMATIERTE DATEI AUSGEBEN
C**                LOK.DATEINAME = bitmap,
C**                PERM.DATEINAME: bitmpXXX, WOBEI XXX=NRBMAP, Z.B. bitmp001)
C**   PARAMETER:   YPFAD     VOLLSTAENDIGER PFAD FUER BITMAP - OHNE FILENAME -
C**                          (WENN YPFAD=' ': CATALOG IN AKTUELLEN PFAD)
C**                          - MAX. 100 CHAR. -
C**                          CRAY  : /routfox/routarz/te23c/bank/daten/bitmap
C**                          RUS   : /rhome/routarz/te23c/bank/daten/bitmap
C**                          WS1   : /usr/people/routarz/te23c/bank/daten/bitmap
C**                NRBMAP    KATALOG-NR. DER BITMAP (INTEGER, max. 3 Ziffern)
C**                IBMAP     BEREICH FUER DIE BITMAP
C**                LBMAP     LAENGE DER BITMAP
C**                NRGRP     ANZAHL DER GITTERPUNKTE
C**                NRGB      ANZAHL BESETZTER GITTERPUNKTE
C**                IRM       FEHLER WENN UNGL. 0
C**   EXTERNALS:   AKDATE,AKTIME,BLEND,CLOSE,INCHAZ,LEN,OPEN,SYSTEM
C**
C**   VERFASSER:   G. BAGINSKI
C**                     MODIF. FUER MFC: 24.02.94 (ARZ3ZAL)
C**                     MODIF. FUER RUS: 25.07.97 (ARZ3ZAL)
C     MODIF.:      A.Zalewsky TI12 03/2000
C                  nur noch #ifdef(CRAY(ohne Inhalt);TEST) #else-Zweig
C                  R.Johanni, SGI, 10/2000:
C                  Veraltete Unterprogramme raus, schreiben direkt in Datei
C                  (ohne CALL SYSTEM('cp bitmap xxx') )

C     AUFBAU DER BITMAP-DATEI (UNFORMATTED):
C     WORT         INHALT
C     1            NR DER BITMAP       - NRBMAP -
C     2            LAENGE IN WORTEN    - LBMAP -
C     3            ANZAHL GITTERPUNKTE - NRGRP -
C     4            ANZAHL BES. GI.PKTE - NRGB -
C     5            DATUM (JAHR*10000+MONAT*100+TAG) - ITAG -
C     6            UHRZEIT (STD*10000+MIN*100+SEK)  - IUHR -
C     7            BITMAP              - IBMAP -

C     YPFZW = YPFAD//'/bitmp'//YNR
C     YID   = ?
C     YTEXT = ?

      IMPLICIT NONE

      INTEGER NRBMAP, IBMAP, LBMAP, NRGRP, NRGB, IRM
      INTEGER LPF, IUN, NXUNIT, JJ, MM, IT, IHH, MIN, ISEK, ITAG, IUHR
      INTEGER IOS, IW

      CHARACTER    YPFAD*(*), YNR*3, YTEXT*200, YID*2, YPFZW*89
      DIMENSION    IBMAP(*)
      INTEGER      IDATE(8)

C.....PFAD-LAENGE ABFRAGEN
      IF (LEN(YPFAD) .GT. 100)                             THEN
         PRINT 1600
 1600    FORMAT(' ///UP BITMEX, YPFAD ZU LANG (GT 100 CH.)')
      ENDIF

      IF ((NRBMAP.LE.0) .OR. (NRBMAP.GT.999))              THEN
         PRINT '('' ///UP BITMEX, FALSCHER WERT FUER NRBMAP:'',
     +                I4)',       NRBMAP
         IRM                 = 1
         RETURN
      ENDIF
      WRITE(YNR,'(I3.3)') NRBMAP

      IF (YPFAD .NE. ' ')                                  THEN
         LPF                 = LEN_TRIM(YPFAD)
         YPFZW               = YPFAD(1:LPF)//'/bitmp'//YNR
         LPF                 = LPF + 9
      ELSE
         YPFZW               = 'bitmp'//YNR
         LPF                 = 8
      ENDIF

      IUN                    = NXUNIT(0)
      OPEN (IUN,FILE=YPFZW,FORM='UNFORMATTED')

C.....KENNGROESSEN ERMITTELN UND AUSGEBEN
      CALL DATE_AND_TIME(VALUES=IDATE)
      JJ   = IDATE(1)
      MM   = IDATE(2)
      IT   = IDATE(3)
      IHH  = IDATE(5)
      MIN  = IDATE(6)
      ISEK = IDATE(7)
      ITAG                   = JJ*10000 + MM*100 + IT
      IUHR                   = IHH*10000 + MIN*100 + ISEK
      WRITE (IUN,ERR=200,IOSTAT=IOS) NRBMAP,LBMAP,NRGRP,NRGB, 
     +                               ITAG,IUHR

C.....BITMAP AUSGEBEN
      WRITE (IUN,ERR=200,IOSTAT=IOS) (IBMAP(IW),IW=1,LBMAP)

C.....ABSCHLUSS
      CLOSE (IUN)
      RETURN

C.....FEHLERAUSGANG
  200 CONTINUE
      PRINT 2400,IOS
 2400 FORMAT('0///UP BITMEX, SCHREIBFEHLER AUF LFN=BITMAP,IOSTAT=',I5)
      IRM                    = 1

      END
