SUBROUTINE Bitmin_ascii &
  (ypfad, nrbmap, lbmap, bitmap, &
   gridcount, used, itag, iuhr, &
   success)
!
! Description:
! <Say what this routine does>
!
! Method:
! <Say how it does it: include references to external documentation>
! <If this routine is divided into sections, be brief here,
! and put Method comments at the start of each section>
!
! Input files:
! <Describe these>
!
! Output files:
! <Describe these>
!
! Current Code Owner: DWD, Michael Gertz
!  phone: +49 69-8062-2735
!  fax  : +49 69-82361493
!  email: Gertz@ecmwf.int       # EM/DM and LM support
!  email: MGertz@dwd.d400.de    # other
!
! History:
! Version    Date       Name
! ---------- ---------- ----
! !VERSION!  !DATE!     Michael Gertz
!  Initial release
!
!            Okt.2000   R. Johanni
! If lbmap == -1, the array bitmap is not set.
! This allows an inquiry of the size of the bitmap before actually reading it
!
! Code Description:
! Language: Fortran 90.
! Software Standards: "European Standards for Writing and
! Documenting Exchangeable Fortran 90 Code".
!=======================================================================
!
! Declarations:
!
! Modules used:
!USE , ONLY : &

!
! Imported Type Definitions:

!
! Imported Parameters:

!
! Imported Scalar Variables with intent (in):

!
! Imported Scalar Variables with intent (out):

!
! Imported Array Variables with intent (in):

!
! Imported Array Variables with intent (out):

!
! Imported Routines:

! <Repeat from USE for each module...>
!=======================================================================
!
IMPLICIT NONE
!=======================================================================
!
! Include statements:

!=======================================================================
!
! Declarations must be of the form:
! <type> <VariableName> ! Description/ purpose of variable
!
! Subroutine / Function arguments
! Scalar arguments with intent(in):
CHARACTER (LEN=*), INTENT (IN) :: ypfad
INTEGER,           INTENT (IN) :: nrbmap
INTEGER,           INTENT (IN) :: lbmap

!
! Array arguments with intent(in):

!
! Scalar arguments with intent(inout):

!
! Array arguments with intent(inout):

!
! Scalar arguments with intent(out):
INTEGER,           INTENT (OUT) :: gridcount
INTEGER,           INTENT (OUT) :: used
INTEGER,           INTENT (OUT) :: itag
INTEGER,           INTENT (OUT) :: iuhr
INTEGER,           INTENT (OUT) :: success

!
! Array arguments with intent(out):
INTEGER,           INTENT (OUT) :: bitmap(*)

!-----------------------------------------------------------------------
!
! Local parameters:

!
! Local scalars:
INTEGER             :: iostat      ! io status
INTEGER             :: rsid        ! Real stream ID
INTEGER             :: intbytelen  ! Length of an integer in bytes
INTEGER             :: intbitlen   ! Length of an integer in bits
INTEGER             :: bmnr_read   ! Bitmap number from file
INTEGER             :: count       ! Scratch

CHARACTER (LEN=10)  :: binary_format = '(xxZxx.xx)'
CHARACTER (LEN=254) :: text, ypfzw
!
INTEGER :: NXUNIT         ! Function

!
! Local arrays:
INTEGER, DIMENSION(20) :: data_lengths = 0

!
!- End of header
!

!
!     COMMON block for the bitmap directory and file name; this block
!     is contained in the subroutine 'readnlst.f' in GME2HRM
!
CHARACTER (LEN=80) :: ybitmapdir  ! Name of directory for the bitmap file
CHARACTER (LEN=80) :: ybitmaplfn  ! Name of GME bitmap data file
!
COMMON   / gme_bitmap / ybitmapdir, ybitmaplfn
!ybitmaplfn = ' '
!ybitmapdir = ' '
!
!=======================================================================

!
! Prepare some data
!
success    = 0
intbitlen  = BIT_SIZE(intbytelen)
intbytelen = INT(intbitlen / 8)
rsid       = NXUNIT(0)
itag       = 0
iuhr       = 0

IF ( ybitmaplfn == ' ' ) THEN
  ybitmaplfn = 'bitmp'
  WRITE (ybitmaplfn(6:8), '(I3.3)') nrbmap
END IF
IF ( ybitmapdir /= ' ' ) THEN
   count = LEN_TRIM(ybitmapdir)
   IF ( ybitmapdir(count:count) == '/' ) count = count - 1
   YPFZW = ybitmapdir(1:count) // '/' // ybitmaplfn
ELSE IF ( ypfad /= ' ' ) THEN
   count = LEN_TRIM(ypfad)
   IF ( ypfad(count:count) == '/' ) count = count - 1
   YPFZW = ypfad(1:count) // '/' // ybitmaplfn
ELSE
   YPFZW = ybitmaplfn
ENDIF
!
! Open the bitmap file
!
OPEN (rsid, FILE=YPFZW, FORM='FORMATTED', STATUS='OLD', ACTION='READ', IOSTAT=success)
IF ( success /= 0 ) THEN
  WRITE (*, '(2A)') "BITMIN: Error on opening the bitmap file:", YPFZW(1:LEN_TRIM(YPFZW))
END IF
!
! Read the meta data
!
IF ( success == 0 ) THEN
  READ (rsid, '(A)', IOSTAT=success) text
  READ (text(1:3), '(I3.3)') bmnr_read
  READ (text(5:10), '(I6.6)') gridcount
  READ (text(12:17), '(I6.6)') used
  READ (rsid, '(10I20.20)', IOSTAT=iostat) data_lengths
  IF ( iostat == 0 ) THEN
    data_lengths(15) = INT((gridcount + intbitlen - 1 ) / intbitlen)
    WRITE (*,*) ' Bitmap inform.: ', bmnr_read,data_lengths(15),gridcount,used
  ELSE
    success = iostat
  END IF
  IF ( success /= 0 ) THEN
    WRITE (*, '(A)') "BITMIN: Error on reading meta data from the bitmap file."
  END IF
END IF
!
! Security checking
!
IF ( success == 0 ) THEN
  IF ( lbmap /= -1 .AND. lbmap < data_lengths(15) ) THEN
    WRITE (*, '(A,I6,A,I6,A)') 'BITMIN: Bitmap array larger than defined:', &
                               lbmap, ' defined, ', data_lengths(15), &
                               ' necessary.'
    success = 1
  ELSE IF ( data_lengths(11) > 0 .OR. &
       data_lengths(12) > 0 .OR. &
       data_lengths(13) > 0 .OR. &
       data_lengths(14) > 0 .OR. &
       data_lengths(16) > 0 ) THEN
    WRITE (*, '(A)') 'BITMIN: Bitmap file contains unexpected data.'
    success = 1
  ELSE IF ( nrbmap /= bmnr_read ) THEN
    WRITE (*, '(A,I4,A,I4)') 'BITMIN: Wrong bitmap number read: ', &
                             bmnr_read, ' Assumed: ', nrbmap
    success  = 1
  END IF
END IF
!
! Reading in the bitmap
!
IF ( success == 0 .AND. lbmap /= -1 ) THEN
  IF ( data_lengths(15) > 0 ) THEN
    WRITE (binary_format(2:3), '(I2.2)') 128 / ( intbytelen * 2 )
    WRITE (binary_format(5:6), '(I2.2)') intbytelen * 2
    WRITE (binary_format(8:9), '(I2.2)') intbytelen * 2
    READ (rsid, binary_format, IOSTAT=iostat) &
     (bitmap(count), count=1,data_lengths(15))
    IF ( iostat /= 0 ) THEN
      WRITE (*, '(A,2I10)') 'BITMIN: Error on reading the bitmap file.', iostat, data_lengths(15)
      success = iostat
    END IF
  END IF
END IF
!
CLOSE(rsid)
!
RETURN
END SUBROUTINE bitmin_ascii
