      SUBROUTINE BITMIN_BIN (YPFAD, NRBMAP, LBMAP, IBMAP, NRGRP, NRGB,
     +                       ITAG, IUHR, IRM)

C**** BITMIN   -   UP:BITMAPWERTE VON DATEI HOLEN
C**   AUFRUF   :   CALL BITMIN (YPFAD, NRBMAP, LBMAP, IBMAP, NRGRP, NRGB,
C**               +             ITAG, IUHR, IRM)
C**   ZWECK    :   BITMAP ENTSPRECHEND KATALOG-NR. VON DATEI HOLEN
C**                 DATEINAME: bitmpXXX, WOBEI XXX=NRBMAP,
C**                 z.B. bitmp001 (NAME WIRD AUTOMATISCH ERZEUGT!)
C**                Bitmap muss im "neuen" Bitmap-Format vorliegen:
C**                BYTE  1..    4 = 'BITM',
C**                BYTE  5..    7 = NBYTG,
C**                                 GESAMTLAENGE DES BITMAP-FILES IN BYTES
C**                BYTE  8        = GRIB-EDITIONS-NUMMER (=1)
C**                BYTE  9..      = BITMAP-SECTION IN WMO-FORM
C**                BYTE  9..   11 = BYTE-LAENGE DER BITMAP-SECTION
C**                BYTE 12        = UNBESETZTE BITS AM BITMAP-SECTION-ENDE
C**                BYTE 13..   14 = BITMAP-NUMMER (=0, WEIL BITMAP FOLGT)
C**                BYTE 15..NBYTG = BITMAP; JEDES GESETZTE BIT BEDEUTET
C**                                         EINEN DEF.GPKT.-DATENWERT
C**   PARAMETER:
C**     INPUT  :   YPFAD     PFAD FUER BITMAP (OHNE OB. DATEINAMEN)
C**                          Wenn YPFAD == ' ' , wird die Environmentvariable
C**                          $LIBDWD_BITMAP_PATH ausgewertet
C**                NRBMAP    KATALOG-NR. DER BITMAP (INTEGER) 1 - 999
C**                LBMAP     VOM BENUTZER DIMENSIONIERTE LAENGE V. IBMAP
C**                          Falls LBMAB == -1, wird IBMAP nicht besetzt
C**                          Auf diese Weise kann die Laenge der Bitmap
C**                          ermittelt werden.
C**     OUTPUT :   IBMAP     BEREICH FUER DIE BITMAP
C**                NRGRP     ANZAHL DER GITTERPUNKTE
C**                NRGB      ANZAHL BES. GITTERPUNKTE
C**                ITAG      Nur zur Kompatibilitaet mit alten Versionen
C**                          wird auf 0 gesetzt
C**                IUHR      Nur zur Kompatibilitaet mit alten Versionen
C**                          wird auf 0 gesetzt
C**                IRM       FEHLERRUECKMELDUNG (FEHLER WENN UNGLEICH 0)
C**                          Z.B. WENN KEINE BITMAP VORHANDEN
C**
C**   VERFASSER:   R. Johanni, SGI, 04.2001
C**   GEAENDERT:   R.Johanni, 03.2002: Alles, was mit SPUMB besetzt wird
C**                vorher mit 0 belegen, wenn nur partielle Worte besetzt
C**                werden steht sonst der alte Schrott drinnen


      IMPLICIT NONE

#include "machconsts.h"

      CHARACTER(LEN=*), INTENT(IN) :: YPFAD
      INTEGER, INTENT(IN)  :: NRBMAP
      INTEGER, INTENT(IN)  :: LBMAP
      INTEGER, INTENT(OUT), DIMENSION(*) :: IBMAP
      INTEGER, INTENT(OUT) :: NRGRP
      INTEGER, INTENT(OUT) :: NRGB
      INTEGER, INTENT(OUT) :: ITAG
      INTEGER, INTENT(OUT) :: IUHR
      INTEGER, INTENT(OUT) :: IRM

      INTEGER, PARAMETER :: MAX_PATH_LEN = 1024

      CHARACTER(LEN=MAX_PATH_LEN) :: YPFZW
      CHARACTER(LEN=3) :: YNR

      INTEGER, ALLOCATABLE :: IBLOCK(:)

      INTEGER :: LPF, IUN, LFLB, LFL, IKENN, ILEN, IEDNR, NUNUSB,
     &           NW, NB, I

      INTEGER :: IBITM
      DATA IBITM  /Z'4249544D'/ ! "BITM"


C.....Vorbesetzungen

      ITAG = 0
      IUHR = 0
      IRM  = 0

C.....BITMAP-NR PRUEFEN
      IF ((NRBMAP.LE.0) .OR. (NRBMAP.GT.999))              THEN
         PRINT 2000,NRBMAP
 2000    FORMAT('  ///UP BITMIN,FALSCHER WERT FUER NRBMAP:',I6)
         IRM                 = 1
         RETURN
      ENDIF
      WRITE(YNR,'(I3.3)') NRBMAP

C.....Pfadnamen der Bitmap ermitteln

      IF (YPFAD .NE. ' ')                                  THEN
         YPFZW               = YPFAD
         LPF                 = LEN_TRIM(YPFAD)
      ELSE
C........DATEI-PFAD ZUSAMMENSETZEN
         CALL GETENVIRONMENT('LIBDWD_BITMAP_PATH',YPFZW,IRM)
         IF (IRM .NE. 0) THEN
            PRINT *,' ///UP BITMIN, $LIBDWD_BITMAP_PATH ungueltig'
            RETURN
         ENDIF
         LPF                 = LEN_TRIM(YPFZW)
      ENDIF

      IF (LPF+9 .GT. MAX_PATH_LEN)                           THEN
         PRINT *,' ///UP BITMIN, YPFAD ZU LANG'
         IRM                 = 1
         RETURN
      ENDIF

      YPFZW(LPF+1:LPF+9) = '/bitmp'//YNR

C.....Oeffen der Bitamp Datei

      CALL COPEN(IUN,YPFZW,'r  ',IRM)
      IF (IRM.NE.0) THEN
         PRINT *,' ///UP BITMIN, DATEI: ',YPFZW(1:LPF+9)
         PRINT *,'    KANN NICHT GEOEFFNET WERDEN!'
         RETURN
      ENDIF

C.....Zunaechst CUEGIN mit 0 als Maximalgroesse aufrufen,
C.....IRM muss anschliessend -2 sein.
C.....Dann IBLOCK allokieren und Bitmap-Daten einlesen.

      CALL CUEGIN (IUN, 0, IBLOCK, LFLB, IRM)
      IF (IRM.NE.-2) THEN
         PRINT *,' ///UP BITMIN, Fehler beim Lesen'
         RETURN
      ENDIF

      LFL = (LFLB-1)/IBYTW + 1
      ALLOCATE(IBLOCK(1:LFL))

      CALL CREWIND (IUN, IRM)
      IF (IRM.NE.0) THEN
         PRINT *,' ///UP BITMIN, Fehler beim Rewind'
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

      CALL CUEGIN (IUN, LFL*IBYTW, IBLOCK, LFLB, IRM)
      IF (IRM.NE.0) THEN
         PRINT *,' ///UP BITMIN, Fehler beim Lesen'
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

      CALL CCLOSE(IUN,'exi',IRM)
      IF (IRM.NE.0) THEN
         PRINT *,' ///UP BITMIN, Fehler beim Close'
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

C.....Plausibilitaetstests

      IF (LFLB.LT.15) THEN
         PRINT *,' ///UP BITMIN, Bitmap Laenge zu klein'
         IRM = 1
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

C.....Bytes 1-4: Kennung 'BITM'

      IKENN = 0
      CALL SPUMB(IBLOCK,1,4,IBYTW-4+1,IKENN,IRM)
      IF (IKENN.NE.IBITM) THEN
         PRINT *,' ///UP BITMIN, Daten beginnen nicht mit BITM'
         IRM = 1
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

C.....Bytes 5-7: Gesamtlaenge Bitmap-Daten

      ILEN = 0
      CALL SPUMB(IBLOCK,5,3,IBYTW-3+1,ILEN,IRM)
      IF (ILEN.NE.LFLB) THEN
         PRINT *,' ///UP BITMIN, Laengeangaben inkonsistent'
         IRM = 1
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

C.....Byte 8: GRIB-EDITIONS-NUMMER

      IEDNR = 0
      CALL SPUMB(IBLOCK,8,1,IBYTW-1+1,IEDNR,IRM)
      IF (IEDNR.NE.1) THEN
         PRINT *,' ///UP BITMIN, Editionsnummer ',IEDNR,' unbekannt'
         IRM = 1
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

C.....Bytes 9-11: BYTE-LAENGE DER BITMAP-SECTION

      ILEN = 0
      CALL SPUMB(IBLOCK,9,3,IBYTW-3+1,ILEN,IRM)
      IF (ILEN.NE.LFLB-8) THEN
         PRINT *,' ///UP BITMIN, Laengeangaben inkonsistent'
         IRM = 1
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

C.....Byte 12: UNBESETZTE BITS AM BITMAP-SECTION-ENDE

      NUNUSB = 0
      CALL SPUMB(IBLOCK,12,1,IBYTW-1+1,NUNUSB,IRM)
      IF (NUNUSB.GT.15) THEN
         PRINT *,' ///UP BITMIN, NUNUSB falsch'
         IRM = 1
         DEALLOCATE(IBLOCK)
         RETURN
      ENDIF

C.....Bytes 13-14 enthalten Bitmap-Nummer, diese sollte 0 sein.
C.....Wir lassen eine Ueberpruefung hier!

C.....Anzahl der Gitterpunkte kann nun ermittelt werden

      NRGRP = (ILEN-6)*8 - NUNUSB

C.....IBMAP besetzen, wenn gewuenscht

      IF (LBMAP.NE.-1) THEN

         IF(LBMAP*IBMAX .LT. NRGRP) THEN
            PRINT *,' ///UP BITMIN, LBMAX zu klein'
            IRM = 1
            DEALLOCATE(IBLOCK)
            RETURN
         ENDIF

C........Letztes zu besetzendes Wort auf 0 setzten, da evtl. nur
C........partiell besetzt, Worte dahinter werden nicht angefasst
         IBMAP( (NRGRP-1)/IBMAX+1 ) = 0
         CALL SPUMB(IBLOCK,15,(NRGRP-1)/8+1,1,IBMAP,IRM)

      ENDIF

C.....Anzahl besetzter Gitterpunkte ermitteln

      NW = 14/IBYTW+1  ! Erstes Wort in IBLOCK, das Bitmap enthaelt
      NB = 15          ! Bit-Nummer im ersten Wort, gilt fuer IBYTW = 8,4,2
      NRGB = 0

      DO I=1,NRGRP
         IF(BTEST(IBLOCK(NW),NB)) NRGB = NRGB+1
         NB=NB-1
         IF (NB.LT.0) THEN
            NW=NW+1
            NB = IBMAX-1
         ENDIF
      ENDDO

      DEALLOCATE(IBLOCK)

      END
