      REAL FUNCTION CHAFLO (YCHAR)
C**** CHAFLO   -   CHARACTER-ZAHL IN FLOATING-POINT-ZAHL UMWANDELN
C**   AUFRUF       REAL = CHAFLO (YCHAR)
C**   EXTERNALS    ICHAR
C**   ZWECK        SCHNELLE UMWANDELUNG VON CHARACTER-  ZU REAL-ZAHLEN
C**                ALLER FORTRAN-REAL-FORMATE WIE:
C**                (+-) COEFF
C**                (+-) COEFF E (+-) EXP
C**                (+-) N     E (+-) EXP
C**
C**                WOBEI COEFF SEIN KANN  N.
C**                                       N.N
C**                                        .N
C**                N    IST EINE ZIFFERN-FOLGE
C**                EXP  IST EIN VORZEICHENLOSER GANZZAHLIGER EXPONENT (BASIS 10)
C**                BLANKS ZWISCHEN DER CHARAKTER-ZAHL WERDEN ]BERLESEN.
C**   METHODE      MIT HILFE DER ASCII-TABELLE CHARACTER F]R CHARACTER
C**                UMWANDELN DIES STELLT SICH ALS 4-5 MAL SCHNELLER
C**                HERAUS, ALS DIE ALTE METHODE ]BER 'INTERNAL READ'.
C**                BEI FEHLERHAFTER EINGABE RESULTIERT      -1E10

C     VERFASSER    U.VOIGT MAI 1989
C     Geaendert:   B.Loeser, 11/00, IMPLICIT NONE, LENFUL --> LEN_TRIM

      IMPLICIT NONE
      INTEGER I, J, K, L, IEXPO, INEGA, IPLUS, JASCII
      REAL FMULT
      CHARACTER YCHAR*(*)
      LOGICAL   KONEG,EXNEG

      EXNEG = .FALSE.
      KONEG = .FALSE.
      IEXPO = 0
      CHAFLO = 0.
      L     = LEN_TRIM(YCHAR)
      IPLUS = 43
      INEGA = 45
      DO 100 I = 1,L
      K = I
      JASCII   = ICHAR(YCHAR(I:I))
      IF ((JASCII .GE. 48) .AND. (JASCII .LE. 57)) THEN
C        ZIFFERN VERARBEITEN                                      '0'..'9'
         CHAFLO = (CHAFLO * 10.) + (JASCII-48)
      ELSEIF (JASCII .EQ. 46) THEN
C        DEZIMAL-PUNKT                                            '.'
         GO TO 101
      ELSEIF (JASCII .EQ. 32) THEN
C        BLANK-ZELLE WIRD IGNORIERT                               ' '
         GO TO 100
      ELSEIF ((JASCII .EQ. 69) .OR. (JASCII .EQ. 101)) THEN
C        An erster Stelle darf kein E stehen
         IF (I .EQ. 1) GO TO 900
C        EXPONENT FOLGT                                           'E' ODER 'e'
         GO TO 201
      ELSEIF (JASCII .EQ. INEGA) THEN
C        VORZEICHEN NEGATIV                                       '-'
         KONEG = .TRUE.
         INEGA = 48
         IPLUS = 48
      ELSEIF (JASCII .EQ. IPLUS) THEN
C        VORZEICHEN POSITIV                                       '+'
         INEGA = 48
         IPLUS = 48
      ELSE
C        SONSTIGE ZEICHEN                                         'SONST'
         GO TO 900
      ENDIF
100   CONTINUE
      GO TO 301
101   J = K + 1
      FMULT = 1.
      DO 200 I = J,L
      K = I
      JASCII   = ICHAR(YCHAR(I:I))
      IF ((JASCII .GE. 48) .AND. (JASCII .LE. 57)) THEN
C        ZIFFERN VERARBEITEN
         CHAFLO = CHAFLO + ((JASCII-48) * 0.1 * FMULT)
         FMULT  = 0.1 * FMULT
      ELSEIF ((JASCII .EQ. 69) .OR. (JASCII .EQ. 101)) THEN
C        EXPONENT FOLGT                                           'E' ODER 'e'
         GO TO 201
      ELSEIF (JASCII .EQ. 32) THEN
C        BLANK WIRD IGNORIERT
         GO TO 200
      ELSE
         GO TO 900
      ENDIF
200   CONTINUE
      GO TO 301
201   FMULT = 1.
      IPLUS = 43
      INEGA = 45
      J = K + 1
      DO 300 I = J,L
      JASCII   = ICHAR(YCHAR(I:I))
      IF ((JASCII .GE. 48) .AND. (JASCII .LE. 57)) THEN
C        ZIFFERN VERARBEITEN
         IEXPO = (IEXPO *10) + (JASCII-48)
      ELSEIF (JASCII .EQ. 32) THEN
C        BLANK-ZELLE WIRD IGNORIERT                               ' '
         GO TO 300
      ELSEIF (JASCII .EQ. INEGA) THEN
C        VORZEICHEN NEGATIV                                       '-'
         EXNEG = .TRUE.
         INEGA = 48
         IPLUS = 48
      ELSEIF (JASCII .EQ. IPLUS) THEN
C        VORZEICHEN POSITIV                                       '+'
         INEGA = 48
         IPLUS = 48
      ELSE
C        SONSTIGE ZEICHEN                                         'SONST'
         GO TO 900
      ENDIF
300   CONTINUE
      IF (EXNEG) IEXPO = - IEXPO
      CHAFLO = CHAFLO * 10.**FLOAT(IEXPO)
301   IF (KONEG) CHAFLO = - CHAFLO
      RETURN
900   CHAFLO = -1E10
      END
