      SUBROUTINE DATBIL (YDATI,IVV,YDATO,IDATO,IPART,IEXIT)

C**** DATBIL   -   DATUMS-/ZEIT-ABKUERZUNG EXPANDIEREN
C**   AUFRUF:      CALL DATBIL (YDATI,IVV,YDATO,IDATO,IPART,IEXIT)
C**   ZWECK:       DATUMS-ABKUERZUNGEN ZU VOLLSTAENDIGEM DATUM GGF.
C**                DURCH MASCHINEN-DATUM UND -ZEIT , SOWIE VORHERSAGE-
C**                DATUM ERGAENZEN.
C**   EXTERNALS:   ICHA, SYNTAX, VNDAT, VNMIN, CHAFLO
C**   PARAM:       YDATI  EINGABE-        YDATO       AUSGABE-DATUM
C**                       (LINKSBUENDIG, BLANK FILLED, TYP CHARACTER*13)
C**                       ----------------------------------------------
C**                       ' '             YYYYMMDDGG     MOMENTANE ZEIT
C**                       'H'             YYYYMMDD       AKTUELLES DATUM
C**                       'G'             ........       GESTRIGES DATUM
C**                       'V'             ........    VORGESTRIGES DATUM
C**                       GG              YYYYMMDDGG     AKTUELLES DATUM
C**                       G               YYYYMMDDGG     AKTUELLES DATUM
C**                       'H'GG           ..........     GESTRIGES DATUM
C**                       'G'GG           ..........     GESTRIGES DATUM
C**                       'V'GG           ..........  VORGESTRIGES DATUM
C**                       GG.NN           YYYYMMDDGG.NN  AKTUELLES DATUM
C**                       DDGG.NN         YYYYMMDDGG.NN  AKTUELLES DATUM
C**                       'H'GG.NN        .............  GESTRIGES DATUM
C**                       'G'GG.NN        .............  GESTRIGES DATUM
C**                       'V'GG.NN        .............
C**                       YYMMDD          YYYYMMDD
C**                       YYYYMMDD        ........
C**                       YYMMDDGG        YYYYMMDDGG
C**                       YYMMDDGGNN      YYYYMMDDGGNN
C**                       YYYYMMDDGG      ..........
C**                       YYYYMMDDGGNN    YYYYMMDDGGNN
C**                       YYMMDDGG.NN     YYYYMMDDGG.NN
C**                       YYYYMMDDGG.NN   .............
C**                       ----------------------------------------------
C**                       HIERBEI BEDEUTEN:
C**                       YYYY = JAHRESZAHL VIERSTELLIG
C**                         YY = .......... JAHR UND -ZEHNT
C**                            2000+YY < 50 => 1900+YY
C**                         MM = MONAT
C**                         DD = MONATSTAG
C**                         GG = STUNDE
C**                         NN = MINUTE
C**
C**                IVV    VORHERSAGE-ZEITRAUM (MINUTEN) TYP INTEG.
C**                       DEFAULT: IVV=0
C**                YDATO (1)  AUSGABE-DATUM (WIE O.G. RECHTE TABELLE)
C**                       (LINKSBUENDIG, BLANK FILLED, TYP CHARACTER*13)
C**                YDATO (2)  VORHERSAGE-DATUM, WENN IVV=0 ODER GG
C**                           NICHT IN YDATO(1) ENTHALTEN IST, SIND
C**                           BEIDE IDENTISCH (2) = (1)
C**                IDATO (5,2) INTEGER-ARRAY
C**                      (X,1) EINZELNE DATUMS-WERTE VON YDATO (1)
C**                      (X,2) ......................... YDATO (2)
C**                       X=1 VIERSTELLIGE JAHRESZAHL
C**                       X=2 MONATSZAHL
C**                       X=3 TAGES ZAHL
C**                       X=4 STUNDEN
C**                       X=5 MINUTEN
C**                IPART  BESETZTE DATUMS-ANTEILE
C**                       0 FEHLER
C**                       3 YYYYMMDD
C**                       4 YYYYMMDDGG
C**                       5 YYYYMMDDGG.NN
C**                      -5 YYYYMMDDGGNN
C**                IEXIT  0= FEHLERFREI
C**                       1= FALSCHE SYNTAX ODER FALSCHES DATUM
C     VERFASSER:   U. VOIGT
C     Geaendert:   B.Loeser, 11/00, IMPLICIT NONE,
C                          hermes raus --> print, xyzprt.h raus
C                          aktime, akdate --> DATE_AND_TIME

      IMPLICIT NONE
      INTEGER I, J, K, L, IDATO, IDIFF, IEXIT, IJAHR, IJHDT, IMIN,
     + IMONAT, IPART, IRM, ISTD, ITAG, IVV, IZW, MAXOK
      INTEGER IDATE(8)
      REAL CHAFLO
      DIMENSION IDATO (5,2) , YDATO (2)
      CHARACTER * 13 YDATI , YDATI1 , YDATO ,  YDAT , YMIN , YMAX
      CHARACTER * 12 YMINN , YMAXN
      CHARACTER YFORM * 23 , YFORMN * 10
      LOGICAL SYNTAX
      EXTERNAL ICHA
C                              YYYYMMDDGG.NN
      DATA    YMIN      /     '1000000000.00' /
      DATA    YMAX      /     '2999193929.59' /
C                              YYYYMMDDGGNN
      DATA    YMINN     /     '100000000000'  /
      DATA    YMAXN     /     '299919392959'  /
      DATA    YFORM     /     '(I4,3I2.2,:,''.'',I2.2)' /
      DATA    YFORMN    /     '(I4,4I2.2)'    /
      
      IEXIT=0
      CALL AKMG (YDATI, YDATI1)
      DO 50 J=1,2
      YDATO (J) = ' '
      DO 50 I=1,5
50    IDATO (I,J) =  99
C     AKTUELLES MASCHINEN-DATUM UND -ZEIT ABFRAGEN
      CALL DATE_AND_TIME(VALUES=IDATE)
      IJAHR  = IDATE(1)
      IMONAT = IDATE(2)
      ITAG   = IDATE(3)
      ISTD   = IDATE(5)
      IMIN   = IDATE(6)
      
C     SPAETER AUSZUGEBENDE DATUMS-ANTEILE (1=JAHR,2=JAHR+MONAT.....)
      IPART = 0
C     DATUMS-DIFFERENZ ZU ANGEGEBENEM ODER MASCHINEN-DATUM
      IDIFF = 0
C     ------------------------------------------------------------------
C     ------------------   S Y N T A X   -   PRUEFUNG   ----------------
C     ------------------------------------------------------------------
      IF( YDATI1 .EQ. ' ' ) THEN
          IPART = 4
          IDATO(4,1) = ISTD
          IDATO(5,1) = IMIN
          GO TO 100
      ELSE IF (YDATI1 (1:1) .EQ. 'H' ) THEN
          IPART = 3
          YDAT  = YDATI1 (2:)
      ELSE IF (YDATI1 (1:1) .EQ. 'G' ) THEN
          IDIFF = -1
          YDAT  = YDATI1(2:)
          IPART = 3
      ELSE IF (YDATI1 (1:1) .EQ. 'V' ) THEN
          IDIFF = -2
          YDAT  = YDATI1(2:)
          IPART = 3
      ELSE
          YDAT  = YDATI1
      ENDIF
      IF( YDAT .EQ. ' ' ) THEN
      ELSE IF ( SYNTAX (YDAT,YMIN(9:10),YMAX(9:10),ICHA ,MAXOK))THEN
C     GG
         IPART = 4
         READ (YDAT,'(I2)') IDATO(4,1)
      ELSE IF ( SYNTAX (YDAT,YMIN(10:10),YMAX(10:10),ICHA ,MAXOK))THEN
C     G
         IPART = 4
         READ (YDAT,'(I2)') IDATO(4,1)
      ELSE IF ( SYNTAX (YDAT,YMIN(9:13),YMAX(9:13),ICHA ,MAXOK))THEN
C     GG.NN
         IPART = 5
         READ (YDAT,'(I2,1X,I2)') IDATO(4,1),IDATO(5,1)
      ELSE IF ( SYNTAX (YDAT,YMIN(7:13),YMAX(7:13),ICHA ,MAXOK))THEN
C     DDGG.NN
         IPART = 5
         READ (YDAT,'(2I2,1X,I2)') IDATO(3,1),IDATO(4,1),IDATO(5,1)
      ELSE IF ( (YDAT(1:2) .NE. '19') .AND. (YDAT(1:2).NE.'20') )THEN
C     YY.....
         YDATO(2) = YDAT
         IZW=CHAFLO(YDAT(1:2))
         IF (IZW .LT. 50) THEN
            IJHDT = 20
         ELSE
            IJHDT = 19
         ENDIF
C        Loesung aktuelles Jahrhundert wegen 2000-Problem abgeloest 
C        IJHDT = ICENT() / 100
         WRITE(YDAT,'(I2,A11)') IJHDT, YDATO(2)
      ENDIF
      IF( SYNTAX (YDAT,YMIN,YMAX,ICHA ,MAXOK) ) THEN
C     YYYYMMDDGG.NN
          IPART = 5
          READ (YDAT,'(I4,3I2,1X,I2)') IJAHR,IMONAT,ITAG
     +                                ,IDATO(4,1),IDATO(5,1)
      ELSE IF( SYNTAX (YDAT,YMINN,YMAXN,ICHA ,MAXOK) ) THEN
C     YYYYMMDDGGNN
          IPART = -5
          READ (YDAT,'(I4,4I2)') IJAHR,IMONAT,ITAG
     +                                ,IDATO(4,1),IDATO(5,1)
      ELSE IF ( SYNTAX (YDAT,YMIN(:10),YMAX(:10),ICHA ,MAXOK) ) THEN
C     YYYYMMDDGG
          IPART = 4
          READ (YDAT,'(I4,3I2)') IJAHR , IMONAT , ITAG , IDATO(4,1)
      ELSE IF ( SYNTAX (YDAT,YMIN(:8),YMAX(:8),ICHA ,MAXOK) ) THEN
C     YYYYMMDD
          IPART = 3
          READ (YDAT,'(I4,2I2)') IJAHR , IMONAT , ITAG
      ENDIF
      IF( (IMONAT.LT.1) .OR. (IMONAT.GT.12) .OR.
     +    (ITAG  .LT.1) .OR. (ITAG  .GT.31) .OR.
     +    (IPART .EQ. 0) ) THEN
          IPART = 0
C         FALSCHE SYNTAX
          GO TO 999
      ENDIF
100   IRM = 0
      CALL VNDAT (IJAHR,IMONAT,ITAG,IDIFF
     +           ,IDATO(1,1),IDATO(2,1),IDATO(3,1),IRM)
      IF(IRM.NE.0) THEN
         IPART = 0
         GO TO 999
      ENDIF
      K=0
      IF( IABS(IPART) .GT. 3 ) THEN
         IF(IDATO(4,1).EQ.99) IDATO(4,1) = 0
         IF(IDATO(5,1).EQ.99) IDATO(5,1) = 0
      CALL VNMIN (IDATO(1,1), IDATO(2,1), IDATO(3,1), IDATO(4,1)
     +               ,IDATO(5,1), IVV      ,IDATO(1,2),IDATO(2,2)
     +               ,IDATO(3,2),IDATO(4,2),IDATO(5,2),IRM)
         IF( IRM .NE. 0 ) THEN
           IPART = 0
           GO TO 999
         ENDIF
         K=1
      ENDIF
      L=1
      DO 200 I=1,2
      IF (IPART .GT. 0) THEN
         WRITE (YDATO (I) , YFORM) (IDATO (J,L),J=1,IPART)
      ELSE
         WRITE (YDATO (I) , YFORMN)(IDATO (J,L),J=1,-IPART)
      ENDIF
200   L = L + K
999   IF( IPART .EQ. 0 ) THEN
         IEXIT = 1
         PRINT *, 'W: DATBIL/ YYYYMMDDGG.NN=',YDATI,' IVV=',
     +         IVV,' MINUTEN oder'
         PRINT *, 'F: DATBIL/ YYYYMMDDGGNN=',YDATI,' IVV=',
     +         IVV,' MINUTEN'
      ENDIF
      RETURN
      END
