      SUBROUTINE DATJUL (IYEAR, IMONTH, IDAY, IDATJU, IRM)

C**** DATJUL   -   UP:BESTIMMT JULIANISCHES DATUM AUS DATUM
C**   AUFRUF     : CALL DATJUL (IJAHR ,IMONAT ,ITAG ,IDATJU ,IRM)
C**   ZWECK      : DAS PROGRAMM DATJUL SOLL DIE LAUFENDE NUMMER DES
C**                TAGES INNERHALB DES JAHRES DES UEBERGEBENEN TAGES-
C**                DATUMS ERRECHNEN
C**   EXTERNALS  : DATPR
C**   PARAMETER  : IJAHR     JAHR, MIT ODER OHNE JAHRHUNDERT (INTEGER)
C**                IMONAT,ITAG MONAT, TAG (INTEGER)
C**                IDATJU  = JULIANISCHES DATUM
C**                IRM     = FEHLER-RUECKMELDEZELLE "0 = FEHLER
C**   VERFASSER:   A. ZALEWSKY
C** 
C**   HINWEIS:     UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DAS JAHR 4-STELLIG
C**                UEBERGEBEN;
C**                BEI 2-STELLIGER JAHRESANGABE WIRD DAS JAHRHUNDERT WIE IM
C**                ALTEN BANK-PROGRAMM ZUGEWIESEN, ->
C**                IJAHR >= 50, -> 1900; IJAHR < 50, -> 2000 !
C.....MODIF.:      HINWEIS, A.ZALEWSKY...........................14.01.1999
C                  B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER NTAGE, IYY, IYEAR, IRM, IMONTH, IDAY, ISCHAL, IDATJU
      DIMENSION NTAGE (13)

      DATA NTAGE /    0,  31,  59,  90, 120, 151, 181,
     +                   212, 243, 273, 304, 334, 365 /

      IRM              = 0
C.....JAHRHUNDERT NUR UEBER IYEAR, NICHT UEBER ICENT ZUWEISEN....14.01.1999      
C.....BEI 2-STELLIGER JAHRESANGABE, JAHRHUNDERT WIE IN DER ALTEN BANK
      IYY              = IYEAR
      IF (IYY .LT. 100)                                    THEN
         IF (IYY .LT. 50)                                  THEN
         IYY           = 2000 + IYEAR
         ELSE
            IYY        = 1900 + IYEAR
         ENDIF
      ENDIF
                     
C.....DATUM AUF RICHTIGKEIT PRUEFEN
C.....CALL DATPR (IYEAR, IMONTH, IDAY, ISCHAL, IRM)..............14.01.1999
      CALL DATPR (IYY,   IMONTH, IDAY, ISCHAL, IRM)
      IF (IRM .NE. 0)                                      RETURN

C.....LAUFENDE NUMMER DES TAGES INNERHALB DES JAHRES BESTIMMEN
      IDATJU           = NTAGE (IMONTH) + IDAY
      IF (IMONTH .GT. 2)
     +   IDATJU        = IDATJU + ISCHAL

      RETURN
      END
