      SUBROUTINE DATPR (IYEAR, IMONTH, IDAY, ISCHAL, IRM)

C**** DATPR    -   UP:DATUM PRUEFEN, SCHALTJAHR ANGEBEN
C**   AUFRUF     : CALL DATPR (IJAHR, IMONAT, ITAG, ISCHAL, IRM)
C**   ZWECK      : DAS UP PRUEFT DAS UEBERGEBENE DATUM AUF RICHTIGKEIT
C**                UND GIBT AN, OB ES SICH UM EIN SCHALTJAHR HANDELT
C**   EXTERNALS  : SCHALT
C**   PARAMETER  : IJAHR     JAHR, MIT ODER OHNE JAHRHUNDERT (INTEGER)
C**                          (JAHRES-ANGABE NUR POSITIV)
C**                IMONAT,ITAG   MONAT,TAG (INTEGER)
C**                ISCHAL  = GIBT AN, OB SCHALTJAHR ODER NICHT
C**                          ISCHAL=1 SCHALTJAHR
C**                          ISCHAL=0 KEIN SCHALTJAHR
C**                IRM     = FEHLER-RUECKMELDEZELLE
C**   VERFASSER:   A. ZALEWSKY
C**
C**   HINWEIS:     UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DAS JAHR 4-STELLIG
C**                UEBERGEBEN;
C**                BEI 2-STELLIGER JAHRESANGABE WIRD DAS JAHRHUNDERT WIE IM
C**                ALTEN BANK-PROGRAMM ZUGEWIESEN, ->
C**                IJAHR >= 50, -> 1900; IJAHR < 50, -> 2000 !
C.....MODIF.:      HINWEIS; A.ZALEWSKY..........................14.01.1999
C                  MOD. JUNI 1997, ARZ3ZAL, POSITIVE JAHRESZAHL WIRD GEPRUEFT
C                  B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER  IDAY, IDZW, IMONTH, IRM, ISCHAL, ITAGE, IYEAR, IYY
      EXTERNAL SCHALT

      DIMENSION ITAGE (12)
      DATA ITAGE   /31,28,31,30,31,30,31,31,30,31,30,31/

      IRM              = 0
      IYY              = IYEAR
      
C.....JAHR PRUEFEN
C.....IF ((IYEAR.LT.0) .OR. ((IYEAR.GT.99).AND.(IYEAR.LE.ICENT() )))....24.06.97
      IF (IYEAR .LT. 0)                                    THEN
CTEST    PRINT '('' DATPR: FEHLER IM JAHR IN :'',I6)',IYEAR
         GOTO 999
      ENDIF
C.....JAHRHUNDERT NUR UEBER IYEAR, NICHT UEBER ICENT ZUWEISEN.........14.01.1999      
C.....BEI 2-STELLIGER JAHRESANGABE, JAHRHUNDERT WIE IN ALTER BANK
      IF (IYY .LT. 100)                                    THEN
         IF (IYY .LT. 50)                                  THEN
            IYY        = 2000 + IYEAR
         ELSE
            IYY        = 1900 + IYEAR
         ENDIF
      ENDIF
                                 
C.....MONAT PRUEFEN
      IF((IMONTH.LT.1) .OR. (IMONTH.GT.12))                THEN
CTEST    PRINT '('' DATPR: FEHLER IM MONAT IN :'',I6)',IMONTH
         GOTO 999
      ENDIF

C.....TAG PRUEFEN
      IDZW             = ITAGE (IMONTH)

C.....SCHALTJAHR PRUEFEN
C.....CALL SCHALT (IYEAR, ISCHAL)..............................14.01.1999
      CALL SCHALT (IYY,   ISCHAL)
      IF (IMONTH .EQ. 2)                                   THEN
         IDZW          = IDZW + ISCHAL
      ENDIF

      IF ((IDAY.LT.1) .OR. (IDAY.GT.IDZW))                 THEN
CTEST    PRINT '('' DATPR: FEHLER IM TAG IN :'',I6)',IDAY
         GOTO 999
      ENDIF

      RETURN

  999 IRM              = 1

      END
