      SUBROUTINE DIFMIN (IJAHR,IMONAT,ITAG,ISTUND,IMINUT,
     +                   NJAHR,NMONAT,NTAG,NSTUND,NMINUT,IMDIF,IRM)
C**** DIFMIN   -   UP:BERECHNET AUS 2 EINGABEDATEN DIE DIFFERENZ IN MINUTEN
C**   AUFRUF   :   CALL DIFMIN (IJAHR,IMONAT,ITAG,ISTUND,IMINUT,NJAHR,
C**                             NMONAT,NTAG,NSTUND,NMINUT,IMDIF,IRM)
C**   ZWECK    :   DIFMIN BERECHNET AUS DEN EINGABEDATEN
C**                (DAT1: IJAHR,IMONAT,ITAG,ISTUND,IMINUT,
C**                 DAT2: NJAHR,NMONAT,NTAG,NSTUND,NMINUT)
C**                DIE DIFFERENZ IN MINUTEN: IMDIF = DAT2 - DAT1
C**   EXTERNALS:   DATJUL, SCHALT
C**   PARAMETER:   IJAHR ,NJAHR  )
C**                IMONAT,NMONAT )
C**                ITAG  ,NTAG   )     EINGABEDATEN (INTEGER)
C**                ISTUND,NSTUND )     JAHR MIT ODER OHNE JAHRHUNDERT
C**                IMINUT,NMINUT )
C**                IMDIF               DIFFERENZ (INTEGER) IN MINUTEN
C**                IRM                 FEHLER-RUECKMELDEZELLE
C**                                    IRM IM FEHLERFALL UNGLEICH 0   
C**   VERFASSER:   A. ZALEWSKY / G. BAGINSKI
C**   HINWEIS      UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DIE JAHRESANGABEN
C**                4-STELLIG UEBERGEBEN;
C**                BEI 2-STELLIGER JAHRESANGABE WIRD DAS JAHRHUNDERT WIE
C**                IM ALTEN BANK-PROGRAMM ZUGEWIESEN, ->
C**                IJAHR >= 50, -> 1900; IJAHR < 50, -> 2000 !
C.....MODIF.:      HINWEIS; A.ZALEWSKY..........................14.01.1999
C                  B.Loeser, 05.06.01, IMPLICIT NONE eingefuegt

      IMPLICIT NONE             
      INTEGER IRM, IMDIF, ISTUND, IMINUT, NSTUND, NMINUT, IJAHR, NJAHR,
     +        IJJ, NJJ, IDAY, NDAY, ITDIF, IND1, IND2, IVORZ, KSCHAL,
     +        IMONAT, NMONAT, J1, ITAG, NTAG
      
C.....RUECKGABEDATEN VORBESETZEN
      IRM              = 0
      IMDIF            = 0

C.....ZEITANGABEN PLAUSIBEL
      IF (ISTUND .LT.  0 .OR. NSTUND .LT.  0               .OR.
     +    ISTUND .GE. 24 .OR. NSTUND .GE. 24               .OR.
     +    IMINUT .LT.  0 .OR. NMINUT .LT.  0               .OR.
     +    IMINUT .GE. 60 .OR. NMINUT .GE. 60)              THEN
         IRM           = 1
         RETURN
      ENDIF
      
C.....BEI 2-STELLIGEN JAHREN, JAHRHUNDERT WIE IN ALTER BANK.....14.01.1999
C.....NICHT UEBER ICENT ZUWEISEN
      IJJ              = IJAHR
      NJJ              = NJAHR
      IF (IJJ .LT. 100)                                    THEN
         IF (IJJ .LT. 50)                                  THEN
            IJJ        = 2000 + IJAHR
         ELSE
            IJJ        = 1900 + IJAHR
         ENDIF
      ENDIF
      IF (NJJ .LT. 100)                                    THEN
         IF (NJJ .LT. 50)                                  THEN
            NJJ        = 2000 + NJAHR
         ELSE
            NJJ        = 1900 + NJAHR
         ENDIF
      ENDIF  
                                
C.....DATUM PRUEFEN UND JULIAN. TAG BERECHNEN
C.....CALL DATJUL (IJAHR, IMONAT, ITAG, IDAY, IRM)...........14.01.1999
      CALL DATJUL (IJJ,   IMONAT, ITAG, IDAY, IRM)
      IF (IRM .NE. 0)                                      RETURN
C.....CALL DATJUL (NJAHR, NMONAT, NTAG, NDAY, IRM)...........14.01.1999
      CALL DATJUL (NJJ,   NMONAT, NTAG, NDAY, IRM)
      IF (IRM .NE. 0)                                      RETURN

C.....TAGESDIFFERENZ
      ITDIF            = NDAY - IDAY

C.....GLEICHES JAHR
C.....IF (IJAHR .EQ. NJAHR) GOTO 200.........................14.01.1999
      IF (IJJ .EQ. NJJ)                                    GOTO 200
      
C.....TAGESDIFFERENZ BEI JAHRESWECHSEL
C.....IF (NJAHR .GT. IJAHR) THEN.............................14.01.1999
      IF (NJJ .GT. IJJ)                                    THEN
         IND1          = IJJ
         IND2          = NJJ - 1
         IVORZ         =  1
      ELSE
         IND1          = NJJ
         IND2          = IJJ - 1
         IVORZ         = -1
         ITDIF         = - ITDIF
      ENDIF

C.....SCHLEIFE UEBER JAHRE (TAGESZAHLEN ADDIEREN)
      DO 100        J1 = IND1, IND2
      CALL SCHALT (J1, KSCHAL)
  100 ITDIF            = ITDIF + 365 + KSCHAL

      ITDIF            = ITDIF * IVORZ

C.....DIFFERENZ IN MINUTEN
  200 IMDIF            = (ITDIF*24 + NSTUND - ISTUND) * 60 
     +                             + NMINUT - IMINUT
      END
