      SUBROUTINE   FCRACKA (IAR1, IABDB, UNDEF, ISCAL, REFMIN, IBMJ,
     +                      IBMAP, NRGRP, NRBIT, IAGP, INDEX, ARA, IRM)

C**** FCRACKA  -   ENTZERREN BEST. GITTERPKTE. EINES KOMPR. FELDES (GRIB-CODE)
C**   AUFRUF   :   CALL FCRACKA (IAR1, IABDB, UNDEF, ISCAL, REFMIN, IBMJ, IBMAP,
C**               +              NRGRP, NRBIT, IAGP, INDEX, ARA, IRM)
C**   ZWECK    :   MAX. 200 GITTERPUNKTE EINES IM GRIB-CODE GEPACKTEN FELDES EX-
C**                TRAHIEREN,
C**                MIT FLOATING-WERTEN; BEI VORLIEGEN EINER BITMAP WERDEN
C**                UNDEFINIERTE PUNKTE MIT UNDEF BESETZT
C**   PARAMETER:
C**     INPUT  :   IAR1      EINGABEFELD, GEPACKT
C**                IABDB     ANFANGSADRESSE=1.BYTE MIT DEM DER DATENSATZ BEGINNT
C**                UNDEF     WERT, MIT DEM UNDEFINIERTE GITTERPUNKTE BELEGT
C**                          WERDEN (I.A. -1E10)
C**                ISCAL     EXPONENT (ZUR BASIS 2) D. SKAL.FAKTORS
C**                REFMIN    REFERENZWERT(MINIMUM) FUER DIE UMRECHNUNG
C**                IBMJ      =0, WENN KEINE BITMAP VORLIEGT (ALLE PUNKTE DEFIN.)
C**                          =1, WENN BITMAP VORLIEGT (IN IBMAP)
C**                IBMAP     BITMAP (ZU LIEFERN, WENN IBMJ=1, SONST DUMMY)
C**                NRGRP     ANZAHL DER GITTERPUNKTE VON IAR1 (GESAMT)
C**                NRBIT     ANZAHL BITS JE GITTERPUNKT
C**                IAGP      ANZAHL DER GEWUENSCHTEN GITTERPUNKTE
C**                INDEX     ARRAY MIT DEN GEWUENSCHTEN GITTERPUNKTEN
C**
C**     OUTPUT :
C**                ARA       AUSGABEFELD FUER DIE GPKTE.; ENTZERRT, FLOATING;
C**                IRM       FEHLER, WENN UNGL. 0
C**   VERFASSER:   A.ZALEWSKY, TE23, FEB.'93  (EXT. VON UP FCRACK1)
C     MODIFICATION: CRAY-REFMIN-UMRECHNUNG WIE IN FCRACK1, ARZ3ZAL;.....25.11.97
C                  B. Loeser, TI 14, Juli 2000, Anpassung Symbole fuer FUJITSU
C*    --------------------------------------------------------------------------
C     FORMEL FUER DIE UMRECHNUNG JE WERT:
C         U      = (IS*ZSCAL) + REF
C     MIT:U      = FLOATING-WERT
C         IS     = SKALIERTER WERT
C       ZSCAL    = SKALIERUNGSFAKTOR
C        REF     = REFERENZWERT (MINIMUM)
C*    --------------------------------------------------------------------------
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C*                            Ueberfluessige Parameter raus, #ifdef(CRAY) raus

      IMPLICIT NONE

      INTEGER IAR1, IABDB, ISCAL, IBMJ, IBMAP, NRGRP, NRBIT, IAGP, INDEX
      INTEGER IRM
      INTEGER INDBR, INB, IBMSK, NUMBES, NUMIDX, K, IABIT, IANFB, INDAR
      INTEGER IL1, IANU, IZW, IL2

      REAL    UNDEF, REFMIN, ARA, ZSCAL, REFNEU

#include "machconsts.h"

      DIMENSION    IAR1(*), IBMAP(*), ARA(*), INDEX(*),
     +             INDBR(IAGP)

C*    --------------------------------------------------------------------------
C     INITIALISIERUNG
      ZSCAL      = 2.**ISCAL
      IRM        = 0

C*    --------------------------------------------------------------------------
      IF ( IBMJ .EQ. 1 )                    THEN

C        FELD MIT BITMAP, DANN RELATIVE GITTERPUNKTE BERECHNEN

         INB     = 0  ! Zaehler fuer Worte in IBMAP, zaehlt ab 1
         IBMSK   = 0  ! Bitmaske fuer aktuelles Bit in IBMAP
         NUMBES  = 0  ! Anzahl der besetzten Gitterpunkte
         NUMIDX  = 1  ! Aktueller Wert im Feld INDEX
         DO K = 1, INDEX(IAGP)
            IBMSK = ISHFT(IBMSK,-1)
            IF ( IBMSK .EQ. 0 ) THEN
C*             NEUES BITMAP-WORT BEREITSTELLEN
               INB   = INB + 1
               IBMSK = ISHFT(1,IBMAX-1)
            ENDIF
C*          ABFRAGE, OB GI.PUNKT DEFINIERT
            IF(IAND(IBMAP(INB),IBMSK).NE.0 ) NUMBES = NUMBES + 1
C*          Abfrage, ob K ein Punkt im Feld INDEX
            IF(K.EQ.INDEX(NUMIDX)) THEN
               IF(IAND(IBMAP(INB),IBMSK).NE.0 ) THEN
                  INDBR(NUMIDX) = NUMBES
               ELSE
                  INDBR(NUMIDX) = -1
               ENDIF
               NUMIDX = NUMIDX+1
            ENDIF
         ENDDO

C*       Plausibilitaetskontrolle

         IF(NUMIDX .NE. IAGP+1) THEN
            PRINT *,'FCRACKA: INDEX nicht monoton steigend'
            IRM = 1
            RETURN
         ENDIF

      ELSE

C*       Keine Bitmap -> Relative Gitterpunkte gleich INDEX

         DO K = 1, IAGP
            INDBR(K) = INDEX(K)
         ENDDO

      ENDIF

      REFNEU     = REFMIN

C*    --------------------------------------------------------------------------

      IABIT = (IABDB-1) * IBYTE ! Anfangsbit des Datensatzes, startet ab 0

      DO K  = 1, IAGP

         IF (INDBR(K) .LT. 0) THEN
            ARA(K) = UNDEF
            CYCLE
         ENDIF

         IANFB = ((INDBR(K)-1) * NRBIT) + IABIT ! Anfangsbit im Datensatz, ab 0
         INDAR = IANFB/IBMAX + 1                ! Anfangswort, ab 1
         IANFB = MOD(IANFB,IBMAX)               ! Anfangsbit im Wort, ab 0

C        WIEVIEL BITS SIND IM ERSTEN WORT
         IL1     = MIN ( NRBIT, IBMAX-IANFB )
C        BITS AUS WORT 1 EXTRAHIEREN
         IANU    = IBMAX - ( IANFB + IL1 )
         IZW     = IBITS ( IAR1(INDAR), IANU, IL1 )
C        FALLS IM ZWEITEN WORT NOCH WAS UEBRIG, ANBAUEN
         IL2     = NRBIT - IL1
         IF ( IL1 .NE. NRBIT )                 THEN
           IANU  = IBMAX - IL2
           IZW   = IOR ( ISHFT(IZW,IL2),IBITS(IAR1(INDAR+1),IANU,IL2))
         ENDIF

C        INTEGER WERT FLOAT. UMRECHNEN
         ARA(K)     = IZW*ZSCAL + REFNEU

      ENDDO

      END
