/*
C**** fsleep   - Function, sleep isec seconds
C**   Aufruf:    call fsleep (isec)
C**   Zweck:     sleep-Funktion fuer Fortran-Programme (und nur dafuer!)
C**   Parameter: isec - Zeit in Sekunden
C**   Verfasser: Th. Hanisch, FE 13, 04.11.1998
C*    Geaendert: B.Loeser, 05.06.01: Aenderung Symbole
C*                         08.11.01: IBM-Zweig entsprechend Vorschlag Braunbeck
C*               G.Eymann, 21.01.02: system-abh. Anpassung des Namens in Header 
*/

#include <stdio.h>

#if defined(_AIX)
#include <errno.h>
#include <sys/time.h>
#else
#include <unistd.h>
#endif

#define  EXTERN  extern

/* include Fortran - C Schnittstellen */
#include "fortran_c.h"

int fsleep (FTN_INT *isec)
{
#ifdef _AIX

/* sleep() kann bei IBM von Signalen unterbrochen werden --> */

     struct timestruc_t Requested, Remaining;
     double famount = *isec;
     int rc;

     while (famount > 0.0) 
        {
        Requested.tv_sec = (int) famount;
        Requested.tv_nsec = (int) ((famount - Requested.tv_sec)*1000000000.0);
        rc = nsleep (&Requested, &Remaining);
        if ((rc == -1) && (errno == EINTR)) 
           {
           /* Sleep interrupted. Resume it */
           famount = Remaining.tv_sec + Remaining.tv_nsec / 1000000000.0;
           continue;
           } 
        else 
           {
            /* Completed sleep. Set return to zero */
            return (0);
           }
        }  /* end of while */
     /* famount = 0; exit */
     return 0;

#else

     unsigned sleep (unsigned isec);
     sleep (*isec);
     
     return 0;

#endif
}
