       SUBROUTINE GETENVIRONMENT(NAME,VALUE,IERROR)
!****  GETENVIRONMENT - Workaround fuer PXFGETENV oder getenv 
!**    Aufruf: CALL GETENVIRONMENT(VarName,VarWert,ierror)
!**
!**    Parameter: 
!**       VarName   Eingabestring
!**                 Name der Environmentvariable
!**       VarWert   Ausgabestring
!**                 Wert der Environmentvariable als Zeichenkette
!**                 ohne folgende Leerzeichen 
!**                 Falls keine Variable existiert, enthaelt VarWert 
!**                 Leerzeichen. 
!**       ierror    Fehlercode: 0 --> erfolgreich, 
!**                             1 --> Variable nicht definiert
!**                            >1 --> Laenge von VarWert, wenn String
!**                                   zu lang.
!**    Verfasser: B.Loeser, TI 14
!**    Datum    : 01/01
!**
!*     Geandert: R. Johanni, Mai 2002; Anpassung Symbole fuer LINUX 
       IMPLICIT NONE
       CHARACTER*(*) NAME, VALUE
       CHARACTER*512 VALUE2
       INTEGER LENNAME, LENVALUE, IERROR

       IERROR = 0
       LENNAME = 0
       LENVALUE = 0
       VALUE = ' '
       VALUE2 = ' '
#if defined __uxp__ || defined _AIX || defined __linux__ || defined __nec
       CALL GETENV (NAME,VALUE2)
       LENVALUE = LEN_TRIM(VALUE2)
       IF (LENVALUE .EQ. 0) THEN 
          IERROR = 1
       ELSEIF (LENVALUE .GT. LEN(VALUE)) THEN
          IERROR = LENVALUE
          VALUE = VALUE2(1:LEN(VALUE))
       ELSE
          VALUE = VALUE2(1:LENVALUE)
       ENDIF
#elif defined _WIN32
       CALL GETENV (NAME,VALUE2)
       LENVALUE = LEN_TRIM(VALUE2)
       IF (LENVALUE .EQ. 0) THEN
          IERROR = 1
       ELSEIF (LENVALUE .GT. LEN(VALUE))THEN
          IERROR = LENVALUE
          VALUE = VALUE2(1:LEN(VALUE))
       ELSE
          VALUE = VALUE2(1:LENVALUE)
       ENDIF
#else
       CALL PXFGETENV (NAME, LENNAME, VALUE, LENVALUE, IERROR)
       IF (LENVALUE .EQ. 0) THEN
          IERROR = 1
       ELSEIF (LENVALUE .GT. LEN(VALUE)) THEN
          IERROR = LENVALUE
       ENDIF
#endif 
       END
