      SUBROUTINE   GETBD1 (IEDNR,IBYTA,IBDIM,IBLOCK,IWERT,IBMP2,IWIDTH,
     +                     DSUP,IDANZ,IRM)
C**** GETBD1   -   UP:BINARY-DATA-SECTION EINES GRIB ZERLEGEN (M.COMPLX-PACKING)
C**   AUFRUF     : CALL GETBD1 (IEDNR,IBYTA,NBDIM,IBLOCK,IWERT,IBMP2,IWIDTH,
C**               +             DSUP,IDANZ,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DAS UP DIENT DAZU, AUS IBLOCK DIE KENNDATEN DER BINARY-DATA-
C**                SECTION (BDS) NACH IWERT ZU EXTRAHIEREN
C**   PARAMETER  : INPUT   : IEDNR, IBYTA, NBDIM, IBLOCK
C**                -------------------------------------
C**                IEDNR     EDITIONS-NUMMER, IEDNR=1 AB 11/94
C**                IBYTA     ANFANGSADRESSE DER BDS IM FELD IBLOCK,
C**                          IN BYTES BERECHNET.
C**                IBDIM     USER-DIMENSIONIERUNGEN (IBDIM(6)):
C**                --------------------------------------------  64 bit/32 bit
C**                (1)       NWERT,  USER-DIMENSION. VON IWERT       (11)
C**                (2)       NDSUP , USER-DIMENSION. VON DSUP        (73)
C**                (3)       NBMP2,  USER-DIMENSION. VON IBMP2    (100/200)
C**                (4)       NWDTH,  USER-DIMENSION. VON IWIDTH     (500)
C**                (5)       NBLOCK, USER-DIMENSION. VON IBLOCK (81000/162000)
C**                (6)       IUNDEF, WERT FUER UNDEF.DATEN
C**                IBLOCK    ZU ZERLEGENDER GRIB-BLOCK
C**                OUTPUT  : IWERT, IBMP2, IWIDTH, DSUP , IDANZ, IRM
C**                -------------------------------------------------
C**                IWERT     MAX.  11 INTEGER-WERTE KENNDATEN FUER DIE BDS
C**
C**
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                    1     1 - 3  LBD1    LAENGE DER BDS IN BYTES
C**                    2     4      IFLAG   BIT 1-4,  VERSCHL. LT. TABLE 11:
C**                                         BIT 1: 0 -> GITTERPKTE.
C**                                              : 1 -> SPH. HARM. KOEFFIZIENTEN
C**                                         BIT 2: 0 -> SIMPLE PACKING
C**                                              : 1 -> COMPLEX PACKING ODER
C**                                                     PACKEN 2.ORDNUNG
C**                                         BIT 3: 0 -> FLOAT.POINT-DATEN
C**                                              : 1 -> INTEGER-DATEN
C**                                         BIT 4: 0 -> KEINE WEITERE FLAG AB
C**                                                     BYTE 14
C**                                              : 1 -> WEITERE FLAG AB BYTE 14
C**                                         SP=SIMPLE PACKING,CP=COMPLEX PACKING
C**                                         IFLAG=   0, BIT12=00, GPKTDATEN., SP
C**                                         IFLAG=  64, BIT12=01, GPKTDATEN., CP
C**                                         IFLAG= 128, BIT12=10, SPEK.COEFF.,SP
C**                                         IFLAG= 192, BIT12=11, SPEK.COEFF.,CP
C**                               + NUNUSB  NUMBER OF UNUSED BITS AM ENDE DER
C**                                         BDS ( BIT 5-8)
C**                    3     5 - 6  ISCAL   SCALE-FAKTOR; ISCAL MUSS DEFINIERT
C**                                         SEIN; WENN NICHT, D.H. ALLE BITS
C**                                         SIND GESETZT,  -> IRM = 15, NUR DIE
C**                                                           ERSTEN 11 BYTES
C**                                                           WERDEN EXTRAHIERT;
C**                                         WENN DAS OBERSTE BIT GESETZT IST,
C**                                         WIRD DER WERT OHNE DAS OBERSTE BIT
C**                                         NEGATIV UMGESETZT
C**
C**                 *  R1    7 -10  REFMIN  REF.-WERT: MINIM.DER GEPACKT. WERTE,
C**                                         HEXADEZIMAL; WIRD MIT DER FUNCTION
C**                                         REFSTF IN FLOAT.POINT UMGESETZT;
C**                                         REFMIN MUSS DEFINIERT SEIN, WENN
C**                                         NICHT, D.H. ALLE BITS SIND GESETZT,
C**                                                        -> IRM = 16, NUR DIE
C**                                                           ERSTEN 11 BYTES
C**                                                           WERDEN EXTRAHIERT
C**                    5    11      NRBIT   ANZAHL BITS PRO GEPACKTEN WERT
C**                   GITTERPUNKTDATEN, SP:
C**                   ---------------------
C**                    6 )
C**                    : )   -              UNBENUTZT
C**                   11 )
C**                    -    12..LBD1        'GEPACKTE' DATEN
C**
C**                   ----------------------------------------------------------
C**                   SPHERICAL HARMONIC COEFFICIENTS, SP:
C**                   ------------------------------------
C**                 *  R2   12 -15  RPCOE   REAL PART VOM (0.0) KOEFFIZIENTEN,
C**                                         WIRD MIT DER FUNCTION REFSTF UMGE-
C**                                         SETZT
C**                    7 )
C**                    : )   -              UNBENUTZT
C**                   11 )
C**                    -    16..LBD1        'GEPACKTE' DATEN
C**
C**                   ----------------------------------------------------------
C**                   GITTERPUNKTDATEN, 2.OP:
C**                   -----------------------
C**                    6    12 -13  N1      BYTE-ADRESSE AN DER 1.ORDNUNG-GEP.
C**                                         DATEN BEGINNEN
C**                    7    14      IFLGE   ERWEITERTE FLAG (CODE TABLE 11)
C**                    8    15 -16  N2      BYTE-ADRESSE AN DER 2.ORDNUNG-GEP.
C**                                         DATEN BEGINNEN
C**                    9    17 -18  P1      ANZAHL DER 1.ORDNUNG-GEP. DATEN
C**                   10    19 -20  P2      ANZAHL DER 2.ORDNUNG-GEP. DATEN
C**                   11    21      IRESV   RESERVIERT
C**                   -----------------------------------------------
C**                   FOLGENDE DATEN NOCH NICHT DEFINIERT
C**                   -----------------------------------------------
C**                   12    22    )         1 WEITE ODER P1-WEITEN (JE 1 BYTE)
C**                    :     :    ) NWBIT   VON 2.ORDNUNG-GEP. DATEN IN BITS;
C**                   nn    xx-1  )         nn = 11 + P1, xx = 22 + P1
C**                                         ??? MAX.ANZAHL FUER NWBIT ???
C**                                         (16BIT -> MAX.65534 WERTE MOEGLICH!)
C**                   nn+1  xx     )        2. BITMAP; P2-BITS LANG; AUFGEFUELLT
C**                    :     :     ) I2BMP  MIT BINAEREN NULLEN ZUM GANZEN BYTE;
C**                   mm    yy     )        yy = xx + (P2-1)/IBYTE, mm = N1 - xx
C**
C**                   mm+1  N1    )         P1 1.ORDNUNG GEP. DATEN; AUFGEFUELLT
C**                    :     :    )         MIT BINAEREN NULLEN ZUM GANZEN BYTE
C**                   mm+P1 N2-1  )
C**
C**                    -    N2..LBD1        P2 * 2.ORDNUNG 'GEPACKTE' DATEN
C**
C**                   ----------------------------------------------------------
C**                   SPH.HARMONIC COEF., CP:
C**                   -----------------------
C**                    6    12 -13  N       BYTE-ADRESSE, AN DER GEPACKTE DATEN
C**                                         BEGINNEN;     N = (IUDZ*4) + 19
C**                    7    14 -15  IP      SCALE FACTOR,
C**                                         OBERSTE BIT GESETZT, D.H., DER WERT
C**                                         WIRD OHNE DAS OBERSTE BIT NEGATIV
C**                                         UMGESETZT
C**                                         IP = INT(1000 * P)
C**                    8    16      J     )
C**                    9    17      K     ) PENTAGONAL RESOLUTION PARAMETERS
C**                   10    18      M     )
C**                   11     -      IUDZ    ANZAHL DER 'UNGEPACKTEN' DATEN
C**                  (R2    19    )         'UNGEPACKTE' DATEN (a 4 BYTES),
C**                 *( :     :    ) IUD     WERDEN MIT DER FUNCTION REFSTF UMGE-
C**                  (IUDZ+1 N-1  )         SETZT, IUDZ=(N-19)/4,
C**                    -    N..LBD1         'GEPACKTE' DATEN
C**
C**                IBMP2     2. BITMAP  (IBMAP(100/200) )  NUR BEI 2.ORDER-
C**                IWIDTH    WEITEN     (IWIDTH(500)    )      PACKING
C**
C**                DSUP                     REAL-DATENWERTE
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                    1     7 -10  REFMIN  SIEHE UNTER R1
C**                        ENTWEDER
C**                    2    12 -15  RPCOE   REAL PART VOM (0.0) KOEFFIZIENTEN,
C**                                         (SIEHE R2, SPHER.HARM.COEFF., SP)
C**                        ODER
C**                    2        19)
C**                    :         :) UD      UNGEPACKTE DATEN
C**                    IUDZ+1  N-1)         (SIEHE R2, SPHER.HARM.COEFF., CP)
C**
C**                -------------------------------------------------------------
C**                IDANZ    : 6 WERTE, ANZAHL DER EXTRAHIERTEN DATEN:
C**                --------------------------------------------------
C**                (1)       IANZ,   TATS. DATEN-ANZAHL VON IWERT
C**                (2)       IZDATA, TATS. DATEN-ANZAHL VON DSUP
C**                (3)       ILBMP,  TATS. DATEN-ANZAHL VON IBMP2
C**                (4)       IZWDTH, TATS. DATEN-ANZAHL VON IWIDTH
C**                (5)       IZBT2,  TATS. BITANZAHL IN IBMP2
C**                (6)       IBYTAZ, AKT.  BYTEADRESSE DES DATENSATZES
C**                IRM      : FEHLER-RUECKMELDUNG: WENN IRM UNGLEICH NULL
C**
C**   HINWEIS: DIE MIT * GEKENNZEICHNETEN DATEN WERDEN ALS REAL-DATEN UNTER DEM
C**            ARRAY DSUP  ZURUECKGEGEBEN,
C**            SIE WERDEN IM UP MIT DER FUNCTION REFSTF UMGESETZT
C**
C**   VERFASSER:   A.ZALEWSKY, TE23C, DEZ. 94
C     MODIFICATION: Aenderung der UP-Beschreibung am 03.11.1997, A.Zalewsky
C                   Anpassung Symbole, 07/00, B. Loeser
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IEDNR, IBYTA, IBDIM, IBLOCK, IWERT, IBMP2, IWIDTH, IDANZ
      INTEGER IRM
      INTEGER MXWERT, MXDAT, MXBP2, MXWDTH, JWERT, IL000, IL064, IL192
      INTEGER MSK1, MSK15, MSK4F, MSK8F, MSK_128, MSKC128, MSK__64
      INTEGER MSK_C64, MSK__32, MSK_C32, MSK__16, MSK_C16, IAW, IEW
      INTEGER NWERT, NDSUP, NBMP2, NWIDTH, NBLOCK, IUNDEF, JXWERT, JXDAT
      INTEGER JXBP2, JXWDTH, ILBMP, IZWDTH, IZDATA, IZBT2, J, IBLA, IBLL
      INTEGER IANF, IZW, IANZ, IFLAG, IPACK, IVALU, IFLGE, JJ, IMATR
      INTEGER I2BMP, IWDTH, NRBIT, NUNCO

#if defined(TEST)
      INTEGER IBDSW, IBTR
#endif

      REAL    DSUP, REFMIN, REFSTF, RPCOE, RUD

#include "machconsts.h"

      PARAMETER (MXWERT=11, MXDAT=73, MXBP2=100, MXWDTH=500)

      DIMENSION    IWERT(*), DSUP (*), IBLOCK(*), JWERT(MXWERT),
     +             IBDIM(*), IDANZ(*), IBMP2(*), IWIDTH(*),
     +             IL000(6), IL064(6), IL192(5)

C.....LAENGEN DER EINZELWERTE IN BYTES FUER JEDE PACKUNGSART
C.....GITTERPUNKTWERTE, SP: ILOOO(1..5)
C.....SECTION-AUFBAU BEI SP.HARM COEF., SP: IL000(1..6)
      DATA IL000   / 3, 1, 2, 4, 1, 4/

C.....GITTERPUNKTWERTE,2.OP
      DATA IL064                  / 2, 1, 2, 2, 2, 1/
C.....SECTION-AUFBAU BEI SP.HARM COEF., CP
      DATA IL192                  / 2, 2, 1, 1, 1/

C.....DATA IBTA    /1, 4, 5, 7, 11, 12/
C.....DATA IBTAC   /1, 4, 5, 7, 11, 12, 14, 16, 17, 18 /
C.....DATA IBLEC   /3, 1, 2, 4,  1,  2,  2,  1,  1,  1 /

      DATA MSK1     /Z'8000'/
      DATA MSK15    /Z'7FFF'/
      DATA MSK4F    /Z'FFFF'/
      DATA MSK8F    /Z'FFFFFFFF'/
      DATA MSK_128  /Z'80' /
      DATA MSKC128  /Z'7F' /
      DATA MSK__64  /Z'40' /
      DATA MSK_C64  /Z'3F' /
      DATA MSK__32  /Z'20' /
      DATA MSK_C32  /Z'1F' /
      DATA MSK__16  /Z'10' /
      DATA MSK_C16  /Z'0F' /

      IRM        = 0
      IAW        = 0
      IEW        = 0

#if defined(TEST)
      IZW        = IBYTA - 1
      IBDSW      = (IZW / IBYTW) + 1
      IBTR       = MOD(IZW, IBYTW) + 1
      PRINT '('' GETBD1: IBYTA='',I3,'', IBLOCK('',I2,''),'',/,
     +        ''                    BDS AB BYTE '',I2)',
     +                   IBYTA, IBDSW, IBTR
      CALL ARBITI (IBLOCK(IBDSW),10)
#endif 

      NWERT      = IBDIM(1)
      NDSUP      = IBDIM(2)
      NBMP2      = IBDIM(3)
      NWIDTH     = IBDIM(4)
      NBLOCK     = IBDIM(5)
      IUNDEF     = IBDIM(6)

      JXWERT     = MXWERT
C.....DIMENSIONIERUNG UEBER PARAMETER, NWERT AUSREICHEND ?
      IF (NWERT .LT. MXWERT)                THEN
         PRINT '('' GETBD1: MXWERT='',I5,'', NUR NWERT='',I4,
     +           '' -DATEN WERDEN NACH IWERT GESPEICHERT !'')',
     +                      MXWERT, NWERT
         JXWERT  = NWERT
      ENDIF

      JXDAT      = MXDAT
C.....DIMENSIONIERUNG UEBER PARAMETER, NDSUP  AUSREICHEND ?
      IF (NDSUP  .LT. MXDAT)                THEN
         PRINT '('' GETBD1: MXDAT='',I5,'', NUR NDSUP ='',I4,
     +           '' -DATEN WERDEN NACH DSUP  GESPEICHERT !'')',
     +                      MXDAT, NDSUP
         JXDAT   = NDSUP
      ENDIF

      JXBP2      = MXBP2
C.....DIMENSIONIERUNG UEBER PARAMETER, NDSUP  AUSREICHEND ?
      IF (NBMP2 .LT. MXBP2)                 THEN
         PRINT '('' GETBD1: MXBP2='',I5,'', NUR NBMP2='',I4,
     +           '' -DATEN WERDEN NACH IBMP2 GESPEICHERT !'')',
     +                      MXBP2, NBMP2
         JXBP2   = NBMP2
      ENDIF

      JXWDTH     = MXWDTH
C.....DIMENSIONIERUNG UEBER PARAMETER, NDSUP  AUSREICHEND ?
      IF (NWIDTH .LT. MXWDTH)               THEN
         PRINT '('' GETBD1: MXWDTH='',I5,'', NUR NWIDTH='',I4,
     +           '' -DATEN WERDEN NACH IWIDTH GESPEICHERT !'')',
     +                      MXWDTH, NWIDTH
         JXWDTH  = NWIDTH
      ENDIF

      IRM        = 0
      IAW        = 0
      IEW        = 0
      ILBMP      = 0
      IZWDTH     = 0
      IZDATA     = 0
      IZBT2      = 0
C.....ZIEL-ARRAY LOESCHEN
      DO 10 J    =  1, MXWERT
   10 JWERT(J)   = 0
      IBLA       = IBYTA

C.....ERSTEN 5 DATENWERTE AUS DER BDS HOLEN
      DO 20 J    = 1, 5
      IBLL       = IL000(J)
      IANF       = IBYTW - IL000(J) + 1
      CALL         SPUMB (IBLOCK(1),IBLA,IBLL,IANF,JWERT(J),IRM)
      IF         ( IRM .NE. 0)         RETURN
      IBLA       = IBLA + IBLL
   20 CONTINUE
C.....ISCAL      = JWERT(3), UNDEF ABFRAGEN
      IZW        = JWERT(3)
      IF ((IAND( IZW,MSK4F)) .EQ. MSK4F)     THEN
         IRM     = 15
         PRINT '('' GETBD1: ACHTUNG-FEHLER, ISCAL ='',Z17,
     +           ''; --> IRM=15 '')', JWERT(3)
C........KEIN RETURN, GEAENDERT 03.97, ZAL.
C        RETURN
      ELSE
C........IST DAS OBERSTE BIT DER 2 BYTES GESETZT, WIRD UNTER WEGLASSEN DES
C        OBERSTEN BITS DER SKALIERUNGSFAKTOR NEGATIV UMGESETZT.
         IF ((IAND(IZW,MSK1)) .EQ. MSK1)     THEN
            IZW     = IAND (IZW,MSK15)
            JWERT(3)= -IZW
         ENDIF
      ENDIF

C.....JWERT(4)   = REFMIN, UNDEF ABFRAGEN
      IZW        = JWERT(4)
      IF ((IAND( IZW,MSK8F)) .EQ. MSK8F)     THEN
         IRM     = 16
         PRINT '('' GETBD1: ACHTUNG-FEHLER, REFMIN='',Z17,
     +           ''; --> IRM=16 '')', JWERT(4)
C........KEIN RETURN, GEAENDERT 03.97, ZAL.
C        RETURN
      ENDIF

C.....NEU: FEHLER IN ISCAL UND/ODER REFMIN; 03.97, ZAL.
      IF (IRM .NE. 0)                       THEN
         IANZ    = 5
         GOTO 900
      ENDIF

C.....MIT REFSTF NACH DSUP (1) SETZEN
      REFMIN     = REFSTF(JWERT(4))
      DSUP (1)   = REFMIN

C.....IFLAG BESTIMMEN, BIT1-4 VON BYTE 4, BZW. JWERT(2)
C.....ABFRAGE:  IF  (IAND(MSK_128,IZW) .EQ. MSK_128)
C.....REST:  IZW = IAND (MSKC128, IZW)
      IZW        = JWERT(2)
      IFLAG      = IAND (MSK_128, IZW)
      IZW        = IAND (MSKC128, IZW)
      IPACK      = IAND (MSK__64, IZW)
      IZW        = IAND (MSK_C64, IZW)
      IVALU      = IAND (MSK__32, IZW)
      IZW        = IAND (MSK_C32, IZW)
      IFLGE      = IAND (MSK__16, IZW)

C.....GITTERPUNKTE ODER SPHER.HARM.KOEFF.?
      IF (IFLAG .EQ. MSK_128)               GOTO 500

C.....GITTERPUNKTE..............................................................
C.....SIMPLE PACKING ODER PACKEN 2.ORDNUNG ?
      IF (IPACK .EQ. MSK__64)               GOTO 100

C.....SIMPLE PACKING, ALLE DATEN SIND BEREITS GEHOLT............................
      IANZ       = 5
      GOTO 900

  100 CONTINUE
C.....PACKEN 2.ORDNUNG..........................................................
      IANZ       = 11
      IF (IANZ .GT. JXWERT)                 THEN
         PRINT '('' GETBD1: 2.ORDER; JXWERT='',I5,'', IANZ='',I4,
     +           '' -> IRM = 1 UND RETURN !'')',
     +                      JXWERT, IANZ
         IRM     = 1
         RETURN
      ENDIF

      DO 110   J = 6, IANZ
      JJ         = J - 5
      IBLL       = IL064(JJ)
      IANF       = IBYTW - IL064(JJ) + 1
      CALL         SPUMB (IBLOCK(1),IBLA,IBLL,IANF,JWERT(J),IRM)
      IF         ( IRM .NE. 0)              RETURN
      IBLA       = IBLA + IBLL
  110 CONTINUE

C.....FLOAT.POINT ODER INTEGER-DATEN
      IF (IVALU .EQ. MSK__32)               THEN
         PRINT '('' GETBD1: FEHLER; INTEGER-DATEN N. DEFINIERT='')'
         IRM     = 1
         RETURN
      ENDIF

C.....1.ORDNUNG GEPACKTE DATEN
      IZW        = JWERT(7)
      IZW        = IAND (MSKC128, IZW)
      IMATR      = IAND (MSK__64, IZW)
      IZW        = IAND (MSK_C64, IZW)
      I2BMP      = IAND (MSK__32, IZW)
      IZW        = IAND (MSK_C32, IZW)
      IWDTH      = IAND (MSK__16, IZW)

C.....MATRIX FUER JEDEN GITTERPUNKT-WERT ?
      IF (IMATR .EQ. MSK__64)               THEN
C........Z. ZT. NOCH NICHT DEFINIERT
         PRINT '('' GETBD1: MATRIX FUER GPKT.-WERTE NICHT DEFINIERT'')'
         IRM     = 1
         RETURN
      ENDIF

      IZWDTH     = 0
C.....2.ORDNUNG GEPACKTE DATEN MIT VERSCHIEDENER WEITE ?
      IF (IWDTH .EQ. MSK__16)               THEN

C........JA, VERSCHIEDENE WEITEN, PRO WEITE 1 BYTE
         IZWDTH  = JWERT( 9)
C........DIMENSIONIERUNG AUSREICHEND ?
         IF (IZWDTH .GT. NWIDTH)            THEN
            PRINT '('' GETBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +              ''  - IZWDTH, NWIDTH='',2I5)', IZWDTH, NWIDTH
            IRM  = 1
            RETURN
         ENDIF
         IBLL    = 1
         DO 310 J= 1, IZWDTH
         IANF    = IBYTW - IBLL + 1
         IWIDTH(J)= 0
         CALL SPUMB (IBLOCK(1),IBLA,IBLL,IANF,IWIDTH(J),IRM)
         IF (IRM .NE. 0)                    RETURN
         IBLA    = IBLA + IBLL
  310    CONTINUE
      ELSE
C........NEIN, 1 WEITE PRO 1 BYTE
         IZWDTH  = 1
C........DIMENSIONIERUNG AUSREICHEND ?
         IF (IZWDTH .GT. NWIDTH)            THEN
            PRINT '('' GETBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +              ''  - IZWDTH, NWIDTH='',2I5)', IZWDTH, NWIDTH
            IRM  = 1
            RETURN
         ENDIF
         J       = IZWDTH
         IBLL    = 1
         IANF    = IBYTW - IBLL + 1
         CALL SPUMB (IBLOCK(1),IBLA,IBLL,IANF,IWIDTH(J),IRM)
         IF (IRM .NE. 0)                    RETURN
         IBLA    = IBLA + IBLL
      ENDIF

      ILBMP      = 0
C.....2.BITMAP ?
      IF (I2BMP .EQ. MSK__32)               THEN

C........MIT 2. BITMAP..........................................................
         IAW     = 1
         IZBT2   = JWERT(10)
         ILBMP   = ((IZBT2 - 1) / IBMAX) + 1
C........DIMENSIONIERUNG AUSREICHEND ?
         IF (ILBMP .GT. NBMP2)              THEN
            PRINT '('' GETBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +              ''  - ILBMP, NBMP2='',2I5)', ILBMP, NBMP2
            IRM  = 1
            RETURN
         ENDIF
         IBLL    = IBYTW
         DO 410 J= 1, ILBMP
         IANF    = IBYTW - IBLL + 1
         IBMP2(J)= 0
         CALL SPUMB (IBLOCK(1),IBLA,IBLL,IANF,IBMP2(J),IRM)
         IF (IRM .NE. 0)                    RETURN
         IBLA    = IBLA + IBLL
  410    CONTINUE
      ENDIF

C.....1.ORDER PACKED VALUES NACH DSUP (2).......................................
      NRBIT      = JWERT(5)
      IBLL       = NRBIT / IBYTE

C.....DIMENSIONIERUNG AUSREICHEND ?
      IZDATA     = JWERT(9)
      IF (IZDATA .GT. NDSUP )               THEN
         PRINT '('' GETBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +           ''  - IZDATA, NDSUP ='',2I5)', IZDATA, NDSUP
         IRM     = 1
         RETURN
      ENDIF

      DO 420 J   = 1, IZDATA
      JJ         = J + 1
      IANF       = IBYTW - IBLL + 1
      IZW        = 0
      CALL SPUMB (IBLOCK(1),IBLA,IBLL,IANF,IZW,IRM)
      IF (IRM .NE. 0)                       RETURN
      IBLA       = IBLA + IBLL
      DSUP (JJ)  = REFSTF(IZW)
  420 CONTINUE
      GOTO 900

C...............................................................................
  500 CONTINUE
C.....SPHER.HARM.KOEFF..........................................................
      IF (IPACK .EQ. MSK__64)               GOTO 600

C.....SIMPLE PACKING............................................................
      IANZ       = 6
      J          = IANZ
      IBLL       = IL000(J)
      IANF       = IBYTW - IL000(J) + 1
      CALL         SPUMB (IBLOCK(1),IBLA,IBLL,IANF,JWERT(J),IRM)
      IF         ( IRM .NE. 0)         RETURN
      IBLA       = IBLA + IBLL
C.....JWERT(6)   = RPCOE, MIT REFSTF NACH DSUP (2) SETZEN
      RPCOE      = REFSTF(JWERT(6))
      DSUP (2)   = RPCOE
      DO 510  J  = 7, 10
  510 JWERT  (J) = IUNDEF
      JWERT (11) = 2

      GOTO 900

  600 CONTINUE
C.....COMPLEX PACKING...........................................................

      IANZ       = 10
      DO 610   J = 6, IANZ
      JJ         = J - 5
      IBLL       = IL192(JJ)
      IANF       = IBYTW - IL192(JJ) + 1
      CALL         SPUMB (IBLOCK(1),IBLA,IBLL,IANF,JWERT(J),IRM)
      IF         ( IRM .NE. 0)         RETURN
      IBLA       = IBLA + IBLL
  610 CONTINUE
      IZW        = JWERT(7)
      IF ((IAND( IZW,MSK4F)) .EQ. MSK4F)     THEN
         IRM     = 17
         PRINT '('' GETBD1: ACHTUNG-FEHLER, COMPL.PCKG., SCAL ='',Z17,
     +           ''; --> IRM=17 '')', JWERT(7)
C........KEIN RETURN, GEAENDERT 03.97, ZAL.
C        RETURN
      ELSE
C........IST DAS OBERSTE BIT DER 2 BYTES GESETZT, WIRD UNTER WEGLASSEN DES
C        OBERSTEN BITS DER SKALIERUNGSFAKTOR NEGATIV UMGESETZT.
         IF ((IAND(IZW,MSK1)) .EQ. MSK1)     THEN
            IZW     = IAND (IZW,MSK15)
            JWERT(7)= -IZW
         ENDIF
      ENDIF


C.....UNGEPACKTE DATEN BERECHNEN
      NUNCO      = (JWERT(6) - 19) / 4
      JWERT (11) = NUNCO
      IANZ       = 11
      IF (IANZ .GT. JXWERT)                 THEN
         PRINT '('' GETBD1: COMPLEX; JXWERT='',I5,'', IANZ='',I4,
     +           '' -> IANZ=10 STATT 11 !'')',
     +                      JXWERT, IANZ
         IANZ    = 10
      ENDIF


      IAW        = 1
      IEW        = NUNCO
C.....DIMENSIONIERUNG AUSREICHEND ?
      IF (NUNCO .GT. JXDAT)                  THEN
         PRINT '('' GETBD1: NUNCO >'',I5,'', USER-DIMENSION'',
     +           '' UEBERSCHRITTEN !'')', NUNCO, JXDAT
         PRINT '(''            NUR '',I5,'', DATEN-WERTE WERDEN'',
     +           '' NACH DSUP  GESCHRIEBEN !'')', JXDAT
         IEW     = JXDAT
      ENDIF

      DO 620   J = 1, IEW
      JJ         = J + 1
      IBLL       = 4
      IANF       = IBYTW - IBLL + 1
      IZW        = 0
      CALL         SPUMB (IBLOCK(1),IBLA,IBLL,IANF,IZW,IRM)
      IF         ( IRM .NE. 0)         RETURN
C.....JWERT(J)   = IUD, MIT REFSTF NACH DSUP (2..) SETZEN
      RUD        = REFSTF(IZW)
      DSUP (JJ)  = RUD
      IBLA       = IBLA + IBLL
  620 CONTINUE
      IZDATA     = IEW

C.....DATEN NACH IWERT UMSPEICHERN..............................................
  900 CONTINUE
      IDANZ(1)   = IANZ
      IDANZ(2)   = IZDATA
      IDANZ(3)   = ILBMP
      IDANZ(4)   = IZWDTH
      IDANZ(5)   = IZBT2
      IDANZ(6)   = IBLA

      DO 910   J = 1, JXWERT
  910 IWERT(J)   = JWERT(J)

      END
