      SUBROUTINE GETBM1  (IEDNR,IBYTA,NBLOCK,NWERT,NBMAP,IBLOCK,
     +                    IWERT,IBMAP,IANZ,IRM)

C**** GETBM1   -   BIT-MAP-SECTION (BMS, GRIB-CODE) ZERLEGEN
C**   AUFRUF     : CALL GETBM1 (IEDNR,IBYTA,NBLOCK,NWERT,NBMAP,IBLOCK,
C**               +             IWERT,IBMAP,IANZ,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : AUS IBLOCK WERDEN DIE ERSTEN 6 BYTES - KENNDATEN - NACH IWERT
C**                GESPEICHERT
C**   PARAMETER  : INPUT   : IEDNR,IBYTA,NBLOCK,NWERT,NBMAP,IBLOCK
C**                IEDNR   : EDITIONSNUMMER (IEDNR=1 AB 11/94)
C**                IBYTA   : ANFANGSADRESSE DER BMS IM FELD IBLOCK,
C**                          IN BYTES BERECHNET.
C**                                                            64 bit/32 bit
C**                NBLOCK  : USER-DIMENSIONIERUNG VON IBLOCK   (81000/162000)
C**                NWERT   : USER-DIMENSIONIERUNG VON IWERT         (3)
C**                NBMAP   : USER-DIMENSIONIERUNG VON IBMAP     (3500/7000)
C**                IBLOCK  : ENTHAELT ALS DRITTEN BLOCK DIE BITMAP-SECTION
C**                OUTPUT  : IWERT, IBMAP, IANZ, IRM
C**                IWERT   : 3 WORTE KENNDATEN FUER DIE BMS
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (1)    1 - 3  LBMS    LAENGE DER BMS IN BYTES
C**                   (2)    4      NUNUSB  UNBENUTZTE BITS AM ENDE DER BMS
C**                   (3)    5 - 6  NRBMAP  ZEIGT AN, OB EINE BITMAP FOLGT,ODER
C**                                         OB DIESE AUF EINEM FILE ABGELEGT IST
C**                                         =0 : BITMAP FOLGT,
C**                                         >0 : BITMAP-NUMMER, UNTER DER BITMAP
C**                                              ABGELEGT IST
C**                IBMAP   : BITMAP, SOFERN IN DER SECTION ABGESPEICHERT
C**                IANZ    : ANZAHL DER GITTERPUNKTE IN IBMAP
C**                IRM     : FEHLER-RUECKMELDEZELLE
C**                          FEHLER, WENN IRM UNGLEICH NULL
C**   VERFASSER:   A. ZALEWSKY, SEPTEMBER 1994
C     MODIFICATION: Im PARAMTER-Statement MBMAP gestr. am 03.11.1997, A.Zalewsky
C                   Anpassung Symbole, 07/00, B. Loeser
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C*                 Falls NBMAP == -1 wird IBMAP nicht besetzt

      IMPLICIT NONE

      INTEGER IEDNR, IBYTA, NBLOCK, NWERT, NBMAP, IBLOCK, IWERT, IBMAP
      INTEGER IANZ, IRM
      INTEGER MWERT, IBTA, IBLE, IBLA, J, IBLL, IANF, IBL, IWBL, NUNUSB

#include "machconsts.h"

      PARAMETER (MWERT=3)

      DIMENSION IWERT(*), IBLOCK(*), IBMAP(*),
     +          IBTA(3), IBLE(3)

      DATA IBTA /1,4,5/
      DATA IBLE /3,1,2/

      IF (NWERT .LT. MWERT)                 THEN
         PRINT '('' GETBM1: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
      IBLA       = IBYTA

      DO 100 J   = 1, MWERT
      IWERT(J)   = 0
      IBLL       = IBLE(J)
      IANF       = IBYTW - IBLE(J) + 1
      CALL SPUMB (IBLOCK,IBLA,IBLE(J),IANF,IWERT(J),IRM)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GETBM1: FEHLER IN SPUMB - IBLA,IWERT('',I1,'')='',
     +                               2I7)', J,IBLA,IWERT(J)
         RETURN
      ENDIF
      IBLA       = IBLA + IBLL
  100 CONTINUE

      IANZ       = 0
      IF (IWERT(3) .NE. 0)                  RETURN

C.....BITMAP BEREISTELLEN, ANZAHL DER GITTERPUNKTE BERECHNEN
      IBL        = IWERT(1) - 6
      IWBL       = ((IBL-1)/IBYTW) + 1
      NUNUSB     = IWERT(2)
      IANZ       = (IBL * IBYTE) - NUNUSB

      IF (NBMAP .EQ. -1) RETURN

      IF (IWBL .GT. NBMAP)                  THEN
         PRINT '('' GETBM1: FEHLER - ERRECHNETE BITMAP-LAENGE='',I6,
     +           '' > BITMAP-DIMENSION'',/,
     +           ''         RETURN MIT IRM = 1'')', IWBL
         IRM     = 1
         RETURN
      ENDIF

      IANF       = 1
      CALL SPUMB (IBLOCK,IBLA,IBL,IANF,IBMAP(1),IRM)
      IF (IRM .NE. 0)                       RETURN

      END
