      SUBROUTINE GETGD1  (IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK,
     +                    IWERT, IANZ, IRM)

C**** GETGD1   -   GRID-DEFINITION-SECTION (GDS, GRIB-CODE, IEDNR=1) ZERLEGEN
C**   AUFRUF     : CALL GETGD1  (IEDNR,IBYTA,IUNDEF,NBLOCK,NWERT,IBLOCK,
C**               +              IWERT,IANZ,IRM)
C**   EXTERNALS  : SPUMB, GGD1_00, GGD1_01, GGD1_02, GGD1_03, GGD1_04, GGD1_05,
C**                       GGD1_50, GGD1_90, GGD1_192
C**   ZWECK      : AUS IBLOCK WERDEN DIE KENNDATEN DER GDS EXTRAHIERT
C**   PARAMETER  : INPUT   : IEDNR,IBYTA,IUNDEF,NBLOCK,NWERT,IBLOCK
C**                ------------------------------------------------
C**                IEDNR   : GRIB-EDITIONS-NUMMER; IEDNR = 1, GUELTIG AB 11/1994
C**                IBYTA   : ANFANGSADRESSE DER GDS IN BYTES IM FELD IBLOCK
C**                IUNDEF  : INTEGER-WERT, MIT DEM UNDEFINIERTE DATEN (ALLE BITS
C**                          GESETZT) NACH IWERT UEBERGEBEN WERDEN
C**                NBLOCK  : USER-DIMENSION VON IBLOCK: IBLOCK(NBLOCK)
C**                NWERT   : USER-DIMENSION VON IWERT:   IWERT(NWERT)
C**                IBLOCK  : IBLOCK ENTHAELT ALS 2.SECTION DIE GDS, NACH DER PDS
C**                OUTPUT  : IWERT,IANZ,IRM
C**                ------------------------
C**                IWERT   : 626 KENNDATEN FUER DIE GDS;
C**                          IWERT(  1..  4) - STEUERPARAMETER,
C**                          IWERT(  5.. 25) - GRID-DEFINITIONEN,
C**                          IWERT( 26..225) - MAX. 200 VERTIKALKOORDINATEN,
C**                                            ANZAHL DER VERT.KOOR. STEHT IN NV
C**                          IWERT(226)      - ANZAHL DER FOLG. WERTE (REIHEN)
C**                                            FUER PROGRAMM-INTERNEN ABLAUF,
C**                                            SIEHE PARAMETER NJ BZW. IWERT(7)
C**                          IWERT(227..626) - MAX. 400 WERTE GPKT.ANZAHLEN PRO
C**                                            REIHE
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (1)    1 - 3  LGD1    GDS-LAENGE IN BYTES;       LGD1 =
C**                                         32/42/44/52 + (4 * NV) + (2 * NJ)
C**                   (2)    4      NV      ANZAHL DER VERTIKAL-KOORDINATEN
C**                                         WENN VERTIKAL-KOORDINATEN, DANN
C**                   (3)    5      PV      ADRESSE IN BYTES DER VERTIKAL-KOOR-
C**                                         DINATEN-PARAMETER
C**                                    ODER KEINE VERTIKAL-KOORDINATEN, DANN
C**                   (3)    5      PL      ADRESSE IN BYTES DER LISTE DER GPKT.
C**                                         -ANZAHLEN IN JEDER REIHE
C**                                    ODER WEDER PV NOCH PL, DANN
C**                   (3)    5      255     ALLE BITS GESETZT
C**                   (4)    6      IDRTYP  PROJEKTIONSART ( CODE-TABLE 6 )
C**                     (   ----------------------------------------------------
C**                     (    7 -  32        GRID-DEFINITION ABHAENGIG VON IDRTYP
C**                     (   33 -  42        EXTENSIONS FOR ROT. OR STRETCH. SYS.
C**                     (   33 -  44        EXTENSIONS FOR SPACE VIEW PERSP.PROJ.
C**                     (   33 -  52        EXTENSIONS FOR ROT. AND STRETCH. SYS.
C**                     (     WENN VORHANDEN,
C**                     (   PV              LISTE DER VERTIKAL-KOORDINATEN
C**                     (                   (LAENGE = NV * 4 BYTES)
C**                     (     WENN VORHANDEN,
C**                     (   PL              LISTE DER GITTERPUNKTANZAHL IN JEDER
C**                     (                   REIHE,  LAENGE = NROWS * 2 BYTES,
C**                     (                    NROWS BZW. NJ = ANZAHL DER REIHEN,
C**                     (                   ADRESSE VON PL = 4 NV + PV
C**                     (   ----------------------------------------------------
C**
C**                -------------------------------------------------------------
C**                E N T W E D E R :        IDRTYP= 0, REGULAR LAT./LONG. GRID :
C**                                                10, ROT.       - " -
C**                                                20, STR.       - " -
C**                                                30, ROT./STR.  - " -
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NI      GPKTE. ENTLANG EINES PARALLELKREISES
C**                   (6)    9 -10  NJ      GPKTE. ENTLANG EINES MERIDIANS
C**               ( 7-25)                   SIEHE UP GGD1_00
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**                         33-832          FUER IDRTYP =  0
C**               (26-225)  43-842  IVKOP   FUER IDRTYP = 10 / 20
C**                         53-852          FUER IDRTYP = 30
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP=1 , MERCATOR-PROJEKTION :
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NI      GPKTE. ENTLANG EINES PARALLELKREISES
C**                   (6)    9 -10  NJ      GPKTE. ENTLANG EINES MERIDIANS
C**               ( 7-25)                   SIEHE UP GGD1_01
C**               (26-225)  43-842  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**                .............................................................
C**   !!!!!        IDRTYP=2, IM NEUEN GRIB-CODE NICHT BESCHRIEBEN; ALTE VERSION:
C**                .............................................................
C**
C**                O D E R :                IDRTYP=2 , STEREOGR. PROJEKTION :
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. IN X-RICHTUNG
C**                   (6)    9 -10  NY      GPKTE. IN Y-RICHTUNG
C**               ( 7-25)                   SIEHE UP GGD1_02
C**               (26-225)  33-832  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP= 3, LAMBERT OD. ALBERS PROJ.:
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. ENTLANG DER X-ACHSE
C**                   (6)    9 -10  NY      GPKTE. ENTLANG DER Y-ACHSE
C**               ( 7-25)                   SIEHE UP GGD1_03
C**               (26-225)  43-842  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP= 4, GAUSSIAN LAT./LONG. GRID:
C**                                                14, ROT.        - " -
C**                                                24, STR.        - " -
C**                                                34, ROT./STR.   - " -
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NI      GPKTE. ENTLANG EINES PARALLELKREISES
C**                   (6)    9 -10  NJ      GPKTE. ENTLANG EINES MERIDIANS
C**               ( 7-25)                   SIEHE UP GGD1_04
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**                         33-832          FUER IDRTYP =  4
C**               (26-225)  43-842  IVKOP   FUER IDRTYP = 14 / 24
C**                         53-852          FUER IDRTYP = 34
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP= 5, POL.STEREOGR.PROJEKTION:
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. ENTLANG DER X-ACHSE
C**                   (6)    9 -10  NY      GPKTE. ENTLANG DER Y-ACHSE
C**               ( 7-25)                   SIEHE UP GGD1_05
C**               (26-225)  33-832  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**                O D E R : IDRTYP=50, SPHERICAL HARMONIC CO-EFFICIENTS :
C**                                 60, ROT.         - " -
C**                                 70, STR.         - " -
C**                                 80, ROT./STR.    - " -
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  JSHC    PENTAGONAL RESOLUTION PARAMETER
C**                   (6)    9 -10  KSHC    PENTAGONAL RESOLUTION PARAMETER
C**               ( 7-25)                   SIEHE UP GGD1_50
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**                         33-832          FUER IDRTYP = 50
C**               (26-225)  43-842  IVKOP   FUER IDRTYP = 60 / 70
C**                         53-852          FUER IDRTYP = 80
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP=90, SPACE VIEW PERSPECTIVE :
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. ENTLANG DER X-ACHSE (SPALTEN)
C**                   (6)    9 -10  NY      GPKTE. ENTLANG DER Y-ACHSE
C**                                         (REIHEN ODER ZEILEN)
C**               ( 7-25)                   SIEHE UP GGD1_90
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**               (26-225)  45-844  IVKOP
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP= 192, TRI-ANGULAR-GRID:
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  N2      FAKTORISRG. DES IKOSAEDERS BZGL. 2
C**                   (6)    9 -10  N3      FAKTORISRG. DES IKOSAEDERS BZGL. 3;
C**                                         N3 KANN NUR 0 ODER 1 SEIN, d.h.,
C**                                         ES ERFOLGT -WENN UEBERHAUPT- NUR IM
C**                                         1. TEILUNGSSCHRITT EINE DRITTELUNG
C**                                         DER DREIECKSSEITEN, DANACH NUR HAL-
C**                                         BIERUNGEN
C**               ( 7-25)                   SIEHE UP GGD1_192
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**               (26-225)  33-832  IVKOP   
C**
C**                -------------------------------------------------------------
C**                         ES FOLGT EINE LISTE DER PUNKTE IN JEDER REIHE:
C**                         ----------------------------------------------
C**                  (226)   -      NLIST   ANZAHL DER NACHFOLGENDEN WERTE,
C**                                         WENN KEIN ILIST, DANN NLIST = 0,
C**                                         NUR FUER PROGRAMM-INTERNEN ABLAUF
C**              (227-626)  PL      ILIST   ANZAHL DER PUNKTE IN JEDER REIHE,
C**                                         ADRESSE: PL = 4NV + PV
C**               ..............................................................
C**                IANZ     : ANZAHL DER ERSTEN 25 EXTRAH. DATEN-WERTE IN IWERT
C**                IRM      : FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) IST IM GRIBCODE DAS OBERSTE BIT VON 3
C**                              BYTES GESETZT UND DER WERT POSIT. ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN
C**                           4. MIT ** GEKENNZEICHNETE WERTE MUESSEN VOM USER
C**                              MIT DER FUNCTION REFSTF (SIEHE DWDLIB) UMGE-
C**                              RECHNET WERTDEN
C**
C**
C**   VERFASSER:   A. ZALEWSKY, SEPTEMBER 1994
C**   MODIF.:      NEU: IDRTYP=192                                  01.04.1998
C*                 Anpassung Symbole, B.Loeser, TI14, 07/00
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK, IWERT, IANZ
      INTEGER IRM
      INTEGER MWERT, NKOOR, NROWS, JWERT, IBALL, IBLE, IANZVK, J, IBLZ
      INTEGER IANF, IBLL, IDRTYP, LGDS, IGDSLB, LWORDS, IGDSWD, ITYPE
      INTEGER IBKOOR, IBLEV, LWA, LWE, IBDIF, IANZNR

#include "machconsts.h"

      PARAMETER (MWERT=626,NKOOR=200,NROWS=400)

      DIMENSION IBLOCK(*),IWERT(*),JWERT(MWERT),IBALL(4),IBLE(6)

      DATA IBALL / Z'FF'        ,
     +             Z'FFFF'      ,
     +             Z'FFFFFF'    ,
     +             Z'FFFFFFFF'  /

C     ...INDEX:    1 2 3 4 5 6
      DATA IBLE   /3,1,1,1,2,2/


      IF (MWERT .LT. NWERT)                 THEN
         PRINT '('' GETGD1: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
      IANZVK     = 0
C.....JWERT MIT NULL VORBESETZEN
      DO 10 J    = 1, MWERT
   10 JWERT(J)   = 0
      IBLZ       = IBYTA
#if defined(TEST)
      PRINT '('' GETGD1: IBLZ='',I6)', IBLZ
#endif 

C..................IWERT(1..6) .................................................
      DO 100 J   = 1, 6
      IANF       = IBYTW - IBLE(J) + 1
      IBLL       = IBLE(J)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GETGD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IF (JWERT(J) .EQ. IBALL(IBLL))
     + JWERT(J)  = IUNDEF
      IBLZ       = IBLZ + IBLL
  100 CONTINUE
      IANZ       = 6

      IDRTYP     = JWERT(4)
C     LAENGE DER GDS OHNE VERTIKALKOORDINATEN ERMITTELN MIT FUNCTION IGDSLB
      LGDS       = IGDSLB(IDRTYP,IEDNR)
      LWORDS     = IGDSWD(IDRTYP,IEDNR)
#if defined(TEST)
      PRINT '('' GETGD1: IEDNR, IDRTYP, LGDS, LWORDS, IBLZ='',5I4)',
     +                   IEDNR, IDRTYP, LGDS, LWORDS, IBLZ
#endif 

C     KEINE GUELTIGE PROJEKTIONSART GEFUNDEN
      IF (LGDS .LT. 0) THEN
         IRM     = 1
         PRINT '('' GETGD1: IEDNR, IDRTYP ='',2I4,
     +           '' NICHT DEFINIERT'')', IEDNR, IDRTYP
         RETURN
      ENDIF

C.....IBYTA AN UPS WEITERGEBEN; IM UP:  IBLZ = IBYTA + 10
      IF (IDRTYP.EQ. 0 .OR. IDRTYP.EQ.10    .OR.
     +    IDRTYP.EQ.20 .OR. IDRTYP.EQ.30)   THEN
         CALL GGD1_00 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 0
      ELSE IF              (IDRTYP.EQ. 1)   THEN
         CALL GGD1_01 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 1
      ELSE IF              (IDRTYP.EQ. 2)   THEN
         CALL GGD1_02 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 2
      ELSE IF              (IDRTYP.EQ. 3)   THEN
         CALL GGD1_03 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 3
      ELSE IF (IDRTYP.EQ. 4 .OR. IDRTYP.EQ.14    .OR.
     +         IDRTYP.EQ.24 .OR. IDRTYP.EQ.34)   THEN
         CALL GGD1_04 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 4
      ELSE IF              (IDRTYP.EQ. 5)   THEN
         CALL GGD1_05 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 5
      ELSE IF (IDRTYP.EQ.50 .OR. IDRTYP.EQ.60    .OR.
     +         IDRTYP.EQ.70 .OR. IDRTYP.EQ.80)   THEN
         CALL GGD1_50 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 50
      ELSE IF              (IDRTYP.EQ.90)   THEN
         CALL GGD1_90 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                 JWERT,IBLZ,IRM)
         ITYPE   = 90
      ELSE IF              (IDRTYP.EQ.192)  THEN
         CALL GGD1_192 (LWORDS,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
     +                  JWERT,IBLZ,IRM)
         ITYPE   = 192 
         IF (IRM.NE.0)                         THEN
            PRINT '('' GETGD1: FEHLER IN GGD1_'',I3.3,
     +              ''; IDRTYP,LWORDS,LGDS='',3I5)', ITYPE,
     +                  IDRTYP,LWORDS,LGDS
            RETURN
         ENDIF        
      ELSE
         IRM     = 1
         PRINT '('' GETGD1: IEDNR, IDRTYP ='',2I4,
     +           '' NICHT DEFINIERT'')', IEDNR, IDRTYP
         RETURN
      ENDIF
      IF (IRM.NE.0)                         THEN
         PRINT '('' GETGD1: FEHLER IN GGD1_'',I2.2,
     +           ''; IDRTYP,LWORDS,LGDS='',3I5)', ITYPE,
     +               IDRTYP,LWORDS,LGDS
         RETURN
      ENDIF
      IANZ       = LWORDS

  250 CONTINUE
#if defined(TEST)
      PRINT '('' GETGD1: GGD1_'',I2.2,
     +        ''; IBLZ,IDRTYP,LWORDS,LGDS='',4I5)', ITYPE,
     +            IBLZ,IDRTYP,LWORDS,LGDS
#endif 

C     VERTIKALKOORDINATEN EXTRAHIEREN, NUR WENN JWERT(2) > 0
      IANZVK     = JWERT(2)
      IF (IANZVK.LE.0)                      THEN
C........OHNE VERTIKALKOORDINATEN
         IBKOOR  = 0
         DO 251 J= 26, 225
  251    JWERT(J)= IUNDEF
         GOTO 300
      ELSE
C........MIT VERTIKALKOORDINATEN
         IF (IANZVK.GT.NKOOR)               THEN
#if defined(TEST)
            PRINT '('' GETGD1: FEHLER-'',I5,'' VERTIK.KOORDINATEN,'',/,
     +              ''                '',I5,'' WERDEN EXTRAHIERT'')',
     +                                   IANZVK, NKOOR
#endif 
            IANZVK  = NKOOR
         ENDIF

C...............................................................................
         IBLEV   = 4
         IBKOOR  = IANZVK * IBLEV
         LWA     = 26
         LWE     = 26 + IANZVK - 1
         IANF    = IBYTW - IBLEV + 1

         DO 260 J= LWA, LWE
         CALL SPUMB (IBLOCK,IBLZ,IBLEV,IANF,JWERT(J),IRM)
         IF (IRM.NE.0)                      THEN
            PRINT '('' GETGD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                                I10)', J, JWERT(J)
            RETURN
         ENDIF
         IBLZ    = IBLZ + IBLEV
  260    CONTINUE

         IF (LWE .LT. 225)                  THEN
            DO 261 J= LWE+1, 225
  261       JWERT(J)= IUNDEF
         ENDIF
      ENDIF

C...............................................................................
  300 CONTINUE

C     NROWS-LISTING, NUR WENN LGDS > (JWERT(1))
      IBLEV      = 2
      IBDIF      = JWERT(1) - LGDS - IBKOOR
      IANZNR     = IBDIF / IBLEV
      IF (IANZNR .LE. 0)                    THEN
C........OHNE NROWS-LISTING
         JWERT(226) = 0
         DO   305 J = 227, MWERT
  305    JWERT(J)   = IUNDEF
         GOTO 500
      ELSE
C........MIT NROWS-LISTING
         JWERT(226) = IANZNR
         IF (IANZNR .GT. NROWS)             THEN
             PRINT '('' GETGD1: FEHLER-'',I5,'' NROWS-LISTING,'',/,
     +               ''                '',I5,'' SIND ERLAUBT'')',
     +                                    IANZNR, NROWS
             IRM    = 1
             RETURN
         ENDIF

         IBLEV   = 2
         LWA     = 227
         LWE     = 227 + IANZNR - 1
         IANF    = IBYTW - IBLEV + 1
#if defined(TEST)
         PRINT '('' GETGD1: IBLZ, LWA, LWE, IANZNR='',4I6)',
     +                      IBLZ, LWA, LWE, IANZNR
#endif 

         DO 310 J= LWA, LWE
         CALL SPUMB (IBLOCK,IBLZ,IBLEV,IANF,JWERT(J),IRM)
         IF (IRM.NE.0)                      THEN
            PRINT '('' GETGD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                                I10)', J, JWERT(J)
            RETURN
         ENDIF
         IBLZ    = IBLZ + IBLEV
  310    CONTINUE
         IF (LWE .LT. MWERT)                THEN
            DO 311 J= LWE+1, MWERT
  311       JWERT(J)= IUNDEF
         ENDIF
      ENDIF

  500 CONTINUE

C.....JWERT NACH IWERT UMSPEICHERN
      DO 510 J   = 1, NWERT
  510 IWERT(J)   = JWERT(J)


      RETURN
      END

