      SUBROUTINE   GETPD1 ( IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK,
     +                      IWERT, IANZ, IRM)

C**** GETPD1   -   UP ZERLEGT PRODUKT-DEFINIT.-SEKTION (PDS) AB GRIB-EDIT.-NR.=1
C**   AUFRUF     : CALL GETPD1  (IEDNR,IBYTA,IUNDEF,NBLOCK,NWERT,IBLOCK,
C**               +              IWERT,IANZ,IRM)
C**   EXTERNALS  : SPUMB, GPD1_78, GPD1_98, GPD1_ND
C**   ZWECK      : DAS UP HOLT AUS IBLOCK DIE KENNDATEN DER PRODUKT-DEFINITION-
C**                SEKTION (PDS) UND SPEICHERT SIE NACH IWERT
C**                (LAENGE: 54 / MAX. 342 BYTES)
C**   PARAMETER  : INPUT:    IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK
C**                -----------------------------------------------------
C**                IEDNR   : EDITIONSNUMMER (AUS SECTION 0, BYTE 8)
C**                IBYTA   : ANFANGSADRESSE DER PDS IN BYTES IM FELD IBLOCK
C**                          (FUER IEDNR=1 GILT IBYTA=9)
C**                IUNDEF  : INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                NBLOCK  : USER-DIMENSIONIERUNG VON IBLOCK
C**                NWERT   : USER-DIMENSIONIERUNG VON IWERT   (NWERT=321)
C**                IBLOCK  : GRIB-DATENBLOCK DER EDIT.-NR. 1
C**                OUTPUT  : IWERT, IANZ, IRM
C**                IWERT   : 24/47/54 BIS MAX. 321 WORTE KENNDATEN DER PDS
C**                -------------------------------------------------------------
C**                INDEX     BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                 (1)      1 - 3  LPD1    LAENGE DER PDS IN BYTES
C**                 (2)      4      GTVSN   GRIB-TABLE-VERSIONNR., GTVSN=2 FUER
C**                                         INTERNAT. AUSTAUSCH (128-254 RESERV.
C**                                         FOR LOCAL USE)
C**                 (3)      5      IDC     IDENTTIFIC.-CENTRE (RZ=78)
C**                                         (SEE CODE TABLE 0)
C**                 (4)      6      IGPINR  GENERAT.-PROC.-IDENTIFIC.-NR.=TYPNR
C**                 (5)      7      ICATNR  KATALOG-NR. DES GRIB'S (GRID-DEF.),
C**                                         ALLE BITS GESETZT, ICATNR=UNDEFINED
C**                 (6)      8      IBFLAG  BLOCK-FLAG, ZEIGT AN, OB GDS UND BMS
C**                                         FOLGEN (SEE CODE TABLE 1)
C**                 (7)      9      IEE     ELEMENT-KENNUNG (SEE CODE-TABLE 2 OR
C**                                         GTVSN)
C**                 (8)     10      LVTYP   LEVEL-TYP (SEE CODE-TABLE 3),
C**                                         1 ODER 2 FLAECHEN VERSCHLUESSELT;
C**                E N T W E D E R  FUER:   LVTYP=100,103,105,107,109,111,113,
C**                                               115,117,119,125,160,200,201,222
C**                 (9)      -      -       UNDEFINIERT (=0)
C**                 (10)    11 -12  LEVEL   HOEHE, FLAECHE , TAB.3
C**                O D E R :
C**                 (9)     11      LEVEL   HOEHE, FLAECHE , TAB.3, OBERGRENZE
C**                 (10)    12      LEVEL   HOEHE, FLAECHE , TAB.3, UNTERGRENZE
C**                 (11)    13      IYY     JAHR DES JAHRH.)
C**                 (12)    14      IMM     MONAT          ) REFERENZZEIT
C**                 (13)    15      IDD     TAG            )   DER
C**                 (14)    16      IGG     STUNDEN        )  DATEN
C**                 (15)    17      IMIN    MINUTEN        )
C**                 (16)    18      IUTIME  ZEITEINHEIT FUER ITIME1/ITIME2
C**                                         ( SEE CODE TABLE 4)
C**                E N T W E D E R :        (WENN ITFLAG GLEICH 10)
C**                 (17)     -      -       UNDEFINIERT (=0)
C**                 (18)    19-20   IT12    EIN VORHERSAGE-ZEITRAUM
C**                O D E R :                (WENN ITFLAG UNGLEICH 10)
C**                 (17)    19      ITIME1  VORHERSAGE-ZEITRAUM 1
C**                 (18)    20      ITIME2  VORHERSAGE-ZEITRAUM 2
C**                 (19)    21      ITFLAG  TIME-FLAG ZEIGT, WELCHER VORHERSAGE-
C**                                         ZEITRAUM FOLGT (SEE CODE-TABLE 5)
C**                 (20)    22 -23  NARVG   ANZ.GEMITTELTER/AKKUMULIERTER FAELLE
C**                 (21)    24      NMSSG   ANZAHL DER MITTL./AKKUMUL. FEHLT
C**                 (22)    25      IYY00   JAHRHUNDERT DER REFERENZZEIT
C**                 (23)    26      IDCSUB  SUB-CENTRE zu IDC;
C**                                         ab Nov.2005:  IDCSUB wird abgefragt 
C**                                         fuer weitere ProgrammVerzweigung
C**            *    (24)    27 -28  IUDSCF  UNITS DECIMAL SCALE FACTOR (D)
C**                 ------------------------1.MOEGL.PDS-BYTE-LAENGE-------------
C**                 (25)    29      IRES2 )
C**                   :      :      :     ) 12 RESERV. WERTE / 1 BYTE
C**                 (36)    40      IRES12)
C**                 ------------------------2.MOEGL.PDS-BYTE-LAENGE-------------
C**                 WENN IWERT(1) > 40,     LOKALE NUTZUNG:
C**                 ---------------------------------------
C**                 (37)    41              KENNUNG FUER WEITEREN DATENVERLAUF:
C**                                         =  254 UND LPDS1=54,
C**                                         =  253 UND LPDS1=66,
C**                                            SIEHE UP GPD1_78
C**                                            !!! KANN ZU FEHLERN FUEHREN, WENN
C**                                            ANDERE CENTER IN DIESEM BYTE DIE
C**                                            KENNUNG 254 oder 253 BENUTZEN !!!
C**
C**                                         = -254 UND IDC=98 UND LPDS1>54,
C**                                                SIEHE UP GPD1_98,
C**                                                DER INHALT AB BYTE 41 WIRD
C**                                                NACH IWERT(48..) GESCHRIEBEN
C**                                         = -254 UND IDC#78/79/98,
C**                                                SIEHE UP GPD1_ND
C**                     NEU AB SEPTEMBER'03:= -253 UND IDC=98,
C**                                                oder ab 11/2005 IDCSUB=98,
C**                                                DER INHALT AB BYTE 41 WIRD
C**                                                NACH IWERT(50..) GESCHRIEBEN,
C**                                                IN IWERT(48) STEHT DIE ANZAHL
C**                                                DER RESTL.UNBEK.PDB-DATEN,
C**                                                IN IWERT(49) STEHT DIE WORT-
C**                                                ANZAHL DER RESTL.UNBEK.DATEN,
C**                                                SIEHE UP GPD1_ND
C**
C**                IANZ     : ANZAHL DER EXTRAH. DATENWERTE IN IWERT
C**                IRM      : FEHLER-RUECKMELDEZELLE
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**   * HINWEIS:   DATEN, BEI DENEN DAS OBERSTE BIT GESETZT IST, SIND NEGATIV
C**                UMZUSETZEN, D.H., DIESE DATEN WERDEN OHNE DAS OBERSTE BIT
C**                NEGATIV GESETZT
C**
C**   VERFASSER:   A. ZALEWSKY, SEPTEMBER 1994
C*    GEAENDERT:   B.Loeser, Ti14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C*    GEAENDERT:   A.Zalewsky, TI14, 04.06.2002;
C*                 ! alle LEVEL(ILEVL) in 60-DO-LOOP abfragen
C*    GEAENDERT:   H. Weber, TI17, 22.04.2003  erlaube EZMW(98) PDS mit Laenge 80 
C*    GEAENDERT:   A.Zalewsky, TI14, 09.09.2003  unbekannter lokaler Bereich ab     
C*                 BYTE 40 wird mit UP GPD1_ND BYTEWEISE EXTRAHIERT
!**                geaend. 03/04 MiSt - Leveltyp-Liste auf Anforderung
!**                                     von FE13 erweitert
!**                                    (neu: lvtyp=222 - Satellite channel)
!**   Version      Maerz 2004
C*    GEAENDERT:   A.Zalewsky, TI14, SEPTEMBER '05;
C*                 ENSEMBLE-VORHERSAGEN UNTER IDC=78 MIT
C*                                            LPDS1=66,IANZ=54,IWERT(37)=253
C*    GEAENDERT:   A.Zalewsky, TI14, NOVEMBER  '05;
C*                 IDCSUB=JWERT(23)=98, SUBCENTRE WIRD FUER PROGRAMMVERZWEIGUNG
C*                                     ABGEFRAGT;
C*                 ACHTUNG, FALLS HIERMIT NEUER, UNBEKANNTER LOKALER
C*                          SCHLUESSEL EINGEFUEHRT WIRD !!!
      IMPLICIT NONE
         
      INTEGER IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK, IWERT, IANZ
      INTEGER IRM
      INTEGER IDWD, IEZM0, ILOC, MWERT, ILEVL, JWERT, IBALL, IBTA1, ISTA
      INTEGER IBLE1, ISLE, LEVEL, MSKLALO, MSKLALF, MSK1, MSK15, IBLA, J
      INTEGER IBLL, IANF, LVTYP, J2, JJ, IZW, LPDS1, IDC, IP
      INTEGER IDCSUB

#include "machconsts.h"

      PARAMETER (IDWD=47,IEZM0=24,ILOC=36,MWERT=321,ILEVL=15)

      DIMENSION IWERT(*), IBLOCK(*), JWERT(MWERT), IBALL(4),
     +          IBTA1(ILOC), ISTA(2),
     +          IBLE1(ILOC), ISLE(2), LEVEL(ILEVL)

      DATA IBALL /  Z'FF'        ,
     +              Z'FFFF'      ,
     +              Z'FFFFFF'    ,
     +              Z'FFFFFFFF'  /

C.....IBTA1 ENTHAELT ANFANGSBYTES DER PDS FUER IWERT-BEREICH MIT 2 FELDERN
C.....UND 2 ZEITEN
C     INDEX:....  1 2 3 4 5 6 7  8  9 10 11 12 13 14 15 16 17 18 19 20
      DATA IBTA1 /1,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,
C     INDEX:.... 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36
     1           24,25,26,27,29,30,31,32,33,34,35,36,37,38,39,40/

C.....IBLA1 ENTHAELT DIE BYTE-LAENGEN FUER DIE IWERT-ABSPEICHERUNG
C     INDEX:....  1 2 3 4 5 6 7  8  9 10 11 12 13 14 15 16 17 18 19 20
      DATA IBLE1 /3,1,1,1,1,1,1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2,
C     INDEX:.... 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36
     1            1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/

!     Liste auf Anforderung von FE13 erweitert: neuer level-typ 222
      DATA LEVEL  /100,103,105,107,109,111,113,115,117,119,
     +             125,160,200,201,222/
      DATA ISTA   /11,19/
      DATA ISLE   / 2, 2/

      DATA MSKLALO  / Z'800000' /
      DATA MSKLALF  / Z'7FFFFF' /
      DATA MSK1     / Z'8000' /
      DATA MSK15    / Z'7FFF' /

      IBLA       = IBYTA

      IF (IBYTA .LT. 9)                     THEN
         PRINT '('' GETPD1 : IBYTA.LT.9 ==> IRM=1 UND RETURN '')'
         IRM     = 1
         RETURN
      ENDIF

      IF (MWERT .LT. NWERT)                 THEN
         PRINT '('' GETPD1: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
C     AUSGABEBEREICH LOESCHEN
      DO 20 J    = 1, MWERT
   20 JWERT(J)   = 0

      DO 50 J    = 1, 8
      IBLL       = IBLE1(J)
      IANF       = IBYTW - IBLL + 1
      IBLA       = IBYTA + IBTA1(J) - 1
      CALL SPUMB  (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
         RETURN
      ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C     IF (JWERT(J) .EQ. IBALL(IBLL))
C    + JWERT(J)  = IUNDEF
C.....IBLA       = IBLA + IBLL
   50 CONTINUE

C.....LVTYP BESTIMMEN
      LVTYP      = JWERT(8)
C.....DO 60 J2   = 1, 5............................................04.06.2002
      DO 60 J2   = 1, ILEVL
      IF ( LVTYP.EQ.LEVEL(J2))              THEN
         JJ      = 1
         GOTO 65
      ENDIF
   60 CONTINUE
      JJ         = 0

C.....ABFRAGE 1 FLAECHE
   65 IF ( JJ.NE.0)                         THEN
         JWERT(9)= 0
         IBLL    = ISLE(1)
         IANF    = IBYTW - IBLL + 1
         IBLA    = IBYTA + ISTA(1) - 1
         CALL SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(10),IRM)
         IF (IRM.NE.0)                      THEN
            PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                         I10)',        J, JWERT(J)
            RETURN
         ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C        IF (JWERT(10) .EQ. IBALL(IBLL))
C    +   JWERT(J)= IUNDEF
C........IBLA    = IBLA + IBLL
      ELSE
C........2 FLAECHEN HOLEN
         DO 100 J= 9, 10
         IBLL    = IBLE1(J)
         IANF    = IBYTW - IBLL + 1
         IBLA    = IBYTA + IBTA1(J) - 1
         CALL SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
         IF (IRM.NE.0)                      THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
            RETURN
         ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C        IF (JWERT(J) .EQ. IBALL(IBLL))
C    +   JWERT(J)  = IUNDEF
C........IBLA    = IBLA + IBLL
  100    CONTINUE
      ENDIF

      DO 105 J   = 11, 16
      IBLL       = IBLE1(J)
      IANF       = IBYTW - IBLL + 1
      IBLA       = IBYTA + IBTA1(J) - 1
      CALL SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
         RETURN
      ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C     IF (JWERT(J) .EQ. IBALL(IBLL))
C    + JWERT(J)  = IUNDEF
C.....IBLA       = IBLA + IBLL
  105 CONTINUE

C.....ITFLAG BESTIMMEN
      DO 110 J   = 19, 21
      IBLL       = IBLE1(J)
      IANF       = IBYTW - IBLL + 1
      IBLA       = IBYTA + IBTA1(J) - 1
      CALL SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
         RETURN
      ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C     IF (JWERT(J) .EQ. IBALL(IBLL))
C    + JWERT(J)  = IUNDEF
C.....IBLA       = IBLA + IBLL
  110 CONTINUE

C.....ITFLAG ABFRAGEN
      IF ( JWERT(19) .EQ. 10)               THEN
C........EIN VORHERSAGEZEITRAUM
         JWERT(17)  = 0
         IBLL       = ISLE(2)
         IANF       = IBYTW - IBLL + 1
         IBLA       = IBYTA + ISTA(2) - 1
         CALL SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(18),IRM)
         IF (IRM.NE.0)                         THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
            RETURN
         ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C        IF (JWERT(17) .EQ. IBALL(IBLL))
C    +   JWERT(17)  = IUNDEF
C........IBLA       = IBLA + IBLL
      ELSE
C........ZWEI VORHERSAGEZEITRAEUME
         DO 120 J= 17, 18
         IBLL    = IBLE1(J)
         IANF    = IBYTW - IBLL + 1
         IBLA    = IBYTA + IBTA1(J) - 1
         CALL SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
         IF (IRM.NE.0)                      THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
            RETURN
         ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C        IF (JWERT(J) .EQ. IBALL(IBLL))
C    +   JWERT(J)= IUNDEF
C........IBLA    = IBLA + IBLL
  120    CONTINUE
      ENDIF

      DO 200 J   = 22, 23
      IBLL       = IBLE1(J)
      IANF       = IBYTW - IBLL + 1
      IBLA       = IBYTA + IBTA1(J) - 1
      CALL         SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
         RETURN
      ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C     IF (JWERT(J) .EQ. IBALL(IBLL))
C    + JWERT(J)  = IUNDEF
C.....IBLA       = IBLA + IBLL
  200 CONTINUE

C     SKALIERUNGSFAKTOR ISCALD NEGATIV - OBERSTES BIT GESETZT - ?
C     IST DAS OBERSTE BIT DER 2 BYTES DES SKALIERUNGSFAKTOR GESETZT,
C     WIRD UNTER WEGLASSEN DES OBERSTEN BITS DER SKALIERUNGSFAKTOR
C     NEGATIV UMGESETZT.
      J          = 24
      IBLL       = IBLE1(J)
      IANF       = IBYTW - IBLL + 1
      IBLA       = IBYTA + IBTA1(J) - 1
      CALL         SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
         RETURN
      ENDIF
C.....IBLA       = IBLA + IBLL
CT    CALL ARBITI(JWERT(J),1)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C        JWERT(J)= IUNDEF
      ELSE
         IF (IAND(JWERT(J),MSK1) .EQ. MSK1)  THEN
            IZW     = IAND (JWERT(J),MSK15)
            JWERT(J)= -IZW
         ENDIF
      ENDIF

C.....PDS-BYTE-LAENGE=28 ERREICHT...............................................
      IANZ       = 24
      LPDS1      = JWERT(1)
C.....IF (LPDS1 .EQ. 28)                    GOTO 500....................24.06.97
      IF (LPDS1 .LE. 28)                    GOTO 500

C.....WERTEBEREICH VON 25..36 IST RESERVIERT FOR FUTURE, WIRD NICHT EXTRAHIERT
      DO 210 J   = 25, 36
      JWERT(J)   = 0
      IBLA       = IBYTA+ IBTA1(J) - 1
C.....IBLA       = IBLA + IBLE1(J)
  210 CONTINUE

C.....PDS-BYTE-LAENGE=40 ERREICHT...............................................
      IANZ       = 36
C.....IF (LPDS1 .EQ. 40)                    GOTO 500....................24.06.97
      IF (LPDS1 .LE. 40)                    GOTO 500
C.....durch geaenderte Berechnung wird IBLA+1 an nachfolgende UP's uebergeben 
      IBLA       = IBLA + 1

      IDC        = JWERT(3)
C.....neu ab Nov.2005
      IDCSUB     = JWERT(23)
C.....VERZWEIGUNG IN UPS FUER LOCAL-DATENBEREICH
      IF (IDC.EQ.78 .OR. IDC.EQ.79)         THEN
         CALL GPD1_78 (IBLA,IUNDEF,NBLOCK,NWERT,IBLOCK,JWERT,IANZ,IRM)
         IF (IRM .NE. 0)                    GOTO 500
C.....neu ab Nov.2005
      ELSE IF (IDC .EQ. 98                  .OR. 
     +         IDCSUB .EQ. 98)              THEN
C........UNBEKANNTE PDS-LAENGE...........................ausser Kraft ab 09.09.03
C        IF (LPDS1 .EQ. 80)                 THEN
C           CALL GPD1_ND (                     
C    +           IBLA,NBLOCK,NWERT,IBLOCK,JWERT,IANZ,IRM)
C           PRINT '('' GETPD1:'',
C    +           ''  AB BYTE 41 UNBEK.DATEN; IDC, IANZ='',2I5,
C    +           /,''         JWERT(37..49)='',T43,4I7,/,10I7)',
C    +           IDC, IANZ, (JWERT(IP),IP=37,49)
C           IF (IRM .NE. 0)                 GOTO 500
C        ELSE...........................................ausser Kraft ab 09.09.03
            CALL GPD1_98 (
     +           IBLA,IUNDEF,NBLOCK,NWERT,IBLOCK,JWERT,IANZ,IRM)
            IF (IRM .NE. 0)                 GOTO 500
C...........NEU: JWERT(37)=-253,--> UP GPD1_ND WIRD AUFGERUFEN..........09.09.03
C           UNBEKANNTER LOKALER BEREICH  
            IF (JWERT(37) .EQ. -253)
     +      CALL GPD1_ND (                     
     +           IBLA,NBLOCK,NWERT,IBLOCK,JWERT,IANZ,IRM)
            IF (IRM .NE. 0)                 GOTO 500
C        ENDIF..........................................ausser Kraft ab 09.09.03
      ELSE
C........JWERT(37)  = 254 und JWERT(1)=54   ---> DWD-Vorspann
C........JWERT(37)  = 253 und JWERT(1)=66   ---> DWD-Vorspann  ?????????????????
         IZW        = 0
         IBLL       = 1
         IANF       = IBYTW - IBLL + 1
         CALL         SPUMB (IBLOCK,IBLA,IBLL,IANF,IZW,IRM)
         IF (IRM.NE.0)                      THEN
            PRINT '('' GETPD1: FEHLER IN SPUMB, JWERT(37)='',
     +                         I10)',           IZW
            RETURN
         ENDIF

         IF (LPDS1.EQ.54 .AND. IZW.EQ.254)    THEN
            CALL GPD1_78 (IBLA,IUNDEF,NBLOCK,NWERT,IBLOCK,JWERT,IANZ,
     +                    IRM)
            IF (IRM .NE. 0)                   RETURN
!        ???????????????????????
!        ELSE IF (LPDS1.EQ.66 .AND. IZW.EQ.253) THEN
!           CALL GPD1_78 (IBLA,IUNDEF,NBLOCK,NWERT,IBLOCK,JWERT,IANZ,
!    +                    IRM)
!           IF (IRM .NE. 0)                   RETURN
         ELSE
            CALL GPD1_ND (IBLA,NBLOCK,NWERT,IBLOCK,JWERT,IANZ,IRM)
C...........PRINT '('' GETPD1: AB BYTE 41 UNBEK.DATEN FUER IDC='',I5,/,.........
C    +              ''         JWERT(37..39), IANZ='',4I10)',                  :
C    +                   IDC, (JWERT(IP),IP=37,39), IANZ                       :
C...........CALL ARBITI (JWERT(40),JWERT(39))...........................24.06.97
            PRINT '('' GETPD1: AB BYTE 41 UNBEK.DATEN; IDC, IANZ='',2I5,
     +            /,''         JWERT(37..49)='',T43,4I7,/,10I7)',
     +             IDC, IANZ, (JWERT(IP),IP=37,49)
CT          CALL ARBITI (JWERT(50),JWERT(49))
         ENDIF
      ENDIF
  500 CONTINUE

C.....JWERT NACH IWERT UMSPEICHERN
      DO 510  J  = 1, NWERT
  510 IWERT(J)   = JWERT(J)

      RETURN
      END
