      SUBROUTINE GETSD1 (IBLOCK, UNDEF, IANZ, INDEX, IPDB, IGDB, DS1,
     +                   RPCOE, IRM)

C**** GETSD1   -   FELD IM GRIB-CODE IN EINZELWERTE UND DATENSATZ ZERLEGEN
C**   AUFRUF   :   CALL GETSD1 (IBLOCK,UNDEF,IANZ,INDEX,IPDB,IGDB,DS1,RPCOE,IRM)
C**   ZWECK    :   GRIB_1-CODE-FELD, JE BLOCK MAX. 200 EINFACH GEPACKTE EINZEL-
C**                                  WERTE EXTRAHIEREN,
C**   EXTERNALS:   GETPD1, GETGD1, GETBM1, GETBD1, FCRACKA, SPUMB
C**   INPUT    :   IBLOCK    1 FELD IM GRIB-CODE
C**                UNDEF     WERT, MIT DEM EIN UNDEFINIERTER PUNKT IM AUSGABE-
C**                          FELD BESETZT WERDEN SOLL;  BEI ANGABE VON 0.
C**                          ODER -1. WIRD UNDEF AUF  -1E10 GESETZT(= DEFAULT)
C**                IANZ      ARRAY FUER:
C**                IANZ(1)   ANZAHL DER ZU LIEFERNDEN GPKT.-DATENWERTE
C**                          ( MAX. 200 DATENWERTE )
C**                IANZ(2)   ANZAHL DER ZU LIEFERNDEN PDB-DATENWERTE ,
C**                          ( MAX. 321 DATENWERTE )
C**                IANZ(3)   ANZAHL DER ZU LIEFERNDEN GDB-DATENWERTE ,
C**                          ( MAX. 626 DATENWERTE )
C**                INDEX     ARRAY MIT DEN FELDINDEXWERTEN DER ZU LIEFERNDEN GIT-
C**                          TERPUNKTE, DIE GITTERPKTE. MUESSEN VOM ERSTEN ZUM
C**                          LETZTEN GITTERPUNKT AUFSTEIGEND SORTIERT SEIN,
C**                          DIMENSION:          INDEX(IANZ(1))
C**   OUTPUT   :
C**                IPDB      MAX. 321 EINZELWERTE
C**                          --- ERLAEUTERUNGEN SIEHE IM UP GETPD1
C**                IGDB      MAX. 626 EINZELWERTE DES GRID-DESCRIPTION-BLOCK,
C**                          --- ERLAEUTERUNGEN SIEHE IM UP GETGD1
C**                DS1       GEWUENSCHTE GITTERPUNKT-DATENWERTE,
C**                          DIMENSION:          DS1(IANZ(1))
C**                RPCOE     REAL PART FUER SPHER.HARM.COEFFICIENTS
C**                IRM       FEHLER-RUECKMELDEZELLE (BEI FEHLER UNGLEICH 0)
C**
C**
C**   HINWEIS:     DIESES UP IST NUR FUER SIMPLE-PACKING-DATA GEDACHT
C**
C**   VERFASSER:   A.ZALEWSKY, FEB.'96
C                  last modif.: 25.07.97, cd4: /rhome/routarz
C     Letzte Aenderung U.Voigt am 1.8.97: ROUTROOT vor die Dateipfade
C     MODIFICATION: PARAMETER-WERTE NBLOCK/LBMAX GEAENDERT, A.Zalewsky, 03.11.97
C     MODIFICATION: DATENWERTE MIT IUDSC/PDS UMRECHNEN,     A.Zalewsky, 06.08.98
C     MODIFICATION: INTEGER AND                             A.Zalewsky  29.10.98
C     MODIFICATION: NBLOCK=140000(*2),LBMAX=4500(*2)........A:ZALEWSKY..04.03.99
C     MODIFICATION: ANPASSUNG SYMBOLE FUER FUJITSU          B.LOESER   Juli 2000
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C*                            Ueberfluessige Parameter raus, #ifdef(CRAY) raus

      IMPLICIT NONE

      INTEGER IBLOCK, IANZ, INDEX, IPDB, IGDB, IRM
      INTEGER NBLOCK, MAXDW, IUNBES, NPDS, NGDS, NBMS, NBDS, NDSUP, NBP2
      INTEGER NWDTH, IPDS, IGDS, IBMS, IBDS, IBMP2, IWIDTH, IBDIM, IDANZ
      INTEGER IGRIB, MASK4, MSKF0, MSK0F, IANZ1, IANZ2, IANZ3, KENN
      INTEGER LGRIB, IBLL, IBYTC, IB5, IEDNR, IB8, IBYTA, IZPDS, J1
      INTEGER IBFLAG, IBIT1, IBIT2, IZGDS, IZBMS, IZBMAP, IBMJ, LBMAX
      INTEGER NRBMAP, NRGB, ITAG, IUHR, IZBDS, IZDSUP, ILBMP2, IZWDTH
      INTEGER IZBT2, IBYTAZ, IFLAG, NUNUSB, ISCAL, NRBIT, IBDSA, NRGRP
      INTEGER NRGRPW, IUDSC, J

      REAL    UNDEF, DS1, RPCOE, DSUP, UNDEFI, REFMIN, FAK

#if defined(TEST)
      INTEGER IP, IARB
#endif

#include "machconsts.h"

C     NB: NBLOCK geht zwar als Parameter in einige Unterprogramme ein,
C     wird aber nirgends benutzt, deshalb ist es egal wie wir es setzen

      PARAMETER (NBLOCK=999999)

      PARAMETER (MAXDW=200, IUNBES=-999999)
      PARAMETER (NPDS=321, NGDS=626, NBMS=3, NBDS=11, NDSUP=73)
      PARAMETER (NBP2=100, NWDTH=500)

      DIMENSION IBLOCK(*), IPDB(*), IGDB(*), IANZ(*),
     +          IPDS(NPDS), IGDS(NGDS), IBMS(NBMS), IBDS(NBDS),
     +          DSUP(NDSUP), INDEX(*), DS1(*),
     +          IBMP2(NBP2), IWIDTH(NWDTH), IBDIM(6), IDANZ(6)

      INTEGER, ALLOCATABLE:: IBMAPI(:)


      DATA IGRIB / Z'47524942' /
      DATA MASK4 / Z'FFFFFFFF' /
      DATA MSKF0 / Z'000000F0' /
      DATA MSK0F / Z'0000000F' /


C.....IANZ1 AUF MAXIMALWERT UEBERPRUEFEN
      IANZ1      = IANZ(1)
      IF (IANZ1 .GT. MAXDW)                 THEN
         PRINT '('' GETSD1: IANZ1='',I5,'' - ES WERDEN NUR DIE ERSTEN ''
     +       ,I4,'' DATENWERTE AUSGEGEBEN !'')', IANZ1, MAXDW
         IANZ1   = MAXDW
      ENDIF

C.....IANZ2 AUF MAXIMALWERT UEBERPRUEFEN
      IANZ2      = IANZ(2)
      IF (IANZ2 .GT. NPDS)                  THEN
         PRINT '('' GETSD1: IANZ2='',I5,'' - ES WERDEN NUR'',I5,
     +           '' PDB-WERTE AUSGEGEBEN !'')', IANZ2, NPDS
         IANZ2   = NPDS
      ENDIF

C.....IANZ3 AUF MAXIMALWERT UEBERPRUEFEN
      IANZ3      = IANZ(3)
      IF (IANZ3 .GT. NGDS)                  THEN
         PRINT '('' GETSD1: IANZ3='',I5,'' - ES WERDEN NUR'',I5,
     +           '' GDB-WERTE AUSGEGEBEN !'')', IANZ3, NGDS
         IANZ3   = NGDS
      ENDIF

C.....WERTE VORBESETZEN
      IF (UNDEF.EQ.0. .OR. UNDEF.EQ.-1.)    THEN
         UNDEFI  = -1E10
      ELSE
         UNDEFI  = UNDEF
      ENDIF
      IRM        = 0

C.....IBLOCK IN IPDS, IGDS, IBMS, IBDS ZERLEGEN.................................

C.....KENNUNG 'GRIB' ABFRAGEN
      IF(IBYTW.EQ.8) THEN
         KENN    = IAND (ISHFT(IBLOCK(1),-32), MASK4)
      ELSE
         KENN    = IAND (IBLOCK(1), MASK4)
      ENDIF
      IF (KENN .NE. IGRIB)                  THEN
         PRINT '('' ///GETSD1-FEHLER: ANFANGSKENNUNG NICHT GRIB'')'
         IRM     = 1
         RETURN
      ENDIF

C.....LGRIB
      LGRIB      = 0
      IBLL       = 3
      IBYTC      = IBYTW - IBLL + 1
      IB5        = 5
      CALL SPUMB (IBLOCK(1), IB5, IBLL, IBYTC, LGRIB, IRM)
C.....CALL SPUMB (IBLOCK(1), 5, IBLL, IBYTC, LGRIB, IRM)................03.11.97
      IF (IRM .NE. 0)                       THEN
         PRINT '('' ///GETSD1-FEHLER: SPUMB-LGRIB-FEHLER'')'
         IRM     = 1
         RETURN
      ENDIF

C.....IEDNR
      IEDNR      = 0
      IBLL       = 1
      IB8        = 8
      CALL SPUMB (IBLOCK(1), IB8, IBLL, IBYTW, IEDNR, IRM)
C.....CALL SPUMB (IBLOCK(1), 8, 1, IBYTW, IEDNR, IRM)...................03.11.97
      IF (IRM .NE. 0)                       THEN
         PRINT '('' ///GETSD1-FEHLER: SPUMB-IEDNR-FEHLER'')'
         IRM     = 1
         RETURN
      ENDIF

#if defined(TEST)
      PRINT '('' GETSD1: IEDNR, LGRIB='',2I7)', IEDNR, LGRIB
#endif 

C.....PDS HOLEN
      IBYTA      = 9
      CALL GETPD1 (IEDNR, IBYTA, IUNBES, NBLOCK, NPDS, IBLOCK(1),
     +             IPDS,  IZPDS, IRM)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' ///GETSD1: GETPD1-FEHLER'')'
         RETURN
      ENDIF

C.....VOM USER GEWUENSCHTE PDB-WERTE UMSPEICHERN
      DO 120 J1  = 1, IANZ2
  120 IPDB(J1)   = IPDS(J1)

#if defined(TEST)
      PRINT '('' GETSD1: IBYTA,IZPDS='',2I4,10X,''IPDS='',32(/,10I7))',
     +                   IBYTA,IZPDS,(IPDS(IP),IP=1,IZPDS)
#endif 
      IBYTA      = IBYTA + IPDS(1)

C.....BITS AUS IBFLAG HOLEN
      IBFLAG     = IPDS(6)
      IBIT1      = IAND ( ISHFT (IBFLAG, -7) , 1 )
      IBIT2      = IAND ( ISHFT (IBFLAG, -6) , 1 )
#if defined(TEST)
      PRINT '('' GETSD1:IBIT1,IBIT2='',2I2)', IBIT1, IBIT2
#endif 

C.....GDS HOLEN
      IZGDS      = 0
      IGDS(1)    = 0
      IF (IBIT1 .EQ. 1)                     THEN
         CALL GETGD1 (IEDNR, IBYTA, IUNBES, NBLOCK, NGDS, IBLOCK(1),
     +                IGDS,  IZGDS, IRM)
         IF (IRM .NE. 0)                    THEN
            PRINT '('' ///GETSD1: GETGD1-FEHLER'')'
            RETURN
         ENDIF

C........VOM USER GEWUENSCHTE GDB-WERTE UMSPEICHERN
         DO 130 J1  = 1, IANZ3
  130    IGDB(J1)   = IGDS(J1)

#if defined(TEST)
         PRINT '('' GETSD1: IBYTA,IZGDS='',2I4,10X,''IGDS='',
     +         3(/,10I7))', IBYTA,IZGDS,(IGDS(IP),IP=1,25)
#endif 
      ELSE
C........VOM USER GEWUENSCHTE GDB-WERTE SIND NICHT IM GRIB ENTHALTEN
         DO 140 J1  = 1, IANZ3
  140    IGDB(J1)   = 0
      ENDIF
      IBYTA      = IBYTA + IGDS(1)

C.....IBMS HOLEN
      IZBMS      = 0
      IBMS(1)    = 0
      IZBMAP     = 0
      IBMJ       = 0
      IF (IBIT2 .EQ. 1)                     THEN

         ! Groesse der Bitmap ermitteln, IBMAPI aber zur Zeit nicht besetzen

         LBMAX   = -1
         IBMJ    = 1
         CALL GETBM1 (IEDNR, IBYTA, NBLOCK, NBMS, LBMAX, IBLOCK(1),
     +                IBMS,  IBMAPI(1), IZBMAP, IRM)
         IF (IRM .NE. 0)                    THEN
            PRINT '('' ///GETSD1: GETBM1-FEHLER'')'
            RETURN
         ENDIF
         NRBMAP  = IBMS(3)
         IF (NRBMAP .GT. 0)                 THEN
C...........BITMAP AUS DATEI HOLEN
            CALL BITMIN (' ', NRBMAP, LBMAX, IBMAPI, IZBMAP, NRGB,
     +                    ITAG, IUHR, IRM)
            IF (IRM .NE. 0)                 THEN
               PRINT '('' ///GETSD1: BITMIN-FEHLER'')'
               RETURN
            ENDIF
         ENDIF

         ! Bitmapgroesse ist jetzt bekannt, bitmap allokieren und einlesen

         LBMAX = (IZBMAP-1)/IBMAX + 1

         ALLOCATE(IBMAPI(1:LBMAX))

         CALL GETBM1 (IEDNR, IBYTA, NBLOCK, NBMS, LBMAX, IBLOCK(1),
     +                IBMS,  IBMAPI(1), IZBMAP, IRM)
         IF (IRM .NE. 0)                    THEN
            PRINT '('' ///GETSD1: GETBM1-FEHLER'')'
            DEALLOCATE(IBMAPI)
            RETURN
         ENDIF
         NRBMAP  = IBMS(3)
         IF (NRBMAP .GT. 0)                 THEN
C...........BITMAP AUS DATEI HOLEN
            CALL BITMIN (' ', NRBMAP, LBMAX, IBMAPI, IZBMAP, NRGB,
     +                    ITAG, IUHR, IRM)
            IF (IRM .NE. 0)                 THEN
               PRINT '('' ///GETSD1: BITMIN-FEHLER'')'
               DEALLOCATE(IBMAPI)
               RETURN
            ENDIF
         ENDIF

#if defined(TEST)
         PRINT '('' GETSD1: IBYTA,IZBMAP='',2I4,10X,''IBMS='',3I7)',
     +                      IBYTA,IZBMAP,(IBMS(IP),IP=1,3)
         IF (IZBMAP .GT. 0)                 THEN
C...........BITMAP NUR BIS ZUM LETZTEN ANGEFORDERTEN GITTERPUNKT AUSGEBEN
            IARB = (INDEX(IANZ1) / IBMAX) + 1
            CALL ARBITI (IBMAPI(1),IARB)
         ENDIF
#endif 

      ENDIF
      IBYTA      = IBYTA + IBMS(1)

C.....BDS (OHNE DATENSATZ) HOLEN
      IBDIM(1)   = NBDS
      IBDIM(2)   = NDSUP
      IBDIM(3)   = NBP2
      IBDIM(4)   = NWDTH
      IBDIM(5)   = NBLOCK
      IBDIM(6)   = IUNBES
      CALL GETBD1 (IEDNR, IBYTA, IBDIM, IBLOCK(1), IBDS, IBMP2, IWIDTH,
     +             DSUP,  IDANZ, IRM)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' ///GETSD1: GETBD1-FEHLER'')'
         IF(ALLOCATED(IBMAPI)) DEALLOCATE(IBMAPI)
         RETURN
      ENDIF
      IZBDS      = IDANZ(1)
      IZDSUP     = IDANZ(2)
      ILBMP2     = IDANZ(3)
      IZWDTH     = IDANZ(4)
      IZBT2      = IDANZ(5)
      IBYTAZ     = IDANZ(6)
      IFLAG      = IAND(IBDS(2),MSKF0)
      NUNUSB     = IAND(IBDS(2),MSK0F)
      ISCAL      = IBDS(3)
      NRBIT      = IBDS(5)
      REFMIN     = DSUP(1)
      RPCOE      = 0.0
      IF (IFLAG.EQ.8 .AND. IZDSUP.EQ.2)     RPCOE = DSUP(2)

#if defined(TEST)
      PRINT '('' GETSD1: IBYTA,IZBDS='',2I4,10X,''IBDS='',
     +           /,1X,3I7,Z17,7I7)',
     +                   IBYTA,IZBDS,(IBDS(IP),IP=1,IZBDS)
      PRINT '(''         IBYTAZ,IZDSUP,ILBMP2,IZWDTH,IZBT2='',5I6)',
     +                   IBYTAZ,IZDSUP,ILBMP2,IZWDTH,IZBT2
      PRINT '(''         REFMIN,RPCOE,IFLAG,NUNUSB=        '',2E12.5,
     +       2I6)',      REFMIN,RPCOE,IFLAG,NUNUSB

      IF (IZDSUP .GT. 2)                    THEN
         PRINT '('' GETSD1: DSUP(2..'',I2,'')='',20(/,1X,5E12.5))',
     +                            IZDSUP+1,(DSUP(IP),IP=2,IZDSUP+1)
      ENDIF
#endif 

C.....IFLAG
      IF (IFLAG .EQ. 0)                     THEN
         IBDSA   = 11
      ELSEIF (IFLAG .NE. 128)               THEN
         IBDSA   = 15
      ELSE
         PRINT '('' GETSD1: DIESES UP BEARBEITET NUR EINF. GEPACKTE''
     +           ,'' DATEN, IRM = 1 UND RETURN'')'
         IRM     = 1
         IF(ALLOCATED(IBMAPI)) DEALLOCATE(IBMAPI)
         RETURN
      ENDIF

C.....GESAMTZAHL GITTERPUNKTE FESTLEGEN
      IF (IBIT2 .EQ. 1)                     THEN
C........GITTERPUNKTE AUS BITMAP
         NRGRP   = IZBMAP
      ELSE
C........GITTERPUNKTE AUS BDS BERECHNEN
         NRGRP   = (((IBDS(1) - IBDSA) * IBYTE) - NUNUSB) / NRBIT
      ENDIF
#if defined(TEST)
      PRINT '('' GETSD1: LBDS,IBDSA,NUNUSB,NRGRP,IBMJ='',5I7)',
     +                IBDS(1),IBDSA,NUNUSB,NRGRP,IBMJ
#endif 

C.....DATENSATZ HOLEN, NUR DIE GEWUENSCHTEN WERTE
      NRGRPW     = INDEX(IANZ1)
      IF (NRGRPW .GT. NRGRP)                NRGRPW = NRGRP

C.....FCRACKA BERECHNET FUER JEDEN GEF. GPKT. DIE ANFANGSADRESSE................
      CALL FCRACKA (IBLOCK(1), IBYTAZ, UNDEFI, ISCAL, REFMIN, IBMJ,
     +              IBMAPI, NRGRPW, NRBIT, IANZ1, INDEX, DS1, IRM)
      IF(ALLOCATED(IBMAPI)) DEALLOCATE(IBMAPI)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' ///GETSD1: FCRACKA-FEHLER'')'
         RETURN
      ELSE
         IUDSC   = IPDS(24)
         IF (IUDSC .NE. 0)                  THEN
            FAK  = 10**(IUDSC)
            DO 200 J = 1, IANZ1
            IF (DS1(J) .NE. UNDEFI)
     +      DS1(J)   = DS1(J) / FAK
  200       CONTINUE
         ENDIF                                  
      ENDIF


      END
