      SUBROUTINE GGD1_00  (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK,
     +                     IWERT, IBYTO, IRM)

C**** GGD1_00   -  GRID-DEFIN.-SECTION, IEDNR=1, IDRTYP=0/10/20/30 ZERLEGEN
C**   AUFRUF     : CALL GGD1_00 (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
C**               +              IWERT,IBYTO,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : AUS IBLOCK WERDEN DIE KENNDATEN DER WEITEREN GDS EXTRAHIERT
C**                FUER IDRTYP= 0/10/20/30, REGULAR LAT./LONG. GRID
C**   PARAMETER  : INPUT   : IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK
C**                ----------------------------------------------------
C**                IANZ    : ANZAHL DER ZU EXTRAHIERENDEN DATENWERTE
C**                LGDS    : BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA   : 1.BYTE IN DER GDS (IBLZ = IBYTA + 10 !)
C**                IUNDEF  : INTEGER-WERT, MIT DEM UNDEFINIERTE DATEN (ALLE BITS
C**                          GESETZT) NACH IWERT UEBERGEBEN WERDEN
C**                NWERT   : USER-DIMENSION VON IWERT:   IWERT(NWERT)
C**                IBLOCK  : IBLOCK ENTHAELT ALS 2.SECTION DIE GDS, NACH DER PDS
C**                OUTPUT  : IWERT,IBYTO,IRM
C**                -------------------------
C**                IWERT   : 626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN GETGD1, HIER AB IWERT(7)
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  LA1     GEOGR. BREITE DES 1.GPKT.
C**                   (8)   14 -16  LO1     GEOGR. LAENGE DES 1.GPKT.
C**                   (9)   17      IRFLAG  AUFLOESUNG UND BESTANDTEILE
C**                                         ( CODE TABLE 7 )
C**                   (10)  18 -20  LA2     GEOGR. BREITE DES LTZT. GPKT.
C**                   (11)  21 -23  LO2     GEOGR. LAENGE DES LTZT. GPKT.
C**                   (12)  24 -25  DI      I - RICHTUNGS-INCREMENT
C**                   (13)  26 -27  DJ      J - RICHTUNGS-INCREMENT
C**                   (14)  28      MODSC   RASTERART
C**                                         ( FLAG/CODE TABLE 8 )
C**                   (15)  29      IRES1   )
C**                     :    :      :       ) RESERVIERT (=0)
C**                   (18)  32      IRES4   )
C**                   (19)   -      -       UNBENUTZT
C**                         ES FOLGEN FUER ROT. UND ROT./STR.:
C**                         ----------------------------------
C**                   (20)  33- 35  LARSP   GEOGR. BREITE DES SUEDL. POLS
C**                   (21)  36- 38  LORSP   GEOGR. LAENGE DES SUEDL. POLS
C**                ** (22)  39- 42  IROTWK  ROTATIONSWINKEL (SIEHE 4. HINWEIS)
C**                         ES FOLGEN FUER STR.:
C**                         --------------------
C**                   (20)  33- 35  LARSP   GEOGR. BREITE DES STRETCH. POLS
C**                   (21)  36- 38  LORSP   GEOGR. LAENGE DES STRETCH. POLS
C**                ** (22)  39- 42  ISTRFK  STRETCH. FAKTOR (SIEHE 4. HINWEIS)
C**                         ES FOLGEN FUER ROT./STR.:
C**                         -------------------------
C**                   (23)  43- 45  LARSP   GEOGR. BREITE DES STRETCH. POLS
C**                   (24)  46- 48  LORSP   GEOGR. LAENGE DES STRETCH. POLS
C**                ** (25)  49- 52  ISTRFK  STRETCH. FAKTOR (SIEHE 4. HINWEIS)
C**               ..............................................................
C**                IBYTO    : ABS. ENDBYTE IM GDS
C**                IRM      : FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) IST IM GRIBCODE DAS OBERSTE BIT VON 3
C**                              BYTES GESETZT UND DER WERT POSIT. ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN
C**                           4. MIT ** GEKENNZEICHNETE WERTE MUESSEN VOM USER
C**                              MIT DER FUNCTION REFSTF (SIEHE DWDLIB) UMGE-
C**                              RECHNET WERTDEN
C**
C**
C**   VERFASSER:   A. ZALEWSKY, MAERZ 1995
C*    GEAENDERT:   B.Loeser, TI 14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, AND -> IAND, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK, IWERT, IBYTO
      INTEGER IRM
      INTEGER MWERT, JWERT, IBALL, IBLE, IBLERS, MSK31, MSK3R, J, IBLZ
      INTEGER IDRTYP, JJ, IANF, IBLL, IWZW, IZW, JANZ

#include "machconsts.h"

      PARAMETER (MWERT=626)

      DIMENSION IBLOCK(*),IWERT(*),JWERT(MWERT),IBALL(4),
     +          IBLE(8),IBLERS(6)

      DATA MSK31 /  Z'800000'  /
      DATA MSK3R /  Z'7FFFFF'  /

      DATA IBALL /  Z'FF'        ,
     +              Z'FFFF'      ,
     +              Z'FFFFFF'    ,
     +              Z'FFFFFFFF'  /

C     ...INDEX:     7  8  9 10 11 12 13 14
      DATA IBLE   / 3, 3, 1, 3, 3, 2, 2, 1/
C     ...INDEX:    20 21 22 23 24 25
      DATA IBLERS / 3, 3, 4, 3, 3, 4/

      IRM        = 0
C.....JWERT MIT NULL VORBESETZEN
      DO 10 J    = 7, IANZ
   10 JWERT(J)   = 0

C.....DIE ERSTEN 10 BYTES WURDEN BEREITS IN GETGD1 GEHOLT
      IBLZ       = IBYTA + 10
      IDRTYP     = IWERT(4)

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(7..8)
      DO 120 J   = 7, 8
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  120 CONTINUE
C..................JWERT(9)
      J          = 9
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(10..11)
      DO 140 J   = 10, 11
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  140 CONTINUE

C..................JWERT(12..14)
      DO 170 J   = 12, 14
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL
  170 CONTINUE

      JANZ       = 14
      IF (JANZ .EQ. IANZ)                   THEN
C........WEITERE DATEN AB JWERT(26) IN GETGD1; IBLZ = IBYTA + LGDS
         DO 171 J= 15, 25
  171    JWERT(J)= IUNDEF
         GOTO 500
      ENDIF

C.....WEITERE DATEN AB JWERT(20); IBLZ = IBLZ + 32
      DO 175 J   = 15, 19
  175 JWERT(J)   = IUNDEF
      IBLZ       = IBYTA + 32

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(20..21); IDRTYP=10/20/30
      DO 200 J   = 20, 21
      JJ         = J - 19
      IANF       = IBYTW - IBLERS(JJ) + 1
      IBLL       = IBLERS(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  200 CONTINUE
C..................JWERT(22)
      J          = 22
      JJ         = J - 19
      IANF       = IBYTW - IBLERS(JJ) + 1
      IBLL       = IBLERS(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL

      JANZ       = 22
      IF (JANZ .EQ. IANZ)                   THEN
C........IDRTYP=10/20; WEITERE DATEN AB JWERT(26) IN GETGD1; IBLZ = IBYTA + LGDS
         DO 205  J  = 23, 25
  205    JWERT(J)   = IUNDEF
         GOTO 500
      ENDIF

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(23..24); IDRTYP=30
      DO 210 J   = 23, 24
      JJ         = J - 19
      IANF       = IBYTW - IBLERS(JJ) + 1
      IBLL       = IBLERS(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  210 CONTINUE
C..................JWERT(25)
      J          = 25
      JJ         = J - 19
      IANF       = IBYTW - IBLERS(JJ) + 1
      IBLL       = IBLERS(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_00: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL
      JANZ       = 25

  500 CONTINUE
      IBYTO      = IBYTA + LGDS

C.....JWERT NACH IWERT UMSPEICHERN
      DO 510 J   = 7, IANZ
  510 IWERT(J)   = JWERT(J)

      RETURN
      END

