      SUBROUTINE GGD1_02  (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK,
     +                    IWERT, IBYTO, IRM)

C**** GGD1_02   -   GRID-DEFINITION-SECTION,IEDNR=1, IDRTYP=2 ZERLEGEN
C**   AUFRUF     : CALL GGD1_02  (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
C**               +              IWERT,IBYTO,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : AUS IBLOCK WERDEN DIE KENNDATEN DER WEITEREN GDS EXTRAHIERT
C**                FUER IDRTYP=2, STEREOGR. PROJEKTION
C**   PARAMETER  : INPUT   : IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK
C**                ---------------------------------------------
C**                IANZ    : ANZAHL DER ZU EXTRAHIERENDEN DATENWERTE
C**                LGDS    : BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA   : 1.BYTE IN DER GDS (IBLZ = IBYTA + 10 !)
C**                IUNDEF  : INTEGER-WERT, MIT DEM UNDEFINIERTE DATEN (ALLE BITS
C**                          GESETZT) NACH IWERT UEBERGEBEN WERDEN
C**                NWERT   : USER-DIMENSION VON IWERT:   IWERT(NWERT)
C**                IBLOCK  : IBLOCK ENTHAELT ALS 2.SECTION DIE GDS, NACH DER PDS
C**                OUTPUT  : IWERT,IBYTO,IRM
C**                -------------------------
C**                IWERT   : 626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN GETGD1, HIER AB IWERT(7)
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  LA1     GEOGR. BR. DES LINK. UNT. ECKPUNKTES
C**                   (8)   14 -16  LO1     GEOGR. LA. DES LINK. UNT. ECKPUNKTES
C**                   (9)   17      IRFLAG  AUFLOESUNG  ( CODE TABLE 7 )
C**                   (10)  18 -20  LA2     GEOGR. BR. DES RECHT. OB.ECKPUNKTES
C**                   (11)  21 -23  LO2     GEOGR. LA. DES RECHT. OB.ECKPUNKTES
C**                   (12)  24 -25  IDX     GITTERPUNKT-ABSTAENDE IN X-RICHTUNG
C**                   (13)  26 -27  IDY     GITTERPUNKT-ABSTAENDE IN Y-RICHTUNG
C**                   (14)  28      MODSC   RASTERART   ( FLAG/CODE TABLE 8 )
C**                   (15)  29      IPRZ    PROJEKTIONS-ZENTRUM (0 = NORDPOL)
C**                   (16)  30 -32  IRESVA  RESERVIERT (=0)
C**               (17- 25)   -      -       UNBENUTZT
C**               ..............................................................
C**                IBYTO    : ABS. ENDBYTE IM GDS
C**                IRM      : FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) IST IM GRIBCODE DAS OBERSTE BIT VON 3
C**                              BYTES GESETZT UND DER WERT POSIT. ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN
C**
C**   VERFASSER:   A. ZALEWSKY, MAERZ 1995
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, AND -> IAND, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK, IWERT, IBYTO
      INTEGER IRM
      INTEGER MWERT, JANZ, JWERT, IBALL, IBLE, MSK31, MSK3R, J, IBLZ
      INTEGER IDRTYP, JJ, IANF, IBLL, IWZW, IZW

#include "machconsts.h"

      PARAMETER (MWERT=626,JANZ=15)

      DIMENSION IBLOCK(*),IWERT(*),JWERT(MWERT),IBALL(4),
     +      IBLE(9)

      DATA MSK31 /  Z'800000'  /
      DATA MSK3R /  Z'7FFFFF'  /

      DATA IBALL /  Z'FF'        ,
     +              Z'FFFF'      ,
     +              Z'FFFFFF'    ,
     +              Z'FFFFFFFF'  /

C     ...INDEX:      7  8  9 10 11 12 13 14 15
      DATA IBLE   /  3, 3, 1, 3, 3, 2, 2, 1, 1/

      IF (IANZ .NE. JANZ)                   THEN
         PRINT '('' GGD1_02: FEHLER - IANZ#JANZ; IANZ, JANZ='',2I5)',
     +                                           IANZ, JANZ
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
C.....JWERT MIT NULL VORBESETZEN
      DO 10 J    = 7, IANZ
   10 JWERT(J)   = 0

C.....DIE ERSTEN 10 BYTES WURDEN BEREITS IN UP GETGD1 GEHOLT
      IBLZ       = IBYTA + 10
      IDRTYP     = IWERT(4)

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(7..8)
      DO 120 J   = 7, 8
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_02: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  120 CONTINUE
C..................JWERT(9)
      J          = 9
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_02: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(10..11)
      DO 140 J   = 10, 11
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_02: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  140 CONTINUE

C..................JWERT(12..15)
      DO 170 J   = 12, 15
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_02: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL
  170 CONTINUE

C.....WEITERE DATEN AB JWERT(26) MOEGLICH; IBLZ = IBYTA + LGDS
      DO 176  J  = 16, 25
  176 JWERT(J)   = IUNDEF
      IBYTO      = IBYTA + LGDS

C.....JWERT NACH IWERT UMSPEICHERN
      DO 510 J   = 7, IANZ
  510 IWERT(J)   = JWERT(J)

      RETURN
      END

