      SUBROUTINE GGD1_03  (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK,
     +                    IWERT, IBYTO, IRM)

C**** GGD1_03  -   GRID-DEFINITION-SECTION, IEDNR=1, IDRTYP=3 ZERLEGEN
C**   AUFRUF     : CALL GGD1_03  (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
C**               +               IWERT,IBYTO,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : AUS IBLOCK WERDEN DIE KENNDATEN DER WEITEREN GDS EXTRAHIERT
C**                FUER IDRTYP= 3, LAMBERT ODER ALBERS PROJEKTION
C**   PARAMETER  : INPUT   : IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK
C**                ---------------------------------------------
C**                IANZ    : ANZAHL DER ZU EXTRAHIERENDEN DATENWERTE
C**                LGDS    : BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA   : 1.BYTE IN DER GDS (IBLZ = IBYTA + 10 !)
C**                IUNDEF  : INTEGER-WERT, MIT DEM UNDEFINIERTE DATEN (ALLE BITS
C**                          GESETZT) NACH IWERT UEBERGEBEN WERDEN
C**                NWERT   : USER-DIMENSION VON IWERT:   IWERT(NWERT)
C**                IBLOCK  : IBLOCK ENTHAELT ALS 2.SECTION DIE GDS, NACH DER PDS
C**                OUTPUT  : IWERT,IBYTO,IRM
C**                -------------------------
C**                IWERT   : 626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN GETGD1, HIER AB IWERT(7)
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  LA1     GEOGR. BREITE DES 1. GPKT.
C**                   (8)   14 -16  LO1     GEOGR. LAENGE DES 1. GPKT.
C**                   (9)   17      IRFLAG  AUFLOESUNG UND BESTANDTEILE
C**                                         ( CODE TABLE 7 )
C**                   (10)  18 -20  LOV     GRID-ORIENTIERUNG,
C**                                         PARALLEL ZUR Y-ACHSE
C**                   (11)  21 -23  IDX     GRIDLAENGE IN X-RICHTUNG
C**                   (12)  24 -26  IDY     GRIDLAENDE IN Y-RICHTUNG
C**                   (13)  27      PCFLAG  PROJEKTIONSZENTRUM,
C**                                         BIT 1 = 0 -> NORDPOL
C**                                         BIT 1 = 1 -> SUEDPOL
C**                                         BIT 2 = 0 -> NUR 1 PROJ.ZENTRUM
C**                                         BIT 2 = 1 -> 2-POL. UND SYMM. PROJ.
C**                   (14)  28      MODSC   RASTERART  ( FLAG/CODE TABLE 8 )
C**                   (15)  29 -31  LATIN 1 1. BREITENGRAD AB POL, AN DEM DIE
C**                                         KEGELSEKANTE DIE ERDKUGEL SCHNEIDET
C**                   (16)  32 -34  LATIN 2 2. BREITENGRAD AB POL, AN DEM DIE
C**                                         KEGELSEKANTE DIE ERDKUGEL SCHNEIDET
C**                   (17)  35 -37  LASP    GEOGR. BREITE DES SUEDL. POLS
C**                   (18)  38 -40  LOSP    GEOGR. LAENGE DES SUEDL. POLS
C**                   (19)  41      IRES1   RESERVIERT (=0)
C**                   (20)  42      IRES2   RESERVIERT (=0)
C**               (21- 25)  -       -       UNBENUTZT
C**               ..............................................................
C**                IBYTO    : ABS. ENDBYTE IM GDS
C**                IRM      : FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) IST IM GRIBCODE DAS OBERSTE BIT VON 3
C**                              BYTES GESETZT UND DER WERT POSIT. ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN
C**
C**   VERFASSER:   A. ZALEWSKY, MAERZ 1995
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, AND -> IAND, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK, IWERT, IBYTO
      INTEGER IRM
      INTEGER MWERT, JANZ, JWERT, IBALL, IBLE, MSK31, MSK3R, J, IBLZ
      INTEGER IDRTYP, JJ, IANF, IBLL, IWZW, IZW

#include "machconsts.h"

      PARAMETER (MWERT=626,JANZ=18)

      DIMENSION IBLOCK(*),IWERT(*),JWERT(MWERT),IBALL(4),
     +          IBLE(12)

      DATA MSK31 /  Z'800000'  /
      DATA MSK3R /  Z'7FFFFF'  /

      DATA IBALL /  Z'FF'        ,
     +              Z'FFFF'      ,
     +              Z'FFFFFF'    ,
     +              Z'FFFFFFFF'  /

C     ...INDEX:     7  8  9 10 11 12 13 14 15 16 17 18
      DATA IBLE   / 3, 3, 1, 3, 3, 3, 1, 1, 3, 3, 3, 3/

      IF (IANZ .NE. JANZ)                 THEN
         PRINT '('' GGD1_03: FEHLER - IANZ#JANZ; IANZ, JANZ='',2I5)',
     +                                           IANZ, JANZ
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
C.....JWERT MIT NULL VORBESETZEN
      DO 10 J    = 1, IANZ
   10 JWERT(J)   = 0

C.....DIE ERSTEN 10 BYTES WURDEN BEREITS IN UP GETGD1 GEHOLT
      IBLZ       = IBYTA + 10
      IDRTYP     = JWERT(4)

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(7..8)
      DO 120 J   = 7, 8
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_03: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  120 CONTINUE
C.....................JWERT(9)
      J          = 9
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_03: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                         I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(10)
      J          = 10
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_03: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL

C..................JWERT(11..14)
      DO 160 J   = 11, 14
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_03: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL
  160 CONTINUE

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(15..18)
      DO 180 J   = 15, 18
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_03: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  180 CONTINUE

C.....WEITERE DATEN AB JWERT(26); IBLZ = IBYTA + LGDS
      DO 191   J = 19, 25
  191 JWERT(J)   = IUNDEF

      IBYTO      = IBYTA + LGDS
C.....JWERT NACH IWERT UMSPEICHERN
      DO 510 J   = 7, IANZ
  510 IWERT(J)   = JWERT(J)

      RETURN
      END

