      SUBROUTINE GGD1_192 (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK,
     +                     IWERT, IBYTO, IRM)

C**** GGD1_192  -  GRID-DEFINITION-SECTION, IEDNR=1, IDRTYP=192 ZERLEGEN
C**   AUFRUF     : CALL GGD1_192 (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
C**               +              IWERT,IBYTO,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : AUS IBLOCK WERDEN DIE KENNDATEN DER WEITEREN GDS EXTRAHIERT
C**                FUER IDRTYP= 192, TRI-ANGULAR-GRID
C**   PARAMETER  : INPUT   : IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK
C**                ---------------------------------------------
C**                IANZ    : ANZAHL DER ZU EXTRAHIERENDEN DATENWERTE
C**                LGDS    : BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA   : 1.BYTE IN DER GDS (IBLZ = IBYTA + 10 !)
C**                IUNDEF  : INTEGER-WERT, MIT DEM UNDEFINIERTE DATEN (ALLE BITS
C**                          GESETZT) NACH IWERT UEBERGEBEN WERDEN
C**                NWERT   : USER-DIMENSION VON IWERT:   IWERT(NWERT)
C**                IBLOCK  : IBLOCK ENTHAELT ALS 2.SECTION DIE GDS, NACH DER PDS
C**                OUTPUT  : IWERT,IBYTO,IRM
C**                -------------------------
C**                IWERT   : 626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN GETGD1, HIER AB IWERT(7)
C**                -------------------------------------------------------------
C**                   (7)   11 -13  ND      ANZAHL DER DIAMANTEN (RHOMBEN),
C**                                         ND=10 BESAGT, DASS JEWEILS 2 DER 20
C**                                               DREIECKE DES IKOSAEDERS EINEN 
C**                                               DIAMANTEN BILDEN
C**                   (8)   14 -16  NI      ANZAHL DER UNTERTEILUNGEN EINER 
C**                                         DREIECKSSEITE DES IKOSAEDERS:
C**                                         NI = 3**N3 * 2**N2
C**                   (9)   17      IAFLAG  FLAG BZGL. DER ANORDNUNG DER DIA-
C**                                         MANTEN;    TABELLE A:
C**                                         ANORDNUNG DER DIAMANTEN (VOM POLPKT.
C**                                         GESEHEN),
C**                                         = 0,   BIT 1 = 0; IM UHRZEIGERSINN
C**                                         = 128, BIT 1 = 1; GEG. UHRZEIGERSINN
C**                   (10)  18 -20  LAPP    GEOGR. BREITE DES POLPUNKTES
C**                                         (LOKATION DES IKOSAEDERS INNERHALB
C**                                          DER KUGEL)
C**                   (11)  21 -23  LOPP    GEOGR. LAENGE DES POLPUNKTES
C**                   (12)  24 -26  LAMPL   GEOGR. LAENGE DER MITTELPUNKTLINIE
C**                                         DES 1. DIAMANTEN
C**                                         (AURICHTUNG DES IKOSAEDERS IN WEST-
C**                                          OST-RICHTUNG)
C**                   (13)  27      IRES    RESERVIERT (=0)
C**                   (14)  28      IBFLAG  FLAG BZGL. DER REIHENFOLGE DER AB-
C**                                         SPEICHERUNG DER GITTERPUNKTE,
C**                                         TABELLE B:
C**                                         BIT 1: ZUR FESTLEGUNG DER RICHTUNG 
C**                                                DER 1. KOORDINATE i1,
C**                                            =0, +i1, VOM POL ZUM AEQUATOR
C**                                            =1, -i1
C**                                         BIT 2: ZUR FESTLEGUNG DER RICHTUNG
C**                                                DER 2. KOORDINATE i2,
C**                                            =0, +i2, VON WEST NACH OST
C**                                            =1, -i2
C**                                         BIT 3: ZUR FESTLEG. DER REIHENFOLGE,
C**                                            =0, AUFEINANDERFOLGENDE PUNKTE
C**                                                LIEGEN IN +i1 RICHTUNG,
C**                                                ZAEHLWEISE ERST IN i1-, DANN
C**                                                IN i2-RICHTUNG
C**                                            =1, AUFEINANDERFOLGENDE PUNKTE
C**                                                LIEGEN IN +i2 RICHTUNG,
C**                                                ZAEHLWEISE ERST IN i2-, DANN
C**                                                IN i1-RICHTUNG
C**                                         ALLE 3 BITS SIND =0 GESETZT
C**
C**                   (15)  29      IRES1   )
C**                     :    :              ) RESERVIERT (=0)
C**                   (18)  32      IRES4   )
C**                   (19)   -      -       )
C**                     :    :      :       ) UNBENUTZT
C**                   (25)   -      -       )
C**               ..............................................................
C**                IBYTO    : ABS. ENDBYTE IM GDS
C**                IRM      : FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) IST IM GRIBCODE DAS OBERSTE BIT VON 3
C**                              BYTES GESETZT UND DER WERT POSIT. ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN
C**
C**
C**   VERFASSER:   A. ZALEWSKY, TI12, MAERZ 1998
C.....MODIF.:      IWERT(13) MUSS EXTRAHIERT WERDEN, SONST STIMMT BYTE-FOLGE NICHT;
C..................A.ZALEWSKY..........................................20.01.1999
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, AND -> IAND, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK, IWERT, IBYTO
      INTEGER IRM
      INTEGER MWERT, JWERT, IBALL, IBLE, IBLERS, MSK31, MSK3R, J, IBLZ
      INTEGER IDRTYP, JJ, IANF, IBLL, IWZW, IZW, JANZ

#include "machconsts.h"

      PARAMETER (MWERT=626)

      DIMENSION IBLOCK(*),IWERT(*),JWERT(MWERT),IBALL(4),
     +          IBLE(8),IBLERS(6)

      DATA MSK31 / Z'800000'  /
      DATA MSK3R / Z'7FFFFF'  /

      DATA IBALL / Z'FF'        ,
     +             Z'FFFF'      ,
     +             Z'FFFFFF'    ,
     +             Z'FFFFFFFF'  /

C     ...INDEX:     7  8  9 10 11 12 13 14
      DATA IBLE   / 3, 3, 1, 3, 3, 3, 1, 1/
C     ...INDEX:    20 21 22 23 24 25
      DATA IBLERS / 3, 3, 4, 3, 3, 4/

      IRM        = 0
C.....JWERT MIT NULL VORBESETZEN
      DO 10 J    = 7, IANZ
   10 JWERT(J)   = 0

C.....DIE ERSTEN 10 BYTES WURDEN BEREITS IN UP GETGD1 GEHOLT
      IBLZ       = IBYTA + 10
      IDRTYP     = JWERT(4)

C..................JWERT(7..9)
      DO 120 J   = 7, 9
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_192: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                        I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL
  120 CONTINUE

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(10..12)
      DO 140 J   = 10, 12
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_192: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                        I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  140 CONTINUE

C..................JWERT(14)........................................20.01.1999
C.....DO 170 J   = 14, 14
C..................JWERT(13..14)
      DO 170 J   = 13, 14
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_192: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                        I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL
  170 CONTINUE

      JANZ       = 14
      IF (JANZ .EQ. IANZ)                   THEN
C........WEITERE DATEN AB JWERT(26) IN GETGD1; IBLZ = IBYTA + LGDS
         DO 171 J= 15, 25
  171    JWERT(J)= IUNDEF
         GOTO 500
      ENDIF

C.....WEITERE DATEN AB JWERT(26); IBLZ = IBLZ + 32
      DO 175 J  = 15, 25
  175 JWERT(J)  = IUNDEF
      IBLZ      = IBYTA + 32

CC     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
CC     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
CC...............JWERT(20..21); IDRTYP=
C      DO 200 J   = 20, 21
C      JJ         = J - 19
C      IANF       = IBYTW - IBLERS(JJ) + 1
C      IBLL       = IBLERS(JJ)
C      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
C      IF (IRM.NE.0)                         THEN
C         PRINT '('' GGD1_192: FEHLER IN SPUMB, JWERT('',I1,'')='',
C     +                        I10)',        J, JWERT(J)
C         RETURN
C      ENDIF
C      IWZW       = JWERT(J)
C      IF (IWZW .EQ. IBALL(IBLL))            THEN
C         JWERT(J)= IUNDEF
C      ELSE
C         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
C            IZW     = IAND(IWZW,MSK3R)
C            JWERT(J)= -IZW
C         ENDIF
C      ENDIF
C      IBLZ       = IBLZ + IBLL
C  200 CONTINUE
CC..................JWERT(22)
C      J          = 22
C      JJ         = J - 19
C      IANF       = IBYTW - IBLERS(JJ) + 1
C      IBLL       = IBLERS(JJ)
C      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
C      IF (IRM.NE.0)                         THEN
C         PRINT '('' GGD1_192: FEHLER IN SPUMB, JWERT('',I1,'')='',
C     +                        I10)',        J, JWERT(J)
C         RETURN
C      ENDIF
C      IWZW       = JWERT(J)
C      IF (IWZW .EQ. IBALL(IBLL))            THEN
C         JWERT(J)= IUNDEF
C      ENDIF
C      IBLZ       = IBLZ + IBLL
C
C      JANZ       = 22
C      IF (JANZ .EQ. IANZ)                   THEN
CC.....IDRTYP=     ; WEITERE DATEN AB JWERT(26) IN GETGD1; IBLZ = IBYTA + LGDS
C         DO 205 J= 23, 25
C  205    JWERT(J)= IUNDEF
C         GOTO 500
C      ENDIF
C
CC     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
CC     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
CC...............JWERT(23..24); IDRTYP=
C      DO 210 J   = 23, 24
C      JJ         = J - 19
C      IANF       = IBYTW - IBLERS(JJ) + 1
C      IBLL       = IBLERS(JJ)
C      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
C      IF (IRM.NE.0)                         THEN
C         PRINT '('' GGD1_192: FEHLER IN SPUMB, JWERT('',I1,'')='',
C     +                        I10)',        J, JWERT(J)
C         RETURN
C      ENDIF
C      IWZW       = JWERT(J)
C      IF (IWZW .EQ. IBALL(IBLL))            THEN
C         JWERT(J)= IUNDEF
C      ELSE
C         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
C            IZW     = IAND(IWZW,MSK3R)
C            JWERT(J)= -IZW
C         ENDIF
C      ENDIF
C      IBLZ       = IBLZ + IBLL
C  210 CONTINUE
CC..................JWERT(25)
C      J          = 25
C      JJ         = J - 19
C      IANF       = IBYTW - IBLERS(JJ) + 1
C      IBLL       = IBLERS(JJ)
C      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
C      IF (IRM.NE.0)                         THEN
C         PRINT '('' GGD1_192: FEHLER IN SPUMB, JWERT('',I1,'')='',
C     +                        I10)',        J, JWERT(J)
C         RETURN
C      ENDIF
C      IWZW       = JWERT(J)
C      IF (IWZW .EQ. IBALL(IBLL))            THEN
C         JWERT(J)= IUNDEF
C      ENDIF
C      IBLZ       = IBLZ + IBLL
C      JANZ       = 25

  500 CONTINUE
      IBYTO      = IBYTA + LGDS

C.....JWERT NACH IWERT UMSPEICHERN
      DO 510 J   = 7, IANZ
  510 IWERT(J)   = JWERT(J)

      RETURN
      END

