      SUBROUTINE GGD1_90  (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK,
     +                     IWERT, IBYTO, IRM)

C**** GGD1_90  -   GRID-DEFINITION-SECTION, IEDNR=1, IDRTYP=90 ZERLEGEN
C**   AUFRUF     : CALL GGD1_90  (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK,
C**               +               IWERT,IBYTO,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : AUS IBLOCK WERDEN DIE KENNDATEN DER WEITEREN GDS EXTRAHIERT
C**                FUER IDRTYP=90, SPACE VIEW PERSPECTIVE
C**   PARAMETER  : INPUT   : IANZ,LGDS,IBYTA,IUNDEF,NWERT,IBLOCK
C**                ---------------------------------------------
C**                IANZ    : ANZAHL DER ZU EXTRAHIERENDEN DATENWERTE
C**                LGDS    : BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA   : 1.BYTE IN DER GDS (IBLZ = IBYTA + 10 !)
C**                IUNDEF  : INTEGER-WERT, MIT DEM UNDEFINIERTE DATEN (ALLE BITS
C**                          GESETZT) NACH IWERT UEBERGEBEN WERDEN
C**                NWERT   : USER-DIMENSION VON IWERT:   IWERT(NWERT)
C**                IBLOCK  : IBLOCK ENTHAELT ALS 2.SECTION DIE GDS, NACH DER PDS
C**                OUTPUT  : IWERT,IBYTO,IRM
C**                -------------------------
C**                IWERT   : 626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN GETGD1, HIER AB IWERT(7)
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  LAP     GEOGR. BREITE VOM SUB-SATELLITE-PKT.
C**                   (8)   14 -16  LO1     GEOGR. LAENGE VOM SUB-SATELLITE-PKT.
C**                   (9)   17      IRFLAG  AUFLOESUNG UND BESTANDTEILE
C**                                         ( CODE TABLE 7 )
C**                   (10)  18 -20  DX      SCHEINB. ERDDURCHMESSER IN GRIDLAEN-
C**                                         GEN, IN X-DIRECTION
C**                   (11)  21 -23  DY      SCHEINB. ERDDURCHMESSER IN GRIDLAEN-
C**                                         GEN, IN Y-DIRECTION
C**                   (12)  24 -25  XP      X-KOORDINATE VOM SUB-SATELLITE-PKT.
C**                   (13)  26 -27  YP      Y-KOORDINATE VOM SUB-SATELLITE-PKT.
C**                   (14)  28      MODSC   RASTERART  ( FLAG/CODE TABLE 8 )
C**                   (15)  29 -31  ORIEN   GRID-ORIENTIERUNG,  WINKEL ZWISCHEN
C**                                         ANSTEIG. Y-ACHSE UND DEM MERIDIAN
C**                                         DES SUB-SATELLITE-PKTS. IN RICHTUNG
C**                                         ANSTEIGENDER BREITENGRADE
C**                   (16)  32 -34  NR      KAMERA-HOEHE UEBER'M ERDZENTRUM,
C**                                         GEMESSEN IN EINHEITEN DES ERD-RADIUS
C**                   (17)  35 -36  XO      X-KOORDINATE DER BILD-SEKTOR-QUELLE
C**                   (18)  37 -38  YO      Y-KOORDINATE DER BILD-SEKTOR-QUELLE
C**                   (19)  39      IRES1   )
C**                     :    :      :       ) RESERVIERT (=0)
C**                   (25)  44      IRES2   )
C**               ..............................................................
C**                IBYTO    : ABS. ENDBYTE IM GDS
C**                IRM      : FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) IST IM GRIBCODE DAS OBERSTE BIT VON 3
C**                              BYTES GESETZT UND DER WERT POSIT. ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN
C**
C**   VERFASSER:   A. ZALEWSKY, MAERZ 1995
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, AND -> IAND, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IBLOCK, IWERT, IBYTO
      INTEGER IRM
      INTEGER MWERT, JANZ, JWERT, IBALL, IBLE, MSK21, MSK2R, MSK31
      INTEGER MSK3R, J, IBLZ, IDRTYP, JJ, IANF, IBLL, IWZW, IZW

#include "machconsts.h"

      PARAMETER (MWERT=626,JANZ=18)

      DIMENSION IBLOCK(*),IWERT(*),JWERT(MWERT),IBALL(4),
     +      IBLE(12)

      DATA MSK21 /  Z'8000'  /
      DATA MSK2R /  Z'7FFF'  /
      DATA MSK31 /  Z'800000'  /
      DATA MSK3R /  Z'7FFFFF'  /

      DATA IBALL /  Z'FF'        ,
     +              Z'FFFF'      ,
     +              Z'FFFFFF'    ,
     +              Z'FFFFFFFF'  /

C     ...INDEX:      7  8  9 10 11 12 13 14 15 16 17 18
      DATA IBLE   /  3, 3, 1, 3, 3, 2, 2, 1, 3, 3, 2, 2/

      IF (IANZ .NE. JANZ)                   THEN
         PRINT '('' GGD1_90: FEHLER - IANZ#JANZ; IANZ, JANZ='',2I5)',
     +                                           IANZ, JANZ
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
C.....JWERT MIT NULL VORBESETZEN
      DO 10 J    = 7, IANZ
   10 JWERT(J)   = 0

C.....DIE ERSTEN 10 BYTES WURDEN BEREITS IN UP GETGD1 GEHOLT
      IBLZ       = IBYTA + 10
      IDRTYP     = JWERT(4)

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 3 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(7..8)
      DO 120 J   = 7, 8
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_90: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  120 CONTINUE

C..................JWERT(9..11)
      DO 130 J   = 9, 11
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_90: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL
  130 CONTINUE

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 2 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(12..13)
      DO 150 J   = 12, 13
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_90: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK21)) .EQ. MSK21)  THEN
            IZW     = IAND(IWZW,MSK2R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  150 CONTINUE
C..................JWERT(14)
      J          = 14
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_90: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (JWERT(J) .EQ. IBALL(IBLL))        THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 2 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(15)
      J          = 15
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_90: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK31)) .EQ. MSK31)  THEN
            IZW     = IAND(IWZW,MSK3R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
C..................JWERT(16)
      J          = 16
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_90: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ENDIF
      IBLZ       = IBLZ + IBLL

C     GEOGR. ANGABEN, DEREN OBERES BIT (VON 2 BYTES) GESETZT IST, WERDEN
C     UNTER WEGLASSEN DES OBERSTEN BITS NEGATIV UMGESETZT (= WEST/SUED)
C..................JWERT(17..18)
      DO 190 J   = 17, 18
      JJ         = J - 6
      IANF       = IBYTW - IBLE(JJ) + 1
      IBLL       = IBLE(JJ)
      CALL SPUMB (IBLOCK,IBLZ,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GGD1_90: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
      IWZW       = JWERT(J)
      IF (IWZW .EQ. IBALL(IBLL))            THEN
         JWERT(J)= IUNDEF
      ELSE
         IF ((IAND(IWZW,MSK21)) .EQ. MSK21)  THEN
            IZW     = IAND(IWZW,MSK2R)
            JWERT(J)= -IZW
         ENDIF
      ENDIF
      IBLZ       = IBLZ + IBLL
  190 CONTINUE

C.....WEITERE DATEN AB JWERT(26); IBLZ = IBYTA + LGDS
      DO 191  J  = 19, 25
  191 JWERT(J)   = IUNDEF

  500 CONTINUE
      IBYTO      = IBYTA + LGDS

C.....JWERT NACH IWERT UMSPEICHERN
      DO 510 J   = 7, IANZ
  510 IWERT(J)   = JWERT(J)

      RETURN
      END

