      SUBROUTINE   GPD1_78 (IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK,
     +                      IWERT, IANZ, IRM)

C**** GPD1_78  -   UP ZERLEGT PDS AB BYTE 41 (IWERT(37)) FUER IDC=78
C**   AUFRUF     : CALL GPD1_78  (IBYTA,IUNDEF,NBLOCK,NWERT,IBLOCK,
C**               +              IWERT,IANZ,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DAS UP HOLT LOCAL-PDS-KENNDATEN AB BYTE 41 AUS IBLOCK,
C**                AUFRUF ERFOLGT AUS GETPD1
C**   PARAMETER  : INPUT:    IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK
C**                -----------------------------------------------------
C**                IBYTA   : ANFANGSADRESSE DER PDS IN BYTES IM FELD IBLOCK
C**                          (FUER IEDNR=1 GILT IBYTA=9)
C**                IUNDEF  : INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                NBLOCK  : USER-DIMENSIONIERUNG VON IBLOCK
C**                NWERT   : USER-DIMENSIONIERUNG VON IWERT   (NWERT=321)
C**                IBLOCK  : GRIB-DATENBLOCK DER EDIT.-NR. 1
C**                OUTPUT  : IWERT, IANZ, IRM
C**                --------------------------
C**                IWERT   : 24/47/54 BIS MAX. 321 WORTE KENNDATEN DER PDS,
C**                          HIER VON IWERT(37..47/54)
C**                          LOKALER NUTZUNGS-BEREICH:
C**                ----------------------------------------------------------
C**                   INDEX: BYTE:  INHALT:
C**                 ............................................................
C**                   (37)  41              LOKALE DWD-KENNUNG FUER WEITEREN
C**                                         DATENVERLAUF;
C**                                         = 254
C**                                         NEU AB SEPTEMBER '05:
C**                                         = 253, ab BYTE 55 FOLGEN 7 DATEN
C**                                                FUER ENSEMBLE-VORHERSAGEN
C**                   (38)  42              TAGESNUMMER DES MRZ-BACKUP-FILES
C**                   (39)  43 -45          RECORDNUMMER DES MRZ-BACKUP-FILES
C**                   (40)  46              ENTSCHLUESSELN AUF MFA(=1)/MFB(=0)
C**                   (41)  47              ZUSATZ-ELEMENTNUMMER
C**                   (42)  48              JAHR
C**                   (43)  49              MONAT
C**                   (44)  50              TAG
C**                   (45)  51              STUNDE
C**                   (46)  52              MINUTE
C**                   (47)  53 -54          IVSN
C**                 ............................................................
C**                   (48)  55              USER-IDENTIFICATION
C**                   (49)  56 -57          EXPERIMENT IDENTIFIER
C**                   (50)  58 -59          ENSEMBLE IDENTIFICATION
C**                   (51)  60 -61          NUMBER OF ENSEMBLE MEMBERS
C**                   (52)  62 -63          ACTUAL NUMBER OF ENSEMBLE NUMBER
C**                   (53)  64              MODEL MAJOR VERSION NUMBER
C**                   (54)  65              MODEL MINOR VERSION NUMBER
C**                   (--)  66              BLANK
C**
C**                IANZ     : ANZAHL DER EXTRAH. DATENWERTE IN IWERT
C**                IRM      : FEHLER-RUECKMELDEZELLE
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**   * HINWEIS:   DATEN, BEI DENEN DAS OBERSTE BIT GESETZT IST, SIND NEGATIV
C**                UMZUSETZEN, D.H., DIESE DATEN WERDEN OHNE DAS OBERSTE BIT
C**                NEGATIV GESETZT
C**
C**   VERFASSER:   A. ZALEWSKY, FEBRUAR 1995
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C*    GEAENDERT:   A.Zalewsky, TI14, 09/05,
C*                             ENSEMBLE-VORHERSAGEN MIT IWERT(37)=253 UND
C*                                                      IANZ     = 54
C*                  ............................................................

      IMPLICIT NONE

      INTEGER IBYTA, IUNDEF, NBLOCK, NWERT, IBLOCK, IWERT, IANZ, IRM
      INTEGER ILOC, IDWD, MWERT, JWERT, IBALL, IBLE1, MSKLALO, MSKLALF
      INTEGER MSK1, MSK15, IBLA, LPD1, J, JJ, IBLL, IANF, LOCKEN
      INTEGER I253, IBL253

#include "machconsts.h"

      PARAMETER (ILOC=11,IDWD=47,MWERT=321)
      PARAMETER (I253=7)

      DIMENSION IWERT(*),IBLOCK(*),JWERT(MWERT),IBALL(4),IBLE1(ILOC)
      DIMENSION IBL253(I253)


      DATA IBALL /  Z'FF'        ,
     +              Z'FFFF'      ,
     +              Z'FFFFFF'    ,
     +              Z'FFFFFFFF'  /

C.....IBLA1 ENTHAELT DIE BYTE-LAENGEN FUER DIE IWERT-ABSPEICHERUNG
C     INDEX:....     37 38 39 40 41 42 43 44 45 46 47
      DATA IBLE1    / 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 2/
C.....IBL253 ENTHAELT DIE BYTE-LAENGEN FUER DIE IWERT-ABSPEICHERUNG
C.....                                      DER ENSEMBLE-VORHERSAGEN 
C     INDEX:....     48 49 50 51 52 53 54
      DATA IBL253   / 1, 2, 2, 2, 2, 1, 1/

      DATA MSKLALO  / Z'800000' /
      DATA MSKLALF  / Z'7FFFFF' /
      DATA MSK1     / Z'8000' /
      DATA MSK15    / Z'7FFF' /

      IF (MWERT .LT. NWERT)                 THEN
         PRINT '('' GPD1_78: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IBLA       = IBYTA
      LPD1       = IWERT(1)
      IRM        = 0

C.....AUSGABEBEREICH LOESCHEN
      DO 20 J    = 37, MWERT
   20 JWERT(J)   = 0

C.....LOCAL-KENNUNG
      J          = 37
      JJ         = J - 36
      IBLL       = IBLE1(JJ)
      IANF       = IBYTW - IBLL + 1
      CALL         SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GPD1_78: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C     IF (JWERT(J) .EQ. IBALL(IBLL))
C    + JWERT(J)  = IUNDEF
      IBLA       = IBLA + IBLL
      LOCKEN     = JWERT(37)

C.....PDS-BYTE-LAENGE=54 .......................................................
      IANZ       = IDWD
      IF (LOCKEN .NE. 254)                    THEN
       IF (LOCKEN .EQ. 253)                   THEN
C.......NEU AB SEPTEMBER '05
C.......ENSEMBLE-VORHERSAGEN
C.......PDS-BYTE-LAENGE=66......................................................
        IANZ     = IANZ+I253
       ELSE
C........LOKALER PDS-BEREICH UNBEKANNT
         PRINT '('' GPD1_78: FEHLER; LPD1, LOCKEN='',2I5,
     +              '' NICHT DEFINIERT'')', LPD1, LOCKEN
            IRM  = 1
            RETURN
       ENDIF
      ENDIF

C.....DWD-DATEN EXTRAHIEREN
      DO 220 J   = 38, IDWD
      JJ         = J - 36
      IBLL       = IBLE1(JJ)
      IANF       = IBYTW - IBLL + 1
      CALL         SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
      IF (IRM.NE.0)                         THEN
         PRINT '('' GPD1_78: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                       I10)',        J, JWERT(J)
         RETURN
      ENDIF
C.....WEGEN BANK-PROBLEMEN WERDEN ALLE GESETZTEN BITS UMGESETZT; 21.02.1996 ZAL.
C     IF (JWERT(J) .EQ. IBALL(IBLL))
C    + JWERT(J)  = IUNDEF
      IBLA       = IBLA + IBLL
  220 CONTINUE

C.....PDS-BYTE-LAENGE=54 .......................................................
C     IANZ       = IDWD

C.....NEU AB SEPTEMBER '05
C.....PDS-BYTE-LAENGE=66 .......................................................
      IF (LOCKEN .EQ. 253)                    THEN
C......ENSEMBLE-VORHERSAGEN
       DO 230 JJ = 1, I253   
       J         = IDWD+JJ
       IBLL      = IBL253(JJ)
       IANF      = IBYTW-IBLL+1
       CALL        SPUMB (IBLOCK,IBLA,IBLL,IANF,JWERT(J),IRM)
       IF (IRM.NE.0)                         THEN
        PRINT '('' GPD1_78: FEHLER IN SPUMB, JWERT('',I1,'')='',
     +                      I10)',        J, JWERT(J)
        RETURN
       ENDIF
       IBLA      = IBLA+IBLL
  230  CONTINUE
      ENDIF

C.....JWERT NACH IWERT UMSPEICHERN
      DO 510  J  = 37, IANZ
  510 IWERT(J)   = JWERT(J)

      RETURN
      END
