      SUBROUTINE GRBCMI (IPDB,IUN,IRM,YCENT,YCENTA,YCENTF,YMODEL)
C**** GRBCMI   -   GRIB-AUSGABESTELLE UND MODELL-TYP AUS PDB BENENNEN
C**   AUFRUF       CALL GRBCMI (IPDB,IUN,IRM,YCENT,YCENTA,YCENTF,YMODEL)
C**   EXTERNALS    TYPKD, getEnvironment
C**   ZWECK        NAMEN FUER DIE PDB-OCTETS 5 UND 6, DAS SIND
C**                CENTRE UND MODEL IDENTIFICATION, BEREITSTELLEN
C**   PARAMETER
C**     EINGABE    IPDB    FELD VON INTEGER-ZAHLEN MIT INHALT VON PDB
C**                IUN     UNIT-NR. DES CENTRE-TABELLEN-FILE
C**     AUSGABE    IRM     RETURN-CODE   O = FEHLERFREI
C**                                     #0 = FEHLER IN PROGRAMMEINHEIT
C**                YCENT   NAME DER GRIB-AUSGABESTELLE  (MAX. 30 CHAR)
C**                        LT. WMO-TABELLE
C**                YCENTA  ABGEKUERZTE BEZEICHNUNG FUER DIE GRIB-
C**                        AUSGABESTELLE LT. TABELLE CENTRE_TAB
C**                                                   (MAX. 10 CHAR)
C**                YCENTF  FM-SENDEKOPFBEZEICHNUNG FUER DIE GRIB-
C**                        AUSGABESTELLE (LT. WMO-TABELLE)  (4 CHAR)
C**                YMODEL  MODELL-KENNUNG (LT. DWD-TABELLE) (5 CHAR)
C**                        - BEI FALSCHER MODELL-KENNUNG: 'TYiii'
C**                              MIT iii ALS MODELL-NUMMER AUS PDB -
C**                        - WENN AUSGABESTELLE NICHT DWD, DANN EBEN-
C**                          FALLS 'TYiii' MIT iii ALS MODELL-NUMMER
C**                          AUS PDB -
C**        - WENN FALSCHE SCHLUESSELZAHL FUER GRIB-AUSGABESTELLE
C**          IN IPDB(3) ENTHALTEN, SO WIRD SCHALTER IRM GESETZT
C**          UND YCENTA MIT INHALT 'XXXXXXXXXX' AN DAS RUFENDE
C**          PROGRAMM ZURUECKGEGEBEN,
C**           YCENT ENTHAELT DANN DEN TEXT:
C**             CENTRE-KENNUNG NICHT IN WMO-KATALOG  -
C**   VERFASSER: M. STAHLHACKE
C     Letzte Aenderung U.Voigt am 1.8.97: ROUTROOT vor die Dateipfade
C     Geandert:  B.Loeser, 15.11.00, NOS/VE-Zweig raus, Pfad Grib-Tabellen,
C                                    IMPLICIT NONE, LENFUL --> LEN_TRIM
C                B.Loeser, 21.05.01, GETENV --> getEnvironment, ROUTROOT raus
C                                    und absolute Pfade, include machconsts.h
C
C     BENUTZTE VARIABLE :
C
C     IWTYP    FELD MIT KENNGROESSEN FUER PDB UND BITMAP-BLOCK
C              AUS DEM UP -TYPKD- (NUR FUER UP-AUFRUF)
C     IWGDB    FELD MIT GDB-KENNGROESSEN AUS DEM UP -TYPKD-
C                                 (NUR FUER UP-AUFRUF)
C     IRM1     UP-INTERNER FEHLER-ZEIGER
C     IEDIV    NR. DER ZULETZT AUFGERUFENEN GRIB-EDITION
C     ICYCLE   NR. DES BENOETIGTEN TABELLEN-FILE-CYCLE
C     ICNUM    FELD MIT DEN NUMMERN DER AUSGABESTELLEN
C     YLFILE   LFN DES TABELLEN-FILE
C     YLOCFN   FILE-BEZEICHNUNG DES TABELLEN-FILE IN OPEN-STATEMENT
C              (BETRIEBSSYSTEM NOS/VE 1.3.1)
C     YVAR     2-DIMENSIONALE VARIABLE, IN DEREN ERSTEM WORT
C              DIE MODELL-KENNUNG DES GRIB-FELDES ENTHALTEN IST
C     YCNTER   FELD MIT NAMEN DIE GRIB-AUSGABESTELLEN
C     YCKURZ   FELD MIT AUF 10 ZEICHEN GEKUERZTEN NAMEN DER
C              GRIB-AUSGABESTELLEN
C     YCENFM   FELD MIT DEN FM-KENNUNGEN DER GRIB-AUSGABESTELLEN
C     YCMD     BEFEHLSINHALT FUER SCLCMD-AUFRUF
C     STAT     STATUS-INHALT VON SCLCMD-AUFRUF
C     YDUM     VARIABLE FUER UP-TYPKD-AUFRUF (ENTHAELT ' ')
C
      IMPLICIT NONE

#include "machconsts.h"
      INTEGER  IUN, IRM, IRM1, IRM2, IEDIV, ICYCLE, ISTAT, IPDB, I
      INTEGER  IWTYP, IWGDB, ICNUM, ITMAX
      PARAMETER (ITMAX=98)
      DIMENSION IPDB(*), IWTYP(5), IWGDB(22), ICNUM(ITMAX)
      DIMENSION YCNTER(ITMAX), YCKURZ(ITMAX), YCENFM(ITMAX)
      DIMENSION YVAR(2)
      CHARACTER *   2 YZW
      CHARACTER *   4 YCENTF, YCENFM
      CHARACTER *   5 YVAR, YMODEL, YDUM
      CHARACTER *  10 YCENTA, YCKURZ
      CHARACTER * 100 YLOCFN
      CHARACTER *  30 YCENT, YCNTER
      CHARACTER *  50 YROUT
      EXTERNAL TYPKD, getEnvironment
C
      SAVE IEDIV
      SAVE ICNUM, YCNTER, YCKURZ, YCENFM
C
      DATA YDUM   / ' ' / 
      DATA IEDIV  / -1 /
C
C     DIE FELDER ICNUM,YCENFM,YCKURZ UND YCNTER BESCHREIBEN DIE RECORDS
C     IN DER TABELLE MIT DEN KENNUNGEN FUER DIE GRIB-AUSGABESTELLEN
C
      IRM  = 0
      IRM1 = 0
      IRM2 = 0
C     AUSGABE-TEXTE VORBESETZEN
      YCENTA = 'XXXXXXXXXX'
      YCENTF = 'XXXX'
      YCENT  = 'CENTRE NICHT IN WMO-KATALOG'
C
C     ****************************************************************
C     **********    TABELLEN-FILE-VERARBEITUNG BEGINNEN     **********
C     ****************************************************************
C     FILE-ATTACH FUER CENTRE-TABELLE NUR BEI ERSTEM AUFRUF ODER
C     BEI GEAENDERTER GRIB-EDITION
      IF (IEDIV.NE.IPDB(2)) THEN
         IEDIV  = IPDB(2)
C **  CENTRE-TABELLE AENDERT SICH MIT GRIB-EDITIONS-AENDERUNG NICHT,
C **  DESHALB Z. ZT. IMMER ICYCLE=1 !!!
C **     ICYCLE = IEDIV + 1
         ICYCLE = 1
         WRITE (YZW,'(I2.2)') ICYCLE
C        DATEI-PFAD ZUSAMMENSETZEN
         CALL getEnvironment('LIBDWD_GRIBTABLE_PATH',YROUT,IRM2)
         YLOCFN = YROUT(:LEN_TRIM(YROUT))//PATH_CHAR//'cenwmo'//YZW
         OPEN (UNIT=IUN,FILE=YLOCFN,IOSTAT=ISTAT)
         IF (ISTAT.NE.0)  GOTO 4
         READ (IUN,3,IOSTAT=ISTAT,END=4)
     +         (ICNUM(I),YCENFM(I),YCKURZ(I),YCNTER(I),I=1,ITMAX)
3        FORMAT (I2,A4,A10,A30)

4        CONTINUE
         IF (ISTAT.GT.0) THEN
            PRINT 95 ,YLOCFN(1:LEN_TRIM(YLOCFN)),ISTAT
95          FORMAT (T10,'GRBCMI --- FEHLER BEI READ ',A8,'---,ISTAT
     + =',I5.1)
            IRM1 = 1
         END IF
         CLOSE (UNIT=IUN,IOSTAT=ISTAT)
      END IF
C     ****************************************************************
C     **********  TABELLEN-FILE-VERARBEITUNG ABGESCHLOSSEN  **********
C     ****************************************************************
C
C     KENNUNG FUER CENTRE AUS SCHLUESSELZAHL IPDB(3) BESTIMMEN
C
      DO 10 I = 1,ITMAX
      IF (ICNUM(I).EQ.IPDB(3))  GOTO 15
10    CONTINUE
      IRM = 1
      GOTO 25
15    CONTINUE
      YCENTA = YCKURZ(I)
      YCENTF = YCENFM(I)
      YCENT  = YCNTER(I)
25    CONTINUE
C
C     KENNUNG FUER MODELL-TYP BESTIMMMEN
C     - BESTIMMUNG NUR DURCHFUEHREN, WENN ABSENDER (CENTRE) = OFFENBACH
C
      IF (IPDB(3).EQ.78.OR.IPDB(3).EQ.79) THEN
C
         CALL TYPKD (IPDB(4),YDUM,YVAR,IWTYP,IWGDB,IRM)
         IF (IRM.NE.0) THEN
            PRINT 96
96          FORMAT (T10,'GRBCMI --- FEHLER IN UP TYPKD:            ---',
     +            /,T16,'MODELL-TYP-NR. ZU GROSS ODER NEGATIV      ---',
     +            /,T16,'ODER    PROGRAMM-FEHLER                   ---')
            GOTO 9000
         END IF
         IF (YVAR(1).EQ.' ') THEN
C     WENN TYP NICHT DEFINIERT, MODELL-NUMMER IN DER FORM 'TYIII' NACH
C     YMODEL SCHREIBEN
            WRITE (YMODEL,9101) IPDB(4)
9101        FORMAT ('TY',I3.3)
         ELSE
            YMODEL = YVAR(1)
         END IF
      ELSE
C     - WENN CENTRE .NE. OFFENBACH, MODELL-NR. IN DER FORM 'TYIII' NACH
C       YMODEL SCHREIBEN
         WRITE (YMODEL,9101) IPDB(4)
      END IF
C
C     PROGRAMM BEENDEN
9000  CONTINUE
      IRM = IRM + IRM1
      RETURN
      END
