      SUBROUTINE GRBEX1 (IEDNR,IPS,UNDEF,NDIMS,IDIMS,IWPDS,IWGDS,IWBMS,
     +                   IWBDS,IBMAP,DSUP,DS,IBLOCK,IRM)

C**** GRBEX1   -   FELDDATEN (KENNDATEN,DATENSATZ) IN GRIB1-CODE UMSETZEN
C**   AUFRUF   :   CALL GRBEX1 (IEDNR,IPS,UNDEF,NDIMS,IDIMS,IWPDS,IWGDS,IWBMS,
C**               +             IWBDS,IBMAP,DSUP,DS,IBLOCK,IRM)
C**   ZWECK    :   FELDDATEN IM GRIB-CODE SPEICHERN
C**                (HINWEISE  S.A. .ROUTARZ.MRZ3.TIPS.GRIB.GRIB_DOKU)
C**   PARAMETER: INPUT:
C**                IEDNR     EDITIONSNUMMER, IEDNR=1 AB 11/1994
C**                IPS       SCHALTER FUER VERPACKUNGSART (VPA),
C**                          = 1, -> packGRIB1Daten WIRD AUFGERUFEN
C**                        ( = 2, -> FPACK2 WIRD AUFGERUFEN,
C**                                  DIESE VPA IST NOCH NICHT DEFINIERT )
C**                UNDEF     UNDEFINIERTER DATENSATZ-WERT (IN DER REGEL: -1E10)
C**                NDIMS     =20, BENOETIGTE DIMENSION FUER IDIMS
C**                IDIMS     DIMENSIONIERUNGEN
C**                -"- (1)   NWPDS,  DIMENSION FUER IWPDS
C**                -"- (2)   NWGDS,  DIMENSION FUER IWGDS
C**                -"- (3)   NWBMS,  DIMENSION FUER IWBMS
C**                -"- (4)   NWBDS,  DIMENSION FUER IWBDS
C**                -"- (5)   NBMAP,  DIMENSION FUER IBMAP
C**                -"- (6)   NDSUP,  DIMENSION FUER DSUP
C**                -"- (7)   LDS,    DIMENSION FUER DS
C**                -"- (8)   NBLOCK, DIMENSION FUER IBLOCK
C**                -"- (9)   -,      RESERVIERT
C**                -"-(10)   -,      RESERVIERT
C**                -"-(11)   IZPDS,  ANZAHL DER IWPDS-DATENWERTE
C**                -"-(12)   IZGDS,  ANZAHL DER IWGDS-DATENWERTE
C**                                  (nur die ersten, bis zu 25 IWGDS-DATENWERTE)
C**                -"-(13)   IZBMS,  ANZAHL DER IWBMS-DATENWERTE
C**                -"-(14)   IZBDS,  ANZAHL DER IWBDS-DATENWERTE
C**                -"-(15)   IZMAP,  ANZAHL DER BESETZTEN GITTERPUNKTE
C**                -"-(16)   IZSUP,  ANZAHL DER DSUP-DATENWERTE
C**                -"-(17)   IZLDS,  ANZAHL DER DS-DATENWERTE (=GITTERPKTE.),
C**                                  HINWEIS: IZLDS=0 IST NICHT ZULAESSIG;
C**                -"-(18)   LIBLAK, WORT-LAENGE VON IBLOCK (OUTPUTPARAMETER)
C**                -"-(19)   LIBLAKB,BYTE-LAENGE VON IBLOCK (OUTPUTPARAMETER)
C**                -"-(20)   -,      RESERVIERT
C**
C**                IWPDS      36 KENNDATEN BIS MAXIMAL
C**                          321 KENNDATEN DER PRODUKT-DEFINTION-SECTION (PDS):
C**                          ERLAEUTERUNG S. UP PUTPD1:
C**                          ALLE DATENWERTE (2..IZPDS) MUESSEN DEFINIERT SEIN,
C**                          UNBESETZTE WERTE BITTE MIT -999999 DEFINIEREN,
C**                          DEFAULT-WERTE (-1) SIND NICHT MEHR VORGESEHEN;
C**                          IWPDS(1) WIRD UEBER IZPDS VOM PROGRAMM ERMITTELT;
C**
C**                          UEBER IWPDS(6) (BLOCK-FLAG, S. TAB. 1 GRIB-CODE)
C**                          KANN DIE AUSGABE DER GRID-DESCRIPTION- UND DER
C**                          BITMAP-SECTION GESTEUERT WERDEN:
C**                          IWPDS(6)=128: NUR GDS AUSGEBEN;
C**                          IWPDS(6)=192: GDS UND BMS AUSGEBEN;
C**
C**                          WICHTIGE DATENWERTE FUER DEN PROGRAMMABLAUF SIND:
C**                          -------------------------------------------------
C**                          INDEX:    INHALT:     HINWEISE:
C**                          (6)       IBFLAG      BLOCK-FLAG,
C**                                                =128 -> GDS
C**                                                =192 -> GDS + BMS
C**                          (8)       FLAECH.-TYP TAB. 3
C**                          (19)      TIME-FLAG   TAB. 5
C**
C**                IWGDS     MAX. 626 KENNDATEN DER GRID-DEFINITION-SECTION (GDS):
C**                          ERLAEUTERUNG S. UP PUTGD1:
C**                          ALLE DATENWERTE (2..IZGDS) MUESSEN DEFINIERT SEIN,
C**                          UNBESETZTE WERTE BITTE MIT -999999 DEFINIEREN,
C**                          DEFAULT-WERTE (-1) SIND NICHT MEHR VORGESEHEN;
C**                          IWGDS(1) WIRD UEBER IZGDS VOM PROGRAMM ERMITTELT;
C**                          AB IWGDS(26) WERDEN VERTIKAL-KOORDINATEN ERWARTET,
C**                          DIESE MUESSEN MIT DWDLIB-FUNKTION IREFTS UMGESETZT
C**                          SEIN;
C**                          WICHTIGER DATENWERT FUER DEN PROGRAMMABLAUF IST:
C**                          ------------------------------------------------
C**                          IWGDS(226)=NROWS,  AB IWGDS(227) NROWS-REIHEN
C**                          IWGDS(226)= 0,     WENN KEINE NROWS-REIHEN
C**
C**                IWBMS     3 KENNDATEN DER BITMAP-SECTION
C**                          IWBMS(1) UND IWBMS(2) WERDEN VOM PROGRAMM GESETZT;
C**                          WICHTIGER DATENWERT FUER DEN PROGRAMMABLAUF IST:
C**                          ------------------------------------------------
C**                          IWBMS(3)  = NRBMAP,
C**                          > 0 -> NR DER ZU VERWENDENDEN BITMAP;  IBFLAG=192
C**                          = 0 -> BITMAP WIRD IN IBMAP GELIEFERT; IBFLAG=192
C**                          =-2 -> KEINE BITMAP, ALLE PKTE.DEFIN.; IBFLAG=128
C**                                               -> KEINE BITMAP-SECTION
C**
C**                IWBDS     11 KENNDATEN (MAX. 500) DER BINARY-DATA-SECTION,
C**                          ERLAEUTERUNG S. UP PUTBD1;
C**                          IWBDS(1), IWBDS(3), IWBDS(4) WERDEN VOM PROGRAMM
C**                          BESETZT;
C**                          UNBESETZTE WERTE BITTE MIT -999999 DEFINIEREN;
C**                          WICHTIGE DATENWERTE FUER DEN PROGRAMMABLAUF SIND:
C**                          -------------------------------------------------
C**                          IWBDS(2)  = IFLAG, INFORM. ZUR DATEN-ABSPEICHERUNG:
C**                              1.BIT = 0, -> EINF. GITTERPUNKTE
C**                                    = 1, -> SPHER. HARM. COEFF.
C**                              2.BIT = 0, -> SIMPLE PACKING
C**                                    = 1, -> COMPLEX PACKING
C**                              3.BIT = 0, -> FLOAT. POINT DATEN
C**                                    = 1, -> INTEGER DATEN
C**                              4.BIT = 0, -> KEINE WEITERE FLAG
C**                                    = 1, -> WEITERE FLAG (BEI SEC.ORDER.PCK.)
C**                           5..8.BIT      -> NUMBER OF UNUSED BITS, WIRD IM
C**                                            PROGRAMM ERRECHNET;
C**                                      WENN 4.BIT=1, DANN AB BYTE 14:
C**                                            (SECOND ORDER PACKING)
C**                              1.BIT = 0, -> RESERVED
C**                              2.BIT = 0, -> SINGLE DATUM
C**                                    = 1, -> MATRIX OF VOLUMES
C**                              3.BIT = 0, -> KEINE WEITEREN BITMAPS
C**                                    = 1, -> WEITERE BITMAPS
C**                              4.BIT = 0, -> SEC. ORDER VALUES CONSTANT WIDTH
C**                                    = 1, -> SEC. ORDER VALUES DIFFERENT WIDTH
C**                          IWBDS(5)  = NRBIT, BITANZAHL, ZULAESSIGER WERT:
C**                                      BYTE-ORIENTIERT (8, 16, ...),
C**                                      64-BIT-R.: <=48; 32-BIT-R.: <=24
C**                          IWBDS(6..11)   SIMPLE  PACKING DATA: -999999,
C**                                         COMPLEX PACKING DATA: SIEHE PUTBD1;
C**
C**                IBMAP     BITMAP, WENN IBMJ=IWBMS(3)  >= 0,
C**                                  LAENGE: JE GITTERPUNKT 1 BIT,
C**                                  BIT=1:  GITTERPUNKT DEFINIERT,
C**                                  BIT=0:  GITTERPUNKT UNDEFINIERT;
C**                          ALS DUMMY (IBMAP(1)) ZU LIEFERN, WENN NRBMAP # 0
C**
C**                DS        DATENSATZ (REAL-WERTE,
C**                          EINSCHLIESSLICH UNDEF. GITTERPUNKTE);
C**                          UNDEFINIERTE PUNKTE SOLLEN MIT -1E10 BELEGT SEIN;
C**                          BEI IUDSC=IWPDS(24)#0 WIRD DS MIT IUDSC SKALIERT:
C**                          DS(..) = DS(..) * 10**IUDSC
C**                DSUP(2)   = RPCOE, REAL PART OF COEFF. als REAL-WERT bei
C**                                   SPHER.HARM.COEFF. und SIMPLE PACKING
C**
C**              OUTPUT:
C**                IDIMS(18) LIBLAK, TATSAECHLICHE LAENGE VON IBLOCK IN WORTEN
C**                IDIMS(19) LIBLAKB, TATSAECHLICHE LAENGE VON IBLOCK IN BYTES
C**                DSUP      ARRAY ENTHAELT NACH DEM VERPACKEN (durch UP 
C**                          packGRIB1Daten)
C**                          REFMIN, (INPUT: DSUP(2)=RPCOE)  ODER UNGEP. DATEN;
C**                          DSUP(1)=REFMIN, WIRD VON packGRIB1Daten ERMITTELT, 
C**                          ODER AB DSUP(2)..   FOLGEN UNGEP. DATEN 
C**                          (durch UP SP2CP);
C**
C**                          SIEHE UP PUTBD1
C**                IBLOCK    FERTIGER GRIB-BLOCK (ERGEBNIS)
C**                IRM       FEHLER, WENN UNGLEICH 0
C**
C**
C**   VERFASSER:   A.ZALEWSKY, 11/94 (modifiziert, ohne TYPKD1: JAN.'97)
C     MODIFICATION: PARAMETER-WERTE NDSI/LBMAX/MBLOCK geaen.,A.Zalewsky,03.11.97
C     MODIFICATION: MBLOCK=81000*2 fuer 64-BIT-RECHNER, ARZ3ZAL.........25.11.97
C     MODIFICATION: IDIMS(19)=LGRIB.....................................23.04.98
C     MODIFICATION:MBLOCK=109000(*2),NDSI=210.000.......................23.11.98
C     MODIFICATION: SCHLEIFEN-OPTIMIERUNG LT. J.PICHELMEIER.............14.01.99
C     MODIFICATION:MBLOCK=140000(*2),NDSI=264000,LBMAX=4500(*2).........24.02.99
C.....MODIFICATION: FLOAT(10**-INT.WERT)=0.0, -> 1./FLOAT(10**+INT.WERT);
C...................nur noch #ifdef(CRAY;TEST)........................03.02.2000
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C*                            Ueberfluessige Parameter raus, #ifdef(CRAY) raus
C*                            Hilfsfelder vermeiden
C     MODIFICATION: IUNDEF=INT(UNDEF); A.Zalewsky.....................16.09.2004

      IMPLICIT NONE

      INTEGER IEDNR, IPS, NDIMS, IDIMS, IWPDS, IWGDS, IWBMS, IWBDS
      INTEGER IBMAP, IBLOCK, IRM
      INTEGER NRBMX, NRBMAPA, NRGB, MSKF0, MSK80, MSK40, MSK20, MSK10
      INTEGER NWPDS, NWGDS, NWBMS, NWBDS, NWBMAP, NDSUP, NBLOCK, NRBMPI
      INTEGER NRBIT, NRBGS, NUNUSB
      INTEGER IUNBES, ITMAX, ITMIN, NPDS, NGDS, NBMS, NBDS, NBP2, NWDTH
      INTEGER IWIDTH, IBMP2, IWPDSI, IWGDSI, IWBMSI, IWBDSI, IGRIB
      INTEGER I7777, MASK, MASK4, IUNDEF, LDS, IZPDS, IZGDS, IZBMS
      INTEGER IZBDS, IZBMAP, IZDAT, IZLDS, LIBLAK, IZBP2, IZWDTH, IBYTA
      INTEGER IBLL, IANF, IBYTS0, IDC, ITYPNR, IBFLAG, ITFLAG, IFLAG
      INTEGER IBMJ, IBIT1, IBIT2, IBYTS1, IDRTYP, IBYTS2, IWGANZ, KEND
      INTEGER IROWS, J1, LGDBI, IGDSLB, IBML, IBMLW, LDSI, ITAG, IUHR
      INTEGER IBYTS3, IFLG1, IFLG2, IFLG3, IFLG4, IBYTS4, IBYTAZ, IUDSC
      INTEGER IZW, ISCAL, IRB, IGRDE, IBLA, LGRIB, IBYTDR, KJ, KK, KM
      INTEGER KP, KJL, KKL, KML, KN, J3, JJ, IDSA, IZLDSI

      REAL    UNDEF, DSUP, DS, FZW, FAKT, REFMIN

#if defined(TEST)
      INTEGER IP
#endif
#include "machconsts.h"

      PARAMETER (IUNBES=-999999)
      PARAMETER (ITMAX=200,ITMIN=21,NPDS=321,NGDS=626,NBMS=3,NBDS=11)
      PARAMETER (NBP2=100,NWDTH=500)
      PARAMETER (NRBMX=3*IBMAX/4)  ! 24 fuer 32 bit Integers, 48 fuer Cray

      DIMENSION IWPDS(*),IWGDS(*),IWBMS(*),IWBDS(*),IDIMS(*),
     +          IBMAP(*),IBLOCK(*),DSUP(*),DS(*),
     +          IWIDTH(NWDTH),IBMP2(NBP2)
      DIMENSION IWPDSI(NPDS), IWGDSI(NGDS), IWBMSI(NBMS), IWBDSI(NBDS)

      REAL, ALLOCATABLE:: DSI(:)
      INTEGER, SAVE:: LBMAX
      DATA LBMAX /-1/
      INTEGER, SAVE, POINTER:: IBMAPI(:)

      CHARACTER YVAR(2)*5, YTYP*5
      SAVE NRBMAPA, NRGB
      DATA NRBMAPA /0/

      DATA IGRIB / Z'47524942' /
      DATA I7777 / Z'37373737' /
      DATA MASK  / Z'7FFFFF'   /
      DATA MASK4 / Z'FFFFFFFF' /
      DATA MSKF0 / Z'F0' /
      DATA MSK80 / Z'80' /
      DATA MSK40 / Z'40' /
      DATA MSK20 / Z'20' /
      DATA MSK10 / Z'10' /

C.....IUNDEF     = UNDEF.................................................16.09.04
      IUNDEF     = INT(UNDEF)
      IRM        = 0

C.....VERPACKUNGSART, IPS = 1 FUER packGRIB1Daten ?
      IF (IPS .NE. 1)                       THEN
         PRINT '('' GRBEX1: FEHLER, VERPACKUNGSART, IPS ='',I3,
     +           '' IST NOCH NICHT DEFINIERT !!'')',IPS
         IRM     = 1
         RETURN
      ENDIF

C.....DIMENSIONIERUNGEN UMSPEICHERN
      NWPDS      = IDIMS(1)
      NWGDS      = IDIMS(2)
      NWBMS      = IDIMS(3)
      NWBDS      = IDIMS(4)
      NWBMAP     = IDIMS(5)
      NDSUP      = IDIMS(6)
      LDS        = IDIMS(7)
      NBLOCK     = IDIMS(8)
C.....NBP2       = IDIMS(9)
C.....NWDTH      = IDIMS(10)

      IZPDS      = IDIMS(11)
      IZGDS      = IDIMS(12)
      IZBMS      = IDIMS(13)
      IZBDS      = IDIMS(14)
      IZBMAP     = IDIMS(15)
      IZDAT      = IDIMS(16)
      IZLDS      = IDIMS(17)
      LIBLAK     = IDIMS(18)
      IZBP2      = IDIMS(19)
      IZWDTH     = IDIMS(20)

C.....Beim ersten Aufruf IBMAPI als Dummy anlegen

      IF(LBMAX .LT. 0) THEN
         LBMAX = 1
         ALLOCATE(IBMAPI(1:1))
      ENDIF

#if defined(TEST)
      PRINT '('' GRBEX1: IDIMS='',2(/,1X,8I8))', (IDIMS(IP),IP=1,20)
#endif 

C.....DIMENSIONIERUNGEN UEBERPRUEFEN............................................
      IF (IZLDS .LE. 0)                     THEN
         PRINT '('' GRBEX1: FEHLER, GRIB OHNE GPKT.-DATEN; IDIMS(17)='',
     +                      I10)',                         IZLDS
         IRM     = 1
         RETURN
      ENDIF

      IF (IZBMAP.GT.0                       .AND.
     +   (IZBMAP.GT. IZLDS))                THEN
         PRINT '('' GRBEX1: BITMAP > DATENSATZLAENGE, IZBMAP, IZLDS='',
     +                      2I10)',                   IZBMAP, IZLDS
         IRM     = 1
         RETURN
      ENDIF

      IF (NWPDS .GT. NPDS)                  THEN
         PRINT '('' GRBEX1: MAX. DIMENSION FUER IWPDS UEBERSCHRITTEN,'',
     +           '' MAX. DIMENSION='',I5)', NPDS
         IRM     = 1
         RETURN
      ENDIF
      IF (NWGDS .GT. NGDS)                  THEN
         PRINT '('' GRBEX1: MAX. DIMENSION FUER IWGDS UEBERSCHRITTEN,'',
     +           '' MAX. DIMENSION='',I5)', NGDS
         IRM     = 1
         RETURN
      ENDIF
      IF (NWBMS .GT. NBMS)                  THEN
         PRINT '('' GRBEX1: MAX. DIMENSION FUER IWBMS UEBERSCHRITTEN,'',
     +           '' MAX. DIMENSION='',I5)', NBMS
         IRM     = 1
         RETURN
      ENDIF
      IF (NWBDS .GT. NBDS)                  THEN
         PRINT '('' GRBEX1: MAX. DIMENSION FUER IWBDS UEBERSCHRITTEN,'',
     +           '' MAX. DIMENSION='',I5)', NBDS
         IRM     = 1
         RETURN
      ENDIF

C.....ANZAHL DER DATENWERTE FUER DIE SEKTIONEN UEBERPRUEFEN.....................
      IF (IZPDS .GT. NPDS)                  THEN
         PRINT '('' GRBEX1: FEHLER; IZPDS > NPDS, IZPDS='',I5)',IZPDS
         IRM     = 1
         RETURN
      ELSE IF (IZPDS .LT. 0)                THEN
         PRINT '('' GRBEX1: FEHLER; IZPDS < 0, IZPDS='',I5)',IZPDS
         IRM     = 1
         RETURN
      ENDIF
      IF (IZGDS .GT. NGDS)                  THEN
         PRINT '('' GRBEX1: FEHLER; IZGDS > NGDS; IZGDS='',I5)',IZGDS
         IRM     = 1
         RETURN
      ELSE IF (IZGDS .LT. 0)                THEN
         PRINT '('' GRBEX1: FEHLER; IZGDS < 0, IZGDS='',I5)',IZGDS
         IRM     = 1
         RETURN
      ENDIF
      IF (IZBMS .GT. NBMS)                  THEN
         PRINT '('' GRBEX1: FEHLER; IZBMS > NBMS; IZBMS='',I5)',IZBMS
         IRM     = 1
         RETURN
      ELSE IF (IZBMS .LT. 0)                THEN
         PRINT '('' GRBEX1: FEHLER; IZBMS < 0, IZBMS='',I5)',IZBMS
         IRM     = 1
         RETURN
      ENDIF
      IF (IZBDS .GT. NBDS)                  THEN
         PRINT '('' GRBEX1: FEHLER; IZBDS > NBDS; IZBDS='',I5)',IZBDS
         IRM     = 1
         RETURN
      ELSE IF (IZBDS .LT. 0)                THEN
         PRINT '('' GRBEX1: FEHLER; IZBDS < 0, IZBDS='',I5)',IZBDS
         IRM     = 1
         RETURN
      ENDIF
      IF (IEDNR .NE. 1)                     THEN
         PRINT '('' GRBEX1: FEHLER; IEDNR='',I5)',IEDNR
         IRM     = 1
         RETURN
      ENDIF

C.....KENNUNG 'GRIB'  IN BYTE 1..4, IEDNR IN BYTE 8.............................
C.....GES. GRIBLAENGE IN BYTE 5..7 WIRD ERST AM PROGRAMM-ENDE ABGESPEICHERT
      IBLOCK(1) = ISHFT(IGRIB,IBMAX-32) ! Shift left fuer 64  Bit Integers
      IBYTA     = 8
      IBLL      = 1
      IANF      = IBYTW - IBLL + 1
      CALL SPUMB (IEDNR,IANF,IBLL,IBYTA,IBLOCK(1),IRM)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN SPUMB,'',
     +           '' IEDNR, IBYTA='',2I5)', IEDNR, IBYTA
         RETURN
      ENDIF

C.....SECTION 0, BYTELAENGE
      IBYTS0    = 8
      IBYTA     = IBYTS0 + 1

#if defined(TEST)
      PRINT '('' GRBEX1: IWPDS(1..'',I3,'')='',32(/,1X,10I7))',
     +           IZPDS, (IWPDS(IP),IP=1,IZPDS)
#endif 

C.....TYP-KENNGROESSEN HOLEN
      IRM        = 0
      IDC        = IWPDS(3)
      ITYPNR     = IWPDS(4)
      IBFLAG     = IWPDS(6)
      ITFLAG     = IWPDS(19)
      NRBMPI     = IWBMS(3)
      IFLAG      = IWBDS(2)
      NRBIT      = IWBDS(5)

C.....IBMJ  MIT (=1) ODER OHNE (=-1) BITMAP
      IBMJ          = 1
      IF (NRBMPI.EQ.-2)                     THEN
         IBMJ       = -1
         IDIMS(13)  = 0
         IDIMS(15)  = 0
      ENDIF

C.....IBFLAG, ITFLAG, NRBMPI NICHT DEFINIERT....................................
      IF (IBFLAG .EQ. IUNBES                .OR.
     +    IBFLAG .EQ. IUNDEF)               THEN
         PRINT '('' GRBEX1: FEHLER,'',
     +           '' IBFLAG IST NICHT DEFINIERT'')'
         IRM        = 1
         RETURN
      ENDIF
      IF (ITFLAG .EQ. IUNBES                .OR.
     +    ITFLAG .EQ. IUNDEF)               THEN
         PRINT '('' GRBEX1: FEHLER,'',
     +           '' ITFLAG IST NICHT DEFINIERT'')'
         IRM        = 1
         RETURN
      ENDIF
      IF (NRBMPI.EQ.-1                      .OR.
     +    NRBMPI.EQ.IUNBES                  .OR.
     +    NRBMPI.EQ.IUNDEF)                 THEN
         PRINT '('' GRBEX1: FEHLER,'',
     +           '' NRBMPI IST NICHT DEFINIERT'')'
         IRM        = 1
         RETURN
      ENDIF

C.....ABFRAGE, OB ITFLAG (IND=19) 2 WERTE ERFORDERT
   40 CONTINUE
      IF (ITFLAG.GE.2 .AND. ITFLAG.LE.5)    THEN
         IF (IWPDS(17) .EQ. IUNBES          .OR.
     +       IWPDS(17) .EQ. IUNDEF)         THEN
            PRINT '('' GRBEX1: FEHLER, ITFLAG='',I2,
     +              '' ERFORDERT 2 ZEITANGABEN '')', ITFLAG
            IRM     = 1
            RETURN
         ENDIF
      ENDIF

C.....IBFLAG UNTERSUCHEN:
C     BIT1 VON IBFLAG =1: GDS AUSZUGEBEN, BIT2 =1: BMS AUSZUGEBEN
      IBIT1         = IAND (ISHFT(IBFLAG,-7) ,1)
      IBIT2         = IAND (ISHFT(IBFLAG,-6) ,1)

#if defined(TEST)
      PRINT '('' GRBEX1: IBIT1,IBIT2='',2I2)',IBIT1,IBIT2
#endif 

      CALL PUTPD1 (IEDNR,IBYTA,IUNBES,NBLOCK,NPDS,IWPDS,
     +             IBLOCK,IZPDS,IRM)
C.....SECTION 1, BYTE-LAENGE
      IBYTS1     = IWPDS(1)
      IBYTA      = IBYTA + IBYTS1
#if defined(TEST)
      PRINT '('' GRBEX1: AFTER PUTPD1- IBYTS1, IBYTA='',2I10)',
     +                                 IBYTS1, IBYTA
#endif 

      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN PUTPD1 -'',
     +           '' IEDNR,IBYTA,IBYTS1='',3I5)', IEDNR,IBYTA,IBYTS1
         RETURN
      ENDIF

C.....GRID-DESCRIPTION-SECTION (GDS) AUFBEREITEN................................
C     IBFLAG-ABFRAGE FUER GDS
      IF (IBIT1 .NE. 1)                     THEN
         IF (IZGDS .EQ. 0)                  THEN
C...........KEIN GDB IM GRIB-FELD
            IDRTYP     = IUNBES
            IBYTS2     = 0
            IWGANZ     = 0
            KEND       = 0
            IROWS      = 0
            DO 45 J1   = 1, NGDS
   45       IWGDS(J1)  = 0
            GOTO 90
         ELSE
            IRM  = 1
            PRINT '('' GRBEX1: FEHLER, IBIT1=0, IZGDS='',I4,/,8X,
     +              '' -> KEINE GRID-DEFINITION-SECTION !!! '')',IZGDS
            RETURN
         ENDIF
      ENDIF

C.....WERTE DER GDS.............................................................

C.....WIEVIEL VORBESETZTE WORTE IN ABHAENGIGKEIT VON IDRTYP
      IDRTYP        = IWGDS(4)
      IF (IDRTYP.EQ.-1                      .OR.
     +    IDRTYP.EQ.IUNDEF                  .OR.
     +    IDRTYP.EQ.IUNBES)                 THEN
         IRM        = 1
         PRINT '('' GRBEX1: FEHLER, IDRTYP='',I10,
     +              ''; ! NICHT DEFINIERT !!! '')',IDRTYP
         RETURN
      ENDIF


C.....IWGDS(1) WIRD SPAETER BELEGT

C.....RESTL.WERTE BIS IWGDS(25) NULL SETZEN, WENN NICHT GELIEFERT
      IF (IZGDS .LT. 25)                    THEN
         DO 60 J1      = IZGDS+1, 25
         IWGDS(J1)     = 0
   60    CONTINUE
      ENDIF

C.....ROTIERTE GRIBS ABFRAGEN
C     IEDNR  IST UEBERGEBEN
      LGDBI      = IGDSLB(IDRTYP,IEDNR)
      IF (LGDBI .LT. 0)                     THEN
         PRINT '('' GRBEX1: IDRTYP, IEDNR='',2I5)', IDRTYP, IEDNR
         IRM     = 1
         RETURN
      ENDIF

      IWGANZ     = 25

C     WENN IWGDSI(2) > 0, DANN KOORD. AUS IWGDS UEBERNEHMEN
      KEND          = IWGDS(2)
      IF (KEND .GT. 0)                      THEN
C........4 BYTES PRO VERTIKALKOORDINATE
         KEND       = KEND + 25
         IF (NWGDS .LT. KEND)               THEN
#if defined(TEST)
            PRINT '('' GRBEX1: NWGDS < KEND; IDRTYP,IEDNR,NWGDS,KEND='',
     +              2I4)',                   IDRTYP,IEDNR,NWGDS,KEND
#endif 
            IRM     = 1
            RETURN
         ENDIF
         IF (KEND .LT. 225)                 THEN
            DO 71 J1   = KEND+1, 225
   71       IWGDS(J1)  = IUNBES
         ENDIF
      ELSE
         DO 72 J1   = 26, 225
   72    IWGDS(J1)  = IUNBES
      ENDIF

C.....NROWS-LISTING
      IROWS         = IWGDS(226)
      IWGDS(226)    = IROWS
      IF (IROWS .GT. 0)                     THEN
         IWGANZ     = IROWS + 227 - 1
         IF (IWGANZ .LT. 626)               THEN
            DO 81 J1   = IWGANZ+1, 626
   81       IWGDS(J1)  = IUNBES
         ENDIF
      ELSE
         IWGDSI(226)= 0
         DO 82 J1   = 227, 626
   82    IWGDS(J1)  = IUNBES
      ENDIF

C.....GDS NACH IBLOCK AUSGEBEN
#if defined(TEST)
      PRINT '('' GRBEX1: IBYTA,IZGDS,KEND,IROWS='',4I4,10X,''IWGDS='',
     +                   /,2(1X,10I7),/1X,I7,Z17,4X,2I7,Z17)',
     +                   IBYTA,IZGDS,KEND,IROWS,(IWGDS(IP),IP=1,25)
#endif 
      CALL PUTGD1 (IEDNR,IBYTA,IUNBES,NBLOCK,NGDS,IWGDS,
     +             IBLOCK,IZGDS,IRM)
C.....SECTION 2, BYTE-LAENGE
      IBYTS2     = IWGDS(1)
      IBYTA      = IBYTA + IBYTS2
      IF (IRM .NE. 0)                    THEN
         PRINT '('' GRBEX1: FEHLER IN PUTGD1 -'',
     +           '' IEDNR,IBYTA,IBYTS2='',3I5)', IEDNR,IBYTA,IBYTS2
         RETURN
      ENDIF

   90 CONTINUE
#if defined(TEST)
      PRINT '('' GRBEX1: AFTER PUTGD1- IBYTS2, IBYTA='',2I10)',
     +                                 IBYTS2, IBYTA
#endif 
C.....BITMAP-SECTION ?
      IF (IBMJ .EQ. -1)                     GOTO 150

C.....BITMAP-SECTION (BMS) AUFBEREITEN UND AUSGEBEN.............................

C.....BITMAP-LAENGE IN BYTES U. WORTEN  BERECHNEN
      IBML      = (IZLDS + IBYTE - 1) / IBYTE
      IBMLW     = (IBML  + IBYTW - 1) / IBYTW

#if defined(TEST)
      PRINT '('' GRBEX1: IZLDS,IBML,IBMLW,IBMJ='',4I7)',
     +                   IZLDS,IBML,IBMLW,IBMJ
#endif 

C.....BITMAP BEREITSTELLEN
      IF (NRBMPI .EQ. 0)                    THEN
C        GELIEFERTE BITMAP UMSPEICHERN, NRGB NACH BDB BERECHNEN
         NRBMAPA    = 0
C........Altes IBMAPI freigeben und in richtiger Groesse anlegen
         DEALLOCATE(IBMAPI)
         LBMAX = IBMLW
         ALLOCATE(IBMAPI(1:LBMAX))
         DO 100 J1  = 1, IBMLW
  100    IBMAPI(J1) = IBMAP(J1)
      ELSE IF (NRBMPI .GT. 0)               THEN
C        BITMAP AUS DATEI HOLEN, WENN NICHT SCHON ERFOLGT
         IF (NRBMAPA .NE. NRBMPI)           THEN
            NRBMAPA = NRBMPI
C...........BITMIN zunaechst mit LBMAX == -1 aufrufen, um Groesse der Bitmap
C...........zu ermitteln, altes IBMAPI freigeben und in richtiger Groesse anlegen,
C...........Bitmap einlesen
C...........DEFAULT-PFADNAMEN (YPFAD) IN UP BITMIN
            LBMAX = -1
            CALL BITMIN (' ' , NRBMPI, LBMAX, IBMAPI,
     +                   LDSI, NRGB, ITAG, IUHR, IRM)
            DEALLOCATE(IBMAPI)
            LBMAX = (LDSI-1)/IBMAX + 1
            ALLOCATE(IBMAPI(1:LBMAX))
            CALL BITMIN (' ' , NRBMPI, LBMAX, IBMAPI,
     +                   LDSI, NRGB, ITAG, IUHR, IRM)

C...........WARNG., WENN DS-LAENGE LAUT BITMAP-FILE FALSCH
            IF (IZLDS .NE. LDSI)            THEN
               PRINT '('' GRBEX1:'',
     +         '' WARNUNG...DS-LAENGE(PARAM.)'',
     +         '' UNGL.BITMAP-LAENGE: '',2I6,''; LDSI SIEGT!'')',
     +            IZLDS,LDSI
               IZLDS      = LDSI
               IZBMAP     = NRGB
               IDIMS(15)  = NRGB
               IDIMS(17)  = IZLDS
CT             CALL ARBITI (IBMAPI,10)
            ENDIF
         ENDIF
      ENDIF

#if defined(TEST)
      PRINT '('' GRBEX1: IBYTA,IZBMS,IZBMAP='',3I4,10X,''IWBMS='',
     +       /,1X,3I7)', IBYTA,IZBMS,IZBMAP,(IWBMS(IP),IP=1,IZBMS)
#endif 
      CALL PUTBM1 (IEDNR,IBYTA,NBLOCK,NWBMS,NWBMAP,IWBMS,
     +             IBMAPI,IBLOCK,IZLDS,IRM)
C.....SECTION 3, BYTE-LAENGE
      IBYTS3     = IWBMS(1)
      IBYTA      = IBYTA + IBYTS3
#if defined(TEST)
      PRINT '('' GRBEX1: AFTER PUTBM1- IBYTS3, IBYTA='',2I10)',
     +                                 IBYTS3, IBYTA
#endif 
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN PUTBM1 -'',
     +           '' IEDNR,IBYTA,IBYTS3='',3I5)', IEDNR,IBYTA,IBYTS3
         RETURN
      ENDIF

C.....DATEN-SECTION (BDS) AUFBEREITEN UND AUSGEBEN, ............................
C     DATENSATZ GEPACKT AUSGEBEN

  150 IF ((NRBIT.LE.0) .OR. (NRBIT.GT.NRBMX))    THEN
         PRINT '('' GRBEX1: FEHLER, NRBIT= '',I4,
     +           ''; ERLAUBT:0<NRBIT<='',I2)', NRBIT, NRBMX
         IRM     = 1
         RETURN
      ENDIF

C.....FLAGS UNTERSUCHEN
C     IFLAG -> 1 BYTE -> 8 BITS -> BITS: 8 7 6 5 4 3 2 1
C     IFLAG(1)   =   0,                  0               -> EINF. GITTERPUNKTE
C                =   1,                  1               -> SPHER. HARM. COEFF.
C     IFLAG(2)   =   0,                    0             -> SIMPLE PACKING
C                =   1,                    1             -> COMPLEX PACKING
C     IFLAG(3)   =   0,                      0           -> FLOAT.POINT DATEN
C                =   1,                      1           -> INTEGER DATEN
C     IFLAG(4)   =   0,                        0         -> KEINE WEITERE FLAG
C                =   1,                        1         -> WEITERE FLAG
C     IFLAG(5..12)   WERDEN ERST BEI BEDARF DEFINIERT

C.....DEFAULT-FLAG AUS UP TYPKD1
      IF (IWBDS(2) .EQ. -1                  .OR.
     +    IWBDS(2) .EQ. IUNBES              .OR.
     +    IWBDS(2) .EQ. IUNDEF)             THEN
         PRINT '('' GRBEX1: FEHLER, IWBDS(2)= '',I10,
     +           ''; ! NICHT DEFINIERT'')', IWBDS(2)
         IRM     = 1
         RETURN
      ENDIF

      IFLAG      = IAND(IWBDS(2),MSKF0)
      IFLG1      = IAND(IFLAG,MSK80)
      IFLG2      = IAND(IFLAG,MSK40)
      IFLG3      = IAND(IFLAG,MSK20)
      IFLG4      = IAND(IFLAG,MSK10)
#if defined(TEST)
      PRINT '('' GRBEX1: IFLAG='',Z17,10X,''IFLG1..4='',/,1X,4Z17)',
     +                   IFLAG, IFLG1,IFLG2,IFLG3,IFLG4
#endif 
C.....IFLG3      = MSK20, -> INTEGER-DATEN......................................
      IF (IFLG3 .EQ. MSK20)                 THEN
         PRINT '('' GRBEX1: INTEGER-DATEN NICHT DEFINIERT !!!'')'
         IRM     = 1
         RETURN
      ENDIF
C.....IFLG4      = MSK10, -> WEITERE FLAG
      IF (IFLG4 .EQ. MSK10)                 THEN
         PRINT '('' GRBEX1: WEITERE FLAG NICHT VORGESEHEN !!!'')'
         IRM     = 1
         RETURN
      ENDIF

C.....IFLG2      =   MSK40, -> COMPLEX PACKING..................................
      IF (IFLG2 .EQ. MSK40)                 GOTO 300

C.....IFLG2      =   0, -> SIMPLE PACKING, FELD PACKEN UND AUSGEBEN

      IF (IFLG1 .EQ. MSK80)                 THEN
C........IFLG1      =  MSK80             -> SPH.HARMONICS
C        ABWEICHENDE LAENGE DER BDS BEI SPEKTRAL-KOEFF.
         NDSUP      = 2
         IBYTS4     = 15
C        EXTERNES FELD ABFRAGEN
         IF (IWPDS(4).GT.200 .OR. IDC.NE.78) IWBDS(7) = 8
      ELSE
C........IFLG1      =  0,                -> EINF. GITTERPKTE
         NDSUP      = 1
         IBYTS4     = 11
         IWBDS(6)   = 0
C........EXTERNES FELD ABFRAGEN
         IF ((IWPDS(4).GT.200) .OR. (IDC.NE.78)) IWBDS(7) = 0
      ENDIF

C.....BYTE-ADRESSE FUER GITTERPUNKTDATEN-ABSPEICHERUNG: IBYTAZ -> packGRIB1Daten
      IBYTAZ        = IBYTA + IBYTS4
#if defined(TEST)
      PRINT '('' GRBEX1: VOR packGRIB1Daten- IBYTAZ, IBYTS4='',2I10)',
     +                               IBYTAZ, IBYTS4
#endif 

C.....DATEN MIT IWPDS(24) SKALIEREN
      IUDSC         = IWPDS(24)
      IF (IUDSC .NE. 0)                     THEN
C........RJ: DS wird beim Skalieren nicht mehr in das Zwischenfeld DSI
C            kopiert um Speicherplatz zu sparen.
C            Stattdessen wird FAKT an die Pack-Routine uebergeben.
C........FAKT       = 10**IUDSC....................................03.02.2000
C........FAKT       = 1./(10**IUDSC); wenn IUDSC negativ:FAKT=0.0..03.02.2000
         IZW        = ABS(IUDSC)
         FZW        = FLOAT(10**(IZW))
         IF (IUDSC .LT. 0)                  THEN
            FAKT    = 1.0/FZW
         ELSE
            FAKT    = FZW
         ENDIF
      ELSE
         FAKT = 1.0
      ENDIF

      NRBIT         = IWBDS(5)
#if defined(TEST)
      PRINT '('' GRBEX1: IZLDS,IBMJ,NRBIT,IUDSC='',4I8)',
     +                   IZLDS,IBMJ,NRBIT,IUDSC
#endif 
C.....Die Pack-Routine heisst jetzt packGRIB1Daten, weil sie den weiteren
C     Parameter FAKT hat.
      CALL packGRIB1Daten (DS(1),IZLDS,FAKT,UNDEF,IBMJ,IBMAPI,
     +             NRBIT,IBYTAZ,IBLOCK,ISCAL,REFMIN,NRGB,IRM)
#if defined(TEST)
      PRINT '('' GRBEX1: ISCAL,NRGB,REFMIN='',2I8,F18.10)',
     +                   ISCAL,NRGB,REFMIN
#endif 
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN packGRIB1Daten -'',
     +           '' IZLDS,IBYTAZ,IBMJ='',3I5)', IZLDS,IBYTAZ,IBMJ
         RETURN
      ENDIF
C.....NRGB FUER DATEN MIT BITMAP BEIM FELD AUSGEBEN
      IF (IBYTS3 .GT. 6)
     +   IDIMS(15)  = NRGB

C.....REFERENZWERT NACH DSUP(1) SETZEN
      DSUP(1)       = REFMIN

C.....LAENGE DER BDS IN BYTES
      NRBGS         = NRGB*NRBIT
      IBYTS4        = IBYTS4 + ((NRBGS+IBYTE-1) / IBYTE)
      IWBDS(1)      = IBYTS4
C.....UNUSED BITS BERECHNEN
      NUNUSB        = 0
      IRB           = MOD(NRBGS, IBYTE)
      IF (IRB .NE. 0)                       THEN
         NUNUSB     = IBYTE - IRB
      ENDIF
C.....GERADE BYTE-ANZAHL
      IGRDE         = MOD(IBYTS4,2)
      IF (IGRDE .NE. 0)                     THEN
         IF (NUNUSB .EQ. IBYTE)             THEN
            IBYTS4     = IBYTS4 - 1
            IWBDS(1)   = IBYTS4
            NUNUSB     = 0
         ELSE
            IBYTS4     = IBYTS4 + 1
            IWBDS(1)   = IBYTS4
            NUNUSB     = NUNUSB + IBYTE
         ENDIF
      ENDIF
C.....IFLAG UND NUNUSB -> IWBDSI(2)
      IWBDS(2)      = IFLAG + NUNUSB
      IWBDS(3)      = ISCAL
      IWBDS(5)      = NRBIT

#if defined(TEST)
      PRINT '('' GRBEX1:NRGB,NRBGS,IBYTS4,NUNUSB,IFLAG='',5I8)',
     +                  NRGB,NRBGS,IBYTS4,NUNUSB,IFLAG
#endif 

C.....BDS (OHNE DATENSATZ AUSGEBEN)
      IZBDS      = IDIMS(14)
      CALL PUTBD1 (IEDNR,IBYTA,NBLOCK,NWBDS,NDSUP,IWBDS,DSUP,
     +             IBLOCK,IZBDS,IRM)
C.....SECTION 4, BYTE-LAENGE
      IBYTA      = IBYTA + IBYTS4
#if defined(TEST)
      PRINT '('' GRBEX1: AFTER PUTBD1- IBYTS4, IBYTA='',2I10)',
     +                                 IBYTS4, IBYTA
#endif 
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN PUTBD1 -'',
     +           '' IEDNR,IBYTA,IBYTS4='',3I5)', IEDNR,IBYTA,IBYTS4
         RETURN
      ENDIF

C.....KENNUNG '7777' AUSGEBEN
      IBLA       = 1
      IBLL       = 4
      CALL SPUMB (ISHFT(I7777,IBMAX-32), IBLA, IBLL, IBYTA, IBLOCK(1),
     &            IRM)
C.....CALL SPUMB (I7777, 1, 4, IBYTA, IBLOCK(1), IRM)...................03.11.97
      IBYTA      = IBYTA  + 3
      LGRIB      = IBYTA
      LIBLAK     = (IBYTA + IBYTW - 1) / IBYTW
      IDIMS(18)  = LIBLAK
      IDIMS(19)  = LGRIB
#if defined(TEST)
      PRINT '('' GRBEX1: GESAMTLAENGE- IBYTA,LIBLAK,LGRIB='',3I10)',
     +                                 IBYTA,LIBLAK,LGRIB
#endif 

C.....GES. GRIBLAENGE (=IBYTA) IN BYTE 5..7 ABSPEICHERN.........................
      IBYTDR    = 5
      IBLL      = 3
      IANF      = IBYTW - IBLL + 1
      CALL SPUMB (LGRIB,IANF,IBLL,IBYTDR,IBLOCK(1),IRM)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN SPUMB,'',
     +           '' LGRIB, IBYTADR='',2I5)', LGRIB, IBYTDR
         RETURN
      ENDIF

      IF (LIBLAK .GT. NBLOCK) THEN
         PRINT '('' FEHLER V. GRBEX1: DIMENSION VON IBLOCK ZU KLEIN'',
     +           '';NBLOCK='',I6)',NBLOCK
         IRM     = 1
      ENDIF
      RETURN

  300 CONTINUE
C.....COMPLEX PACKING...........................................................

C.....RJ: Im Fall des COMPLEX PACKING brauchen wir DSI, da dieses Feld
C         in SP2CP umgeschaufelt wird

      ALLOCATE(DSI(1:IZLDS))

C.....DATEN MIT IWPDS(24) SKALIEREN
      IUDSC         = IWPDS(24)
      IF (IUDSC  .NE. 0)                    THEN
C........SCHLEIFEN-OPTIMIERUNG LT. J.PICHELMEIER.......................14.01.99
C........FAKT       = 10**IUDSC......................................03.02.2000
C........FAKT       = 1./(10**IUDSC); wenn IUDSC negativ:FAKT=0.0....03.02.2000
         IZW        = ABS(IUDSC)
         FZW        = FLOAT(10**(IZW))
         IF (IUDSC .LT. 0)                  THEN
            FAKT    = 1.0/FZW
         ELSE
            FAKT    = FZW
         ENDIF               
         DO 310 J1  = 1, IZLDS
         IF (DS(J1) .NE. UNDEF)             THEN
C...........DSI(J1) = DS(J1) * 10**IUDSC...............................14.01.99
            DSI(J1) = DS(J1) * FAKT
         ELSE
            DSI(J1) = DS(J1)
         ENDIF
  310    CONTINUE
      ELSE
         DO 320 J1  = 1, IZLDS
  320    DSI(J1)    = DS(J1)
      ENDIF

C.....DATENSATZ SORTIEREN UND NORMIEREN
      KJ         = IWGDS(5)
      KK         = IWGDS(6)
      KM         = IWGDS(7)
      KP         = IWBDS(7)
      KJL        = IWBDS(8)
      KKL        = IWBDS(9)
      KML        = IWBDS(10)
      KN         = 0
      CALL SP2CP  (DSI,KJ,KK,KM,KJL,KKL,KML,KP,KN,IRM)
      IF (IRM .NE. 0)                    THEN
         PRINT '('' GRBEX1: FEHLER IN SP2CP1 -'',
     +           '' KJ,KK,KM,KP,KJL,KKL,KML,KN='',/,1X,8I9)',
     +              KJ,KK,KM,KP,KJL,KKL,KML,KN
         DEALLOCATE(DSI)
         RETURN
      ENDIF

      DO 330 J3  = 1, KN
      JJ         = J3 + 1
  330 DSUP(JJ)  = DSI(J3)
      IDSA       = KN + 1
      IZLDSI     = IZLDS - KN

      IBYTS4     = 18 + KN*4
#if defined(TEST)
      PRINT '('' GRBEX1: KJ,KK,KM,KP,KJL,KKL,KML,KN,IBYTS4='',/,9I9)',
     +                   KJ,KK,KM,KP,KJL,KKL,KML,KN,IBYTS4
      PRINT '('' GRBEX1: DSUP(   2..'',I4,'')='',15(/,1X,5E12.5))',
     +            KN+1, (DSUP(IP),IP=2,KN+1)
#endif 

      IWBDS ( 6) = IBYTS4 + 1
      IWBDS (11) = KN

C.....KOMPRIMIERBARE DATEN PACKEN
      IBYTAZ     = IBYTA + IBYTS4
#if defined(TEST)
      PRINT '('' GRBEX1: IBYTAZ,IZLDS,IZLDSI,IBMJ,NRBIT='',5I8)',
     +                   IBYTAZ,IZLDS,IZLDSI,IBMJ,NRBIT
#endif 
C.....RJ: Wir benutzen auch hier packGRIB1Daten, damit nur eine 
C     Version noetig ist
      CALL packGRIB1Daten (DSI(IDSA), IZLDSI, 1.0, UNDEF, IBMJ, 
     +             IBMAPI, NRBIT,IBYTAZ, IBLOCK, ISCAL,
     +             REFMIN, NRGB, IRM)
C.....RJ: Ab hier wird DSI nicht mehr gebraucht
      DEALLOCATE(DSI)
#if defined(TEST)
      PRINT '('' GRBEX1: ISCAL,NRGB,REFMIN='',2I8,F18.10)',
     +                   ISCAL,NRGB,REFMIN
#endif 
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN packGRIB1Daten -'',
     +           '' IZLDS,IBYTAZ,IBMJ='',3I5)', IZLDS,IBYTAZ,IBMJ
         RETURN
      ENDIF
C.....REFERENZWERT NACH DSUP(1) UMSETZEN
      DSUP(1)   = REFMIN

C.....LAENGE DER BDS IN BYTES
      NRBGS      = NRGB  * NRBIT
      IBYTS4     = IBYTS4 + ((NRBGS+IBYTE-1) / IBYTE)
      IWBDS (1)  = IBYTS4
C.....UNUSED BITS BERECHNEN
      IRB        = MOD (NRBGS, IBYTE)
      NUNUSB     = 0
      IF (IRB .NE. 0)                       THEN
         NUNUSB  = IBYTE - IRB
      ENDIF
C.....GERADE BYTE-ANZAHL
      IGRDE         = MOD(IBYTS4,2)
      IF (IGRDE .NE. 0)                     THEN
         IF (NUNUSB .EQ. IBYTE)             THEN
            IBYTS4     = IBYTS4 - 1
            IWBDS (1)  = IBYTS4
            NUNUSB     = 0
         ELSE
            IBYTS4     = IBYTS4 + 1
            IWBDS (1)  = IBYTS4
            NUNUSB     = NUNUSB + IBYTE
         ENDIF
      ENDIF

C.....IFLAG UND NUNUSB -> IWBDSI(2) SPEICHERN
      IWBDS (2)  = NUNUSB + IFLAG
      IWBDS (3)  = ISCAL
      IWBDS (5)  = NRBIT
#if defined(TEST)
      PRINT '('' GRBEX1:NRGB,NRBGS,IBYTS4,NUNUSB,IFLAG='',5I8)',
     +                  NRGB,NRBGS,IBYTS4,NUNUSB,IFLAG
#endif 

C.....VORDERTEIL DER BDS EINFUEGEN ( EVTL.MIT NICHT KOMPRIMIERTEN WERTEN)
      IZBDS      = IDIMS(14)
      CALL PUTBD1 (IEDNR,IBYTA,NBLOCK,NWBDS,NDSUP,IWBDS,DSUP,
     +             IBLOCK,IZBDS,IRM)
C.....SECTION 4, BYTE-LAENGE
      IBYTA      = IBYTA + IBYTS4
#if defined(TEST)
      PRINT '('' GRBEX1: AFTER PUTBD1- IBYTS4, IBYTA='',2I10)',
     +                                 IBYTS4, IBYTA
#endif 
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN PUTBD1 -'',
     +           '' IEDNR,IBYTA,IBYTS4='',3I5)', IEDNR,IBYTA,IBYTS4
         RETURN
      ENDIF

C.....KENNUNG '7777' AUSGEBEN...................................................
      IBLA       = 1
      IBLL       = 4
      CALL SPUMB (ISHFT(I7777,IBMAX-32), IBLA, IBLL, IBYTA, IBLOCK(1),
     &            IRM)
C.....CALL         SPUMB (I7777, 1, 4, IBYTA, IBLOCK(1), IRM)...........03.11.97
      IBYTA      = IBYTA + 3
      LGRIB      = IBYTA
      LIBLAK     = (IBYTA + IBYTW - 1) / IBYTW
      IDIMS(18)  = LIBLAK
      IDIMS(19)  = LGRIB
#if defined(TEST)
      PRINT '('' GRBEX1: GESAMTLAENGE- IBYTA,LGRIB,LIBLAK='',3I10)',
     +                                 IBYTA,LGRIB,LIBLAK
#endif 

C.....GES. GRIBLAENGE (=IBYTA) IN BYTE 5..7 ABSPEICHERN.........................
      IBYTDR    = 5
      IBLL      = 3
      IANF      = IBYTW - IBLL + 1
      CALL SPUMB (LGRIB,IANF,IBLL,IBYTDR,IBLOCK(1),IRM)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' GRBEX1: FEHLER IN SPUMB,'',
     +           '' LGRIB, IBYTADR='',2I5)', LGRIB, IBYTDR
         RETURN
      ENDIF

      RETURN


  500 CONTINUE
      RETURN

  700 CONTINUE
      RETURN

      END
