      SUBROUTINE GRBIN1 (IEDNR,UNDEF,NDIMS,IDIMS,IBLOCK,IBMAP,IWPDS,
     +                   IWGDS,IWBMS,IWBDS,DSUP,DS,IRM)

C**** GRBIN1   -   GRIBCODE-FELD MIT IEDNR=1 IN KENNDATEN UND DATENSATZ ZERLEGEN
C**   AUFRUF   :   CALL GRBIN1 (IEDNR,UNDEF,NDIMS,IDIMS,IBLOCK,IBMAP,IWPDS,
C**               +             IWGDS,IWBMS,IWBDS,DSUP,DS,IRM)
C**   ZWECK    :   GRIBCODE-FELD JE BLOCK IN EINZELWERTE ZERLEGEN
C**   PARAMETER:   INPUT:    UNDEF, NDIMS, IDIMS(1..10), IBLOCK
C**                --------------------------------------------
C**                UNDEF     WERT, MIT DEM EIN UNDEFINIERTER PUNKT IM AUSGABE-
C**                          FELD BESETZT WERDEN SOLL; BEI ANGABE VON 0. OD. -1.
C**                          WIRD UNDEF PER DEFAULT MIT -1E10 BESETZT
C**                NDIMS     =20, ERWARTETE DIMENSION FUER IDIMS
C**                IDIMS( 1..10):    DIMENSIONIERUNG FUER:
C**                 -"- (1)  NWPDS,  USER-DIMENSION FUER IWPDS
C**                 -"- (2)  NWGDS,  USER-DIMENSION FUER IWGDS
C**                 -"- (3)  NWBMS,  USER-DIMENSION FUER IWBMS
C**                 -"- (4)  NWBDS,  USER-DIMENSION FUER IWBDS
C**                 -"- (5)  NWBMAP, USER-DIMENSION FUER IBMAP
C**                 -"- (6)  NDSUP,  USER-DIMENSION FUER DSUP
C**                 -"- (7)  NDS,    USER-DIMENSION FUER DS
C**                 -"- (8)  NBLOCK, USER-DIMENSION FUER IBLOCK
C**                 -"- (9)  -,      RESERVIERT (=0)
C**                 -"-(10)  -,      RESERVIERT (=0)
C**                     --
C**                IBLOCK    FELD IM GRIB-CODE (IEDNR=1 AB 11/94)
C**
C**                OUTPUT:   IEDNR,IDIMS(11..20),IBMAP,IWPDS,IWGDS,IWBMS,
C**                                                    IWBDS,DSUP,DS,IRM
C**                ------------------------------------------------------
C**                IEDNR     EDITIONSNUMMER, IEDNR=1 AB 11/1994
C**                IDIMS(11..20):    AKTUELLE ANZAHL DER DATEN
C**                 -"-(11)  IZPDS,  ANZAHL DER DATEN IN IWPDS
C**                 -"-(12)  IZGDS,  ANZAHL DER DATEN IN IWGDS
C**                                  (NUR DIE ERSTEN, BIS ZU 25 IWGDS-DATENWERTE)
C**                 -"-(13)  IZBMS,  ANZAHL DER DATEN IN IWBMS
C**                 -"-(14)  IZBDS,  ANZAHL DER DATEN IN IWBDS
C**                 -"-(15)  IZBMAP, ANZAHL DER BESETZTEN GITTERPUNKTE
C**                 -"-(16)  IZSUP,  ANZAHL DER DATEN IN DSUP
C**                 -"-(17)  IZLDS,  ANZAHL DER DATEN IN DS
C**                                  = LAENGE DES GELESENEN DATENSATZES
C**                 -"-(18)  IZBLCK, GESAMTLAENGE DES GRIBS IN WORTEN
C**                 -"-(19)  LGRIB,  GESAMTLAENGE DES GRIBS IN BYTES
C**                 -"-(20)  -,      RESERVIERT (=0)
C**
C**   !!! Oktober 2000, RJ:
C**                Falls IDIMS(5) (NWBMAP) = -1 wird IBMAP nicht besetzt,
C**                alle anderen Berechnungen laufen normal ab.
C**                Falls IDIMS(7) (NDS) = -1 wird DS nicht besetzt,
C**                die Laenge des Gribs wird in IDIMS(17) zurueckgegeben,
C**                so dass ein erneuter Aufruf mit ausreichend dimensionierten
C**                Feldern erfolgen kann.
C**
C**                IBMAP     FELD-BITMAP
C**                IWPDS      36 KENNDATEN BIS MAXIMAL
C**                          321 KENNDATEN DER PRODUCT-DEFINIT.-SECTION
C**                          - ERLAEUTERUNGEN S. UP GETPD1 -
C**   !!! NEU AB SEPT. '03:                                                         
C**                          IWPDS37)=-253, AB BYTE 41 WERDEN UNBEKANNTE PDB-DATEN
C**                          AB IWPDS(50) BYTEWEISE UMGESPEICHERT !
C**                          IN IWPDS(48) STEHT ANZAHL DER RESTL.UNBEKANNTEN BYTES,
C**                          IN IWPDS(49) STEHT WORT-ANZAHL FUER RESTL.UNBEK.BYTES,
C**                          GILT AUCH FUER:  IWPDS(37)=-254 UND IWPDS(3)#98/78/79
C**
C**                IWGDS     MAX. 626 KENNDATEN DER GRID-DESCRIPTION-SECTION;
C**                          IN IWGDS(2) STEHT DIE ANZAHL DER VERTIKAL-KOORDINATEN,
C**                          IN IWGDS(226) STEHT DIE ANZAHL DER REIHEN
C**                          - ERLAEUTERUNGEN S. UP GETGD1 -
C**                IWBMS     3 KENNDATEN DER BITMAP-SECTION,
C**                          - ERLAEUTERUNGEN S. UP GETBM1 -
C**   !!! NEU AB MAERZ '97:
C**                          WENN KEINE BITMAP-SECTION BEIM FELD, ALSO IWPDS(6)
C**                          =128 ODER =0, DANN WIRD IWBMS(3) = -2 GESETZT STATT
C**                          WIE BISHER IWBMS(3) = 0; DIES GESCHIEHT ZUR FEHLER-
C**                          VERMEIDUNG, WENN NACH GRBIN1 GRBEX1 AUFGERUFEN WIRD
C**
C**                IWBDS     MAX. 11 KENNDATEN DER BINARY-DATA-SECTION,
C**                          - ERLAEUTERUNGEN S. UP GETBD1 -
C**                DSUP     ARRAY ENTHAELT REFMIN, RPCOE ODER UNGEP. DATEN,
C**                          DSUP(1)=REFMIN,
C**                          DSUP(2)=RPCOE ODER AB DSUP(2)..
C**                                              FOLGEN UNGEP. DATEN;
C**                          - ERLAEUTERUNGEN S. UP GETBD1 -
C**                DS        DATENSATZ (JE WERT 1 WORT, REAL);
C**                          NEU: DATEN SIND MIT IWPDS(24) SKALIERT;  08.05.1996
C**                               DS(..) = DS(..) * 10**(-IWPDS(24))
C**                IRM       FEHLER-RUECKMELDEZELLE (BEI FEHLER UNGLEICH 0)
C**   VERFASSER:   A.ZALEWSKY, TE23C, 12/94
C                  last modif.: 25.07.97, cd4: /rhome/routarz
C     Letzte Aenderung U.Voigt am 1.8.97: ROUTROOT vor die Dateipfade
C     MODIFICATION: PARAMETER-WERTE LDSMAX/LBMAX geaend., A.Zalewsky,   03.11.97
C.....MODIFICATION: BYTELAENGE DES GRIBS ALS OUTPUT IN IDIMS(19)........23.04.98
C.....MODIFICATION: LDSMAX=210000.......................................23.11.98
C.....MODIFICATION: SCHLEIFEN-OPTIMIERUNG LT. J.PICHELMEIER.............14.01.99
C.....MODIFICATION:LDSMAX=264000,LBMAX=4500(*2).........................24.02.99
C.....MODIFICATION: FLOAT(10**-INT.WERT)=0.0, -> 1./FLOAT(10**+INT.WERT);
C...................nur noch #ifdef(CRAY;UMORG96;TEST)................01.02.2000
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C*                            Ueberfluessige Parameter raus, #ifdef(CRAY) raus
C*    GEAENDERT:   A.Zalewsky, TI14, 09/03, HINWEISE geaendert: NEU AB SEPT. '03

      IMPLICIT NONE

      INTEGER IEDNR, NDIMS, IDIMS, IBLOCK, IBMAP, IWPDS, IWGDS, IWBMS
      INTEGER IWBDS, IRM
      INTEGER NWPDS, NWGDS, NWBMS, NWBMAP
      INTEGER NBP2, NWDTH, IUNBES, ITMAX, ITMIN, NPDS, NGDS, NBMS, NBDS
      INTEGER IBMP2, IWIDTH, IBDIM, IDANZ, NRBMAP, IBMJ, LDS, NRGB
      INTEGER LWBMAP, IGRIB, MASK4, MSKF0, MSK0F, MSK80, MSK40, MSK20
      INTEGER MSK10, IUNDEF, NWBDS, NDSUP, NDS, NBLOCK, IZBLCK, KENN
      INTEGER LGRIB, IBLL, IBZW, IANF, IBYTA, IZPDS, IBFLAG, IBIT1
      INTEGER IBIT2, IZGDS, J5, IZBMAP, ITAG, IUHR, IZW, LBMAPB, LBMUM
      INTEGER J, IZBDS, IZDATA, ILBMP2, IZWDTH, IZBT2, IBYTAZ, IFLAG
      INTEGER NUNUSB, ISCAL, NRBIT, IFLG1, IFLG2, IFLG3, IFLG4, LBDBA
      INTEGER NRGRP, IUDSC, IFLGE, IBDSA, NUNP, J3, JJ, IDSA, IZLDS
      INTEGER IBDS1, NRPACK, KJ, KK, KM, KP, KJL, KKL, KML, KN

#if defined(TEST)
      INTEGER IP, IGZW
#endif

      REAL    UNDEF, DSUP, DS, FZW, FAK, UNDEFI, REFMIN

#include "machconsts.h"


      PARAMETER (NBP2=100,NWDTH=500,IUNBES=-999999)
      
      PARAMETER (ITMAX=200,ITMIN=21,NPDS=321,NGDS=626,NBMS=3,NBDS=11)

      DIMENSION  IBLOCK(*), IWPDS(*), IWGDS(*), IWBMS(*),  IWBDS(*),
     +           DS(*),     DSUP(*),  IBMAP(*),
     +           IDIMS(*),  IBMP2(NBP2),        IWIDTH(NWDTH),
     +           IBDIM(6),  IDANZ(6)

C.....IBMAPI, DA IBMAP DUMMY ARGUMENT
C.....SAVE NRBMAP, IBMAPI, IBMJ, LDS, NRGB..............................03.11.97
      SAVE         NRBMAP, IBMJ, LDS, NRGB, LWBMAP
      DATA NRBMAP /0/
      INTEGER, SAVE:: LBMAX
      DATA LBMAX /-1/
      INTEGER, SAVE, POINTER:: IBMAPI(:)

      DATA IGRIB / Z'47524942' /
      DATA MASK4 / Z'FFFFFFFF' /
      DATA MSKF0 / Z'000000F0' /
      DATA MSK0F / Z'0000000F' /
      DATA MSK80 / Z'00000080' /
      DATA MSK40 / Z'00000040' /
      DATA MSK20 / Z'00000020' /
      DATA MSK10 / Z'00000010' /


C.....WERTE VORBESETZEN
      IUNDEF                 = -999999
      IF ((UNDEF.EQ.0.) .OR. (UNDEF.EQ.-1.))               THEN
         UNDEFI              = -1E10
      ELSE
         UNDEFI              = UNDEF
      ENDIF

      IRM                    = 0
C.....DIMENSIONIERUNGEN UMSPEICHERN
      NWPDS                  = IDIMS(1)
      NWGDS                  = IDIMS(2)
      NWBMS                  = IDIMS(3)
      NWBDS                  = IDIMS(4)
      NWBMAP                 = IDIMS(5)
      NDSUP                  = IDIMS(6)
      NDS                    = IDIMS(7)
      NBLOCK                 = IDIMS(8)
C.....NBP2                   = IDIMS(9)
C.....NWDTH                  = IDIMS(10)
      IZBLCK                 = IDIMS(18)
      IBDIM(1)               = NWBDS
      IBDIM(2)               = NDSUP
      IBDIM(3)               = NBP2
      IBDIM(4)               = NWDTH
      IBDIM(5)               = NBLOCK
      IBDIM(6)               = IUNBES

C.....Beim ersten Aufruf IBMAPI als Dummy anlegen

      IF(LBMAX .LT. 0) THEN
         LBMAX = 1
         ALLOCATE(IBMAPI(1:1))
      ENDIF


C.....KENNUNG 'GRIB' ABFRAGEN
      IF(IBYTW.EQ.8) THEN
         KENN                = IAND (ISHFT(IBLOCK(1),-32), MASK4)
      ELSE
         KENN                = IAND (IBLOCK(1), MASK4)
      ENDIF
      IF (KENN .NE. IGRIB)                                 THEN
         PRINT '('' ///GRBIN1-FEHLER: ANFANGSKENNUNG NICHT GRIB'')'
         IRM                 = 1
         RETURN
      ENDIF

C.....IEDNR UND LGRIB (GRIB-LAENGE) HOLEN
      IEDNR                  = 0
      LGRIB                  = 0
      IBLL                   = 3
      IBZW                   = IBYTW-IBLL+1
      IANF                   = 5
      CALL SPUMB (IBLOCK(1),IANF,IBLL,IBZW,LGRIB,IRM)
C.....CALL SPUMB (IBLOCK(1), 5, IBLL,  IBZW, LGRIB, IRM)................03.11.97
C.....GRIBLAENGE NACH IDIMS(19).........................................23.04.98
      IDIMS(19)              = LGRIB
      IANF                   = 8
      IBLL                   = 1
      CALL SPUMB (IBLOCK(1),IANF,IBLL,IBYTW,IEDNR,IRM)
C.....CALL SPUMB (IBLOCK(1), 8,    1, IBYTW, IEDNR, IRM)................03.11.97
C.....AKT. LAENGE VON IBLOCK IN WORTEN
      IDIMS(18)              = (LGRIB+IBYTW-1)/IBYTW

      IF (IEDNR .EQ. 1)                                    THEN
         IBYTA   = 9
      ELSE
         PRINT '('' GRBIN1: FEHLER - IEDNR='',I3,
     +           '' NICHT DEFINIERT'')',      IEDNR
         IRM                 = 1
         RETURN
      ENDIF
      IF (LGRIB .LE. 0)                                    THEN
         PRINT '('' GRBIN1: FEHLER - LGRIB='',I10)', LGRIB
         IRM                 = 1
         RETURN
      ENDIF
#if defined(TEST)
      PRINT '('' GRBIN1: IEDNR,LGRIB,IZBLCK,IBYTA='',4I8)',
     +                   IEDNR,LGRIB,IZBLCK,IBYTA
      CALL ARBITI (IBLOCK(1),50)
#endif 

C.....PDS HOLEN
      CALL GETPD1 (IEDNR,IBYTA,IUNDEF,NBLOCK,NWPDS,IBLOCK(1),
     +             IWPDS,IZPDS,IRM)
      IF (IRM .NE. 0)                                      RETURN
C.....IDIMS(11)              = IZPDS
      IDIMS(11)              = IZPDS

      IBYTA                  = IBYTA+IWPDS(1)
#if defined(TEST)
      PRINT '(/,'' GRBIN1: IBYTA,IZPDS='',2I4,10X,'' IWPDS='',
     +       32(/,10I7))', IBYTA,IZPDS,(IWPDS(IP),IP=1,IZPDS)
#endif 

C.....BITS AUS IBFLAG HOLEN
      IBFLAG                 = IWPDS(6)
      IBIT1                  = IAND(ISHFT(IBFLAG,-7),1)
      IBIT2                  = IAND(ISHFT(IBFLAG,-6),1)
#if defined(TEST)
      PRINT '('' GRBIN1:IBIT1,IBIT2='',2I2)',IBIT1,IBIT2
#endif 

C.....GDS HOLEN
      IDIMS(12)              = 0
      IF (IBIT1 .EQ. 1)                                    THEN
         CALL GETGD1 (IEDNR,IBYTA,IUNDEF,NBLOCK,NWGDS,IBLOCK,
     +                IWGDS,IZGDS,IRM)
         IF (IRM .NE. 0)                                   RETURN
C........IDIMS(12)           = IZGDS
         IDIMS(12)           = IZGDS
#if defined(TEST)
         PRINT '(/,'' GRBIN1: IZGDS, IWGDS='',I5,
     +                2(/,1X,10I7),/,1X,I7,Z17,4X,2I7,Z17)',
     +                        IZGDS,(IWGDS(IP),IP=1,IZGDS)
         IGZW                = IWGDS(2)+25
         IF (IWGDS(2) .GT. 0)                              PRINT
     +      '('' SPEKTRALKOEFF., IWGDS(26..'',I3,'')='',
     +             50(/,1X,4Z17))', IGZW,
     +          (IWGDS(IP),IP=26,IGZW)
         IGZW                = IWGDS(226)+226
         IF (IWGDS(226) .GT. 0)                            PRINT
     +      '('' ANZAHL DER REIHEN, IWGDS(227..'',I3,'')='',
     +                40(/,1X,10I7))', IGZW,
     +            (IWGDS(IP),IP=227,IGZW)
#endif 
         IBYTA               = IBYTA+IWGDS(1)
      ELSE
C........KEIN GDS
         IDIMS(12)           = 0
         IWGDS(226)          = 0
         DO 50 J5            = 1, 25
   50    IWGDS(J5)           = 0
      ENDIF

      IF (IBIT2 .EQ. 1)                                    GOTO 100
C.....AENDERUNG ZUR FEHLER-VERMEIDUNG, WENN NACH GRBIN1 GRBEX1 AUFGERUFEN WIRD:
C     DO 55 J5               = 1, 3
C  55 IWBMS(J5)              = 0
      IWBMS( 1)              = 0
      IWBMS( 2)              = 0
      IWBMS( 3)              = -2
      IDIMS(13)              = 0
      IDIMS(15)              = 0
      IBMJ                   = 0
      GOTO 200

C.....BM1 HOLEN

  100 CONTINUE
C.....Zunaechst GETBM1 mit LBMAX = -1 aufrufen, um noetige Laenge von IBMAPI
C.....zu erfahren, wenn noetig IBMAPI neu anlegen und neuer Aufruf von GETBM1
      CALL GETBM1 (IEDNR,IBYTA,NBLOCK,NWBMS,-1,IBLOCK(1),
     +              IWBMS,IBMAPI(1),IZBMAP,IRM)
      IF (IRM .NE. 0)                                       RETURN
      IF (IWBMS(3) .EQ. 0) THEN
         DEALLOCATE(IBMAPI)
         LBMAX = (IZBMAP-1)/IBMAX + 1
         ALLOCATE(IBMAPI(1:LBMAX))
         CALL GETBM1 (IEDNR,IBYTA,NBLOCK,NWBMS,LBMAX,IBLOCK(1),
     +                 IWBMS,IBMAPI(1),IZBMAP,IRM)
      ENDIF

C.....IDIMS(15)  = ANZAHL DER BESETZTEN GITTERPUNKTE, WIRD NACH GETBD1 BERECHNET
      IDIMS(13)              = 3
#if defined(TEST)
C ??????????
      PRINT '(/,'' GRBIN1: IZBMAP,IWBMS='',4I6,)',
     +                     IZBMAP,(IWBMS(IP),IP=1,3)
#endif 

      IBYTA                  = IBYTA+IWBMS(1)
      IBMJ                   = 1

      IF (IWBMS(3) .NE. 0)                                  THEN
C........BITMAP AUS DATEI HOLEN,
C        WENN NICHT BEREITS IN EINEM VORANGEGANGENEN GRBIN1-LAUF GESCHEHEN
         IF (IWBMS(3) .NE. NRBMAP)                          THEN
            NRBMAP           = IWBMS(3)
C...........BITMIN zunaechst mit LBMAX == -1 aufrufen, um Groesse der Bitmap
C...........zu ermitteln, altes IBMAPI freigeben und in richtiger Groesse anlegen,
C...........Bitmap einlesen
            CALL BITMIN (' ', NRBMAP,
     +           -1, IBMAPI(1), LDS, NRGB, ITAG, IUHR, IRM)
            IF (IRM .NE. 0)                                 RETURN
            DEALLOCATE(IBMAPI)
            LBMAX = (LDS-1)/IBMAX + 1
            ALLOCATE(IBMAPI(1:LBMAX))
            CALL BITMIN (' ', NRBMAP,
     +           LBMAX, IBMAPI(1), LDS, NRGB, ITAG, IUHR, IRM)
            IF (IRM .NE. 0)                                 RETURN

C...........IDIMS(15)  = NRGB; ANZAHL DER BESETZTEN GITTERPUNKTE
            IDIMS(15)        = NRGB
            IDIMS(13)        = 3
C...........BITMAP-WORTE BERECHNEN......................................03.11.97
            IF (NRGB .GT. 0)                                THEN
               IZW           = (LDS+(IBMAX-1))/IBMAX
               LWBMAP        = IZW
            ENDIF
         ENDIF
#if defined(TEST)
         PRINT '(/,'' GRBIN1: NRBMAP,NRGB,LWBMAP='',3I6,'' IBMAPI='')',
     +                        NRBMAP,NRGB,LWBMAP
         CALL ARBITI (IBMAPI(1),LWBMAP)
#endif 
      ELSE
C........ANZAHL GITTERPUNKTE BERECHNEN
C               (= LAENGE DER BITMAP IN BITS ABZUEGL. UNUSED BITS)
         LBMAPB              = IWBMS(1)-6
         NRBMAP              = 0
         LWBMAP              = (LBMAPB+(IBYTW-1))/IBYTW
         LDS                 = (LBMAPB*IBYTE)-IWBMS(2)
#if defined(TEST)
         PRINT '(/,'' GRBIN1: LDS,LWBMAP='',2I6,'' IBMAPI='')',
     +                        LDS,LWBMAP
         IF (LBMAPB .GT. 0)                                 THEN
            CALL ARBITI (IBMAPI(1),LWBMAP)
         ENDIF
#endif 
      ENDIF
C.....IBMAPI UMSPEICHERN, ..............................................03.11.97
      LBMUM                  = LWBMAP
      IF (NWBMAP .NE. -1 .AND. LWBMAP .GT. NWBMAP)          THEN
C........USER-DIMENSION VON IBMAP NICHT AUSREICHEND FUER BITMAP
         PRINT '('' GRBIN1: LWBMAP>NWBMAP; LWBMAP,NWBMAP='',2I7,/,8X,
     +           '' NWBMAP-WORTE WERDEN NACH IBMAP UMGESPEICHERT'')',
     +                                     LWBMAP,NWBMAP
         LBMUM               = NWBMAP
      ENDIF
      IF (NWBMAP .NE. -1) THEN
C........DO 110 J = 1, LBMAX............................................03.11.97
         DO 110 J            = 1, LBMUM
  110    IBMAP(J)            = IBMAPI(J)
      ENDIF

C.....BDS (OHNE DATENSATZ) HOLEN

  200 CALL GETBD1 (IEDNR,IBYTA,IBDIM,IBLOCK(1),IWBDS,IBMP2,IWIDTH,
     +             DSUP,IDANZ,IRM)
      IF (IRM .NE. 0)                                       RETURN
      IZBDS                  = IDANZ(1)
      IZDATA                 = IDANZ(2)
      ILBMP2                 = IDANZ(3)
      IZWDTH                 = IDANZ(4)
      IZBT2                  = IDANZ(5)
      IBYTAZ                 = IDANZ(6)
      IDIMS(14)              = IZBDS
      IDIMS(16)              = IZDATA
C.....IDIMS(19)  = 0....................................................23.04.98
      IDIMS(20)              = 0

#if defined(TEST)
      PRINT '(/,'' GRBIN1: IWBDS='',/,1X,3I7,Z17,7I7)',
     +                       (IWBDS(IP),IP=1,IZBDS)
      CALL ARBITI(IWBDS(2),1)
      IF (IZWDTH .GT. 0)                                    PRINT
     +   '(''         IWIDTH(1..'',I3,'')='',50(/,10I5))', IZWDTH,
     +               (IWIDTH(IP),IP=1,IZWDTH)
      IF (ILBMP2 .GT. 0)                                    THEN
         PRINT '(''         IBMP2(1..'',I3,'')='')', ILBMP2
         CALL ARBITI (IBMP2(1),ILBMP2)
      ENDIF
      IF (IZDATA .GT. 0)                                    PRINT
     +   '(''         DSUP(1..'',I4,'')='',20(/,1X,5E12.5))', IZDATA+1,
     +               (DSUP(IP),IP=1,IZDATA+1)
#endif 

C.....KENNGROESSEN BEREITSTELLEN
      IFLAG                  = IAND(IWBDS(2),MSKF0)
      NUNUSB                 = IAND(IWBDS(2),MSK0F)
      ISCAL                  = IWBDS(3)
      NRBIT                  = IWBDS(5)
      REFMIN                 = DSUP(1)

#if defined(TEST)
      PRINT '('' GRBIN1: IBYTAZ,IFLAG,NUNUSB,ISCAL,NRBIT,REFMIN='',
     +                   /,5I8,F20.10)',
     +                   IBYTAZ,IFLAG,NUNUSB,ISCAL,NRBIT,REFMIN
#endif 

      IFLG1                  = IAND(IFLAG,MSK80)
      IFLG2                  = IAND(IFLAG,MSK40)
      IFLG3                  = IAND(IFLAG,MSK20)
      IFLG4                  = IAND(IFLAG,MSK10)
#if defined(TEST)
      PRINT '('' GRBIN1: IFLG1,IFLG2,IFLG3,IFLG4='',4I8)',
     +                   IFLG1,IFLG2,IFLG3,IFLG4
#endif 

      IF (IFLG1 .EQ. MSK80)                                THEN
C........IFLG1   =   MSK80            -> SPH.HARMONICS
C        ABWEICHENDE LAENGE DER BDS BEI SPEKTRAL-KOEFF.
         NDSUP               = 2
         LBDBA               = 15
C........IFLG2   =   1, -> COMPLEX PACKING
         IF (IFLG2 .EQ. MSK40)                             GOTO 300
      ELSE
C........IFLG1   =  0,                -> EINF. GITTERPKTE
         NDSUP               = 1
         LBDBA               = 11
C........IFLG2   =   1, -> SECOND ORDER PACKING
         IF (IFLG2 .EQ. MSK40)                             GOTO 500
      ENDIF


#if defined(TEST)
      PRINT '('' GRBIN1: IWBDS(2),NDSUP,LBDBA='',3I5)',
     +                   IWBDS(2),NDSUP,LBDBA
#endif 

C.....GESAMTZAHL GITTERPUNKTE FESTLEGEN
      IF (IBIT2 .EQ. 1)                                    THEN
         NRGRP               = LDS
         IF (IWBMS(3) .EQ. 0)                              THEN
            NRGB             = (((IWBDS(1)-LBDBA)*IBYTE)
     +                           -NUNUSB)/NRBIT
C...........BDS NACH VORHANDENEN DATENWERTEN ABFRAGEN.................28.05.1996
            IF (NRGB .EQ. 0)                               THEN
               NRGRP         = 0
            ENDIF
            IDIMS(15)        = NRGB
         ENDIF
      ELSE
C        GITTERPUNKTE AUS BDB BERECHNEN (KEINE BITMAP-SECTION)
         NRGRP               = (((IWBDS(1)-LBDBA)*IBYTE)
     +                           -NUNUSB)/NRBIT
      ENDIF

#if defined(TEST)
      PRINT '('' GRBIN1: NRGRPI, IBYTA='',2I8)', NRGRP, IBYTAZ
#endif 

      IDIMS(17)              = NRGRP

C.....Falls NDS == -1 ist hier Ende, der Datensatz wird nicht entpackt

      IF (NDS .EQ. -1) RETURN

C.....STIMMT USER-DIMENSION MIT BERECHNETEN DATEN UEBEREIN
      IF (NDS .LT. NRGRP)                   THEN
         PRINT '('' GRBIN1: FEHLER - NRGRP > USER-DIMENSION FUER DS,'',
     +           '' NRGRP, NDS='',2I7)',    NRGRP,NDS
         IRM                 = 1
         RETURN
      ENDIF

C.....IDIMS(15)  = NRGRP , SIEHE BEI GETBM1
C.....DATENSATZ HOLEN
      IF (NRGRP .GT. 0)                                    THEN
      CALL FCRACK1 (IBLOCK(1),IBYTAZ,UNDEFI,ISCAL,REFMIN,IBMJ,
     +              IBMAPI,NRGRP,NRBIT,DS(1),IRM)
         IF (IRM .NE. 0)                                   RETURN
C........NEU:.........DATEN DURCH 10**IUDSC TEILEN........STANEK/BOE. 07.05.1996
         IUDSC               = IWPDS(24)
         IF (IUDSC .NE. 0)                                 THEN
C...........SCHLEIFEN-OPTIMIERUNG LT. J.PICHELMEIER...................14.01.1999         
C...........FAK     = 10**(IUDSC).....................................14.01.1999
C...........FAK     = 1.0 / (10**IUDSC); wenn IUDSC negativ: FAK=0.0..01.02.2000
            IZW              = ABS(IUDSC)
            FZW              = FLOAT(10**(IZW))
            IF (IUDSC .LT. 0)                              THEN
               FAK           = FZW
            ELSE
               FAK           = 1.0/FZW
            ENDIF      
            DO 295         J = 1, NRGRP
C...........IF (DS(J) .NE. UNDEFI)          DS(J) = DS(J) / FAK.......14.01.1999
            IF (DS(J) .NE. UNDEFI) 
     +      DS(J)            = DS(J)*FAK
  295       CONTINUE
         ENDIF
C........NEU....................................................................
      ELSE
         DO 296            J = 1, NDS
  296    DS(J)               = UNDEFI
      ENDIF

      RETURN

  300 CONTINUE
C.....COMPLEX PACKING...........................................................

C.....IFLG3      # 0, -> INTEGER-DATEN
      IF (IFLG3 .EQ. MSK20)                                THEN
         PRINT '('' GRBIN1: INTEGER-DATEN NICHT DEFINIERT !!!'')'
         IRM                = 1
         RETURN
      ENDIF

C.....IFLG4      # 0, -> WEITERE FLAG
      IF (IFLG4 .EQ. MSK10)                                THEN
         IFLGE              = IWBDS(7)
         PRINT '('' GRBIN1: IFLGE='',I8,
     +           '' WEITERE FLAG NICHT VORGESEHEN !!!'')', IFLGE
         IRM                = 1
         RETURN
      ENDIF

C.....SPEKTR.KOEFFIZ., COMPLEX-PACKING
C     ANZAHL UNGEPACKTE WERTE AUS POINTER AUF GEP. WERTE AUSRECHNEN
      IBDSA                 = IWBDS(6)
      NUNP                  = (IBDSA-19)/4
      IF (NUNP .GT. 0)                                    THEN
         DO 310         J3  = 1, NUNP
         JJ                 = J3+1
  310    DS(J3)             = DSUP(JJ)
      ELSE IF (NUNP .LT. 0)                               THEN
         PRINT '('' GRBIN1: ! NUNP='',I10,'' UP SETZT NUNP=0'')', NUNP
         NUNP               = 0
      ENDIF

      IDSA                  = NUNP + 1
      IZLDS                 = NUNP

C.....GEPACKTE GITTERPUNKTE AUS BDB-ANGABEN BERECHNEN
      IBDS1                 = IBDSA - 1
      NRPACK                = (((IWBDS(1)-IBDS1)*IBYTE) 
     +                          -NUNUSB)/NRBIT
      IZLDS                 = IZLDS+NRPACK
      IDIMS(17)             = IZLDS

C.....Falls NDS == -1 ist hier Ende, der Datensatz wird nicht entpackt

      IF (NDS .EQ. -1) RETURN

C.....STIMMT USER-DIMENSION MIT BERECHNETEN DATEN UEBEREIN
      IF (NDS .LT. IZLDS)                   THEN
         PRINT '('' GRBIN1: FEHLER - IZLDS > USER-DIMENSION FUER DS,'',
     +           '' IZLDS, NDS='',2I7)',    IZLDS,NDS
         IRM                 = 1
         RETURN
      ENDIF

#if defined(TEST)
      PRINT '('' GRBIN1: NUNP,NUNUSB,IZLDS,IBDSA,IDSA,IBYTAZ='',/,6I8)',
     +                   NUNP,NUNUSB,IZLDS,IBDSA,IDSA,IBYTAZ
#endif 

C.....BDS NACH DATENWERTEN ABFRAGEN...................................28.06.1996
      IF (NRPACK .EQ. 0)                                   THEN
         DO 490           J  = IDSA, NDS
  490    DS(J)               = UNDEFI
         RETURN
      ENDIF


C.....DATENSATZ ENTPACKEN
      IBMJ                   = 0
      CALL FCRACK1 (IBLOCK(1),IBYTAZ,UNDEFI,ISCAL,REFMIN,
     +              IBMJ,IBMAPI,IZLDS,NRBIT,DS(IDSA),IRM)

C.....BEI COMPLEX GEPACKTEN SP.HARM.COEF. DATENSATZ UMORDNEN UND DE-NORMIEREN
      KJ                     = IWGDS( 5)
      KK                     = IWGDS( 6)
      KM                     = IWGDS( 7)
      KP                     = IWBDS( 7)
      KJL                    = IWBDS( 8)
      KKL                    = IWBDS( 9)
      KML                    = IWBDS(10)
      KN                     = NUNP
      CALL CP2SP  (DS(1),KJ,KK,KM,KJL,KKL,KML,KP,KN,IRM)

C.....NEU:.........DATEN DURCH 10**IUDSC TEILEN...........STANEK/BOE. 07.05.1996
      IUDSC                  = IWPDS(24)
      IF (IUDSC .NE. 0)                                    THEN
C........SCHLEIFEN-OPTIMIERUNG LT: J:PICHELMEIER......................14.01.1999      
C........FAK     = 10**(IUDSC)........................................14.01.1999
C........FAK     = 1.0 / (10**IUDSC); wenn IUDSC negativ: FAK=0.0.....01.02.2000
         IZW                 = ABS(IUDSC)
         FZW                 = FLOAT(10**(IZW))
         IF (IUDSC .LT. 0)                                 THEN
            FAK              = FZW
         ELSE
            FAK              = 1.0/FZW
         ENDIF      
C........DO 495 J= 1, NRGRP...........................................23.04.1998
         DO 495            J = 1, IZLDS
C........IF (DS(J) .NE. UNDEFI)             DS(J) = DS(J) / FAK.......14.01.1999
         IF (DS(J) .NE. UNDEFI)  
     +   DS(J)               = DS(J)*FAK
  495    CONTINUE
      ENDIF
C.....NEU.......................................................................

#if defined(TEST)
      PRINT '('' GRBIN1: DS(1..'',I4,'')='',15(/,1X,5E12.5))',
     +            KN,   (DS(IP),IP=1,KN)
#endif 
      RETURN

  500 CONTINUE

C.....2.ORDER PACKING...........................................................
C.....IFLG3      # 0, -> INTEGER-DATEN
      IF (IFLG3 .EQ. MSK20)                                THEN
         PRINT '('' GRBIN1: INTEGER-DATEN NICHT DEFINIERT !!!'')'
         IRM                 = 1
         RETURN
      ENDIF

C.....IFLG4      # 0, -> WEITERE FLAG
      IF (IFLG4 .EQ. MSK10)                                THEN
         IRM                 = - 999999
         IFLGE               = IWBDS(7)
         PRINT '('' GRBIN1: IFLGE='',I5,
     +           '', AUSWERTEN VON IFLGE IN ARBEIT !!!'')', IFLGE
      ENDIF

      PRINT '('' GRBIN1: 2.ORDER ENTPACKEN NOCH NICHT MOEGLICH !'')'
      RETURN

      END
