      SUBROUTINE GRBT02 (IPDB,IUN,IRM,YEL50,YEL20,YEL10,YDIM)
C**** GRBT02   -   ELEMENT-BEZEICHNUNGEN UND -DIMENSION AUS GRIB HOLEN
C**   AUFRUF       CALL GRBT02 (IPDB,IUN,IRM,YEL50,YEL20,YEL10,YDIM)
C**   EXTERNALS    getEnvironment
C**   ZWECK        BEZEICHNUNGEN FUER DEN INHALT DES PDB-OCTETS 9,
C**                D. H. ELEMENTNAMEN + DIMENSION, AUS DER GRIB-
C**                TABELLE 02 HERAUSSCHREIBEN
C**   PARAMETER
C**     EINGABE    IPDB    FELD VON INTEGER-ZAHLEN MIT INHALT VON PDB
C**                IUN     UNIT-NR. DES TABELLEN-FILE GRIB_TAB02
C**                        -- DER BENOETIGTE FILE WIRD AUS DER
C**                           GRIB-EDITIONS-NR. (IPDB(2)) BESTIMMT --
C**     AUSGABE    IRM     RETURN-CODE   O = FEHLERFREI
C**                                     #0 = FEHLER IN PROGRAMMEINHEIT
C**                YEL50   VOLLSTAENDIGER NAME DES GEWUENSCHTEN ELEMENTS
C**                        LT. GRIB-TABELLE 02
C**                YEL20   ABGEKUERZTE BEZEICHN(50 CHAR)DAS GEWUENSCHTE
C**                        ELEMENT (20 CHAR) LT. TAB. QUICK_GRIB_TAB
C**                YEL10   ABGEKUERZTE BEZEICHNUNG FUER DAS GEWUENSCHTE
C**                        ELEMENT (10 CHAR) LT. TAB. QUICK_GRIB_TAB02
C**                YDIM    ELEMENT-DIMENSION LT. TAB. QUICK_GRIB_TAB02
C**        - WENN FALSCHE SCHLUESSELZAHL FUER ELEMENT-BEZEICHNUNG
C**          IN IPDB(7) ENTHALTEN, SO WIRD YEL20 UND YDIM MIT
C**          INHALT 'XXXXXXXXXXXXXXXXXXXX'
C**          AN DAS RUFENDE PROGRAMM ZURUECKGEGEBEN,
C**          YEL50 ENTHAELT DEN TEXT:
C**             'ELEMENT-NAME NICHT IN TABELLE 02 ENTHALTEN' -
C**
C     ---  EINE VOLLSTAENDIGE TABELLE DER GRIB-CODE-ELEMENTNAMEN  ---
C     ---  UND -ELEMENTDIMENSIONEN LIEGT ALS LIST-FILE UNTER      ---
C     ---   ***  .ROUTARZ.MRZ3.DOKU.GRIB_ELEMENTE_TABELLE  ***    ---
C     ---  AUF MFA UND MFB VOR                                    ---
C**   VERFASSER: M.STAHLAHCKE
C     Letzte Aenderung U.Voigt am 1.8.97: ROUTROOT vor die Dateipfade
C     geaendert: M. Stahlhacke, 05/98 - Fehlerkorrektur 
C                                       (getenv-Aufruf gestrichen)
C     geaendert: B. Loeser, 02/00 - Fehlerkorrektur 
C                                   (Hilfsvariable IZAEHL eingef.)
C                B.Loeser, 11/00, IMPLICIT NONE, LENFUL --> LEN_TRIM,
C                          hermes ersetzt durch print, xyzprt.f raus
C                B.Loeser, 21.05.01, GETENV --> getEnvironment, 
C                                    ROUTROOT raus und absolute Pfade,
C                                    include machconsts.h
C
C     BENUTZTE VARIABLE :
C
C     IRM1     UP-INTERNER FEHLER-ZEIGER
C     IMIN1    UP-INTERNE VARIABLE, WERT=(-1)
C     IEDIV    NR. DER ZULETZT AUFGERUFENEN GRIB-EDITION
C     YEDIV    NR. DER ZULETZT AUFGERUFENEN GRIB-EDITION ALS STRING
C     ITVRSN   VERSIONS-NR. DER VERWENDETEN GRIB-TABELLE 02
C     YTVRSN   VERSIONS-NR. DER VERWENDETEN GRIB-TABELLE 02 ALS STRING
C     ICENTE   NR. DES ZENTRUMS, IN DEM DER GRIB FORMULIERT WURDE
C     YCENTE   string-Version von icente (3 Zeichen)
C     ICYCLE   NR. DES BENOETIGTEN TABELLEN-FILE-CYCLE
C     INEU     SCHALTER FUER NEUES OEFFNEN DER TABELLEN-DATEI
C     IELANZ   ANZAHL DER IN DER GRIB-TABELLE ENTHALTENEN ELEMENTE
C     IZAEHL   HILFSVARIABLE FUER IELANZ (ENTHAELT SCHLEIFENZAEHLER)
C     YLFILE   LFN DES TABELLEN-FILE
C     YLOCFN   FILE-BEZEICHNUNG DES TABELLEN-FILE IN OPEN-STATEMENT
C              (BETRIEBSSYSTEM NOS/VE 1.3.1)
C     IELNUM   FELD MIT DEN CODE-ZAHLEN FUER DIE ELEMENT-BEZEICHNUNGEN
C     YELLA    FELD MIT DEN VOLLSTAENDIGEN ELEMENT-BEZEICHNUNGNEN
C              LT. GRIB-TABELLE 02     (MAX. 50 CHAR)
C     YELMI    FELD MIT ABGEKUERZTEN ELEMENT-BEZEICHNUNGEN
C              LT. TABELLE GRIB_TAB02  (MAX. 20 CHAR)
C     YELKU    FELD MIT STARK ABGEKUERZTZEN ELEMENT-BEZEICHNUNGEN
C              LT. TABELLE GRIB_TAB02  (MAX. 10 CHAR)
C     YDIMI    FELD MIT DEN DIMENSIONS-BEZEICHNUNGEN
C              LT. TABELLE GRIB_TAB02  (MAX. 20 CHAR)
C
C     DER PARAMETER -IELAN- GIBT DIE MAXIMALE ANZAHL DER ELEMENTE IN
C     TABELLE GRIB_TAB02 AN
      IMPLICIT NONE
#include "machconsts.h"      
      INTEGER I, ICYCLE, IELAN, IELNUM, ILEN, IMIN1
      INTEGER IPDB, IRM, IRM1, IRM2, ISTAT, IUN, J
      PARAMETER (IELAN = 800)
      INTEGER IEDIV, ITVRSN, ICENTE, INEU, IELANZ, IZAEHL
      DIMENSION IPDB(*), IELNUM(IELAN)
      DIMENSION YELLA(IELAN), YELMI(IELAN), YELKU(IELAN),YDIMI(IELAN)
      CHARACTER *   2  YZW, YEDNR
      CHARACTER *   3  YTVRSN, YCENTE
      CHARACTER *   6  YUPNAM
      CHARACTER *  10  YEL10, YELKU
      CHARACTER *  14  YLFILE
      CHARACTER *  20  YEL20, YELMI, YDIM, YDIMI
      CHARACTER *  50  YEL50, YELLA
      CHARACTER * 100  YLOCFN
      CHARACTER *  50, YROUT
      LOGICAL LEXIST
C
      SAVE IEDIV, ITVRSN, ICENTE, INEU, IELANZ
      SAVE IELNUM, YELLA, YELMI, YELKU, YDIMI
C
C
      DATA YUPNAM /'GRBT02'/
      DATA YELKU / IELAN * ' ' /
      DATA YELMI / IELAN * ' ' /
      DATA YELLA / IELAN * ' ' /
      DATA YDIMI / IELAN * ' ' /
      DATA YTVRSN / '1' /
      DATA IEDIV / -1 /
      DATA ITVRSN / -1 /
      DATA ICENTE / -1 /
      DATA IMIN1 / -1 /
      DATA INEU / 1 /
C
C     DIE FELDER IELNUM,YELLA,YELMI,YELKU UND YDIMI BESCHREIBEN DIE
C     RECORDS IN DER TABELLE MIT DEN BEZEICHNUNGEN FUER DIE DARZU-
C     STELLENDEN ELEMENTE UND IHRE DIMENSIONEN
C
      IRM  = 0
      IRM1 = 0
      IRM2 = 0
C     AUSGABE-GROESSEN VORBESETZEN
      YEL50 = 'ELEMENT-NAME NICHT IN TABELLE 02 ENTHALTEN'
      YEL10 = 'XXXXX'
      YEL20 = 'XXXXXXXXXXXXXXXXXXXX'
      YDIM  = 'XXXXXXXXXXXXXXXXXXXX'
C
C     ****************************************************************
C     **********    TABELLEN-FILE-VERARBEITUNG BEGINNEN     **********
C     ****************************************************************
C     FILE-ATTACH FUER GRIB-TABELLE 02 NUR BEI ERSTEM AUFRUF ODER
C     BEI GEAENDERTER GRIB-EDITION ODER BEI GEAENDERTER GRIB-TABELLEN-
C     VERSIONS-NR.
      IF (IPDB(2).EQ.0) THEN
         IF (IEDIV.NE.IPDB(2)) THEN
            IEDIV = IPDB(2)
            WRITE (YEDNR,'(I2.2)') IPDB(2)
            INEU = 1
C **  IN GRIB-EDITION 0 GIBT ES NUR EINE GRIB-ELEMENTE-TABELLE
            ICYCLE = 1
            WRITE (YZW,'(I2.2)') ICYCLE
            WRITE (YTVRSN,'(I3.3)') ICYCLE
            YLFILE = 'cgrbt2'//YZW
            ILEN = LEN_TRIM(YLFILE)
C           DATEI-PFAD ZUSAMMENSETZEN
            CALL getEnvironment('LIBDWD_GRIBTABLE_PATH',YROUT,IRM2)
            YLOCFN = YROUT(:LEN_TRIM(YROUT))//PATH_CHAR//
     +            YLFILE(1:ILEN)
         END IF
C     ******************************************************************
      ELSE IF (IPDB(2).GT.0) THEN
C **  AB GRIB-EDITION 1 SIND MEHRERE VERSIONEN DER GRIB-ELEMENTE-
C **  TABELLE 02 ZUGELASSEN; DIE TABELLEN LIEGEN ABER NUR FUER CENTRE
C **  OFFENBACH UNBEGRENZT VOR, SONST NUR INTERNATIONAL GUETIGE VERSIO-
C **  NEN (VERSIONS-NR. 1 - 127, ELEMENTE-NRN. 0 - 127
C **  bzw. Versions-Nr. 128 - 254, Elemente-Nrn. 0 - 254 mit zugehoeriger
C **  center-Kennung)
C **  DIE TABELLEN-VERSIONS-NR. WIRD DANN IN IPDB(2) UEBERGEBEN !!!
C **  -- IN DIESER UP-FASSUNG WIRD DAVON AUSGEGANGEN, DASS ALLES, WAS
C **  -- NICHT GRIB0 IST, ALS GRIB1 AUFGEFASST WERDEN KANN !!!!!!
         IF (ITVRSN.NE.IPDB(2).OR.ICENTE.NE.IPDB(3)) THEN
C     BEI GEAENDERTER VERSIONS-NR. NEUER FILE-ATTACH
C     BEI GEAENDERTER CENTRE-NR. NEUER FILE-ATTACH
            INEU = 1
            IEDIV = 1
            ITVRSN = IPDB(2)
            ICENTE = IPDB(3)
            WRITE (YTVRSN,'(I3.3)') ITVRSN
            WRITE (YEDNR,'(I2.2)') IEDIV
            WRITE (YCENTE,'(I3.3)') ICENTE
C     BEI ZENTREN .NOT. Offenbach SIND NUR TABELLEN-VERSIONEN 1 - 127
C     ERLAUBT, bei Tabellen-Nrn. .GT.127 muss eine Tabelle mit zugehoe-
C     rigem Zentrum existieren, sonst
C     FEHLER-AUSGABE
            IF (ICENTE.LT.78.OR.ICENTE.GT.79) THEN
               IF (ITVRSN.GT.127) THEN
                  ylfile = 'cgrbt2'//ycente//yednr//ytvrsn
               else
                  ylfile = 'cgrbt2'//yednr//ytvrsn
               end if
            else
               YLFILE = 'cgrbt2'//YEDNR//YTVRSN
            end if
            ilen = LEN_TRIM(ylfile)
C           DATEI-PFAD ZUSAMMENSETZEN
            CALL getEnvironment('LIBDWD_GRIBTABLE_PATH',YROUT,IRM2)
            YLOCFN = YROUT(:LEN_TRIM(YROUT))//PATH_CHAR//
     +            YLFILE(1:ILEN)
C     wenn Datei nicht existiert und das Zentrum ist nicht Offenbach,
C     dann wird die entsprechende Tabelle zum Zentrum Offenbach gesucht,
C     und in der Protokolldatei wird eine Fehlermeldung ausgegeben,
C     existiert fuer das Zentrum Offenbach ebenfalls keine entsprechende
C     Tabelle, so wird nach der Fehlermeldung das UP verlassen, 
C     existiert diese Datei,so wird sie verwendet - das kann u. U. zu
C     Fehlinterpretationen der GRIB-Daten fuehren!!!!!
            inquire (FILE=ylocfn,EXIST=lexist)
            if (.NOT.lexist) then
C     wenn Tabelle nicht existiert,
C     dann wird eine Fehlermeldung ausgegeben 
               WRITE (YEL50,9010) IPDB(7), YTVRSN, YEDNR, ICENTE
               WRITE (YEL20,9011) IPDB(7)
               YEL10 = 'XXXXX'
               PRINT *, 'W :', YUPNAM,'/ EE=', IPDB(7),
     +              'aus Tab-Version ', YTVRSN,'Ed-Nr.',YEDNR,
     +              ' von Centre ', ICENTE
C
               if (icente.lt.78.or.icente.gt.79) then
C     wenn Tabelle nicht existiert und orig. center ist nicht Offenbach,
C     dann wird die gewuenschte Versionsnummer als DWD-Versions-Datei gesucht               
                  ylfile = 'cgrbt2'//yednr//ytvrsn
                  ilen = LEN_TRIM(ylfile)
                  YLOCFN = YROUT(:LEN_TRIM(YROUT))//PATH_CHAR//
     +                 YLFILE(1:ILEN)
                  inquire (FILE=ylocfn,EXIST=lexist)
                  if (lexist) then
C     wenn Tabelle existiert,
C     dann wird eine Information ausgegeben
                     PRINT *, 'W :', YUPNAM,'/ *** Achtung: ',
     +                     'Es wird die GRIB-Tabelle 02, Version ',
     +                     YTVRSN,', Edition ',YEDNR, 
     +                     ' aus Offenbach verwendet! ***'
                     goto 1000
                  end if
               end if
C     Tabelle existiert nicht, deshalb muss Vergleichsgroesse ITVRSN=-1
C     gesetzt werden
C     anschliessend UP verlassen
               ITVRSN = IMIN1                  
               goto 9000
            end if
1000        continue                                                                           
         END IF
      END IF
C     ******************************************************************
      IF (INEU.EQ.1) THEN
C     TABELLEN-ELEMENTE-NUMMERN-FELD = (-1) SETZEN
         DO  8 I = 1,IELAN
           IELNUM(I) = IMIN1
8        CONTINUE
         OPEN (UNIT=IUN,FILE=YLOCFN,IOSTAT=ISTAT)
         IF (ISTAT.NE.0)  GOTO 4
         DO 100 J = 1, IELAN
           READ (IUN,3,IOSTAT=ISTAT,END=9)
     +          IELNUM(J),YELKU(J),YELMI(J),YELLA(J),YDIMI(J)
3          FORMAT (I4.2,A10,A20,A50,A20)
         IZAEHL = J
100      CONTINUE
4        CONTINUE
         IF (ISTAT.NE.0) THEN
            PRINT 95,YLFILE(1:ILEN),ISTAT
95          FORMAT (T10,'GRBT02 --- FEHLER BEI READ ',A,' ---',I8.1)
            IRM1 = 1
         END IF
9        CONTINUE
         IELANZ = IZAEHL - 1
         CLOSE (UNIT=IUN,IOSTAT=ISTAT)
         IF (IELANZ.EQ.0) THEN
C     GEWUENSCHTE GRIB-TABELLE 02 LIEGT NICHT VOR
            WRITE (YEL50,9010) IPDB(7), YTVRSN, YEDNR, ICENTE
9010        FORMAT ('EE=',I4,' aus Tab-Version ',A3,'Ed-Nr.',A2,
     +              ' von Centre ',I2.2)
            WRITE (YEL20,9011) IPDB(7)
9011              FORMAT ('EE=',I4,' -keine Tab02')
            YEL10 = 'XXXXX'
            PRINT *, 'W:', YUPNAM,'/ EE=',IPDB(7),
     +            ' - es liegt keine GRIB-Tabelle 02, Version ',
     +            YTVRSN, ', Edition ',YEDNR,' aus Centre Nr. ',
     +            ICENTE,' vor!'
            GOTO 9000
         END IF
         INEU = 0
      END IF
C     ****************************************************************
C     **********  TABELLEN-FILE-VERARBEITUNG ABGESCHLOSSEN  **********
C     ****************************************************************
C
C     ELEMENTNAME UND -DIMENSION AUS DER GRIB-TABELLE 02 BESTIMMEN
C
      DO 10 I = 1,IELANZ
      IF (IELNUM(I).EQ.IPDB(7))  GOTO 15
10    CONTINUE
      GOTO 9000
15    CONTINUE
C     ELEMENTBEZEICHNUNGEN AUS TABELLE 02 UEBERTRAGEN
      YEL50 = YELLA(I)
      YEL20 = YELMI(I)
      YEL10 = YELKU(I)
      YDIM  = YDIMI(I)
C     PROGRAMM BEENDEN
9000  CONTINUE
      IRM = IRM + IRM1
      RETURN
      END
