      SUBROUTINE GRBT03 (IPDB,IUN,IRM,YLENA,YLENAK,YLEDIM,YLEV)
!**** GRBT03   -   LEVEL-BESCHREIBUNG AUS GRIB-PDB AUSGEBEN
!**   AUFRUF       CALL GRBT03 (IPDB,IUN,IRM,YLENA,YLENAK,YLEDIM,YLEV)
!**   EXTERNALS    getEnvironment
!**   ZWECK        LEVEL-BESCHREIBUNG AUS DEM GRIB-PDB MIT LEVEL-TYP,
!**                NIVEAU-ANGABEN UND NIVEAU-DIMENSION ALS CHARACTER-
!**                GROESSEN AUSGEBEN
!**   PARAMETER
!**     EINGABE    IPDB    FELD VON INTEGER-ZAHLEN MIT INHALT VON PDB
!**                IUN     UNIT-NR. DES TABELLEN-FILE GRIB_TAB03
!**                        -- DER BENOETIGTE CYCLE WIRD AUS DER
!**                           GRIB-EDITIONS-NR. (IPDB(2) BESTIMMT --
!**     AUSGABE    IRM     RETURN-CODE   O = FEHLERFREI
!**                                     #0 = FEHLER IN PROGRAMMEINHEIT
!**                YLENA   VOLLSTAENDIGER NAME DES LEVEL-TYPS (50 CHAR)
!**                        LT. GRIB-TABELLE 03
!**                YLENAK  ABGEKUERZTE BEZEICHNUNG FUER LEVEL-TYP
!**                        LT. TABELLE GRIB_TAB03   (MAX. 20 CHAR)
!**                YLEDIM  NIVEAU-DIMENSION LT. TABELLE GRIB_TAB03
!**                                                 (MAX. 10 CHAR)
!**                YLEV    AUS IPDB(9) UND IPDB(10) HERAUSGESCHRIEBENE
!**                        NIVEAU-ANGABE
!**        - WENN FALSCHE SCHLUESSELZAHL FUER LEVEL-TYP
!**          IN IPDB(8) ENTHALTEN, SO WIRD YLENAK MIT
!**          INHALT 'XXXXXXXXXX' AN DAS RUFENDE
!**          PROGRAMM ZURUECKGEGEBEN,
!**          YLENA ENTHAELT DEN TEXT:
!**             'LEVEL-TYP-BEZEICHNUNG NICHT IN TAB. 03 ENTHALTEN' -
!**   VERFASSER: M. STAHLHACKE
!     Letzte Aenderung U.Voigt am 1.8.97: ROUTROOT vor die Dateipfade
!                      B.Loeser, 11/00, NOS/VE-Zweig raus, IMPLICIT NONE
!                      B.Loeser, 21.05.01, GETENV --> getEnvironment,
!                                ROUTROOT raus und absolute Pfade,
!                                include machconsts.h    
!                      M. Stahlhacke, 11/03: neuen lv-Typ 222 eingerichtet
!                                            - Satellite Channel -           
! 
!     BENUTZTE VARIABLE :
! 
!     IRM1     UP-INTERNER FEHLER-ZEIGER
!     IEDIV    NR. DER ZULETZT AUFGERUFENEN GRIB-EDITION
!     ICYCLE   NR. DES BENOETIGTEN TABELLEN-FILE-CYCLE
!     ILENUM   FELD MIT DEN NUMMERN DER LEVEL-TYPES
!     ITOP     OBERES LEVEL EINER SCHICHT
!     IBASE    UNTERES LEVEL EINER SCHICHT
!     YLFILE   LFN DES TABELLEN-FILES
!     YLOCFN   FILE-BEZEICHNUNG DES TABELLEN-FILE IN OPEN-STATEMENT
!     YLEVLA   FELD MIT VOLLSTAENDIGEN NAMEN DER LEVEL-TYPES
!     YLEVKU   FELD MIT AUF 20 ZEICHEN GEKUERZTEN NAMEN DER
!              LEVEL-TYPES
!     YLEVDI   FELD MIT DEN NIVEAU-DIMENSIONEN DER LEVEL-TYPES
!     YCMD     BEFEHLSINHALT FUER SCLCMD-AUFRUF
!     STAT     STATUS-INHALT VON SCLCMD-AUFRUF
! 
      IMPLICIT NONE
#include "machconsts.h" 
      INTEGER I, IBASE, ICYCLE, IEDIV, ILEMAX, ILENUM, IPDB, IRM
      INTEGER IRM1, IRM2, ISTAT, ITOP, IUN
      PARAMETER (ILEMAX= 41)
      DIMENSION IPDB(*), ILENUM(ILEMAX)
      DIMENSION YLEVLA(ILEMAX), YLEVKU(ILEMAX), YLEVDI(ILEMAX)
      CHARACTER *   2  YZW
      CHARACTER *   8  YLFILE
      CHARACTER *  10  YLEDIM, YLEVDI, YLEV
      CHARACTER *  20  YLENAK, YLEVKU
      CHARACTER *  50  YLENA , YLEVLA
      CHARACTER * 100  YLOCFN, YROUT*50
! 
      SAVE IEDIV
      SAVE ILENUM, YLEVLA, YLEVKU, YLEVDI
! 
      DATA IEDIV  / -1 /
! 
!     DIE FELDER ILENUM,YLEVLA,YLEVKU UND YLEVDI BESCHREIBEN DIE RECORDS
!     IN DER TABELLE GRIB_TAB03 MIT DEN BEZEICHNUNGEN DER LEVEL-TYPES
! 
      IRM  = 0
      IRM1 = 0
      IRM2 = 0
!     AUSGABE-TEXTE VORBESETZEN
      YLENAK = 'XXXXXXXXXXXXXXXXXXXX'
      YLENA  = 'LEVEL-TYP-BEZEICHNUNG NICHT IN TAB. 03 ENTHALTEN'
      YLEDIM = 'XXXXXXXXXX'
! 
!     ****************************************************************
!     **********    TABELLEN-FILE-VERARBEITUNG BEGINNEN     **********
!     ****************************************************************
!     FILE-ATTACH FUER TABELLE GRIB_TAB03 NUR BEI ERSTEM AUFRUF ODER
!     BEI GEAENDERTER GRIB-EDITION
      IF (IEDIV.NE.IPDB(2)) THEN
         IEDIV  = IPDB(2)
! **  LEVEL-TABELLE AENDERT SICH MIT GRIB-EDITIONS-AENDERUNG NICHT,
! **  DESHALB Z. ZT. IMMER ICYCLE=1 !!!
! **     ICYCLE = IEDIV + 1
         ICYCLE = 1
         WRITE (YZW,'(I2.2)') ICYCLE
!        DATEI-PFAD ZUSAMMENSETZEN
         CALL getEnvironment('LIBDWD_GRIBTABLE_PATH',YROUT,IRM2)
         YLOCFN = YROUT(:LEN_TRIM(YROUT))//PATH_CHAR//'cgrbt3'//YZW
         OPEN (UNIT=IUN,FILE=YLOCFN,IOSTAT=ISTAT)
         IF (ISTAT.NE.0)  GOTO 4
         READ (IUN,3,IOSTAT=ISTAT,END=4)
     +         (ILENUM(I),YLEVKU(I),YLEVLA(I),YLEVDI(I),I=1,ILEMAX)
3        FORMAT (I3.2,A20,A50,A10)
4        CONTINUE
         IF (ISTAT.GT.0) THEN
            YLFILE = 'CGRBT3'//YZW
            PRINT 95,YLFILE
95          FORMAT (T10,'GRBT03 --- FEHLER BEI READ ',A8,' ---')
            IRM1 = 1
         END IF
         CLOSE (UNIT=IUN,IOSTAT=ISTAT)
      END IF
!     ****************************************************************
!     **********  TABELLEN-FILE-VERARBEITUNG ABGESCHLOSSEN  **********
!     ****************************************************************
! 
!     LEVEL-TYP-BEZEICHNUNG UND NIVEAU-DIMENSION AUS GRIB-TABELLE 03
!     BESTIMMEN
! 
      DO 10 I = 1,ILEMAX
      IF (ILENUM(I).EQ.IPDB(8))  GOTO 15
10    CONTINUE
      GOTO 9000
15    CONTINUE
      YLENA  = YLEVLA(I)
      YLENAK = YLEVKU(I)
      YLEDIM = YLEVDI(I)
25    CONTINUE
! 
!     BEI CODE-ZIFFER .GE. 100 WERDEN DIE NIVEAU-ANGABEN ZUM ANGEWAEHLTEN
!     LEVEL-TYPE IN YLEV ZUSAMMENGEFUEGT
! 
      IF (ILENUM(I).GE.100) THEN
!     BEI LEVEL-TYPE 102 (MEAN SEA LEVEL), 117 (POT. VORTICITY SURFACE),
!                    200 (ENTIRE ATMOSPHERE), 201 (ENTIRE OCEAN)
!     KEINE HOEHENANGABE
         IF (ILENUM(I).NE.102.AND.ILENUM(I).NE.117
     +       .AND.ILENUM(I).NE.200..AND.ILENUM(I).NE.201) THEN
!     BEI LEVEL-TYPE 100 (ISOBARIC LEVEL) NUR EINE FLAECHENANGABE
            IF (ILENUM(I).EQ.100) THEN
               WRITE (YLEV,35) IPDB(10)
35             FORMAT (I6.2)
!     BEI LEVEL-TYPE 103 (FIXED HEIGHT LEVEL) NUR EINE FLAECHENANGABE
            ELSE IF (ILENUM(I).EQ.103) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 105 (FIXED HEIGHT LEVEL) NUR EINE FLAECHENANGABE
            ELSE IF (ILENUM(I).EQ.105) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 107 ( SIGMA LEVEL) NUR EINE LEVEL-ANGABE
            ELSE IF (ILENUM(I).EQ.107) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 109 (HYBRID LEVEL) NUR EINE LEVEL-ANGABE
            ELSE IF (ILENUM(I).EQ.109) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 111 (DEPTH BELOW LAND SURFACE) NUR EIN LEVEL
            ELSE IF (ILENUM(I).EQ.111) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 113 (ISENTROPIC (THETA) LEVEL) NUR EIN LEVEL
            ELSE IF (ILENUM(I).EQ.113) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 115 (LEVEL AT SPECIFIED PRESSURE DIFFERENCES
!     FROM GROUND TO LEVEL) NUR EIN LEVEL
            ELSE IF (ILENUM(I).EQ.115) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 117 (POTENTIAL VORTICITY 10**(-6)*km**2/kg/s )
!     NUR EIN LEVEL
            ELSE IF (ILENUM(I).EQ.117) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 160 (DEPTH BELOW SEA-LEVEL) NUR EIN LEVEL
            ELSE IF (ILENUM(I).EQ.160) THEN
               WRITE (YLEV,35) IPDB(10)
!     BEI LEVEL-TYPE 222 (SATELLITE CHANNEL NUMBER) NUR EIN LEVEL
            ELSE IF (ILENUM(I).EQ.222) THEN
               WRITE (YLEV,35) IPDB(10)
! **  SONST ANGABE VON 2 LEVELS IN DEN WORTEN IPDB(9) UND IPDB(10),
! **  DABEI MUESSEN TEILWEISE DIE LEVEL-BEZEICHNUNGEN WEGEN DER VER-
! **  SCHLUESSELTEN ABSPEICHERUNG IM PDB DEN REGELN ENTSPRECHEND UM-
! **  GESETZT WERDEN
            ELSE IF (ILENUM(I).EQ.114) THEN
!     LEVEL-TYP 114:
!     LAYER BETWEEN TWO ISENTROPIC LEVELS
!     (MUSS MODIFIZIERT WERDEN, WEIL ALS ZAHLENWERT (475-WERT) IN PDB)
               ITOP = 475 - IPDB(9)
               IBASE = 475 - IPDB(10)
               WRITE (YLEV,45) ITOP, IBASE
45             FORMAT (I3,'/',I3)
            ELSE IF (ILENUM(I).EQ.121) THEN
!     LEVEL-TYP 121:
!     LAYER BETWEEN TWO ISOBARIC SURFACES - HIGH PRECISION
!     (MUSS MODIFIZIERT WERDEN, WEIL ALS ZAHLENWERT (1100-WERT) IN PDB)
               ITOP = 1100 - IPDB(9)
               IBASE = 1100 - IPDB(10)
               WRITE (YLEV,55) ITOP, IBASE
55             FORMAT (I4,'/',I4)
            ELSE IF (ILENUM(I).EQ.128) THEN
!     LEVEL-TYP 128:
!     LAYER BETWEEN TWO SIGMA LEVELS - HIGH PRECISION
!     (MUSS MODIFIZIERT WERDEN, WEIL ALS ZAHLENWERT (1100-WERT) IN PDB)
               ITOP = 1100 - IPDB(9)
               IBASE = 1100 - IPDB(10)
               WRITE (YLEV,55) ITOP, IBASE
!     LEVEL-TYP 141:
!     LAYER BETWEEN TWO ISOBARIC SURFACES - MIXED PRECISION
!     (MUSS MODIFIZIERT WERDEN, WEIL ALS ZAHLENWERT DES BOTTOM LEVELS
!     (1100-WERT) IN PDB GESETZT IST)
               ITOP = IPDB(9)
               IBASE = 1100 - IPDB(10)
               WRITE (YLEV,65) ITOP, IBASE
65             FORMAT (I3,'/',I4)
            ELSE
               WRITE (YLEV,45) IPDB(9), IPDB(10)
            END IF
         END IF
      END IF
!     PROGRAMM BEENDEN
9000  CONTINUE
      IRM = IRM + IRM1
      RETURN
      END
