      SUBROUTINE GRBTIM (IPDB,IRM,YDATE,YDA1,YDA2,ITDIF,YTIU,YTIUA,
     +                   YTIR,YTIRA)
C**** GRBTIM   -   ZEITGROESSEN AUS DEM GRIB-CODE-PDB HOLEN
C**   AUFRUF       CALL GRBTIM (IPDB,IRM,YDATE,YDA1,YDA2,ITDIF,YTIU,
C**                             YTIUA,YTIR,YTIRA)
C**   EXTERNALS    VNDAT,VNMIN,VNSTD,WOTAN,DATBIL,BUNDIG
C**   ZWECK        DARSTELLUNG DER ZEITGROESSEN AUS DEM PDB ALS
C**                CHARACTER-VARIABLE, UM MIT DIESEN GROESSEN TEXTE
C**                ZU FORMULIEREN (AUSNAHME: ITDIF - INTEGER-GROESSE)
C**   PARAMETER
C**     EINGABE    IPDB    FELD VON INTEGER-ZAHLEN MIT INHALT VON PDB
C**     AUSGABE    IRM     RETURN-CODE   0 = FEHLERFREI
C**                                     #0 = FEHLER IN PROGRAMMEINHEIT
C**                YDATE   REFERENZDATUM MIT WOCHENTAG,TAG,MONAT,JAHR,
C**                                          STUNDE UND MINUTE
C**                YDA1    ZEITANGABE T1 - WIE REFERENZDATUM, JEDOCH
C**                                                   OHNE WOCHENTAG
C**                YDA2    ZEITANGABE T2 - WIE REFERENZDATUM, JEDOCH
C**                                                   OHNE WOCHENTAG
C**                ITDIF   DIFFERENZ  T2-T1 AUS DEM GRIB-PDB, BZW.
C**                        DIFFERENZ  T1-REFERENZZEIT
C**                     *** BEI YTIR=100 ITDIF MIT SONDERBEDEUTUNG:
C**                     *** ITDIF =  1 - GRUNDMODELL UND ART DER
C**                     ***              VERIFIKATIONS-FELDER (VORHER-
C**                     ***              SAGE ODER ANALYSE) IDENTISCH
C**                     ***          2 - GRUNDMODELL IDENTISCH, ERSTES
C**                     ***              FELD ANALYSE, ZWEITES FELD
C**                     ***              VORHERSAGE
C**                     ***          3 - GRUNDMODELL IDENTISCH, ERSTES
C**                     ***              FELD VORHERSAGE, ZWEITES FELD
C**                     ***              ANALYSE
C**                YTIU    ZEITEINHEIT, IN DER DIE ZEITRAEUME ANGEGEBEN
C**                        SIND (LT. TABELLE 4 IM GRIB-CODE)
C**                YTIUA   ABGEKUERZTE FORM VON YTIU  (3 ZEICHEN)
C**                YTIR    ART DER FELDDARSTELLUNG IM HINBLICK AUF DIE
C**                        ZEIT (LT. TABELLE 5 IM GRIB-CODE)
C**                YTIRA   ABGEKUERZTE FORM VON YTIR  (6 ZEICHEN)
C**        - REFERENZDATUM 0  WIRD ALS ZULAESSIGER WERT ANGESEHEN
C**        - WENN FALSCHE SCHLUESSELZAHLEN FUER DIE TABELLEN 4 UND 5
C**          IN IPDB(16) BZW. IPDB(19) ENTHALTEN SIND, WIRD DER
C**          SCHALTER IRM GESETZT UND YTIUA ODER YTIRA WERDEN MIT
C**          INHALT 'XXXXX' AN DAS RUFENDE PROGRAMM ZURUECKGEGEBEN
C**        - ES WIRD EBENFALLS ALS FEHLER ANGESEHEN, WENN BEI EINER
C**          ZEITRAUM-ANGABE IM GRIB-PDB TIME1 GT. TIME2 IST,
C**          DANN WIRD EBENFALLS SCHALTER IRM GESETZT UND IN YDA1
C**          STEHT DIE MITTEILUNG: '--ERROR-- T1 .GT. T2--'
C**         *** AUSNAHME: BEI TRF=100 (VERIFIKATIONS-DIFFERENZ) DARF
C**         ***           T1 .GT. T2 SEIN
C**          -  A C H T U N G :
C**           DAS UP BENUTZT ALS REFERENZ-JAHRHUNDERT UND JAHRTAUSEND
C**                             1 9 0 0   -
C**           *** das gilt nur fuer Bearbeitung von GRIB0-Feldern,  ***
C**           *** ab GRIB1 wird das Jahrhundert aus dem PDB-Wort 22 ***
C**           *** bestimmt.                                         ***
C**   VERFASSER: M. STAHLHACKE
C**   VERSION    20.02.2002
C**                          geaend. 12/98 ST (Jahrhundert-Bestimung und
C**                                            Ausgabe der 2-stelligen
C**                                            Jahreszahl an WMO-Konvention
C**                                            angepasst,
C**   Geaendert: B.Loeser, 11/00, IMPLICIT NONE
C**                                            Erweiterung der GRIB-Tabelle 5
C**                                            und den Typ Nudging eingebaut)
C**                          geaend. 07/01 ST (Erweiterung der GRIB-Tabelle 5
C**                                            um den Typ "Init. Vorhersage") 
C**                          geaend. 02/02 ST (fehlerhafte Abfrage bei Analyse-
C**                                            Produkten korrigiert) 
C**                          geaend. 03/02 ST (Erweiterung der GRIB-Tabelle 5
C**                                            um den Typ "Redefined Forecast") 
C**                          geaend. 06/05 Zal. Erweiterung der GRIB-Tabelle 4
C**                                             um CodeNr. 13,      14,
C**                                                       (15 Min., 30 Min.);
C**                                             max. CodeNrs.: ITUMAX=14;
C                            ------------------ angepasst werden:
C                                               ITU  (ITUMAX), YTIUNA(ITUMAX),
C                                               YTIUN(ITUMAX)         
C                                               Neue Abfragen:
C                                               IPDB(16).EQ.13, --> 15 min,
C                                               IPDB(16).EQ.14, --> 30 min;
C
C     BENUTZTE VARIABLE :
C
C     ITIM1   -   ZEITRAUM 1 AUS GRIB-PDB
C     ITIM2   -   ZEITRAUM 2 AUS GRIB-PDB
C     ITIMI   -   ZEITRAUM 1 BZW. ZEITRAUM 2 BEI ANGABE VON 3-, 6-, 12-
C                 STUNDEN-INTERVALLEN ZUR BESTIMMUNG VON YDA1 UND YDA2
C     ITU     -   FELD MIT DEN GUELTIGEN CODE-NUMMERN AUS TABELLE 4
C     ITRF    -   FELD MIT DEN GUELTIGEN CODE-NUMMERN AUS TABELLE 5
C     IYY1N   -   DIE MIT HILFE VON ITIM1 GEWONNENE JAHRESZAHL ZU   T1
C     IYY2N   -   "   "   "     "   ITIM2 "         "          "    T2
C     IMM1N   -   "   "   "     "   ITIM1 "         MONATSZAHL ZU   T1
C     IMM2N   -   "   "   "     "   ITIM2 "         "          "    T2
C     IDD1N   -   "   "   "     "   ITIM1 "         TAGESZAHL ZU    T1
C     IDD2N   -   "   "   "     "   ITIM2 "         "         "     T2
C     IHH1N   -   "   "   "     "   ITIM1 "         STUNDENZAHL ZU  T1
C     IHH2N   -   "   "   "     "   ITIM2 "         "           "   T2
C     IMI1N   -   "   "   "     "   ITIM1 "         MINUTENZAHL ZU  T1
C     IMI2N   -   "   "   "     "   ITIM2 "         "           "   T2
C     ISEC1   -   "   "   "     "   ITIM1 "         SEKUNDENZAHL ZU T1
C     ISEC2   -   "   "   "     "   ITIM2 "         "            "  T2
C     IMIASE  -   ANZAHL DER MINUTEN, DIE AUS DEN SEKUNDEN IN ITIM1
C                 ODER IN ITIM2 GEWONNEN WERDEN, UM DIE ZEITEN T1 UND T2
C                 ZU BESTIMMEN
C     ICENT   -   JAHRHUNDERT UND JAHRTAUSEND DER REFERENZZEIT
C     ICENT0  -   vordefinierter Wert fuer ICENT bei GRIB0-Bearbeitung
C     IJAHR   -   4-stellige Jahreszahl der Referenzzeit
C     IJAHRZ  -   2-stellige Jahreszahl der Referenzzeit (ohne Jahrhundert)
C     IYYAMO  -   ANZAHL DER JAHRE, DIE AUS DEN MONATEN IN ITIM1 ODER
C                 IN ITIM2 GEWONNEN WERDEN, UM DIE ZEITEN T1 UND T2
C                 ZU BESTIMMEM
C     NWOTA   -   NUMMER DES WOCHENTAGES AUS UP WOTAN
C     YWOTA   -   NAME DES WOCHENTAGES AUS UP WOTAN (NICHT BENOETIGT)
C     YWOT2   -   FELD MIT DEN ENGL. ABKUERZUNGEN DER WOCHENTAGE (2 CHAR)
C     YTIUN   -   FELD MIT DEN ZULAESSIGEN ZEIT-DIMENSIONEN
C     YTIUNA  -   ABKUERZUNGEN ZU YTIUN (3 CHAR)
C     YTRF    -   FELD MIT DEN ZULAESSIGEN TIME-RANGE-BEZEICHNUNGEN
C     YTRFA   -   ABKUERZUNGEN ZU YTRF (10 CHAR)
C     YDATI   -   DATUM-STRING ALS INPUT FUER UP DATBIL
C     YDATO   -   DATUM-STRING-FELD ALS OUTPUT FUER UP DATBIL
C     IDATO   -   ERGEBNIS-FELD AUS UP DATBIL
C     IPART   -   KONTROLL-GROESSE AUS UP DATBIL
C
      IMPLICIT NONE
      INTEGER I, IRM, ITDIF, ITRIMX, ITUMAX

C     DIE PARAMETER ITUMAX UND ITRIMX GEBEN DIE ANZAHL DER GUELTIGEN
C     ELEMENTE DER TABELLEN 4 UND 5 IM GRIB-CODE AN
C     PARAMETER (ITUMAX=12,ITRIMX=20)..................29.06.05 Zal.
      PARAMETER (ITUMAX=14,ITRIMX=20)
      INTEGER IPDB(*), ITU(ITUMAX), ITRF(ITRIMX)
      INTEGER IDATO(5,2), IPART, IRM1
      INTEGER IVV1, IVV2, ISEC1, ISEC2
      INTEGER ICENT, IDD1N, IDD2N, IHH1N, IHH2N, IMI1N, IMI2N
      INTEGER ILEN1, ILEN2, ILS, IMIASE, IMM1N, IMM2N, IYY1N, IYY2N
      INTEGER IYYAMO, ITIM1, ITIM2, ITIMI, NWOTA
      INTEGER ICENT0, IJAHR, IJAHRZ
C
      CHARACTER *  2, YWOT2(7)
      CHARACTER *  3, YTIUA, YTIUNA(ITUMAX)
      CHARACTER *  6, YTIRA, YTRFA(ITRIMX)
      CHARACTER * 10, YTIU, YTIUN(ITUMAX), YWOTA
      CHARACTER * 10, YTIM1, YTIM2, YJAHR1, YJAHR2
      CHARACTER * 13, YDATI, YDATO(2)
      CHARACTER * 20, YDATE, YTIR, YTRF(ITRIMX)
      CHARACTER * 23, YDA1, YDA2
      CHARACTER *  6, YUPNAM

C     WOCHENTAG-ABKUERZUNGEN SCHREIBEN : 1 - 7 = MO - SU
      DATA YWOT2 / 'MO', 'TU', 'WE', 'TH', 'FR', 'SA', 'SU' /
C     GRIB-TABELLE 4 : ZEITDIMENSION
C     DIE INHALTE VON ITU, YTIUN UND YTIUNA MUESSEN KORRESPONDIEREN,
C     YTIUNA IST GEKUERZTE SCHREIBWEISE VON YTIUN, ITU DIE ZUGEHOERIGE
C     CODE-ZIFFER
C     NEU: 12.,13. WERT in ITU,YTIUNA,YTIUN............29.06.05 Zal.
      DATA ITU    /   0  ,  1  ,  2  ,  3  ,  4  ,  5  ,  6  ,  7  ,
     +               10  , 11  , 12  , 13  , 14 ,
     +              254   /
      DATA YTIUNA / 'Min','Hou','Day','Mon','Yea','Dec','Nor','Cen',
     +              ' 3h',' 6h','12h','15m','30m',
     +              'Sec' /
      DATA YTIUN  / 'Minute','Hour','Day','Month','Year','Decade',
     +              'Normal','Century','3 hours','6 hours','12 hours',
     +              '15 minutes','30 minutes','Second' /
C
C     GRIB-TABELLE 5 : TIME RANGE INDICATOR
C     DIE INHALTE VON ITRF, YTRF UND YTRFA MUESSEN KORRESPONDIEREN,
C     YTRFA IST GEKUERZTE SCHREIBWEISE VON YTRF, ITRF DIE ZUGEHOERIGE
C     CODE-ZIFFER
C     NACHFOLGEND WERDEN FOLGENDE ABKUERZUNGEN VERWENDET:
C     CR     - CONSTANT RANGE  ODER  CONTINUOUS RANGE
C     F/iA   - FORECAST OR INITIALIZED ANALYSIS
C     uiA    - UNINITIALIZED ANALYSIS
C     SR     - SAME REFERENCE TIME
C     SV     - SAME VALID TIME
C     Var iA - TEMPORAL VARIANCE, OR COVARIANCE, OF INITIALIZED ANALYSES
      DATA ITRF  /    0    ,   1    ,   2    ,   3    ,   4    ,
     +                5    ,   10   ,   11   ,   13   ,   14   , 
     +               100   ,  113   ,  114   ,  115   ,  116   ,
     +               117   ,  118   ,  119   ,
     +               123   ,  124   /
      DATA YTRFA / '      ','Init. ','Range ','Av.CR.','Ac.CR.',
     +             'Diff. ','Forc +','In.F +','NudgAn','Re.F +',
     +             'VerDif','Averg.','Accum.','Av.SR.','Ac.SR.',
     +             'Av.SV.','Var iA','StaDev',
     +             'Averg.','Accum.' /
      DATA YTRF  / ' ','Init. Analysis Prod.','Range Time T1 - T2',
     +             'Average CR T1 to T2','Accumul. CR T1 - T2',
     +             'Difference T2-T1','Forecast',
     +             'Initialized Forecast','Nudging Analysis',
     +             'Redefined Forecast','Verific. Difference',
     +             'Averg. F/iA T1 to T2','Accum. F/iA T1 - T2',
     +             'Averg. Forecasts SR','Accum. Forecasts SR',
     +             'Averg. Forecasts SV','TempVar/Covar of iA',
     +             'Standard deviation','Averg. uiA T1 to T2' ,
     +             'Accum. uiA T1 - T2' /
C     AUSGABEGROESSEN VORBESETZEN
C     HILFSGROESSEN DEFINIEREN
      DATA ICENT0 /1900/
      DATA YUPNAM / 'GRBTIM' /
C
      IRM   = 0
      IRM1  = 0
      ITDIF = 0
      ITIM1 = 0
      ITIM2 = 0
      ISEC1 = 0
      ISEC2 = 0
      IVV1  = 0
      IVV2  = 0
      ICENT = 0
      IJAHR = 0
      IJAHRZ= 0
C
C     REFERENZDATUM BESTIMMEN
C     .. zunaechst Jahresangabe vollstaendig mit Jahrhundert und
C        Jahrtausend bestimmen
      IF (IPDB(2).EQ.0) THEN
C     GRIB0-Version hat als Jahrhundertangabe immer 1900
         ICENT = ICENT0
         IJAHR = ICENT + IPDB(11)
      ELSE
C     GRIB1-Version hat die Jahrhundertangabe in PDB-Wort 22
C     verschluesselt
         IJAHR = (IPDB(22)-1)*100 + IPDB(11)
      END IF
      IJAHRZ = MOD(IJAHR,100)           
C
C     BEI DATUMSANGABE 0  WIRD SONDERTEXT NACH YDATE GESCHRIEBEN
      IF (IPDB(11).EQ.0.AND.IPDB(12).EQ.0.AND.IPDB(13).EQ.0) THEN
         YDATE = 'REFERENZDATUM 000000'
      ELSE
C     WOCHENTAG BESTIMMEN
         CALL WOTAN (YWOTA,NWOTA,IJAHR,IPDB(12),IPDB(13),IRM1)
C     REFERENZDATUM NACH YDATE SCHREIBEN
         WRITE (YDATE,10) YWOT2(NWOTA),IPDB(13),IPDB(12),IJAHRZ,
     +                    IPDB(14),IPDB(15)
10       FORMAT (A2,' ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',I2.2,'UTC')
      END IF
C
C     ART DER ZEITDARSTELLUNG -YTIR- BESTIMMEN
C
      DO 15 I = 1,ITRIMX
      IF (IPDB(19).EQ.ITRF(I))  GOTO 25
15    CONTINUE
C     ANGEGEBENE ZEIT-FLAG NICHT IN TABELLE 5 ENTHALTEN
      YTIRA = 'XXXXXX'
      YTIR  = 'ZEIT-FLAG UNBEKANNT'
      IRM   = IRM + 1
      GOTO 9000
C
25    CONTINUE
      YTIR  = YTRF(I)
      YTIRA = YTRFA(I)
C     BEI VORHERSAGEN MIT ITRF=0 WIRD TEXT VON ITRF=10 VERWENDET,
C     !!! Z. ZT. ENTHAELT YTRF(7) DEN TEXT ZU ITRF=10 !!!!
      IF (ITRF(I).EQ.0.AND.IPDB(17).NE.0)  THEN
         YTIR  = YTRF(7)
         YTIRA = YTRFA(7)
      END IF
C
C     EINE WEITERE VERARBEITUNG DES PDB-ZEITBLOCKS IST NUR NOTWENDIG,
C     WENN DAS AUSGABEPRODUKT K E I N E  ANALYSE IST
C
      IF (IPDB(19).NE.1.AND.IPDB(19).NE.13) THEN
C
C     ZEITEINHEIT FUER ZEITRAEUME TIME1 UND TIME2 BESTIMMEN
C
         DO 35 I = 1,ITUMAX
         IF (IPDB(16).EQ.ITU(I))  GOTO 45
35       CONTINUE
C     ANGEGEBENE ZEITEINHEIT NICHT IN GRIB-TABELLE 4 ENTHALTEN
         YTIUA = 'XXX'
         YTIU  = 'EINH. UNBK'
         IRM   = IRM + 1
         GOTO 9000
C
45       CONTINUE
         YTIU  = YTIUN(I)
         YTIUA = YTIUNA(I)
C
C     WEITERE VERARBEITUNG DES PDB NUR, WENN TIME1 ODER TIME2 .NE. 0;
C     BEI ITR = 100 WIRD VERARBEITUNG IN JEDEM FALLE FORTGESETZT
C
         IF (IPDB(19).NE.100) THEN
         IF (IPDB(17).NE.0.OR.IPDB(18).NE.0) THEN
C
C     ZEITEN YDA1 UND YDA2 SOWIE DIE ZEITDIFFERENZ ITDIF BESTIMMEN
C
C     BEI ZEIT-FLAG = 10 IST TIME1 IN IPDB(18) GESPEICHERT, SONST IN
C                                                           IPDB(17)
            IF (IPDB(19).EQ.10) THEN
               ITIM1 = IPDB(18)
C     BEI VORHERSAGEN IST ITIM1 = ITDIF
               ITDIF = ITIM1
            ELSE
               ITIM1 = IPDB(17)
C **  BESONDERHEIT BEI ZEIT-FLAG 115 - 117, 119: KEIN ITDIF !
               IF ((IPDB(19).GT.114.AND.IPDB(19).LT.118).OR.
     +             (IPDB(19).EQ.119)) THEN
                  ITIM2 = IPDB(18)
               ELSE
                  ITDIF = IPDB(17)
C     BEI ZWEITER ZEITANGABE STEHT ITIM2 IN IPDB(18) UND ITDIF IST
C     DIE DIFFERENZ ITIM2-ITIM1+1  *********** SIEHE UNTEN !
                  IF (IPDB(19).GT.1.AND.IPDB(19).NE.11) THEN
                     ITIM2 = IPDB(18)
C     -----
C     BESONDERHEIT !
C     FUER TIME RANGE INDICATOR NRN. 113,114,118,123,124 GILT :
C     ----- ITIM2 = ZEITINTERVALL ZWISCHEN EINZELPRODUKTEN
C     ----- ITIM2 FUER DIE AUSGABE NACH T2 MUSS DAS PRODUKT VON
C     ----- ZEITINTERVALL * (ANZAHL DER EINZELPRODUKTE-1) + ITIM1  SEIN
C     -----     ITIM2 = IPDB(18) * (IPDB(20)-1) + ITIM1
C     ----- DIE AUSGABE-GROESSE ITDIF MUSS DAS ZEITINTERVALL ENTHALTEN
                     IF ((IPDB(19).EQ.113.OR.IPDB(19).EQ.114).OR.
     +                   (IPDB(19).EQ.118).OR.
     +                   (IPDB(19).EQ.123.OR.IPDB(19).EQ.124)) THEN
                        ITIM2 = IPDB(18) * (IPDB(20)-1) + ITIM1
                        ITDIF = IPDB(18)
C     -----
                     ELSE
C     *****  DIE NACHFOLGENDE ZEILE WURDE NACH ANMERKUNG VON H. MAJEWSKI
C     *****  GEAENDERT: DER ZEITRAUM ZWISCHEN ZWEI TERMINEN IST
C     *****           ITIM2 - ITIM1,   SONST NICHTS !       (05/90)
C                 ITDIF = ITIM2 - ITIM1 + 1
                        ITDIF = ITIM2 - ITIM1
C     FEHLER-AUSGANG, WENN TIME1 GT. TIME2
C     *****  GEAENDERT, SIEHE OBEN : ANSTELLE VON .LE. .LT. EINGESETZT
                        IF (ITDIF.LT.0) THEN
                           WRITE (YDA1,54)
54                         FORMAT ('--ERROR-- T1.GT.T2--')
                           IRM = IRM + 1
                           GOTO 9000
                        END IF
                     END IF
                  END IF
               END IF
            END IF
C     -----
C     BESONDERHEIT !
C     FUER TIME RANGE INDICATOR NRN. 115,116,117,119 GILT :
C     ----- ITIM1 = ERSTES VORHERSAGE-INTERVALL
C     ----- ITIM2 = VORHERSAGE-INTERVALL FUER DIE WEITEREN VORHERSAGEN
C     ----- YDATE = REFERENCE TIME BZW. VALID TIME (GEAENDERTE AUSGABE)
            IF ((IPDB(19).GT.114.AND.IPDB(19).LT.118).OR.
     +          (IPDB(19).EQ.119)) THEN
               WRITE (YDA1,205) IPDB(17), YTIU
205            FORMAT ('first p. ',I7,1X,A3)
               WRITE (YDA2,215) IPDB(18), YTIU
215            FORMAT ('other p. ',I7,1X,A3)
               IF (IPDB(19).EQ.117) THEN
C     ----- TRI = 117  -  YDATE = VALID TIME
                  WRITE (YDATE,225) IPDB(13), IPDB(12), IJAHRZ,
     +                              IPDB(14), IPDB(15)
225               FORMAT ('VALID',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',
     +                    I2.2,'z')
               ELSE
C     ----- TRI = 115,116,119  -  YDATE = REFERENCE TIME
                  WRITE (YDATE,235) IPDB(13), IPDB(12), IJAHRZ,
     +                              IPDB(14), IPDB(15)
235               FORMAT ('REF.T',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',
     +                    I2.2,'z')
               END IF
C     -----
            ELSE
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT MINUTE
               IF (IPDB(16).EQ.0) THEN
                  CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        IPDB(15),ITIM1,IYY1N,IMM1N,IDD1N,
     +                        IHH1N,IMI1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,55) IDD1N,IMM1N,IYY1N,IHH1N,IMI1N
55               FORMAT ('T1 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',I2.2,
     +                    'UTC')
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           IPDB(15),ITIM2,IYY2N,IMM2N,IDD2N,
     +                           IHH2N,IMI2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,65) IDD2N,IMM2N,IYY2N,IHH2N,IMI2N
65               FORMAT ('T2 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',I2.2,
     +                       'UTC')
                  END IF
C     NEU: 15 minutes                                  29.06.2005
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT 15 MINUTEN
               ELSE IF (IPDB(16).EQ.13) THEN
                  ITIMI = ITIM1*15
                  CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        IPDB(15),ITIMI,IYY1N,IMM1N,IDD1N,
     +                        IHH1N,IMI1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,55) IDD1N,IMM1N,IYY1N,IHH1N,IMI1N
C55               FORMAT ('T1 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',I2.2,
C    +                    'UTC')
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                  ITIMI = ITIM2*15
                     CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           IPDB(15),ITIMI,IYY2N,IMM2N,IDD2N,
     +                           IHH2N,IMI2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,65) IDD2N,IMM2N,IYY2N,IHH2N,IMI2N
C65               FORMAT ('T2 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',I2.2,
C    +                       'UTC')
                  END IF
C     NEU: 30 minutes                                  29.06.2005
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT 15 MINUTEN
               ELSE IF (IPDB(16).EQ.14) THEN
                  ITIMI = ITIM1*30
                  CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        IPDB(15),ITIMI,IYY1N,IMM1N,IDD1N,
     +                        IHH1N,IMI1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,55) IDD1N,IMM1N,IYY1N,IHH1N,IMI1N
C55               FORMAT ('T1 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',I2.2,
C    +                    'UTC')
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                  ITIMI = ITIM2*30
                     CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           IPDB(15),ITIMI,IYY2N,IMM2N,IDD2N,
     +                           IHH2N,IMI2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,65) IDD2N,IMM2N,IYY2N,IHH2N,IMI2N
C65               FORMAT ('T2 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'.',I2.2,
C    +                       'UTC')
                  END IF
C     NEU: ENDE                                        29.06.2005
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT STUNDE
               ELSE IF (IPDB(16).EQ.1) THEN
                  CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        ITIM1,IYY1N,IMM1N,IDD1N,IHH1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,55) IDD1N,IMM1N,IYY1N,IHH1N,IPDB(15)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           ITIM2,IYY2N,IMM2N,IDD2N,IHH2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,65) IDD2N,IMM2N,IYY2N,IHH2N,IPDB(15)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT STUNDE BEI
C     ITU=10 (ZEITINTERVALL 3 STD.)
               ELSE IF (IPDB(16).EQ.10) THEN
                  ITIMI = ITIM1 * 3
                  CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        ITIMI,IYY1N,IMM1N,IDD1N,IHH1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,55) IDD1N,IMM1N,IYY1N,IHH1N,IPDB(15)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     ITIMI = ITIM2 * 3
                     CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           ITIMI,IYY2N,IMM2N,IDD2N,IHH2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,65) IDD2N,IMM2N,IYY2N,IHH2N,IPDB(15)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT STUNDE BEI
C     ITU=11 (ZEITINTERVALL 6 STD.)
               ELSE IF (IPDB(16).EQ.11) THEN
                  ITIMI = ITIM1 * 6
                  CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        ITIMI,IYY1N,IMM1N,IDD1N,IHH1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,55) IDD1N,IMM1N,IYY1N,IHH1N,IPDB(15)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     ITIMI = ITIM2 * 6
                     CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           ITIMI,IYY2N,IMM2N,IDD2N,IHH2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,65) IDD2N,IMM2N,IYY2N,IHH2N,IPDB(15)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT STUNDE BEI
C     ITU=12 (ZEITINTERVALL 12 STD.)
               ELSE IF (IPDB(16).EQ.12) THEN
                  ITIMI = ITIM1 * 12
                  CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        ITIMI,IYY1N,IMM1N,IDD1N,IHH1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,55) IDD1N,IMM1N,IYY1N,IHH1N,IPDB(15)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     ITIMI = ITIM2 * 12
                     CALL VNSTD (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           ITIMI,IYY2N,IMM2N,IDD2N,IHH2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,65) IDD2N,IMM2N,IYY2N,IHH2N,IPDB(15)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT TAG
               ELSE IF (IPDB(16).EQ.2) THEN
                  CALL VNDAT (IJAHR,IPDB(12),IPDB(13),ITIM1,
     +                           IYY1N,IMM1N,IDD1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,75) IDD1N,IMM1N,IYY1N,IPDB(14)
75                FORMAT ('T1 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,' UTC')
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     CALL VNDAT (IJAHR,IPDB(12),IPDB(13),ITIM2,
     +                           IYY2N,IMM2N,IDD2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                     WRITE (YDA2,85) IDD2N,IMM2N,IYY2N,IPDB(14)
85                FORMAT ('T2 ',I2.2,'.',I2.2,'.',I2.2,' ',I2.2,' UTC')
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT MONAT
               ELSE IF (IPDB(16).EQ.3) THEN
C     JAHRESZAHL-ANGABE 4-STELLIG
                  IYY1N = IJAHR
C
                  IMM1N = IPDB(12) + ITIM1
                  IF (IMM1N.GT.12) THEN
                     IYYAMO = IMM1N / 12
                     IMM1N  = MOD(IMM1N,12)
C     MONAT 12 SOLL ERHALTEN BLEIBEN UND NICHT ALS MONAT 0 IM FOLGEJAHR
C     AUSGEGEBEN WERDEN
                     IF (IMM1N.EQ.0) THEN
                        IYYAMO = IYYAMO-1
                        IMM1N  = 12
                     END IF
                     IYY1N  = IJAHR + IYYAMO
                  ELSE IF (IMM1N.LE.0) THEN
                     IYYAMO = (IMM1N/12) - 1
                     IMM1N  = 12 - (MOD(IMM1N,12))
                     IYY1N  = IJAHR + IYYAMO
                  END IF
                  WRITE (YDA1,95) IMM1N,IYY1N
95                FORMAT ('T1 ',I2.2,'.',I4)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
C     JAHRESZAHL-ANGABE 4-STELLIG
                     IYY2N = IJAHR
C
                     IMM2N = IPDB(12) + ITIM2
                     IF (IMM2N.GT.12) THEN
                        IYYAMO = IMM2N / 12
                        IMM2N  = MOD(IMM2N,12)
C     MONAT 12 SOLL ERHALTEN BLEIBEN UND NICHT ALS MONAT 0 IM FOLGEJAHR
C     AUSGEGEBEN WERDEN
                     IF (IMM2N.EQ.0) THEN
                        IYYAMO = IYYAMO-1
                        IMM2N  = 12
                     END IF
                        IYY2N  = IJAHR + IYYAMO
                     ELSE IF (IMM2N.LE.0) THEN
                        IYYAMO = (IMM2N/12) - 1
                        IMM2N  = 12 - (MOD(IMM2N,12))
                        IYY2N  = IJAHR + IYYAMO
                     END IF
                     WRITE (YDA2,105) IMM2N,IYY2N
105                  FORMAT ('T2 ',I2.2,'.',I4)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT JAHR
               ELSE IF ( IPDB(16).EQ.4) THEN
                  IYY1N = IJAHR + ITIM1
                  WRITE (YDA1,115) IYY1N
115               FORMAT ('T1 ',I5)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     IYY2N = IJAHR + ITIM2
                     WRITE (YDA2,125) IYY2N
125                  FORMAT ('T2 ',I5)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT JAHRZEHNT
               ELSE IF ( IPDB(16).EQ.5) THEN
                  IYY1N = IJAHR + (ITIM1*10)
                  WRITE (YDA1,135) IYY1N
135               FORMAT ('T1 ',I7)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     IYY2N = IJAHR + (ITIM2*10)
                     WRITE (YDA2,145) IYY2N
145                  FORMAT ('T2 ',I7)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT NORMALE (30 J.)
               ELSE IF (IPDB(16).EQ.6) THEN
                  IYY1N = IJAHR + (ITIM1*30)
                  WRITE (YDA1,135) IYY1N
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     IYY2N = IJAHR + (ITIM2*30)
                     WRITE (YDA2,145) IYY2N
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT JAHRHUNDERT
               ELSE IF (IPDB(16).EQ.7) THEN
                  IYY1N = IJAHR + (ITIM1*100)
                  WRITE (YDA1,155) IYY1N
155               FORMAT ('T1 ',I9)
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     IYY2N = IJAHR + (ITIM2*100)
                     WRITE (YDA2,165) IYY2N
165                  FORMAT ('T2 ',I9)
                  END IF
C     ZEITEN YDA1 UND YDA2 BESCHREIBEN BEI ZEITEINHEIT SEKUNDE
               ELSE IF (IPDB(16).EQ.254) THEN
                  IMIASE = ITIM1 / 60
                  ISEC1  = MOD(ITIM1,60)
                  IF (ITIM1.LT.0) THEN
                     IMIASE = IMIASE - 1
                     ISEC1  = 60 - (MOD(ITIM1,60))
                  END IF
                  CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                        IPDB(15),IMIASE,IYY1N,IMM1N,IDD1N,
     +                        IHH1N,IMI1N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                  IYY1N = MOD(IYY1N,100)
                  WRITE (YDA1,175) IDD1N,IMM1N,IYY1N,IHH1N,IMI1N,ISEC1
175               FORMAT ('T1 ',I2.2,'.',I2.2,'.',I2.2,' ',
     +                    I2.2,'.',I2.2,'.',I2.2,'UTC')
                  IF (IPDB(19).GT.1.AND.(IPDB(19).NE.10.AND.
     +                                   IPDB(19).NE.11)) THEN
                     IMIASE = ITIM2 / 60
                     ISEC2  = MOD(ITIM2,60)
                     IF (ITIM2.LT.0) THEN
                        IMIASE = IMIASE -1
                        ISEC2  = 60 - (MOD(ITIM2,60))
                     END IF
                     CALL VNMIN (IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           IPDB(15),IMIASE,IYY2N,IMM2N,IDD2N,
     +                           IHH2N,IMI2N,IRM1)
C     JAHRESZAHL-ANGABE AUF 2 STELLEN FESTLEGEN
                     IYY2N = MOD(IYY2N,100)
                    WRITE (YDA2,185) IDD2N,IMM2N,IYY2N,IHH2N,IMI2N,ISEC2
185                  FORMAT ('T2 ',I2.2,'.',I2.2,'.',I2.2,' ',
     +                       I2.2,'.',I2.2,'.',I2.2,'UTC')
                  END IF
C     ANDERE ZEITDIMENSIONEN SIND IN DER GRIB-TABELLE 4 NICHT ENTHALTEN
               ELSE
                  YDA1 = 'XXXXX'
                  IRM = IRM + 1
                  GOTO 9000
               END IF
            END IF
         END IF
         ELSE
C     VERARBEITUNG VON VERFIKATIONS-DIFFERENZEN (ITR=100)
C     ---------------------------------------------------
C     YDATE = VALID TIME
C     YDA1  = DATUM DES ERSTEN FELDES
C     YDA2  = DATUM DES ZWEITEN FELDES, DAS VOM ERSTEN ABGEZOGEN IST
C     ITDIF = SCHALTER FUER MODELL-AUSWERTUNG BEIDER FELDER (SIEHE OBEN)
C     ITIM1 = ZEITRAUM, DER AUF DIE REFERENZ-ZEIT ADDIERT WIRD, UM YDATE
C             ZU BESTIMMEN
C     ITIM2 = ZEITRAUM, DER VON YDATE ABGEZOGEN WIRD, UM DATUM-TEIL VON
C             YDA2 ZU BESTIMMEN
            ITIM1 = IPDB(17)
            ITIM2 = IPDB(18)
            IF (ITIM1.EQ.0.AND.ITIM2.NE.0) THEN
               ITDIF = 2
            ELSE IF ((ITIM1.NE.0.AND.ITIM2.EQ.0).OR.
     +               (ITIM1.EQ.0.AND.ITIM2.EQ.0)) THEN
C     VERABREDUNGSGEMAESS GILT FUER (ITIM1=0 UND ITIM2=0) EBENFALLS
C     FELD 1 IST VORHERSAGE+00 UND FELD 2 IST ANALYSE!
               ITDIF = 3
            ELSE
               ITDIF = 1
            END IF
C     ...... YDATE FORMULIEREN, ITIM1 UND ITIM2 FUER DATUM-BERECHNUNGEN
C     ...... UMWANDELM
            IF (IPDB(16).NE.0) THEN
C              NEU:                                           29.06.2005
               IF (IPDB(16).EQ.13) THEN
C     BEI ZEITANGABE IN 15 MINUTEN MUSS DIE ZEIT ZUR DATUM-BERECHNUNG IN
C     MINUTEN UMGERECHNET WERDEN
                  IF (ITIM1.NE.0) THEN
                     IVV1 = IPDB(17)*15
                  END IF
                  IF (ITIM2.NE.0) THEN
                     IVV2 = IPDB(18)*15
                  END IF
C              NEU:                                           29.06.2005
               ELSE IF (IPDB(16).EQ.14) THEN
C     BEI ZEITANGABE IN 30 MINUTEN MUSS DIE ZEIT ZUR DATUM-BERECHNUNG IN
C     MINUTEN UMGERECHNET WERDEN
                  IF (ITIM1.NE.0) THEN
                     IVV1 = IPDB(17)*30
                  END IF
                  IF (ITIM2.NE.0) THEN
                     IVV2 = IPDB(18)*30
                  END IF
               ELSE IF (IPDB(16).EQ.1) THEN
C     BEI ZEITANGABE IN STUNDEN MUSS DIE ZEIT ZUR DATUM-BERECHNUNG IN
C     MINUTEN UMGERECHNET WERDEN
                  IF (ITIM1.NE.0) THEN
                     IVV1 = IPDB(17)*60
                  END IF
                  IF (ITIM2.NE.0) THEN
                     IVV2 = IPDB(18)*60
                  END IF
               ELSE IF (IPDB(16).EQ.2) THEN
C     BEI ZEITANGABE IN TAGEN MUSS DIE ZEIT ZUR DATUM-BERECHNUNG IN
C     MINUTEN UMGERECHNET WERDEN
                  IF (ITIM1.NE.0) THEN
                     IVV1 = IPDB(17)*60*24
                  END IF
                  IF (ITIM2.NE.0) THEN
                     IVV2 = IPDB(18)*60*24
                  END IF
               ELSE IF (IPDB(16).EQ.254) THEN
C     BEI ZEITANGABE IN SEKUNDEN MUSS DIE ZEIT ZUR DATUM-BERECHNUNG IN
C     MINUTEN UMGERECHNET WERDEN, REST-SEKUNDEN WERDEN AUFGEHOBEN
                  IF (ITIM1.NE.0) THEN
                     IVV1 = IPDB(17)/60
                     ISEC1 = MOD(IPDB(17),60)
                  END IF
                  IF (ITIM2.NE.0) THEN
                     IVV2 = IPDB(18)/60
                     ISEC2 = MOD(IPDB(18),60)
                  END IF
               ELSE
C     DATUM-BERECHNUNGEN ERFOLGEN OHNE UP DATBIL
                  IVV1 = 0
                  ISEC1 = 0
                  IVV2 = 0
                  ISEC2 = 0
               END IF
            ELSE
C     MINUTEN-WERTE AUS PDB KOENNEN ZUR DATUM-BERECHNUNG UEBERNOMMEN
C     WERDEN
               IVV1 = IPDB(17)
               IVV2 = IPDB(18)
            END IF
C     YDATUM, YDA1 UND YDA2 BESTIMMEN BEI TUI=(0-2,254)
            IF (IPDB(16).LT.3.OR.IPDB(16).GT.7) THEN
               WRITE (YDATI,300) IJAHR,IPDB(12),IPDB(13),IPDB(14),
     +                           IPDB(15)
300            FORMAT (I4.4,I2.2,I2.2,I2.2,'.',I2.2)
               CALL DATBIL (YDATI,IVV1,YDATO,IDATO,IPART,IRM1)
               IF (IRM1.NE.0) THEN
                  PRINT *, 'FEHLER IN UP DATBIL - ',
     +                     'ABBRUCH DER DATUM-BESTIMMUNG'
                  GOTO 9000
               END IF
               CALL WOTAN (YWOTA,NWOTA,IDATO(1,2),IDATO(2,2),IDATO(3,2),
     +                     IRM1)
               IF (ISEC1.GT.0) THEN
C     YDATE BEI SEKUNDEN-ANGABE
                  WRITE (YDATE,305) IDATO(3,2),IDATO(2,2),YDATO(2)(3:4),
     +                              IDATO(4,2),IDATO(5,2),ISEC1
305               FORMAT ('VT',I2.2,'.',I2.2,'.',A2,' ',I2.2,':',I2.2,
     +                    ':',I2.2,'z')
                  IF (ITIM1.EQ.0) THEN
                     YDA1 = YDATE(3:)
                  END IF
                  IF (ITIM2.EQ.0) THEN
                     YDA2 = YDATE(3:)
                  END IF
               ELSE
                  IF (IDATO(5,2).GT.0) THEN
C     YDATE BEI MINUTEN-ANGABE
                     WRITE (YDATE,310) IDATO(3,2),IDATO(2,2),
     +                                 YDATO(2)(3:4),IDATO(4,2),
     +                                 IDATO(5,2)
310                  FORMAT ('VAL ',I2.2,'.',I2.2,'.',A2,' ',I2.2,':',
     +                       I2.2,'z')
                     IF (ITIM1.EQ.0) THEN
                        YDA1 = YDATE(5:)
                     END IF
                     IF (ITIM2.EQ.0) THEN
                        YDA2 = YDATE(5:)
                     END IF
                  ELSE
C     YDATE BEI STUNDEN- ODER TAGES-ANGABE
                     WRITE (YDATE,315) YWOT2(NWOTA),IDATO(3,2),
     +                                 IDATO(2,2),YDATO(2)(3:4),
     +                                 IDATO(4,2)
315                  FORMAT ('VAL  ',A2,' ',I2.2,'.',I2.2,'.',A2,' ',
     +                       I2.2,'z')
                     IF (ITIM1.EQ.0) THEN
                        YDA1 = YDATE(9:)
                     END IF
                     IF (ITIM2.EQ.0) THEN
                        YDA2 = YDATE(9:)
                     END IF
                  END IF
               END IF
               IF (ITIM1.NE.0) THEN
C     YDA1 BEI ITIM1 .NE. 0
                  IF (IPDB(16).EQ.0.OR.IPDB(16).EQ.254
     +                .OR.ITIM1.GT.9999.OR.IPDB(15).NE.0) THEN
C     YDA1 FUER SEKUNDEN- ODER MINUTEN-ANGABE ODER BEI GROSSEM WERT T1
                     WRITE (YTIM1,359) ITIM1
359                  FORMAT (I10)
                     CALL BUNDIG (YUPNAM,IRM1,YTIM1,'L',YTIM1)
                     ILEN1 = LEN_TRIM(YTIM1)
                     WRITE (YDA1,360) YTIM1(1:ILEN1), YTIUA
360                  FORMAT ('VT - ',A,' ',A3)
                  ELSE
C     YDA1 FUER STUNDEN- ODER TAGES-ANGABE
                     WRITE (YDA1,365) IPDB(13), IPDB(12), IJAHRZ,
     +                                IPDB(14), ITIM1, YTIUA
365                  FORMAT (I2.2,'.',I2.2,'.',I2.2,' ',I2.2,'z+',
     +                       I4,A3)
                  END IF
               END IF
               IF (ITIM2.NE.0) THEN
C     YDA2 BEI ITIM2 .NE. 0
                  WRITE (YTIM2,359) ITIM2
                  CALL BUNDIG (YUPNAM,IRM1,YTIM2,'L',YTIM2)
                  ILEN1 = LEN_TRIM(YTIM2)
                  IF (IPDB(16).EQ.0.OR.IPDB(16).EQ.254) THEN
C     YDA2 FUER SEKUNDEN- ODER MINUTEN-ANGABE
                     WRITE (YDA2,360) YTIM2(1:ILEN1), YTIUA
                  ELSE
C     YDA2 FUER STUNDEN- ODER TAGES-ANGABE
C     .. START-DATUM DES ZWEITEN FELDES BERECHNEN
                     YDATI = YDATO(2)
                     CALL DATBIL (YDATI,-IVV2,YDATO,IDATO,IPART,IRM1)
                     IF (IRM1.NE.0) THEN
                        PRINT *, 'FEHLER IN UP DATBIL - ',
     +                           'ABBRUCH DER DATUM-BESTIMMUNG'
                        GOTO 9000
                     END IF
                     IF (IDATO(5,2).EQ.0.AND.ITIM2.LT.10000) THEN
                        WRITE (YDA2,370) IDATO(3,2), IDATO(2,2),
     +                                   YDATO(2)(3:4), IDATO(4,2),
     +                                   ITIM2, YTIUA
370                     FORMAT (I2.2,'.',I2.2,'.',A2,' ',I2.2,'z+',
     +                          I4,A3)
                     ELSE
                        WRITE (YDA2,360) YTIM2(1:ILEN1), YTIUA
                     END IF
                  END IF
               END IF
            ELSE
C     YDATE BEI ZEITANGABEN IN DER DIMENSION MONAT ODER IN LAENGEREN
C     ZEITRAEUMEN BESTIMMEN
               IF (IPDB(16).EQ.3) THEN
C     ZEITANGABEN IN MONATEN
                  IYY1N = IJAHR
                  IMM1N = IPDB(12) + ITIM1
                  IF (IMM1N.GT.12) THEN
                     IYYAMO = IMM1N / 12
                     IMM1N = MOD(IMM1N,12)
C     MONATSZAHL DARF NICHT 0 SEIN
                     IF (IMM1N.EQ.0) THEN
                        IYYAMO = IYYAMO - 1
                        IMM1N = 12
                     END IF
                     IYY1N = IYY1N + IYYAMO
                  ELSE IF (IMM1N.LE.0) THEN
                     IYYAMO = (IMM1N/12) - 1
                     IMM1N = 12 - (MOD(IMM1N,12))
                     IYY1N = IYY1N + IYYAMO
                  END IF
                  IMM2N = ((IYY1N*12)+IMM1N) - ITIM2
                  IYY2N = IMM2N / 12
                  IMM2N = MOD(IMM2N,12)
               ELSE IF (IPDB(16).EQ.4) THEN
C     ZEITANGABEN IN JAHREN
                  IYY1N = IJAHR + ITIM1
                  IYY2N = IYY1N - ITIM2
                  IMM1N = IPDB(12)
                  IMM2N = IMM1N
               ELSE IF (IPDB(16).EQ.5) THEN
C     ZEITANGABEN IN DEKADEN
                  IYY1N = IJAHR + (ITIM1*10)
                  IYY2N = IYY1N - (ITIM2*10)
                  IMM1N = IPDB(12)
                  IMM2N = IMM1N
               ELSE IF (IPDB(16).EQ.6) THEN
C     ZEITANGABEN IN NORMALEN
                  IYY1N = IJAHR + (ITIM1*30)
                  IYY2N = IYY1N - (ITIM2*30)
                  IMM1N = IPDB(12)
                  IMM2N = IMM1N
               ELSE IF (IPDB(16).EQ.7) THEN
C     ZEITANGABEN IN JAHRHUNDERTEN
                  IYY1N = IJAHR + (ITIM1*100)
                  IYY2N = IYY1N - (ITIM2*100)
                  IMM1N = IPDB(12)
                  IMM2N = IMM1N
               END IF
C     DATUM-ANGABEN SCHREIBEN
               IF (ITIM1.EQ.0) THEN
                  IF (IPDB(15).EQ.0) THEN
                     WRITE (YDATE,400) IPDB(13), IMM1N, IYY1N,
     +                                 IPDB(14)
400                  FORMAT ('VALID ',I2.2,'.',I2.2,'.',I4.4,' ',I2.2,
     +                       'z')
                  ELSE
                     WRITE (YDATE,405) IPDB(13), IMM1N, IYY1N,
     +                                 IPDB(14), IPDB(15)
405                  FORMAT ('VT ',I2.2,'.',I2.2,'.',I4.4,' ',I2.2,'.',
     +                       I2.2,'z')
                  END IF
                  WRITE (YDA1,410) IPDB(13),IPDB(12),IJAHR,IPDB(14)
410               FORMAT (I2.2,'.',I2.2,'.',I4.4,' ',I2.2,'z')
               ELSE
                  WRITE (YJAHR1,415) IYY1N
415               FORMAT (I10)
                  CALL BUNDIG (YUPNAM,IRM1,YJAHR1,'L',YJAHR1)
                  ILEN1 = LEN_TRIM(YJAHR1)
                  ILS = ILEN1 - 1
                  IF (IPDB(15).EQ.0) THEN
                     IF (ILEN1.LT.8) THEN
                        IF (ILEN1.LT.5) THEN
                           WRITE (YDATE,400) IPDB(13), IMM1N, IYY1N,
     +                                       IPDB(14)
                        ELSE
                           WRITE (YDATE,420) IPDB(13), IMM1N,
     +                                       YJAHR1(1:ILEN1), IPDB(14)
420                        FORMAT ('VT ',I2.2,'.',I2.2,'.',A,' ',
     +                             I2.2,'z')
                        END IF
                     ELSE
                        WRITE (YDATE,425) IPDB(13), IMM1N,
     +                                    YJAHR1(ILS:ILEN1), IPDB(14)
425                     FORMAT ('VALID ',I2.2,'.',I2.2,'.',A2,' ',
     +                          I2.2,'z')
                     END IF
                  ELSE
                     IF (ILEN1.LT.5) THEN
                        WRITE (YDATE,405) IPDB(13), IMM1N, IYY1N,
     +                                    IPDB(14), IPDB(15)
                     ELSE
                        WRITE (YDATE,430) IPDB(13), IMM1N,
     +                                    YJAHR1(ILS:ILEN1), IPDB(14),
     +                                    IPDB(15)
430                     FORMAT ('VAL ',I2.2,'.',I2.2,'.',A2,' ',I2.2,
     +                          '.',I2.2,'z')
                     END IF
                  END IF
                  WRITE (YTIM1,415) ITIM1
                  CALL BUNDIG (YUPNAM,IRM1,YTIM1,'L',YTIM1)
                  ILEN1 = LEN_TRIM(YTIM1)
                  IF (ILEN1.LT.8) THEN
                     WRITE (YDA1,435) IPDB(12),IJAHR, ITIM1, YTIUA
435                  FORMAT (I2.2,'.',I4.4,' + ',I7,A3)
                  ELSE
                     WRITE (YDA1,440) IPDB(12),IJAHR, YTIM1(1:ILEN1),
     +                                YTIUA
440                  FORMAT (I2.2,'.',I4.4,' +',A,A3)
                  END IF
               END IF
               IF (ITIM2.EQ.0) THEN
                  WRITE (YDA2,410) IPDB(13),IMM1N,IYY1N,IPDB(14)
               ELSE
                  WRITE (YTIM2,415) ITIM2
                  CALL BUNDIG (YUPNAM,IRM1,YTIM2,'L',YTIM2)
                  ILEN1 = LEN_TRIM(YTIM2)
                  WRITE (YJAHR2,415) IYY2N
                  CALL BUNDIG (YUPNAM,IRM1,YJAHR2,'L',YJAHR2)
                  ILEN2 = LEN_TRIM(YJAHR2)
                  ILS = ILEN2 - 1
                  IF (ILEN2.LT.5) THEN
                     IF (ILEN1.LT.8) THEN
                        WRITE (YDA2,435) IMM2N,IYY2N, ITIM2, YTIUA
                     ELSE
                        WRITE (YDA2,440) IMM2N,IYY2N,
     +                                   YTIM2(1:ILEN1), YTIUA
                     END IF
                  ELSE
                     WRITE (YDA2,445) IMM2N, YJAHR2(ILS:ILEN2),
     +                                YTIM2(1:ILEN1), YTIUA
445                  FORMAT (I2.2,'.',A2,' + ',A,A3)
                  END IF
               END IF
            END IF
         END IF
      END IF
C     UP-ABSCHLUSS
9000  CONTINUE
      IRM = IRM + IRM1
      RETURN
      END
