      SUBROUTINE GRPRT1 (IUN,IOUT,IANZ,IGA,IGE,NPR,IFAK)
C**** GRPRT1   -   UP:GRIB-FELDER KURZINFORMATION AUSGEBEN
C**   AUFRUF   :   CALL GRPRT1 (IUN,IOUT,IANZ,IGA,IGE,NPR,IFAK()
C**   EXTERNALS:   ABEX, ARBITI, ARBITU, GRBIN1, LGPDB1, UEGIN
C**   ZWECK    :   GRIB-FELDER-KURZINFORMATION, ABHAENGIG VON NPR-PARAMETER
C**
C**   PARAMETER:   KENNUNG:     WERT:
C**
C**                IUN        = FILE-NAMEN-EINHEIT DER UEGABE-DATEI
C**                IOUT       = PROTOKOLL-DATEI-EINHEIT
C**                             -1 PROTOKOLLIERT AUF STDOUT
C**                IANZ       = ANZAHL FELDER
C**                IGA        = 1.AUSZUGBD.GITTERPKT.WERT  )  unabhaengig von
C**                IGE        = L.AUSZUGBD.GITTERPKT.WERT  )       NPR
C**                NPR        = 1..575, PRINT-PARAMETER, DEFAULT: 2;
C**                                     ERLAEUTERUNG siehe unten
C**                IFAK       = -10..+10 FAKTOR= 10**IFAK
C**                             MIT DEM ALLE GITTERPUNKT-WERTE MULTIPLIZIERT
C**                             WERDEN SOLLEN
C**
C**   DOKUMENTATION FUER PRINT-PARAMETER NPR:
C**
C**                NPR =  1   => folgende Werte aus LGPDB1:
C**                              LEGENDE MIT FELDNUMMER / RECORDNUMMER
C**                                          ZENTRUM / MODELL
C**                                          REFERENZZEIT
C**                                          ( ZEITRAUM )    -
C**                                          ( ZEIT T1  )    -   OPTIONAL
C**                                          ( ZEIT T2  )    -
C**                                          ELEMENT-NAME
C**                                          ELEMENT-DIMENSION
C**                                          LEVEL-BEZEICHNUNG
C**                                          NIVEAU
C**                              tritt in LGPDB1 Fehler auf, wird der PDB aus-
C**                              gegeben
C**                NPR =  2   => RECORD-NR.,MODELL,REFERENZ-ZEIT,ELEMENT,NIVEAU,
C**                              GRIBLAENGE,DATENSATZLAENGE,
C**                              MAX-/MIN-WERT MIT GITTERPUNKT-NUMMER
C**                NPR =  4   => 24 DATENWERTE VOR  MINIMUM-/MAXIMUM-WERT
C**                              24 DATENWERTE NACH MINIMUM-/MAXIMUM-WERT
C**                                 (AUSGABE: 7*7 WERTE MIT MIN/MAX IM MITTELPKT)
C**                NPR =  8   => PDB-WERTE
C**   NEU 09/03:                 IPDB(37)=-253 oder IPDB(37)=-254 und IPDB(3)#98:
C**                              AB BYTE 40 UNBEKANNTE PDB-DATEN, DIESE DATEN
C**                              WERDEN AB IPDB(50).. BYTEWEISE UMGESPEICHERT,
C**                              IN IPDB(48) STEHT DIE ANZAHL DER RESTL.UNBEK.
C**                              BYTES, IN IPDB(49) STEHT DIE WORT-ANZAHL DER
C**                              RESTL.UNBEK.BYTES (! 64-/32- BITRECHNER !)
C**                NPR = 16   => GDB-,BMB-,BDB-WERTE (sofern vorhanden)
C**                NPR = 32   => GRIB binaer mit  ARBITU bzw. ARBITI ausgeben
C**   NEU 09/02:   NPR =512   => BEIM 1.GRBIN1-FEHLER ERFOLGT PROGRAMM-
C**                              ABBRUCH MIT CALL ABEX
C**   HINWEIS:     NPR-KOMBINATIONEN SIND MOEGLICH,
C**                              zum Beispiel:
C**                NPR = 63   => NPR = 32, 16, 8, 4, 2, 1
C**                NPR = 31   => NPR =     16, 8, 4, 2, 1
C**                NPR = 26   => NPR =     16, 8,    2
C**
C**   VERFASSER:   A.ZALEWSKY, JULI 1995
C**                (MOD. CRAY: CUEGIN;       05.02.1997 ZAL.)
C.....MODIFICATION: LDS/LFD/LBMB GEAENDERT, A.ZALEWSKY..................03.11.97
C     MODIFICATION: LFD=81000*2 fuer 64-BIT-RECHNER, ARZ3ZAL............25.11.97
C.....MODIFICATION: GRIBLAENGE IN BYTES IN IDIMS(19)....................23.04.98
C.....MODIFICATION: FAK-AUSGABE AUF F20.5 GESETZT, AZALEWSK.............10.11.98
C.....MODIFICATION: LDS=210000,LFD=109000(*2)...........................23.11.98
C.....MODIFICATION: LDS=264000,LFD=140000(*2),LBMB=4500(*2).............24.02.99
C.....MODIFICATION: FLOAT(10**-INT.WERT)=0.0,->1./FLOAT(10**+INT.WERT)in REFMIN;
C...................nur noch #ifdef(CRAY;OLDC;TEST)...................01.02.2000
C     MODIFICATION  R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
C                             Ueberfluessige Parameter raus, #ifdef(CRAY) raus
C                             Dynamische Allokierung von IBLOCK, IBMAP, DS
C                             Ausgabe Ref.Zeit fuer 32 Bit Maschinen angepasst
C     MODIFICATION  B.Loeser, 11/00, DATA IMASK  / Z'FFFFFFFF' /
C.....MODIFICATION: CHARACTER YREFZ*12, YREFZ statt IREFZ ausgeben;
C...................NPR's FUER JEDEN RECORD NEU SETZEN..............17.07.2001
C.....MODIFICATION: A.ZALEWSKY, TI14, 07/02;
C                   BEI NPR>=512 ERFOLGT BEIM 1.GRBIN1-FEHLER 
C                   PROGRAMM-ABBRUCH MIT CALL ABEX,
C                   DIE RECORD-NR. DES FEHLER-GRIBs WIRD AUSGEGEBEN
C.....MODIFICATION: A.ZALEWSKY, TI14;
C                   AENDERUNG WEGEN CSB1-FEHLER-AUSGABE:
C                   IUDSC=0, WENN IPDB(24)=-999999..................09.09.2002
C.....MODIFICATION: A.ZALEWSKY, TI14;
C                   AENDERUNG WEGEN UNBEKANNTEM, LOKALEM PDB-BEREICH
C                   IPDB(37)=-253/(-254 und IPDB(3)#98).............09.09.2003
C.....MODIFICATION: A.ZALEWSKY, TI14;
C                   IDIMS(8)=LFD nach ALLOCATE(IBLOCK(LFD)).........16.09.2003
C.....MODIFICATION: A.ZALEWSKY, TI14;
C                   generell FORMAT-Angaben I5/I6/I7 in I8 geaendert...09.2005
C.....MODIFICATION: A.ZALEWSKY, TI14;
C                   IDCSUB=IPDB(23)=98  wird abgefragt.................11.2005
C.....MODIFICATION: A.ZALEWSKY, TI14;
C                   1. CUEGIN-/CBACK-AUFRUF ERSETZT DURCH CFINDNEXT....01.2006

      IMPLICIT NONE

      INTEGER IUN, IOUT, IANZ, IGA, IGE, NPR, IFAK, NDIMS, NPDS, NGDS
      INTEGER NBMS, NBDS, NDSUP, IPDB, IGDB, IBMB, IBDB, IDIMS, LEER
      INTEGER IZW, IBMJ, IZAER, IZAEL, LFD, J100, LFLB, IRM, IMASK
      INTEGER LFL, LFDB, IBLOCK1, J1, J2, J3, J4, J6, IEDNR, LDS, LBMB
      INTEGER LDSB, LGRIB, IDC, LDEFNR, IAY, IAC, IAT, IAE, IAL, ITYPNR
      INTEGER IDCSUB
      INTEGER IELNR, ILEVTP, ILEV1, ILEV2, IYY, IMM, IDD, IHH, IMN, II
      INTEGER IMF, I1, I2, I3, I4, IA, IE, IYT, LDSZW, IDSANF, IGMN
      INTEGER IGMX, IGMNZW, IGMXZW, IAMN, IEMN, IAMX, IEMX, IDA, IDE
      INTEGER J34, ID, J35, IGAZW, IGEZW, J36, J38, IZA, IZE, INDL, IP
      INTEGER LDEF, IPE, IPA, IB, IUDSC
      INTEGER NRGRP, NPRZW, NPR6, NPR5, NPR4, NPR3, NPR2, NPR1, NPR0
      INTEGER NPRF, NPDS1, NGDS1, NBMS1, NBDS1, NBMAP1, NDSUP1, NLDS
      INTEGER NBLCK1, LPDB, NUNIT, NXUNIT, NKOOR, NLIST
      INTEGER NPR4M, NPR2M, NPR1M, NPR0M, IREFZ, NPR10
      INTEGER ISKIP, ISKIPA

      REAL    DSUP, FZW, FAK, AMIN, AMAX, FAKP, UNDEF, REFMIN

#include "machconsts.h"

      PARAMETER (NDIMS=20,NPDS=321,NGDS=626,NBMS=3,NBDS=11,NDSUP=73)

      CHARACTER    YTEXT(10)*20, YMF(6)*3, YREFZ*12, YERR*2

      INTEGER, ALLOCATABLE:: IBLOCK(:), IBMAP(:)

      REAL,    ALLOCATABLE:: DS(:)

      DIMENSION    IPDB(NPDS), IGDB(NGDS), IBMB(NBMS), IBDB(NBDS)
      DIMENSION    IDIMS(NDIMS), DSUP(NDSUP)

C*    ------------------------------------------------------------------
      DATA LEER   / Z'4C454552' /
      DATA IMASK  / Z'FFFFFFFF' /
      DATA ISKIP  / 20 /

C.....IPDB(30)   =  0,1,2,..
C                   0 = MFB, 1 = MFA, WEITERE REIHENFOLGE FRAGLICH
      YMF(1)     = 'MFB'
      YMF(2)     = 'MFA'
      YMF(3)     = ' ? '
      YMF(4)     = ' ? '
      YMF(5)     = ' ? '
      YMF(6)     = ' ? '
C.....FAK        = 10.**IFAK........................................01.02.2000
      IF (IFAK .NE. 0)                                     THEN
         IZW     = ABS(IFAK)
         FZW     = FLOAT(10**(IZW))
      ELSE
         FZW     = 1.
      ENDIF            
      IF (IFAK .LT. 0)                                     THEN
         FAK     = 1./FZW
      ELSE
         FAK     = FZW
      ENDIF   
      IBMJ       = 0
      NRGRP      = 0
      UNDEF      = -1E10
      IZAER      = 0
      IZAEL      = 0
      IDIMS( 1)  = NPDS
      IDIMS( 2)  = NGDS
      IDIMS( 3)  = NBMS
      IDIMS( 4)  = NBDS
      IDIMS( 5)  = -1     ! Wird erst spaeter richtig besetzt
      IDIMS( 6)  = NDSUP
      IDIMS( 7)  = -1     ! Wird erst spaeter richtig besetzt
      IDIMS( 8)  = LFD
      IDIMS( 9)  = 0
      IDIMS(10)  = 0

C.....PRINT-AUSGABEN FESTLEGEN:
      YERR       = 'NE'
      NPRZW      = NPR
      NPR10      = 0
      NPR6       = 0
      NPR5       = 0
      NPR4       = 0
      NPR4M      = 0
      NPR3       = 0
      NPR2       = 0
      NPR2M      = 0
      NPR1       = 0
      NPR1M      = 0
      NPR0       = 0
      NPR0M      = 0
      NPRF       = 0
C.....IF (NPRZW.LT.1 .OR. NPRZW.GT.63)      THEN...................18.06.2002
      IF (NPRZW.LT.1 .OR. NPRZW.GT.575)     THEN
C........RECORDNUMMER, MODELNUMMER, ...
         NPR0    = 1
         NPR0M   = 1
      ELSE
         IF (NPRZW .GE. 512)                THEN
C...........PROGRAMM-ABBRUCH BEI FEHLER
            YERR = 'JA'
            NPRZW= NPRZW-512
         ENDIF                     
         IF (NPRZW .GE. 32)                 THEN
C...........IBLOCK
            NPR6 = 1
            NPRZW= NPRZW - 32
         ENDIF
         IF (NPRZW .GE. 16)                 THEN
C...........GDB, BMB, BDB
            NPR5 = 1
            NPRZW= NPRZW - 16
         ENDIF
         IF (NPRZW .GE.  8)                 THEN
C...........PDB
            NPR4 = 1
            NPR4M= 1
            NPRZW= NPRZW -  8
         ENDIF
         IF (NPRZW .GE.  4)                 THEN
C...........24 DATENWERTE VOR UND NACH MIN-/MAX-WERT
            NPR3 = 1
            NPRZW= NPRZW -  4
         ENDIF
         IF (NPRZW .GE.  2)                 THEN
C...........RECORDNUMMER,MODELL,REFERENZZEIT,ELEMENT,NIVEAU,    )
C           GRIBLAENGE,DATENSATZLAENGE,                         )  DEFAULT
C           MAX-/MIN-WERT MIT GITTERPUNKT-NUMMER                )
            NPR2 = 1
            NPR2M= 1
            NPRZW= NPRZW -  2
         ENDIF
         IF (NPRZW .GE.  1)                 THEN
C...........LEGENDE
            NPR1 = 1
            NPR1M= 1
            NPRZW= NPRZW -  1
         ENDIF
      ENDIF

C.....RECORDS EINLESEN UND AUSWERTEN............................................
      DO 100 J100= 1, IANZ

      IF(ALLOCATED(IBLOCK)) DEALLOCATE(IBLOCK)
      IF(ALLOCATED(IBMAP )) DEALLOCATE(IBMAP )
      IF(ALLOCATED(DS    )) DEALLOCATE(DS    )

C.....NEU:..........................................................16.01.2006
C.....Groesse des naechsten Records ermitteln:
      CALL CFINDNEXT (IUN,ISKIP,ISKIPA,LFLB,IRM)
      IF (IRM .NE. 0)                       THEN
       IF (IOUT .EQ. -1)                    THEN
        PRINT '('' GRPRT1:'',
     +          '' CFINDNEXT-FEHLER;'',/,8X,
     +          '' J100,ISKIP,ISKIPA,LFLB,IRM='',5I8)',
     +             J100,ISKIP,ISKIPA,LFLB,IRM
       ELSE
        WRITE  (IOUT,
     +        '('' GRPRT1:'',
     +          '' CFINDNEXT-FEHLER;'',/,8X,
     +          '' J100,ISKIP,ISKIPA,LFLB,IRM='',5I8)')
     +             J100,ISKIP,ISKIPA,LFLB,IRM
       ENDIF  
       CALL ABEX
     +      ('GC',10000,'FEHLER IN CFINDNEXT')
      ENDIF
C.....LFLB       = 0                     => DATEI-ENDE
      IF (LFLB .EQ. 0)                      GOTO 200
C
C.....Noetige Groesse fuer IBLOCK ermitteln und IBLOCK allokieren:
      LFL  = (LFLB-1)/IBYTW + 1
      LFDB = LFLB
      LFD  = LFL
      ALLOCATE(IBLOCK(1:LFD))
      IDIMS(8) = LFD
C
C.....ALT:..........................................................16.01.2006
C.....Groesse des naechsten Records ermitteln:
C.....Hierzu wird CUEGIN mit 0 als Maximalgroesse aufgerufen,
C.....IRM muss anschliessend -2 sein (oder 0, wenn Dateiende)
C     CALL CUEGIN (IUN, 0, IBLOCK, LFLB, IRM)
C     IF (IRM .NE. 0 .AND. IRM .NE. -2)     THEN
C        IF (IOUT .EQ. -1)                  THEN
C           PRINT       '('' GRPRT1:'',
C    +                 '' CUEGIN-FEHLER;J100,LFLB,IRM='',3I8)',
C    +                                  J100,LFLB,IRM
C        ELSE
C           WRITE (IOUT,'('' GRPRT1:'',
C    +                 '' CUEGIN-FEHLER;J100,LFLB,IRM='',3I8)')
C    +                                  J100,LFLB,IRM
C        ENDIF       
C        CALL ABEX
C    +   ('GC',10000,'FEHLER IN CUEGIN')
C     ENDIF
C.....LFLB       = 0                     => ENDE
C     IF (LFLB .EQ. 0)                      GOTO 200
C.....Noetige Groesse fuer IBLOCK ermitteln und IBLOCK allokieren:
C     LFL  = (LFLB-1)/IBYTW + 1
C     LFDB = LFLB
C     LFD  = LFL
C     ALLOCATE(IBLOCK(1:LFD))
C...................................................................16.09.2003
C     IDIMS(8) = LFD
C.....Einlesen
C     CALL CBACK (IUN, IRM)
C     IF (IRM .NE. 0)                       THEN
C        IF (IOUT .EQ. -1)                  THEN
C           PRINT       '('' GRPRT1:'',
C    +                 '' CBACK-FEHLER;J100,IRM='',2I8)',
C    +                                 J100,IRM
C        ELSE
C           WRITE (IOUT,'('' GRPRT1:'',
C    +                 '' CBACK-FEHLER;J100,IRM='',2I8)')
C    +                                 J100,IRM
C        ENDIF       
C        CALL ABEX
C    +   ('GC',10000,'FEHLER IN CBACK')
C     ENDIF
C...................................................................16.01.2006
      CALL CUEGIN (IUN, LFDB, IBLOCK, LFLB, IRM)
#     if defined(TEST)
      IF (IOUT .EQ. -1)                     THEN
         PRINT       '('' GRPRT1: LFD,LFL,LFDB,LFLB,IRM='',5I8)',
     +                            LFD,LFL,LFDB,LFLB,IRM
      ELSE
         WRITE (IOUT,'('' GRPRT1: LFD,LFL,LFDB,LFLB,IRM='',5I8)')
     +                            LFD,LFL,LFDB,LFLB,IRM
      ENDIF
#     endif
      IF (IRM .NE. 0)                      THEN 
         IF (IOUT .EQ. -1)                 THEN
            PRINT       '('' GRPRT1:'',
     +                 '' CUEGIN-FEHLER;J100,LFLB,IRM='',3I8)',
     +                                  J100,LFLB,IRM
         ELSE
            WRITE (IOUT,'('' GRPRT1:'',
     +                 '' CUEGIN-FEHLER;J100,LFLB,IRM='',3I8)')
     +                                  J100,LFLB,IRM
         ENDIF             
         CALL ABEX
     +   ('GC',10000,'FEHLER IN CUEGIN')
      ENDIF

      IZAER      = IZAER + 1
      IF (IOUT .EQ. -1)                     THEN
         PRINT       '(1H ,I8,71(1H_))',    IZAER
      ELSE
         WRITE (IOUT,'(1H ,I8,71(1H_))')    IZAER
      ENDIF

      IF(IBYTW.EQ.8) THEN
         IBLOCK1 = IAND(ISHFT(IBLOCK(1),-32),IMASK)
      ELSE
         IBLOCK1 = IBLOCK(1)
      ENDIF
      IF (IBLOCK1 .EQ. LEER)                THEN
         IF (IOUT .EQ. -1)                  THEN
            PRINT       '('' GRPRT1: LEERFELD-RECORDNR.='',I10)',
     +                                                     IZAER
         ELSE
            WRITE (IOUT,'('' GRPRT1: LEERFELD-RECORDNR.='',I10)')
     +                                                     IZAER
         ENDIF
C........RECORD LEER                     => SCHLEIFEN-ENDE
         GOTO 100
      ENDIF

C.....FEHLERAUSGANG (IBLOCK ZU KLEIN)
      IF (LFL .GT. LFD)                     THEN
         IF (IOUT .EQ. -1)                  THEN
            PRINT       '('' GRPRT1: RECORDNR.,LFD,LFL='',3I8)',
     +                               IZAER,    LFD,LFL
         ELSE
            WRITE (IOUT,'('' GRPRT1: RECORDNR.,LFD,LFL='',3I8)') 
     +                               IZAER,    LFD,LFL
         ENDIF
         CALL ABEX ('GC',10000,' DIMENSION VON IBLOCK ZU KLEIN')
      ENDIF

C.....IBLOCK AUSGEBEN,                      WENN NPR6 = 1
      IF (NPR6 .EQ. 1)                      THEN
         IF (IOUT .EQ. -1)                  THEN
            PRINT       '('' GRPRT1: IBLOCK(1..LFL),LFL='',I8)', LFL
            CALL ARBITI (IBLOCK(1),LFL)
         ELSE
            WRITE (IOUT,'('' GRPRT1: IBLOCK(1..LFL),LFL='',I8)') LFL
            CALL ARBITU (IBLOCK(1),LFL,IOUT)
         ENDIF
      ENDIF


C.....ZAEHLER FUER GRIB-FELDER HOCHRECHNEN
      IZAEL      = IZAEL + 1
C.....UNDEFINIERTE EINZELBLOCKDATEN MIT -999999 BELEGEN
      DO 11  J1  = 1, NPDS
   11 IPDB  (J1) = -999999
      DO 12  J2  = 1, NGDS
   12 IGDB  (J2) = -999999
      DO 13  J3  = 1, NBMS
   13 IBMB  (J3) = -999999
      DO 14  J4  = 1, NBDS
   14 IBDB  (J4) = -999999
C.....IBMAP kann hier noch nicht besetzt werden!
      DO 16  J6  = 1, NDSUP
   16 DSUP  (J6) = -999999

C.....GRBIN1 zunaechst mit LBMB = -1 und LDS = -1 aufrufen, um die
C.....richtigen Dimensionen zu erfahren

      IDIMS(5) = -1
      IDIMS(7) = -1
      CALL GRBIN1 (IEDNR,UNDEF,NDIMS,IDIMS,IBLOCK(1),IBMAP,
     +             IPDB,IGDB,IBMB,IBDB,DSUP,DS,IRM)
      IF (IRM .EQ. 0)                       THEN
C........Felder dimensionieren und aktueller Aufruf von GRBIN1
         LDS   = IDIMS(17)
         LBMB  = (LDS-1)/IBMAX + 1
         ALLOCATE(DS(1:LDS))
         ALLOCATE(IBMAP(1:LBMB))
         IDIMS(5) = LBMB
         IDIMS(7) = LDS
         IBMAP(:) = -999999
         CALL GRBIN1 (IEDNR,UNDEF,NDIMS,IDIMS,IBLOCK(1),IBMAP,
     +                IPDB,IGDB,IBMB,IBDB,DSUP,DS,IRM)
      ENDIF
      IF (IRM .NE. 0)                       THEN
         IF (IOUT .EQ. -1)                  THEN
         PRINT       '('' GRPRT1: GRBIN1-FEHLER; IRM,J100'',
     +                 '',RECORD-NR.='',3I10)', IRM,J100,IZAER
         ELSE
         WRITE (IOUT,'('' GRPRT1: GRBIN1-FEHLER; IRM,J100'',I5,
     +                 '',RECORD-NR.='',3I10)') IRM,J100,IZAER
         ENDIF
C........PROGRAMM-ABBRUCH WEGEN FEHLER, USER-GEWUENSCHT.............18.06.2002
C         IF (YERR.EQ.'JA')                  THEN
C            CALL ABEX ('GC',10000,' GRBIN1-FEHLER')
C         ENDIF             
         NPR10   = 1
         NPRF    = 1
C........NPDS1   = 65...............................................18.06.2002
         NPDS1   = 24
         NGDS1   = 25
         NBMS1   = 3
         NBDS1   = 7
         GOTO 50
      ENDIF

      LDSB       = IDIMS(17)
      NPDS1      = IDIMS(11)
      NGDS1      = IDIMS(12)
      NBMS1      = IDIMS(13)
      NBDS1      = IDIMS(14)
      NBMAP1     = IDIMS(15)
      NDSUP1     = IDIMS(16)
      NLDS       = IDIMS(17)
      NBLCK1     = IDIMS(18)
      LGRIB      = IDIMS(19)

C...............................................................................
      LPDB       = IPDB( 1)
      IDC        = IPDB( 3)
      LDEFNR     = IPDB(37)
C.................................................)
C     IF (IDC .NE. 78)                      THEN  )
C........MIT IDC # 78 KEIN LGPDB1-AUFRUF MOEGLICH )
C        NPR0    = 1                              )    05.06.1996, ZAL.
C        NPR4    = 1                              )    LEGENDE FUER ALLE IDC'S
C        NPR1    = 0                              )
C        NPR2    = 0                              )
C     ENDIF                                       )
C.................................................)

C.....LGPDB1....................................................................
      IAY        = 0
      IAC        = 0
      IAT        = 0
      IAE        = 0
      IAL        = 0

C.........IF (NPR1 .EQ. 1)                      THEN................12.05.1998
C........LEGENDE unabhaengig von NPR1 EXTRAHIEREN
         NUNIT   = NXUNIT(10)
         CALL LGPDB1 ('GRPRT1',IRM,IPDB,NUNIT,YTEXT,IAY,IAC,IAT,IAE,IAL)
         IF (IRM .NE. 0)                    THEN
            IF (IOUT .EQ. -1)               THEN
            PRINT       '('' LGPDB1-FEHLER: J100,FELD-,RECORD-NR.='',
     +                      3I8)',          J100,IZAEL,IZAER
            PRINT       '('' -----> KEINE LEGENDE !'')'
            ELSE
            WRITE (IOUT,'('' LGPDB1-FEHLER: J100,FELD-,RECORD-NR.='',
     +                      3I8)')          J100,IZAEL,IZAER
            WRITE (IOUT,'('' -----> KEINE LEGENDE !'')')
            ENDIF
C...........RECORDNUMMER,MODELLNUMMER,... UND PDB AUSGEBEN
            NPR0 = 1
            NPR4 = 1
            NPR1 = 0
            NPR2 = 0
         ELSE
            NPR0 = NPR0M
            NPR4 = NPR4M
            NPR1 = NPR1M
            NPR2 = NPR2M
         ENDIF
C......ENDIF........................................................12.05.1998


      IF (NPR0 .EQ. 1)                      THEN
C........OHNE LGPDB1, RECORDNUMMER,MODELLNUMMER,.....
         ITYPNR  = IPDB( 4)
         IELNR   = IPDB( 7)
         ILEVTP  = IPDB( 8)
         ILEV1   = IPDB( 9)
         ILEV2   = IPDB(10)
C  Vo    IYY     = IPDB(11)
         IYY     =(IPDB(22)-1) * 100 + IPDB(11)
         IMM     = IPDB(12)
         IDD     = IPDB(13)
         IHH     = IPDB(14)
         IMN     = IPDB(15)
C........RJ: Zu gross fuer 32 Bit Maschinen:
C........IREFZ   = IYY*100000000 +IMM*1000000 +IDD*10000 +IHH*100 +IMN
         IREFZ   = IYY*1000000 +IMM*10000 +IDD*100 +IHH
         YREFZ   = ' '
         WRITE (YREFZ( 1: 4),'(I4.4)') IYY
         WRITE (YREFZ( 5: 6),'(I2.2)') IMM
         WRITE (YREFZ( 7: 8),'(I2.2)') IDD
         WRITE (YREFZ( 9:10),'(I2.2)') IHH
         WRITE (YREFZ(11:12),'(I2.2)') IMN
         IF (IOUT .EQ. -1)                  THEN
            PRINT        1000,
     +            IZAER,ITYPNR,YREFZ,IELNR,ILEVTP,ILEV1,ILEV2
         ELSE
            WRITE (IOUT, 1000)
     +            IZAER,ITYPNR,YREFZ,IELNR,ILEVTP,ILEV1,ILEV2
         ENDIF
 1000    FORMAT(' LFD.NUMMER=',I8,' MODELLNR.=',I5,' REF.ZEIT= ',A,
     +        /,' ELEMENTNR.=',I8,' LEVEL-TYP=',I5,' LEVELS  =',2I5)
         IF (IDC .EQ. 78)                   THEN
C...........ERSTELLUNGSDATUM UND VERSIONSNUMMER
            IF (IOUT .EQ. -1)               THEN
               PRINT       1001, (IPDB(II),II=42,47)
            ELSE
               WRITE (IOUT,1001) (IPDB(II),II=42,47)
            ENDIF
 1001       FORMAT (/,' ERSTELLUNGSDATUM YY-MM-DD-HH-MN :',I4,4('-',I2),
     +              /,' VERSIONSNUMMER :',I20)
            IF (IPDB(38) .GT. 0)            THEN
               IMF = IPDB(40) + 1
               IF (IMF.LT.1 .OR. IMF.GT.5)  IMF = 6
               IF (IOUT .EQ. -1)            THEN
                  PRINT       1002, IPDB(38), IPDB(39), YMF(IMF)
               ELSE
                  WRITE (IOUT,1002) IPDB(38), IPDB(39), YMF(IMF)
               ENDIF
 1002          FORMAT (/,' MRZ-BACK-UP-FILE: TAGESNUMMER   =',I4,
     1                   ' RECORDNUMMER  =',I9,
     2                 /,' ENTSCHLUESSELUNG AUF DER ',A)
            ENDIF
         ENDIF
      ENDIF

      IF (NPR2 .EQ. 1)                      THEN
C........DIESE AUSGABE VOR DER LEGENDE
C        RECORDNUMMER,MODELLNUMMER,.....
         I1      = 1
         I2      = I1 + IAC
         I3      = I2 + IAT
         I4      = I3 + IAE
         IF (IOUT .EQ. -1)                  THEN
            PRINT        1010,
     +            IZAER,YTEXT(I1),YTEXT(I2),YTEXT(I3),YTEXT(I4)
         ELSE
            WRITE (IOUT, 1010)
     +            IZAER,YTEXT(I1),YTEXT(I2),YTEXT(I3),YTEXT(I4)
         ENDIF
 1010    FORMAT(' LFD.NUMMER=',I8,' MODELL= ',A,' REF.ZEIT= ',A,
     +        /,' ELEMENT= ',A,' NIVEAU= ',A)
      ENDIF

      IF (NPR1 .EQ. 1)                      THEN
C........LEGENDE
         IA      = 1
         IE      = IAC
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1020, IZAEL, IZAER, (YTEXT(IYT),IYT=IA,IE)
         ELSE
            WRITE (IOUT,1020) IZAEL, IZAER, (YTEXT(IYT),IYT=IA,IE)
         ENDIF
 1020    FORMAT (/,' FELDNUMMER.......... ',I8,'      .....',/,
     +             ' RECORDNUMMER........ ',I8,'      .....',/,
     +             ' ZENTRUM / MODELL    ',A)
         IA      = IE  + 1
         IE      = IE  + IAT

         GOTO (21,22,23,24)                 IAT
   21    IF (IOUT .EQ. -1)                  THEN
            PRINT       1021, (YTEXT(IYT),IYT=IA,IE)
         ELSE
            WRITE (IOUT,1021) (YTEXT(IYT),IYT=IA,IE)
         ENDIF
 1021    FORMAT  (/,' REFERENZ - ZEIT     ',A)
                                            GOTO 25
   22    IF (IOUT .EQ. -1)                  THEN
            PRINT       1022, (YTEXT(IYT),IYT=IA,IE)
         ELSE
            WRITE (IOUT,1022) (YTEXT(IYT),IYT=IA,IE)
         ENDIF
 1022    FORMAT  (/,' REFERENZ - ZEIT     ',A,
     1            /,' ZEITRAUM            ',A)
                                            GOTO 25
   23    IF (IOUT .EQ. -1)                  THEN
            PRINT       1023, (YTEXT(IYT),IYT=IA,IE)
         ELSE
            WRITE (IOUT,1023) (YTEXT(IYT),IYT=IA,IE)
         ENDIF
 1023    FORMAT  (/,' REFERENZ - ZEIT     ',A,
     1            /,' ZEITRAUM            ',A,
     2            /,' ZEIT                ',A)
                                            GOTO 25
   24    IF (IOUT .EQ. -1)                  THEN
            PRINT       1024, (YTEXT(IYT),IYT=IA,IE)
         ELSE
            WRITE (IOUT,1024) (YTEXT(IYT),IYT=IA,IE)
         ENDIF
 1024    FORMAT  (/,' REFERENZ - ZEIT     ',A,
     1            /,' ZEITRAUM            ',A,
     2            /,' ZEIT T1             ',A,
     3            /,' ZEIT T2             ',A)

   25    CONTINUE
         IA      = IE  + 1
         IE      = IE  + IAE
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1025, (YTEXT(IYT),IYT=IA,IE)
         ELSE
            WRITE (IOUT,1025) (YTEXT(IYT),IYT=IA,IE)
         ENDIF
 1025    FORMAT  (/,' ELEMENT - NAME      ',A,
     +            /,' ELEMENT - DIMENSION ',A)
         IA      = IE  + 1
         IE      = IE  + IAL
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1026, (YTEXT(IYT),IYT=IA,IE)
         ELSE
            WRITE (IOUT,1026) (YTEXT(IYT),IYT=IA,IE)
         ENDIF
 1026    FORMAT  (/,' LEVEL - BEZEICHNUNG ',A,
     +            /,' NIVEAU              ',A)
      ENDIF

C.....MINIMUM- UND MAXIMUM-WERT MIT DAZUGEHOERIGEN GITTERPUNKTEN................
      LDSZW      = NLDS
      IDSANF     = 1
      IF (NLDS .EQ. 0)                      GOTO 50

      CALL MINMAXG (DS(IDSANF),LDSZW,UNDEF,IBMJ,IBMAP,
     +              AMIN,AMAX,IGMN,IGMX,IRM)
      IF (IRM.NE.0)                         THEN
         IF (IOUT .EQ. -1)                  THEN
         PRINT       '('' MINMAXG-FEHLER: J100,FELD-,RECORD-NR.='',
     +                    3I8)',          J100,IZAEL,IZAER
         ELSE
         WRITE (IOUT,'('' MINMAXG-FEHLER: J100,FELD-,RECORD-NR.='',
     +                    3I8)')          J100,IZAEL,IZAER
         ENDIF      
         CALL ABEX
     +   ('GC',10000,' FEHLER IN UP MINMAXG')
      ENDIF

      IF (NPR2 .EQ. 1 .OR. NPR0 .EQ. 1)     THEN
C........MIN-/MAX-WERTE UND GPKTE AUSGEBEN
         AMIN    = AMIN * FAK
         AMAX    = AMAX * FAK
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1030, LFL,LGRIB,LDSZW,FAK,AMIN,IGMN,
     +                                      AMAX,IGMX
         ELSE
            WRITE (IOUT,1030) LFL,LGRIB,LDSZW,FAK,AMIN,IGMN,
     +                                      AMAX,IGMX
         ENDIF
 1030    FORMAT (/,' GRIBLAENGE IN WORTEN/BYTES             =',I8,I8,/
     +            ,' ANZAHL DER GITTERPUNKTE                =',I8,/
     +            ,' FAKTOR FUER MINIMUM UND MAXIMUM        =',F20.5,/
     +            ,' MINIMUM = ',F20.5,' bei GITTERPUNKT    =',I8,/
     +            ,' MAXIMUM = ',F20.5,' bei GITTERPUNKT    =',I8)
      ENDIF

C.....UMGEBUNGSWERTE VON MIN-/MAX,          WENN NPR3 = 1
      IF (NPR3 .EQ. 1)                      THEN
         IGMNZW  = IGMN
         IGMXZW  = IGMX

         IAMN    = IGMN - 25
         IF (IAMN.LT.1)                     IAMN = 1
         IEMN    = IGMN + 24
         IF (IEMN.GT.LDSZW)                 IEMN = LDSZW

         IAMX    = IGMX - 25
         IF (IAMX.LT.1)                     IAMX = 1
         IEMX    = IGMX + 24
         IF (IEMX.GT.LDSZW)                 IEMX = LDSZW

         IDA       = IAMN
         IDE       = IEMN
         DO 34 J34 = IDA , IDE
   34    DS(J34)   = DS(J34) * FAK
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1034, IAMN,IEMN,FAK,(DS(ID),ID=IDA,IDE)
         ELSE
            WRITE (IOUT,1034) IAMN,IEMN,FAK,(DS(ID),ID=IDA,IDE)
         ENDIF
 1034    FORMAT  (T2,'MINIMUM - BEREICH: GITTERPUNKTWERTE '
     1           ,I8,' BIS ',I8, ' AUSGEBEN ',
     2          /,T2,'                 ( FAKTOR = ',F20.5,' )',
     3            10(/,1X,5F15.4))

         IDA       = IAMX
         IDE       = IEMX
         DO 35 J35 = IDA , IDE
   35    DS(J35)   = DS(J35) * FAK
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1035, IAMX,IEMX,FAK,(DS(ID),ID=IDA,IDE)
         ELSE
            WRITE (IOUT,1035) IAMX,IEMX,FAK,(DS(ID),ID=IDA,IDE)
         ENDIF
 1035    FORMAT  ( T2,'MAXIMUM - BEREICH: GITTERPUNKTWERTE '
     1            ,I8,' BIS ',I8, ' AUSGEBEN ',
     2           /,T2,'                 ( FAKTOR = ',F20.5,' )',
     3             10(/,1X,5F15.4))
      ENDIF

C.....GITTERPUNKTDATEN AUSGEBEN
      IF (IGA.GT.0 .AND. IGA.LE.LDSZW)      THEN
         IGAZW   = IGA
         IGEZW   = IGE
         IF (IGEZW .LT. IGAZW)              IGEZW = IGAZW
         IF (IGEZW .GT. LDSZW)              IGEZW = LDSZW
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1036, IGA,IGE,IGAZW,IGEZW,FAK
         ELSE
            WRITE (IOUT,1036) IGA,IGE,IGAZW,IGEZW,FAK
         ENDIF
 1036    FORMAT (/,' GITTERPUNKTE    :',I8,' BIS ',I8,
     1           /,' bzw. DS-NUMMERN :',I8,' BIS ',I8,
     2              ' AUSGEBEN '
     3        ,/,' ..VON...BIS:         ( FAKTOR = ',F20.5,' )')

         DO 36 J36  = IGAZW , IGEZW
   36    DS(J36)    = DS(J36) * FAK

         DO 38 J38  = IGAZW, IGEZW, 5
         IZA        = J38
         IZE        = IZA + 4
         IF (IZE .GT. IGEZW)                IZE = IGEZW
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1038, IZA,IZE,(DS(ID),ID=IZA,IZE)
         ELSE
            WRITE (IOUT,1038) IZA,IZE,(DS(ID),ID=IZA,IZE)
         ENDIF
 1038    FORMAT (1X,2I8,(5F12.4))
   38    CONTINUE
      ELSE
         IF (IGA .NE. 0)                    THEN
            IF (IOUT .EQ. -1)               THEN
               PRINT       1039, IGA, LDSZW
            ELSE
               WRITE (IOUT,1039) IGA, LDSZW
            ENDIF
         ENDIF
 1039    FORMAT(/,T2,'GRPRT1 - FEHLERHAFTE EINGABE VON GIPA=',I6,
     +               ' LDSZW=',I6)
      ENDIF

   50 CONTINUE
C.....PDB-WERTE AUSGEBEN,                   WENN NPR4 = 1 ......................
      IF (NPRF .EQ.1)                       THEN
         IF (IOUT .EQ. -1)                  THEN
            PRINT       '('' GRPRT1 FEHLER-OUTPUT: LFLB='',I8)',
     +                                             LFLB
         ELSE
            WRITE (IOUT,'('' GRPRT1 FEHLER-OUTPUT: LFLB='',I8)')
     +                                             LFLB
         ENDIF
      ENDIF
      IF (NPR4 .EQ. 1 .OR. NPRF .EQ.1)      THEN
         INDL    = NPDS1
C........LDEFNR=-253, -> INDL=49, VON 50 BIS NPDS1 MIT Z17.....................
         IDCSUB  = IPDB(23)
         IF ((LDEFNR.EQ.-254.AND.IDC.NE.98
     +                      .AND.IDCSUB.NE.98) .OR.
     +        LDEFNR.EQ.-253)               THEN 
            INDL = 49
         ENDIF
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1050, INDL,(IPDB(IP),IP=1,INDL)
         ELSE
            WRITE (IOUT,1050) INDL,(IPDB(IP),IP=1,INDL)
         ENDIF
 1050    FORMAT(' IPDB( 1..',I3,') =',5(/,1X,10I7),/,1X,I7,4X,Z17,
     +                                  /,1X,14X,8I7,
     +                               28(/,1X,10I7,:))
C        LDEF    = IPDB(37)
C        IF (LDEF .EQ. -254)                THEN
C           IDC  = IPDB(3)
C           IF (IDC .NE. 98)                THEN
C........neu ab Novemmber 2005:
         IF ((LDEFNR.EQ.-254.AND.IDC.NE.98
     +                      .AND.IDCSUB.NE.98) .OR.
     +        LDEFNR.EQ.-253)               THEN 
C              IP   = INDL - 50 + 1
C..............IN IPDB(48)=RESTL.UNBEKANNTE BYTES,
C..............IN IPDB(49)=WORT-ANZAHL DER UNBEKANNTEN BYTES,
               IP   = IPDB(49)
               IF (IOUT .EQ. -1)            THEN
C                 PRINT 
C    +       '('' GRPRT1: IBMAX,IBYTW,IBYTE='',3I3)',
C    +                    IBMAX,IBYTW,IBYTE
                  PRINT       
     +       '('' UNBEKANNTE IPDB-DATEN IN BYTE 41..'',I3,
     +         ''; IPDB(50:'',I3,''):'')', IPDB(1),IP+50-1
                  CALL ARBITI (IPDB(50),IP)
               ELSE
C                 WRITE (IOUT,
C    +       '('' GRPRT1: IBMAX,IBYTW,IBYTE='',3I3)')
C    +                    IBMAX,IBYTW,IBYTE
                  WRITE (IOUT,                                  
     +       '('' UNBEKANNTE IPDB-DATEN IN BYTE 41..'',I3,
     +         ''; IPDB(50:'',I3,''):'')') IPDB(1),IP+50-1      
                  CALL ARBITU (IPDB(50),IP,IOUT)
               ENDIF
C           ENDIF
         ENDIF
      ENDIF

C.....GDB-,BMB-,BDB-WERTE AUSGEBEN,         WENN NPR5 = 1 ......................
      IF (NPR5 .EQ. 1 .OR. NPRF .EQ.1)      THEN
         INDL    = NGDS1
         IPE     = 25
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1051, IPE,(IGDB(IP),IP=1,IPE)
         ELSE
            WRITE (IOUT,1051) IPE,(IGDB(IP),IP=1,IPE)
         ENDIF
 1051    FORMAT(' IGDB( 1..',I3,') =',2(/,1X,10I7),
     +                                  /,1X,I7,5X,Z17,
     +                                  /,1X,14X,2I7,5X,Z17)
         NKOOR   = IGDB(2)
         IF (NKOOR .GT. 0)                  THEN
            IPA  = 26
            IPE  = IPA + NKOOR -1
            IF (IOUT .EQ. -1)               THEN
               PRINT       1052, IPE,(IGDB(IP),IP=26,IPE)
            ELSE
               WRITE (IOUT,1052) IPE,(IGDB(IP),IP=26,IPE)
            ENDIF
C           max. 200 Vert.-Koordinaten
 1052       FORMAT(' IGDB(26..',I3,') =',50(/,1X,4Z17,:))
         ENDIF
C........IF (INDL .GT. 226)                 THEN )  geaendert am 02.10.1996, ZAL
C...........NLIST= IGDB(226)                     )
         NLIST   = IGDB(226)
         IF (NLIST .GT. 0)                  THEN
            IPA  = 227
            IPE  = IPA + NLIST - 1
            IF (IOUT .EQ. -1)               THEN
               PRINT       1053, IPE,(IGDB(IP),IP=227,IPE)
            ELSE
               WRITE (IOUT,1053) IPE,(IGDB(IP),IP=227,IPE)
            ENDIF
C1053       FORMAT(' IGDB(227..',I3,') =',100(/,1X,4Z17,:))
C           max. 400 nrows (ilist)
 1053       FORMAT(' IGDB(227..',I3,') =',40(/,10I8,:))
         ENDIF
C........BMB-WERTE AUSGEBEN,                WENN NBMS1 > 0
         IF (NBMS1 .GT. 0)                  THEN
            IF (IOUT .EQ. -1)               THEN
               PRINT       1054, (IBMB(IB),IB=1,3)
            ELSE
               WRITE (IOUT,1054) (IBMB(IB),IB=1,3)
            ENDIF
 1054       FORMAT(' IBMB( 1..  3) = ',3I8)
         ENDIF
C........BDB-WERTE AUSGEBEN
         IPE     = NBDS1
         IF (NBDS1 .GT. NBDS)               THEN
         IF (IOUT .EQ. -1)                  THEN
            PRINT           '('' NBDS1, NBDS='',2I8)', NBDS1, NBDS
         ELSE
            WRITE (IOUT,    '('' NBDS1, NBDS='',2I8)') NBDS1, NBDS
         ENDIF
         IPE     = NBDS
         ENDIF
C........SKALIERUNGS-FAKTOR AUS PDB AN REFMIN ANBRINGEN.............30.07.1998
C........IUDSC   = IPDB(24).........................................09.09.2002
         IF (IPDB(24) .EQ. -999999)         THEN
            IUDSC= 0
         ELSE            
            IUDSC= IPDB(24)
         ENDIF            
         IF (IUDSC .NE.0)                   THEN
C...........FAKP = 10**IUDSC........................................01.02.2000         
            IZW  = ABS(IUDSC)
            FZW  = FLOAT(10**(IZW))
            IF (IUDSC .LT. 0)               THEN
               FAKP = 1./FZW
            ELSE
               FAKP = FZW
            ENDIF      
            IF (NPRF .EQ. 0)
     +      REFMIN= (DSUP(1) / FAKP) * FAK
         ELSE         
            IF (NPRF .EQ. 0)
     +      REFMIN=  DSUP(1)         * FAK
         ENDIF
         IF (IOUT .EQ. -1)                  THEN
            PRINT       1055, IPE,(IBDB(IB),IB=1,IPE)
            IF (NPRF .EQ. 0)
     +      PRINT           '('' REFMIN='',F18.8)', REFMIN
         ELSE
            WRITE (IOUT,1055) IPE,(IBDB(IB),IB=1,IPE)
            IF (NPRF .EQ. 0)
     +      WRITE (IOUT,    '('' REFMIN='',F18.8)') REFMIN
         ENDIF
 1055    FORMAT(' IBDB( 1..',I3,') = ',/,1X,3I8,5X,Z17,/,1X,7I8,:)
C........PROGRAMM-ABBRUCH WEGEN FEHLER, USER-GEWUENSCHT..............18.06.2002
         IF (YERR.EQ.'JA' .AND. NPR10.EQ.1) THEN
            CALL ABEX ('GC',10000,' GRBIN1-FEHLER')
         ENDIF             
         IF (NPRF .EQ. 1)                   THEN
            NPRF    = 0
            GOTO 100
         ENDIF
         IF (NDSUP1 .GT. 0)                 THEN
            IPE     = NDSUP1
            DO 60 J6= 1, IPE
   60       DSUP(J6)= DSUP(J6) * FAK
            IF (IOUT .EQ. -1)               THEN
               PRINT       1060, IPE,(DSUP(IP),IP=2,IPE)
            ELSE
               WRITE (IOUT,1060) IPE,(DSUP(IP),IP=2,IPE)
            ENDIF
 1060       FORMAT(' DSUP(2..',I3,') = ',18(/,1X,4Z17,:))
         ENDIF
      ENDIF

  100 CONTINUE
      GOTO 200

  190 IF (J100 .EQ. 1)                      THEN
         IF (IOUT .EQ. -1)                  THEN
            PRINT       '(T2,''UEGABE LEER ODER KEIN ATTF'')'
         ELSE
            WRITE (IOUT,'(T2,''UEGABE LEER ODER KEIN ATTF'')')
         ENDIF
      ENDIF

  200 IF (IOUT .EQ. -1)                     THEN
         PRINT       '(/,'' GRPRT1-ENDE:'',I8,'' RECORD(S) GELESEN'')',
     +                                     IZAER
      ELSE
         WRITE (IOUT,'(/,'' GRPRT1-ENDE:'',I8,'' RECORD(S) GELESEN'')')
     +                                     IZAER
      ENDIF

      IF(ALLOCATED(IBLOCK)) DEALLOCATE(IBLOCK)
      IF(ALLOCATED(IBMAP )) DEALLOCATE(IBMAP )
      IF(ALLOCATED(DS    )) DEALLOCATE(DS    )

      RETURN

      END
