#if defined CRAY 
      INTEGER FUNCTION ICHINT (YCH)

C**** ICHINT   -   FC:CHARACTER-ZAHL IN INTEGER-VARIABLE UMWANDELN
C**   AUFRUF:      INT = ICHINT (YCH)
C**   ZWECK:       CHARACTER-VARIABLE IN INTEGER-ZAHL KONVERTIEREN
C**                (BLANKS WERDEN IGNORIERT)
C**   ARBEITSWEISE:INTERNER READ
C**   PARAMETER:   YCH(INPUT) CHARACTER-VARIABLE, BIS ZU 14 ZEICHEN LANG;
C**                           (=14 ZIFFERN ODER 13 ZIFFERN MIT VORZEICHEN)
C**                ICHINT     ERGEBNIS: INTEGER-VARIABLE;
C**                           IM FEHLERFALL WIRD ICHINT -99999999999999 GESETZT
C**                           (WENN YCH > 14 CHAR. ODER KEINE ZIFFERN)
C**   VERFASSER:   G. BAGINSKI
C     Geaendert:   B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER    IMAX, IMIN, IFEHL, L
      CHARACTER  YCH*(*), FORM*5
           
      PARAMETER (IMAX =   99999999999999,
     +           IMIN =   -9999999999999,
     +           IFEHL = -99999999999999 )
     
      DATA FORM /'(I  )'/
      L     = LEN(YCH)
      IF (L .GT. 15) GOTO 1000

C     FORMAT AUFBAUEN UND INTERNER READ
      WRITE (FORM(3:4),'(I2.2)',ERR=1000)  L
      READ (YCH, FORM, ERR=1000) ICHINT
      IF ((ICHINT.GT.IMAX) .OR. (ICHINT.LT.IMIN)) GOTO 1000
      RETURN

C     FEHLERAUSGANG
 1000 ICHINT= IFEHL

      END
#else 
      INTEGER FUNCTION ICHINT (YCH)

C**** ICHINT   -   FC:CHARACTER-ZAHL IN INTEGER-VARIABLE UMWANDELN
C**   AUFRUF:      INT = ICHINT (YCH)
C**   ZWECK:       CHARACTER-VARIABLE IN INTEGER-ZAHL KONVERTIEREN
C**                (BLANKS WERDEN IGNORIERT)
C**   ARBEITSWEISE:INTERNER READ
C**   PARAMETER:   YCH(INPUT) CHARACTER-VARIABLE, BIS ZU 10 ZEICHEN LANG;
C**                           (DAVON MAX. 9 ZIFFERN UND 1 VORZEICHEN)
C**                ICHINT     ERGEBNIS: INTEGER-VARIABLE;
C**                           IM FEHLERFALL WIRD ICHINT = 1999999999 GESETZT
C**   VERFASSER:   A. ZALEWSKY (MODIF.: 24.07.1996)
C     Geaendert:   B.Loeser, 11/00, IMPLICIT NONE, LENFUL --> LEN_TRIM

      IMPLICIT NONE
      INTEGER    IFEHL, L, J1, IE, IA, IF
      CHARACTER  YCH*(*), YMAX*9, YVZ*1, YZW*9, FORM*4
      PARAMETER (YMAX  =  '999999999',
     +           IFEHL =  1999999999 )     
      DATA FORM /'(I )'/

C.....L          = LEN(YCH)................fehler, am 08.10.1996 geaendert, zal.
C.....rechte blancs werden abgehackt
      L          = LEN_TRIM(YCH)
      IF (L .GT. 10)                        GOTO 1000

C.....1. NON-BLANK-ZEICHEN SUCHEN
      YZW        = ' '
      DO 100 J1  = 1, L
      IA         = J1
      IF (YCH(J1:J1) .NE. ' ')              GOTO 200
  100 CONTINUE
C.....FEHLER, YCH IST BLANK
      GOTO 1000

  200 CONTINUE
      YVZ        = YCH(IA:IA)
      IF (YVZ .EQ. '+' .OR. YVZ .EQ. '-')   THEN
          IA     = IA + 1
      ENDIF

C.....IE = 9 = MAX. LAENGE VON YZW
      IE         = L - IA + 1
      IF (IE .GT. 9)                        GOTO 1000
      YZW(1:IE)  = YCH(IA:L)

C.....FEHLER, YMAX UEBERSCHRITTEN ?
      IF (YZW .GT. YMAX)                    GOTO 1000

C.....FORMAT AUFBAUEN UND INTERNER READ
      WRITE (FORM(3:3), '(I1)', ERR=1000)   IE
      READ (YZW, FORM, ERR=1000)            ICHINT

C.....VORZEICHEN BERUECKSICHTIGEN
      IF (YVZ .EQ. '-')                     ICHINT = -ICHINT
      RETURN

C.....FEHLERAUSGANG
 1000 ICHINT     = IFEHL

      END      
#endif 
