      INTEGER FUNCTION IGDSLB (IDRTYP, IEDNR)
C**** IGDSLB   -   GDS-LAENGE IN BYTES, OHNE VERTIKAL-KOORDINATEN UND REIHEN
C**   AUFRUF   :   LGDSLB = IGDSLB (IDRTYP, IEDNR)
C**   PARAMETER:   IDRTYP - PROJEKTIONSART, SIEHE UP PUTGD1/GETGD1
C**                         IST IDRTYP UNBEKANNT --> IGDSLB(IDRTYP) = -999999
C**                IEDNR  - EDITIONSNUMMER, AB IEDNR = 1
C**
C**   VERFASSERIN: A.ZALEWSKY, SEPTEMBER 1994
C**   MODIF.:      NEU: IDRTYP=192                                   01.04.1998

C.....PARAMETER (IANZ=17)
      IMPLICIT NONE

      INTEGER IANZ, KDRTYP1, KGDSLB1, JJ

      PARAMETER (IANZ=18)
      DIMENSION  KDRTYP1(IANZ),KGDSLB1(IANZ)
      INTEGER    IDRTYP, IEDNR
      
C     IDRTYP =  0, 1, 2,    4, 5, 50,   192  --> 32 BYTES   )
C                        3,                  --> 42 BYTES   )  LGDSLB
C              10,         14,    60,        --> 42 BYTES   )  OHNE
C              20,         24,    70,        --> 42 BYTES   )  VERTIKAL-
C                                   ,90,     --> 44 BYTES   )  KOORDINATEN
C              30,         34,    80         --> 52 BYTES   )



      DATA KDRTYP1 / 0,  1,  2,  3,  4,  5, 50,
     1              10,             14,     60,
     2              20,             24,     70,
     3              30,             34,     80, 90, 192 /

      DATA KGDSLB1 /32, 42, 32, 42, 32, 32, 32,
     1              42,             42,     42,
     2              42,             42,     42,
     3              52,             52,     52, 44,  32 /

      IGDSLB     = -999999

      IF (IEDNR .EQ. 1) THEN
         DO 200  JJ = 1, IANZ
         IF (KDRTYP1(JJ) .NE. IDRTYP) GOTO 200
         IGDSLB     = KGDSLB1(JJ)
         RETURN
  200    CONTINUE
         PRINT '('' IGDSLB: IDRTYP'',I4,'' NICHT DEFINIERT'')', IDRTYP
      ELSE
         PRINT '('' IGDSLB: IEDNR='',I4,'' UNBEKANNT'')', IEDNR
      ENDIF

      END
