      SUBROUTINE JULDAT  (IDATJU, IYEAR, IMONTH, IDAY, IRM)

C**** JULDAT   -   UP:BESTIMMT DATUM AUS JULIANISCHEM DATUM
C**   AUFRUF   :   CALL JULDAT (IDATJU, IJAHR, IMONAT, ITAG, IRM)
C**   ZWECK      : DAS UP BERECHNET AUS DER LAUFENDEN NUMMER DES TAGES
C**                INNERHALB DES UEBERGEBENEN JAHRES DAS DATUM
C**   EXTERNALS  : SCHALT
C**   PARAMETER  : IDATJU  = JULIANISCHES DATUM
C**                IJAHR     JAHR DES JUL. DATUMS  (MIT OD. OHNE JAHRH.)
C**                IMONAT,ITAG  ERRECHNETES DATUM (INTEGER)
C**                IRM     = FEHLER-RUECKMELDEZELLE  "0 = FEHLER
C**   VERFASSER:   A. ZALEWSKY
C**
C**   HINWEIS:     UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DAS JAHR 4-STELLIG
C**                UEBERGEBEN;
C**                BEI 2-STELLIGER JAHRESANGABE WIRD DAS JAHRHUNDERT WIE
C**                IM ALTEN BANK-PROGRAMM ZUGEWIESEN, ->
C**                JAHR >= 50, -> 1900; JAHR < 50, -> 2000 !
C.....MODIF.:      HINWEIS; A.ZALEWSKY..........................14.01.1999
C                  B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER  IDATJU, IDAY, IMONTH, INDEX, IRECH1, IRECH2, IRM
      INTEGER  ISCHAL, IYEAR, IYY, J, NTAGE
      EXTERNAL SCHALT

      DIMENSION NTAGE (13)

      DATA NTAGE /    0,  31,  59,  90, 120, 151, 181,
     +                   212, 243, 273, 304, 334, 365 /

C.....JAHRHUNDERT NUR UEBER IYEAR, NICHT UEBER ICENT ZUWEISEN...14.01.1999
      IYY              = IYEAR
      IF (IYY .LT. 100)                                    THEN
         IF (IYY .LT. 50)                                  THEN
            IYY        = 2000 + IYEAR
         ELSE
            IYY        = 1900 + IYEAR
         ENDIF
      ENDIF               
                                
C.....SCHALTJAHR BESTIMMEN
C.....CALL  S C H A L T  (IYEAR, ISCHAL)........................14.01.1999
      CALL  SCHALT  (IYY,   ISCHAL)
      
      IRM              = 0

      DO 100         J = 1, 12
      INDEX            = J

      IF (J .GT. 2)                                        GOTO 50
      IRECH1           = NTAGE(J)
      IRECH2           = NTAGE(J+1)
      IF (J. EQ. 2) 
     +   IRECH2        = IRECH2 + ISCHAL
      GOTO 90

   50 IRECH1           = NTAGE(J) + ISCHAL
      IRECH2           = NTAGE(J+1) + ISCHAL

   90 IF((IDATJU.GT.IRECH1).AND.(IDATJU.LE.IRECH2))        GOTO 200
  100 CONTINUE
      IRM              = 1
      RETURN

  200 IDAY             = IDATJU - IRECH1
      IMONTH           = INDEX
      RETURN
      END
