      SUBROUTINE LGPDB1 (YUPABS,IRM,IPDB,IUN,YTEXT,IANZ,
     +                   IANC,IANT,IANE,IANL)
C**** LGPDB1   -   UNIVERSAL-GRIB-LEGENDE AUS PRODUCT-DEFINITION-BLOCK
C**   AUFRUF       CALL LGPDB1 (YUPNAM,IRM,IPDB,IUN,YTEXT,IANZ,IANC,
C**               +             IANT,IANE,IANL)
C**   EXTERNALS    GRBCMI,GRBTIM,GRBT02,GRBT03,AKMG
C**   ZWECK        ALLGEMEINE, UMFASSENDE LEGENDENTEXTE AUS DEM PDB IM
C**                FELD -YTEXT- BEREITSTELLEN
C**                YTEXT ENTHAELT DIE TEXTZEILEN IN DER REIHENFOLGE
C**                   KOPFZEILE - ZEITZEILEN - ELEMENTZEILEN -
C**                                           - NIVEAUZEILEN
C**   PARAMETER
C**     EINGABE    YUPNAM  NAME DER RUFENDEN PROGRAMMEINHEIT (CHAR * 6)
C**                IRM     RETURN-CODE   0 = FEHLERFREI
C**                                     #0 = FEHLER IN PROGRAMMEINHEIT
C**                IPDB    FELD VON INTEGER-ZAHLEN MIT INHALT VON PDB
C**                IUN     TAPE-UNIT-NR., UNTER DER DIE TABELLEN-
C**                        FILES ANGESPROCHEN WERDEN SOLLEN
C**     AUSGABE    YTEXT   FELD MIT DEN LEGENDEN-TEXTEN (CHAR * 20)
C**             ---- YTEXT MUSS MINDESTENS MIT 9 DIMENSIONIERT SEIN ----
C**                IANZ    ANZAHL DER AUFBEREITETEN LEGENDENZEILEN
C**                IANC    "      "   "    LEGENDENKOPF-ZEILEN (0-1)
C**                IANT    "      "   "             ZEITZEILEN (0-4)
C**                IANE    "      "   "          ELEMENTZEILEN (0-2)
C**                IANL    "      "   "            LEVELZEILEN (0-2)
C**
C**        MUSTER EINER VOLLSTAENDIGEN UNIVERSAL-LEGENDE:
C**
C**           ZEILE 1)  CENTRE/MODEL-ZEILE (ZAEHLER -IANC-)   MAX. 1 Z.
C**           ZEILE 2)  REFERENZZEIT BZW. VALID TIME (ZAEHLER -IANT-) )
C**           ZEILE 3)  ZEITRAUM           (ZAEHLER -IANT-) ) MAX. 4 Z.
C**           ZEILE 4)  ZEIT T1            (ZAEHLER -IANT-) )
C**           ZEILE 5)  ZEIT T2            (ZAEHLER -IANT-) )
C**           ZEILE 6)  ELEMENT-NAME       (ZAEHLER -IANE-)   ) MAX 2 Z.
C**           ZEILE 7)  ELEMENT-DIMENSION  (ZAEHLER -IANE-)   )
C**           ZEILE 8)  LEVEL-BEZEICHNUNG  (ZAEHLER -IANL-) ) MAX. 2 Z.
C**           ZEILE 9)  NIVEAU-ANGABEN     (ZAEHLER -IANL-) )
C**
C**   --- EINE VOLLSTAENDIGE TABELLE DER GRIB-CODE-ELEMENTNAMEN UND   ---
C**   --- -ELEMENTDIMENSIONEN LIEGT ALS LIST-FILE UNTER               ---
C**   ---  ***  .ROUTARZ.MRZ3.DOKU.GRIB_ELEMENTE_TABELLE  ***         ---
C**   --- AUF BEIDEN MASCHINEN VOR                                    ---
C**
C**   VERFASSER: M. STAHLHACKE
C**   VERSION:   19.05.1994
C**   geaendert: A.Zalewsky TI14; 30.06.2005;
C**              folgende FORMAT-ANGABEN fuer YTEXT:
C**               22 FORMAT (1X,A6,I3,A3,I7)                       
C**               23 FORMAT (1X,A6,I3,A3)                      
C**               24 FORMAT (1X,A6,I6,A3)  
C**                  wurden geaendert in: 
C**               22 FORMAT (A6,I3,'*',A3,I7)
C**               23 FORMAT (A6,I3,'*',A3)
C**               24 FORMAT (A6,I6,'*',A3)
C
C     BENUTZTE VARIABLE :
C
C     YCENT   -   NAME DES PRODUKTERSTELLUNGS-ZENTRUMS LT. TABELLE
C     YCENTA  -   AUF 10 ZEICHEN VERKUERZTE KENNUNG DES ERSTELLUNGS-
C                 ZENTRUMS                             LT. TABELLE
C     YCENTF  -   FM-KENNUNG DES ERSTELLUNGSZENTRUMS   LT. TABELLE
C     YDATE   -   REFERENZDATUM (MIT MINUTENANGABE)
C     YDA1    -   VORHERSAGEDATUM ODER BEGINN EINES ZEITRAUMS (MIT SEC.)
C                 ODER ZEITANGABE FUER ERSTES FELD BEI VERIFIKATIONS-
C                 DIFFERENZ
C     YDA2    -   ENDE EINES ZEITRAUMS (MIT SEKUNDEN, AUSGABE NACH YTEXT
C                                       NUR MIT MINUTEN)
C                 ODER ZEITANGABE FUER TWEITES FELD BEI VERIFIKATIONS-
C                 DIFFERENZ
C     YDIM20  -   DIMENSION DES AUSGEWAEHLTEN ELEMENTS (LT. TABELLE)
C     YEL50   -   AUSGEWAEHLTES ELEMENT (LT. TABELLE)
C     YEL20   -   "             "      , AUF 20 ZEICHEN GEKUERZTER NAME
C     YEL10   -   "             "    , AUF 10 ZEICHEN GEKUERZTE KENNUNG
C     YLENA   -   BEZEICHNUNG DES DARSTELLUNGSFELDES (LT. TABELLE)
C     YLENAK  -   "           "   "    , AUF 20 ZEICHEN GEKUERZTER NAME
C     YLEDIM  -   DIMENSION DES DARSTELLUNGSFELDES (LT. TABELLE)
C     YTIU    -   ZEITEINHEIT BEI DER ANGABE VON ZEITRAEUMEN (LT. TAB.)
C     YTIUA   -   AUF 3 ZEICHEN GEKUERZTE KENNUNG DER ZEITEINHEIT
C     YLEV    -   AUSGEWAEHLTE FLAECHE ODER SCHICHT (LT. TABELLE)
C     YMODEL  -   FELDVERARBEITUNGSMODELL-NAME
C     YMODI2  -   MODELL-DIFFERENZ-BEZEICHNUNG BEI ITDIF=2
C                                                  (AUS UP GRBTIM)
C     YMODI3  -   MODELL-DIFFERENZ-BEZEICHNUNG BEI ITDIF=3
C                                                  (AUS UP GRBTIM)
C     YTIR    -   BEZEICHNUNG DER PRODUKT-ART (LT. TABELLE)
C     YTIRA   -   "           "   "     , AUF 6 ZEICHEN GEKUERZTER NAME
C     YTIRG   -   "           "   "     , "   6 "       "  NAME (GROSS)
C     IAVERG  -   ANZAHL DER FELDWERTE, UEBER DIE EINE MITTELUNG
C                 VORGENOMMEN WURDE (WIRD Z. T. BEI ZEITBESCHREIBUNG
C                                    BENOETIGT)
C     ITDIF   -   ZEITDIFFERENZ (YDA2-YDA1) IN ZEITEINHEITEN YITIU
C     IRM1    -   INTERNER FEHLERZAEHLER
C
      IMPLICIT NONE

      INTEGER IRM
      INTEGER IPDB, IUN, IANZ, IANC, IANT, IANE, IANL, IRM1
      INTEGER IAVERG, ITDIF

      DIMENSION IPDB(*), YTEXT(*)
      CHARACTER *  3, YTIUA
      CHARACTER *  4, YCENTF, YMODI2, YMODI3
      CHARACTER *  5, YMODEL
      CHARACTER *  6, YTIRA, YTIRG, YUPABS, YUPNAM
      CHARACTER * 10, YCENTA, YEL10, YLEDIM, YTIU, YLEV
      CHARACTER * 20, YDATE, YTEXT, YDIM20, YEL20, YLENAK, YTIR
      CHARACTER * 23, YDA1, YDA2
      CHARACTER * 30, YCENT
      CHARACTER * 50, YEL50, YLENA
C
C     AUSGANGSWERTE FUER HILFSGROESSEN BESETZEN
      DATA YUPNAM /'LGPDB1'/
      DATA YMODI2, YMODI3 / '/A-F', '/F-A' /
C
C     FUER WIEDERHOLTEN AUFRUF DES UP'S MUESSEN DIE NACHFOLGENDEN
C     GROESSEN JEDESMAL EXPLIZIT =' ' GESETZT WERDEN
C
      YTIUA  = ' '
      YCENTA = ' '
      YMODEL = ' '
      YTIRA  = ' '
      YLEV   = ' '
      YTIU   = ' '
      YLEDIM = ' '
      YEL10  = ' '
      YEL20  = ' '
      YDATE  = ' '
      YDIM20 = ' '
      YLENAK = ' '
      YTIR   = ' '
      YDA1   = ' '
      YDA2   = ' '
      YCENT  = ' '
      YEL50  = ' '
      YLENA  = ' '
C
      IRM  = 0
      IRM1 = 0
      IANZ = 0
      IANC = 0
      IANT = 0
      IANE = 0
      IANL = 0
C
C     TEXT FUER LEGENDENKOPF-ZEILE BESTIMMEN
      CALL GRBCMI (IPDB,IUN,IRM1,YCENT,YCENTA,YCENTF,YMODEL)
      IF (IRM1.NE.0) THEN
         PRINT *, 'LGPDB1: FEHLER IN GRBCMI, IRM=', IRM1
         IRM = IRM + 1
      END IF
      IANZ = IANZ + 1
      WRITE (YTEXT(IANZ),10) YCENTA, YMODEL
10    FORMAT (A10, '/',4X,A5)
      IANC = IANC + 1
C
C     TEXT FUER ZEITANGABEN-ZEILEN BESTIMMEN (MAX. 4 ZEILEN)
      IAVERG = IPDB(20)
      CALL GRBTIM (IPDB,IRM1,YDATE,YDA1,YDA2,ITDIF,YTIU,YTIUA,
     +             YTIR,YTIRA)
      IF (IRM1.NE.0) THEN
         PRINT *, 'LGPDB1: FEHLER IN GRBTIM, IRM=', IRM1
         IRM = IRM + 1
      ENDIF
C     FUER VERGLEICHSZWECKE GEKUERZTE FORM YTIRA IN GROSSBUCHSTABEN
C     UMWANDELN
      CALL AKMG (YTIRA,YTIRG)
      IANZ  = IANZ+1
C     TEXTSTRING MIT REFERENZ-DATUM BZW. VALID TIME SCHREIBEN
      WRITE (YTEXT(IANZ),20) YDATE
20    FORMAT (A20)
      IANT  = IANT + 1
C     BEI ANALYSEN KEINE WEITEREN ZEITANGABEN
      IF (YTIRG.NE.'      ') THEN
         IANZ = IANZ + 1
         IF (YTIRG.EQ.'INIT. '.OR.YTIRG.EQ.'NUDGAN') THEN
C     ZWEITE ZEITZEILE BEI INITIALISIERTEN ANALYSEN und Nudging analysis
            WRITE (YTEXT(IANZ),21) YTIRA
21          FORMAT (1X,A6)
            IANT = IANT + 1
         ELSE
            IF (YTIRG(1:2).EQ.'AV'.OR.YTIRG(1:2).EQ.'AC'.OR.
     +          YTIRG(1:2).EQ.'VA') THEN
C     ZWEITE ZEITZEILE BEI MITTELUNGEN UND SUMMEN
               IF (IPDB(19).GT.112.AND.IPDB(19).LT.120) THEN
C **  SONDERFAELLE TRI=113,114
C **  SONDERFAELLE TRI=115,116,117
C **  SONDERFAELLE TRI=118,119
                  WRITE (YTEXT(IANZ),26) YTIRA, IAVERG
26                FORMAT (1X,A6,' of F ',I7)
               ELSE IF (IPDB(19).GT.122.AND.IPDB(19).LT.125) THEN
C **  SONDERFAELLE TRI=123,124:
                  WRITE (YTEXT(IANZ),27) YTIRA, IAVERG
27                FORMAT (A6,' of uA ',I7)
               ELSE
                  WRITE (YTEXT(IANZ),22) YTIRA, ITDIF, YTIUA, IAVERG
C22                FORMAT (1X,A6,I3,A3,I7).............30.06.2005
22                FORMAT (A6,I3,'*',A3,I7)
               END IF
               IANT = IANT + 1
            ELSE IF (YTIRG(1:2).EQ.'VE') THEN
C     ZWEITE ZEITZEILE BEI VERIFIKATIONS-DIFFERENZEN
               WRITE (YTEXT(IANZ),25) YTIR
C     KORREKTUR DER MODELL-ZEILE BEI ANALYSE- UND MODELL-VERKNUEPFUNGEN
               IF (ITDIF.EQ.2) THEN
                  WRITE (YTEXT(1),11) YCENTA, YMODEL, YMODI2
11                FORMAT (A10,'/',A5,A4)
               ELSE IF (ITDIF.EQ.3) THEN
                  WRITE (YTEXT(1),11) YCENTA, YMODEL, YMODI3
               END IF
            ELSE
C     ZWEITE ZEITZEILE BEI ANDEREN DARSTELLUNGEN
               IF (IPDB(19).NE.10) THEN
C     ZEITANGABE MAX. 3-STELLIG BEI TIME-RANGE-FLAG #10
                  WRITE (YTEXT(IANZ),23) YTIRA, ITDIF, YTIUA
C23                FORMAT (1X,A6,I3,A3).............30.06.2005
23                FORMAT (A6,I3,'*',A3)
               ELSE
                  WRITE (YTEXT(IANZ),24) YTIRA, ITDIF, YTIUA
C24                FORMAT (1X,A6,I6,A3).............30.06.2005
24                FORMAT (A6,I6,'*',A3)
               END IF
               IANT = IANT + 1
            END IF
C     ZEITZEILEN 3 UND 4 WERDEN BEI BEDARF BESETZT
C        WENN YDA1 = ' ' , DANN SIND DIE ZEITZEILEN 3 UND 4 LEER
            IF (YDA1.NE.' ') THEN
               IANZ = IANZ + 1
C     TIME 1 WIRD NACH YTEXT GEBRACHT
               WRITE (YTEXT(IANZ),25) YDA1
25             FORMAT (A20)
               IANT = IANT + 1
               IF (YDA2.NE.' ') THEN
                  IANZ = IANZ + 1
C     TIME 2 WIRD NACH YTEXT GEBRACHT
                  WRITE (YTEXT(IANZ),25) YDA2
                  IANT = IANT + 1
               END IF
            END IF
         END IF
      END IF
C
C     TEXT FUER ELEMENT-ZEILEN (MAX. 2 ZEILEN)
      CALL GRBT02 (IPDB,IUN,IRM1,YEL50,YEL20,YEL10,YDIM20)
      IF (IRM1.NE.0) THEN
         PRINT *, "LGPDB1: FEHLER IN GRBT02  BEI EL.-NAME ", YEL50,
     +             ", DIM = ", YDIM20
         IRM = IRM + 1
      END IF
      IANZ = IANZ + 1
      WRITE (YTEXT(IANZ),30) YEL20
30    FORMAT (A20)
      IANE = IANE + 1
C     ZWEITE ELEMENTZEILE NUR BEI BEDARF BESCHREIBEN
      IF (YDIM20.NE.' ') THEN
         IANZ = IANZ + 1
         WRITE (YTEXT(IANZ),30) YDIM20
         IANE = IANE + 1
      END IF
C
C     TEXT FUER NIVEAU-ZEILEN SCHREIBEN (MAX. 2 ZEILEN)
      CALL GRBT03 (IPDB,IUN,IRM1,YLENA,YLENAK,YLEDIM,YLEV)
      IF (IRM1.NE.0) THEN
         PRINT *, 'LGPDB1: FEHLER IN GRBT03, IRM=', IRM1
         IRM = IRM + 1
      END IF
C     EINE NIVEAU-ANGABE SOLLTE IM PDB IMMER VORHANDEN SEIN
      IANZ = IANZ + 1
      WRITE (YTEXT(IANZ),40) YLENAK
40    FORMAT (A20)
      IANL = IANL + 1
C     ZWEITE NIVEAU-ZEILE NUR BEI BEDARF BESETZEN
      IF (YLEV.NE.' ') THEN
         IANZ = IANZ + 1
         WRITE (YTEXT(IANZ),41) YLEV, YLEDIM
41       FORMAT (A10,A10)
         IANL = IANL + 1
      END IF
C
C     UP ABSCHLIESSEN
C
9000  CONTINUE
      RETURN
      END
