      SUBROUTINE LOCNAM ( YNAM, YLNAM, NLNAM, ILNR, IRM )

C**** LOCNAM   -   UP: NAME AUS LISTE SUCHEN UND EINDEUTIG MACHEN
C**   AUFRUF   :   CALL LOCNAM ( YNAM, YLNAM, NLNAM, ILNR, IRM )
C**   ZWECK    :   NAME IN EINER LISTE SUCHEN UND PRUEFEN, OB DIESER EINDEUTIG
C**                IST; HIERZU REICHT EINE EINDEUTIGE ANZAHL ANFANGS-CHARACTER
C**                (LOCate_NAMe)
C**   PARAMETER:   INPUT:
C**                YNAM      ZU SUCHENDER NAME
C**                YLNAM     LISTE DER ERLAUBTEN NAMEN(Z.B. PARAMETER-KENNUNGEN)
C**                          VOM BENUTZER ZU DIMENSIONIEREN:
C**                          Z.B. CHARACTER YLNAM(nlnam)*10 UND ZU BESETZEN;
C**                NLNAM     LAENGE VON YLNAM (DIMENSION);
C**                          ABSCHLUSS DER LISTE DURCH BLANK-WERT ERLAUBT;
C**                          IST DER 1. WERT BLANK, ERFOLGT KEINE PRUEFUNG!
C**                OUTPUT:
C**                ILNR      GEFUNDENE ELEMENT-NR. VON YLNAM (WENN > 0 )
C**                          =  0 NAME NICHT GEFUNDEN (S.U. IRM)
C**                IRM       FEHLERRUECKMELDUNG:
C**                            =  0: KEIN FEHLER (AUCH WENN YNAM ODER YLNAM(1)
C**                                  = BLANK)
C**                            =  1: NAME NICHT EINDEUTIG
C**                            =  2: NAME NICHT GEFUNDEN
C**   HINWEIS:     ES ERFOLGT KEINE CHARACTER-UMWANDLUNG (Z.B. MIT UP AKMG)
C**   VERFASSER:   G.BAGINSKI
C     Geandert:    B.Loeser, 11/00, IMPLICIT NONE, BLEND --> LEN_TRIM

      IMPLICIT NONE
      INTEGER NLNAM, ILNR, IRM, J1, IEND, J2
      CHARACTER  YNAM*(*), YLNAM(NLNAM)*(*)

      ILNR = 0
      IRM  = 0
      IF ((YNAM .EQ. ' ') .OR. (YLNAM(1).EQ. ' ')) RETURN

      DO 100 J1 = 1, NLNAM

C*    LISTE DURCHSUCHEN (VOLLE CHARACTER-LAENGE)
      IF (YLNAM(J1) .EQ. ' ') GOTO 110
      IF (YNAM .NE. YLNAM(J1)) GOTO 100
         IF (ILNR .NE. 0) THEN
C*          WERT NICHT EINDEUTIG
            ILNR = 0
            IRM  = 1
            RETURN
         ENDIF
      ILNR = J1

  100 CONTINUE

  110 IF (ILNR .NE. 0) RETURN

C*    VERKUERZTEN WERT AUF EINDEUTIGKEIT UNTERSUCHEN
      IEND = LEN_TRIM(YNAM)
      DO 200 J2 = 1, NLNAM

      IF (YLNAM(J2) .EQ. ' ') GOTO 220
      IF (YNAM .NE. YLNAM(J2)(1:IEND)) GOTO 200
         IF (ILNR .NE. 0) THEN
C*          NAME NICHT EINDEUTIG
            ILNR = 0
            IRM = 1
            RETURN
         ENDIF
      ILNR = J2

  200 CONTINUE

C*    WERT NICHT GEFUNDEN
  220 IF (ILNR .EQ. 0)  IRM = 2

      END
