      SUBROUTINE MINMAX (AR, LAR, UNDEF, IBMJ, IBMAP, AMIN, AMAX, IRM)

C**** MINMAX   -   UP:MINIMUM UND MAXIMUM EINES FLOATING-FELDES ERMITTELN
C**   AUFRUF   :   CALL MINMAX (AR, LAR, UNDEF, IBMJ, IBMAP, AMIN, AMAX, IRM)
C**   ZWECK    :   FUER EINEN BEREICH VON FLOATING-WERTEN MINIMUM UND
C**                MAXIMUM ERMITTELN
C**   PARAMETER:
C**     INPUT  :   AR        FELD (FLOATING)
C**                LAR       LAENGE DES FELDES
C**                UNDEF     WERT EINES UNDEFINIERTEN GITTERPUNKTES (Z.B. -1E10)
C**                          (NUR WENN IBMJ = 0)
C**                IBMJ      =-1, WENN ALLE PUNKTE DEFINIERT
C**                          = 0, WENN KEINE BITMAP VORLIEGT
C**                          = 1, WENN BITMAP VORLIEGT
C**                IBMAP     BITMAP (WENN IBMJ=1, SONST DUMMY)
C**     OUTPUT :   AMIN      ERMITTELTES MINIMUM
C**                AMAX      ERMITTELTES MAXIMUM
C**                IRM       FEHLER, WENN UNGLEICH 0
C**   VERFASSER:   G. BAGINSKI
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00,  FORTRAN 90

      IMPLICIT NONE

      INTEGER LAR, IBMJ, IBMAP, IRM
      INTEGER INB, IBMSK, J

      REAL    AR, UNDEF, AMIN, AMAX

#include "machconsts.h"

      DIMENSION AR(1:LAR), IBMAP(*)

      IRM  = 0

      I F (IBMJ .EQ. 1) T H E N

C-----ZWEIG: MIT BITMAP-----------------------------------------------

         AMIN  =  HUGE(AMIN)
         AMAX  = -HUGE(AMAX)

         INB   = 0
         IBMSK = 0

         DO J = 1, LAR

            IBMSK = ISHFT(IBMSK,-1)
            IF ( IBMSK .EQ. 0 ) THEN
C*             NEUES BITMAP-WORT BEREITSTELLEN
               INB   = INB + 1
               IBMSK = ISHFT(1,IBMAX-1)
            ENDIF
C*          ABFRAGE, OB GI.PUNKT DEFINIERT
            IF(IAND(IBMAP(INB),IBMSK).NE.0 ) THEN
               AMIN = MIN(AMIN,AR(J))
               AMAX = MAX(AMAX,AR(J))
            ENDIF

         ENDDO
         RETURN

      E L S E  I F (IBMJ .EQ. -1) THEN

C-----ZWEIG: ALLE GITTER-PUNKTE DEFINIERT-----------------------------

         AMIN = MINVAL(AR)
         AMAX = MAXVAL(AR)
         RETURN

      E L S E  I F (IBMJ .EQ. 0) THEN

C-----ZWEIG: FELD MIT UNDEFINIERTEN PUNKTEN (OHNE BITMAP)-------------

         AMIN = MINVAL(AR,MASK=AR.NE.UNDEF)
         AMAX = MAXVAL(AR,MASK=AR.NE.UNDEF)
         RETURN

      E N D I F

C-----FEHLERAUSGANG
      PRINT '('' MINMAX: FALSCHE ANGABE FUER IBMJ='',I2)',IBMJ
      IRM = 1

      END
