      SUBROUTINE MINMAXG (AR, LAR, UNDEF, IBMJ, IBMAP, AMIN, AMAX,
     +                    IGMN, IGMX, IRM)
C**** MINMAXG - MINIMUM, MAXIMUM UND GITTERPUNKTE EINES FLOAT-FELDES ERMITTELN
C**   AUFRUF   :   CALL MINMAXG (AR, LAR, UNDEF, IBMJ, IBMAP, AMIN, AMAX,
C**               +             IGMN, IGMX, IRM)
C**   ZWECK    :   FUER EINEN BEREICH VON FLOATING-WERTEN MINIMUM UND
C**                MAXIMUM UND DAZUGEHOERIGE GITTERPUNKT-NRN. ERMITTELN
C**   PARAMETER:
C**     INPUT  :   AR        FELD (FLOATING)
C**                LAR       LAENGE DES FELDES
C**                UNDEF     WERT EINES UNDEFINIERTEN GITTERPUNKTES (Z.B. -1E10)
C**                          (NUR WENN IBMJ = 0)
C**                IBMJ      =-1, WENN ALLE PUNKTE DEFINIERT
C**                          = 0, WENN KEINE BITMAP VORLIEGT
C**                          = 1, WENN BITMAP VORLIEGT
C**                IBMAP     BITMAP (WENN IBMJ=1, SONST DUMMY)
C**     OUTPUT :   AMIN      ERMITTELTES MINIMUM
C**                AMAX      ERMITTELTES MAXIMUM
C**                IGMN      GITTERPUNKTNUMMER DES MINIMUM
C**                IGMX      GITTERPUNKTNUMMER DES MAXIMUM
C**                IRM       FEHLER, WENN UNGLEICH 0
C**   VERFASSER:   G. BAGINSKI
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00,  FORTRAN 90

      IMPLICIT NONE

      INTEGER LAR, IBMJ, IBMAP, IGMN, IGMX, IRM
      INTEGER INB, IBMSK, J

      REAL    AR, UNDEF, AMIN, AMAX

#include "machconsts.h"

C     INITIALISIERUNG
      DIMENSION AR(1:LAR), IBMAP(*)
      INTEGER IHLP(1) ! Fuer MINLOC/MAXLOC

      IRM  = 0

      IF (IBMJ .EQ. 1) THEN

C-----ZWEIG: MIT BITMAP-----------------------------------------------

         AMIN  =  HUGE(AMIN)
         AMAX  = -HUGE(AMAX)

         INB   = 0
         IBMSK = 0

         DO J = 1, LAR

            IBMSK = ISHFT(IBMSK,-1)
            IF ( IBMSK .EQ. 0 ) THEN
C*             NEUES BITMAP-WORT BEREITSTELLEN
               INB   = INB + 1
               IBMSK = ISHFT(1,IBMAX-1)
            ENDIF
C*          ABFRAGE, OB GI.PUNKT DEFINIERT
            IF(IAND(IBMAP(INB),IBMSK).NE.0 ) THEN
               IF (AR(J)<AMIN) THEN
                  AMIN = AR(J)
                  IGMN = J
               ENDIF
               IF (AR(J)>AMAX) THEN
                  AMAX = AR(J)
                  IGMX = J
               ENDIF
            ENDIF

         ENDDO
         RETURN

      E L S E  I F (IBMJ .EQ. -1) THEN

C-----ZWEIG: ALLE GITTER-PUNKTE DEFINIERT-----------------------------

         IHLP = MINLOC(AR)
         IGMN = IHLP(1)
         IHLP = MAXLOC(AR)
         IGMX = IHLP(1)
         AMIN = AR(IGMN)
         AMAX = AR(IGMX)
         RETURN

      E L S E  I F (IBMJ .EQ. 0) THEN

C-----ZWEIG: FELD MIT UNDEFINIERTEN PUNKTEN (OHNE BITMAP)-------------

         IHLP = MINLOC(AR,MASK=AR.NE.UNDEF)
         IGMN = IHLP(1)
         IHLP = MAXLOC(AR,MASK=AR.NE.UNDEF)
         IGMX = IHLP(1)
         AMIN = AR(IGMN)
         AMAX = AR(IGMX)
         RETURN

      E N D I F

C-----FEHLERAUSGANG
      PRINT '('' MINMAXG: FALSCHE ANGABE FUER IBMJ='',I2)',IBMJ
      IRM = 1

      END
