      SUBROUTINE PARLESC ( IUN, NPAR, YPKENN, YPWERT, IRM )

C**** PARLESC  -   UP: AUFTRAGS-PARAMETER VON EINGABE-EINHEIT EINLESEN
C***                   (OHNE CHARACTER-UMWANDLUNG DES GEFUNDENEN WERTES)
C**   AUFRUF   :   CALL PARLESC (IUN, NPAR, YPKENN, YPWERT, IRM)
C**   ZWECK    :   EINLESEN VON PARAMETER-AUFTRAEGEN :  JEWEILS
C**                EINEM WERTEPAAR (Z.B. kenn1=wert1) WIRD DIE KENNUNG (kenn1)
C**                ENTNOMMEN UND IN YPKENN GESUCHT (BEI NICHTAUFFINDEN:FEHLER);
C**                DER ZUGEHOERIGE WERT (wert1) WIRD AN ENTSPRECHENDER STELLE
C**                VON YPWERT ZURUECKGELIEFERT;
C**                HIERBEI WERDEN - IM GEGENSATZ ZU UP PARLES - EINGELESENE
C**                WERTE  N I C H T  UMGEWANDELT (CHARACTER: KLEIN -> GROSS)
C**                MAX. LAENGE JE ZEILE = 256 CHAR. (FORTSETZUNG MOEGLICH)
C**   EXTERNAL :   PARLSSC (EINLESEN  E I N E R  ZEILE ALS STRING)
C**   PARAMETER:   INPUT:
C**                IUN       EINHEIT (Z.B. 60) - VOM BENUTZER ZU EROEFFNEN
C**                NPAR      ANZAHL PARAMETERKENNUNGEN
C**                YPKENN    PARAMETERKENNUNGEN; VOM BENUTZER ZU DIMENSIONIEREN
C**                          UND VORZUBESETZEN,
C**                          Z.B. CHARACTER YPKENN(npar)*nchar, WOBEI  nchar
C**                          MAXIMAL 10 CHAR., npar = ANZAHL PARAMETER
C**                          - NUR GROSSBUCHSTABEN -
C**                OUTPUT:
C**                YPWERT    EINGELESENER WERT (DEFAULT: BLANK); VOM BENUTZER
C**                          ZU DIMENSIONIEREN:  CHARACTER YPWERT(npar)*nchar,
C**                          WOBEI nchar MAX. 256 CHAR. (BEI ZAHLENWERTEN WEITER
C**                          MIT DWDLIB-FUNKTIONEN  ICHINT ODER CHAFLO)
C**                IRM       STATUS NACH RUECKKEHR
C**                          0   = FEHLERFREI
C**                          1   = SYNTAX-FEHLER
C**                          2   = PARAMETER-KENNUNG NICHT GEFUNDEN
C**                          100 = DATEI-ENDE (EOI) ODER 'RETURN' ODER BLANK
C**                          101 = DATEI-ENDE MIT FEHLER ( WENN FORTS. ERWARTET)
C**                          102 = EINGABE VON 'QUI(T)' ODER 'END'
C**                          103 = EINGABE EINES FRAGEZEICHENS (?) ODER 'HELP'
C**   HINWEISE : - DIE AUFTRAEGE WERDEN IN FOLGENDER FORM ERWARTET
C**                (MAX.LAENGE = 132 CHAR):
C**                      par1=wert1 par2=wert2 U.S.W.  WOBEI JEDER WERT
C**                EIN EINZELWERT SEIN KANN ODER EINE LISTE VON WERTEN:
C**                  (wert11,wert12,wert13) ODER EIN BEREICH ('RANGE'):
C**                  (wert11..wert12) -> ZERLEGEN MIT DWDLIB-UP PARZER;
C**              - BEI ZEICHEN  '+'  WIRD DIE FOLGEZEILE ALS FORTSETZUNG
C**                INTERPRETIERT UND MIT EINGELESEN;
C**              - TRENNUNG DER WERTEPAARE DURCH  ','  ODER BLANK (AUSSER
C**                WENN DER WERT MIT  (   )  - S.O. - EINGESCHLOSSEN WIRD);
C**              - ANFANGSKENNUNG  '/progname'  ERLAUBT;
C**              - ZEILENABSCHLUSS MIT ')'  ERLAUBT;
C**              - DATEIENDE DURCH <QUI> ODER <END> (1.-3.CHAR.) ERLAUBT;
C**              - DIE EINGEGEBENE KENNUNG DARF AUCH KLEINBUCHSTABEN ENTHALTEN;
C**              - DER EINGEGEBENE PARAMETER-WERT WIRD NICHT UMGEWANDELT;
C**              - BEI ANGABE DER KENNUNG REICHT EINE EINDEUTIGE ANZAHL VON
C**                ANFANGS-CHARAKTEREN (S.UNTER UP LOCNAM);
C**              - NACH EINGABE VON <SPAWN> WERDEN DIE EINGABEN ALS SCL-BEFEHLE
C**                ABGESETZT, WAS DURCH EINGABE VON <EXIT> BEENDET WIRD;
C**              - DIE ZUWEISUNG VON KENNUNG UND WERT OHNE PRUEFUNG ANHAND EINER
C**                LISTE (YPKENN S.O.) KANN MIT HILFE DES UP PARLEX ERFOLGEN
C**   VERFASSER:   W.OTT/->DWDLIB: G.BAGINSKI
C     Geaendert:   B.Loeser, 11/00, NOS/VE-Zweig raus, Blend --> LEN_TRIM
C                            IMPLICIT NONE, Parameteranw. raus (nicht verw.)

      IMPLICIT NONE
      INTEGER  IUN, NPAR, IRM, J1, J2, IPLUS, NMAX
      CHARACTER  YPKENN(NPAR)*(*), YPWERT(NPAR)*(*)
      CHARACTER  YIN*256

      IRM     = 0
      DO 10 J1 = 1, NPAR
   10 YPWERT(J1) = ' '

C*    EINLESEN DES AUFTRAGS VON IUN (EINSCHL. FORTSETZGS.ZEILEN)
      DO 500 J2 = 1, 100000

      YIN        = 'XXXX'
      READ       ( IUN,'(A)',END=600 ) YIN
C*    ABFRAGE 'RETURN'  ODER BLANK
      IF (YIN .EQ. ' ') THEN
         IRM = 100
         RETURN
      ENDIF

      NMAX = LEN_TRIM(YIN)
      PRINT   1000, YIN(1:NMAX)
 1000 FORMAT     (' PARLESC - ',A )
      CALL PARLSSC (YIN, NPAR, YPKENN, YPWERT, IPLUS, IRM)

C*    RETURN BEI FEHLER ODER ZEILE OHNE (+)
      IF ((IRM .NE. 0) .OR. (IPLUS .EQ. 0)) RETURN

  500 CONTINUE

C*    SCHLEIFENENDE ERREICHT!!!
      PRINT '('' PARLESC - ZUVIELE FORTSETZUNGSZEILEN'')'
      CALL ABEX ('AG', 15000, 'FATALER FEHLER VON PARLESC')

C*    RETURN FUER INPUT-ENDE (EOI)
  600 CONTINUE
      IRM = 100

      END
