      SUBROUTINE PARLSSC ( YIN, NPAR, YPKENN, YPWERT, IPLUS, IRM )

C**** PARLSSC  -   UP: AUFTRAGS-PARAMETER (STRING) ENTZERREN (O.CHAR.UMWANDLG.)
C**   AUFRUF   :   CALL PARLSSC (YIN, NPAR, YPKENN, YPWERT, IPLUS, IRM)
C**   ZWECK    :   ENTZERREN EINER PARAMETER-AUFTRAG-ZEILE :  JEWEILS
C**                EINEM WERTEPAAR (Z.B. kenn1=wert1) WIRD DIE KENNUNG (kenn1)
C**                ENTNOMMEN UND IN YPKENN GESUCHT (BEI NICHTAUFFINDEN:FEHLER);
C**                DER ZUGEHOERIGE WERT (wert1) WIRD AN ENTSPRECHENDER STELLE
C**                VON YPWERT ZURUECKGELIEFERT;
C**                IM GEGENSATZ ZU UP PARLSS BLEIBEN DIE CHARACTER IN YPWERT
C**                UNVERAENDERT
C**   PARAMETER:   INPUT:
C**                YIN       PARAMETER-AUFTRAG (STRING); VOM BENUTZER ZU DIMENS.
C**                          - KEINE BEGRENZUNG -
C**                NPAR      ANZAHL PARAMETERKENNUNGEN
C**                YPKENN    PARAMETERKENNUNGEN; VOM BENUTZER ZU DIMENSIONIEREN
C**                          UND VORZUBESETZEN - NUR GROSSBUCHSTABEN -
C**                          Z.B. CHARACTER YPKENN(npar)*nchar, WOBEI  nchar
C**                          MAXIMAL 10 CHAR., npar = ANZAHL PARAMETER
C**                OUTPUT:
C**                YPWERT    EINGELESENER WERT (DEFAULT: BLANK); VOM BENUTZER
C**                          ZU DIMENSIONIEREN, Z.B. CHARACTER YPWERT(npar)*20
C**                          MAX. LAENGE = 500 CHAR. (BEI ZAHLENWERTEN WEITER
C**                          MIT DWDLIB-FUNKTIONEN  ICHINT ODER CHAFLO)
C**                IPLUS     = 1 WENN FORTSETZUNGSZEICHEN GEFUNDEN (+)
C**                IRM       STATUS NACH RUECKKEHR
C**                          0   = FEHLERFREI
C**                          1   = SYNTAX-FEHLER
C**                          2   = PARAMETER-KENNUNG NICHT GEFUNDEN
C**                          101 = QUI(T)/END MIT FEHLER (Z.B. WENN FORTS. ERW.)
C**                          102 = QUI(T)/END GEFUNDEN
C**                          103 = ? ODER HELP GEFUNDEN
C**   HINWEISE : - DIE AUFTRAEGE WERDEN IN FOLGENDER FORM ERWARTET
C**                      par1=wert1 par2=wert2 U.S.W.  WOBEI JEDER WERT
C**                EIN EINZELWERT SEIN KANN ODER EINE LISTE VON WERTEN:
C**                  (wert11,wert12,wert13) ODER EIN BEREICH ('RANGE'):
C**                  (wert11..wert12) -> ZERLEGEN MIT DWDLIB-UP PARZER;
C**              - CONTINUATION_CHARACTER, PARAMETERKENNUNG = CONC  IST DAS '+'
C**                (per DEFAULT fuer jeden neuen Auftrag),
C**                MIT DIESEM ZEICHEN WIRD DIE FOLGEZEILE ALS FORTSETZUNG
C**                INTERPRETIERT ( DAS UP MUSS ABER NOCHMALS GERUFEN WERDEN );
C**                DER CONTINUATION_CHAR. KANN IN JEDES BELIEBIGE ASCII-ZEICHEN
C**                UMDEFINIERT WERDEN, Z.B. CONC=# (parn=CONC, wertn=#),
C**                AB DIESER ZUWEISUNG NIMMT DAS PROGRAMM STATT '+' DAS '#' -
C**                ZEICHEN ALS CONTINUATION_CHARACTER;
C**                DIESES ZEICHEN DARF DANN BEI KEINER ANDEREN PARAMETER-
C**                ZUWEISUNG MEHR AUFTAUCHEN;
C**              - TRENNUNG DER WERTEPAARE DURCH  ','  ODER BLANK (AUSSER
C**                WENN DER WERT MIT  (   )  - S.O. - EINGESCHLOSSEN WIRD);
C**              - ANFANGSKENNUNG  '/progname'  ERLAUBT;
C**              - ZEILENABSCHLUSS MIT ')'  ERLAUBT;
C**              - DIE EINGEGEBENE KENNUNG DARF AUCH KLEINBUCHSTABEN ENTHALTEN;
C**              - DER EINGEGEBENE PARAMETER-WERT WIRD NICHT UMGEWANDELT;
C**              - BEI ANGABE DER KENNUNG REICHT EINE EINDEUTIGE ANZAHL VON
C**                ANFANGS-CHARAKTEREN (S.UNTER UP LOCNAM);
C**              - DIE ABFRAGE VON IPLUS WIRD EMPFOHLEN;
C**              - QUI(T)/END/HELP ODER ? AM ANFANG WERDEN ABGEFRAGT
C**              - DIE ZUWEISUNG VON KENNUNG UND WERT OHNE PRUEFUNG ANHAND EINER
C**                LISTE (YPKENN S.O.) KANN MIT HILFE DES UP PARLSX ERFOLGEN
C**   VERFASSER:   W.OTT/ -> DWDLIB: G.BAGINSKI
C     Geaendert:   B.Loeser, 11/00, IMPLICIT NONE, BLEND --> LEN_TRIM

      IMPLICIT NONE
      INTEGER IEND, IGLEI,IPAR, IPLUS, IPLUSI, IRM, ISTR, ISTRE,
     +        J1, J3, J5, LENPW, NCHAR, NKMAX, NMAX, NPAR, NWMAX, 
     +        NWMAXP
      PARAMETER  (NKMAX = 10, NWMAXP = 500)

      CHARACTER  YPKENN(NPAR)*(*), YPWERT(NPAR)*(*) , YZ*1, YIN3*3
      CHARACTER  YIN*(*), YAKMG*4
      CHARACTER  YWORT*(NWMAXP), YKENN*(NKMAX), YCONC*1
      SAVE IPLUSI, YCONC

C*    INITIALISIERUNG
      LENPW = LEN ( YPWERT(1) )
CTEST PRINT '('' PARLSSC:LENPW='',I4)',LENPW
      IF (LENPW .LT. NWMAXP) THEN
         NWMAX = LENPW
      ELSE
         NWMAX = NWMAXP
      ENDIF
      IRM     = 0

C*    WENN IM VORAUFTRAG KEIN FORTSETZUNGSZ. (+) -> YPWERT LOESCHEN
      IF (IPLUSI .NE. 1)  THEN
         YCONC   = '+'
         DO 10 J1 = 1, NPAR
         YPWERT(J1) = ' '
   10    CONTINUE
      ENDIF

      IF (YIN .EQ. ' ') GOTO 600
      NMAX = LEN_TRIM(YIN)
CTEST PRINT   1000, YIN(1:NMAX)
C1000 FORMAT     (' PARLSSC- ',A )

C*    FRAGEZEICHEN (?) ODER HELP ABFRAGEN
      IF ((YIN(1:1).EQ.'?') .OR. (YAKMG(YIN(1:4)).EQ.'HELP')) THEN
         DO 15 J1 = 1, NPAR
   15    YPWERT(J1) = ' '
         IRM = 103
         RETURN
      ENDIF

C*    ENDE-BEDINGUNG (INSBES. F. INTERAKTIVEN BETRIEB)
      CALL AKMG (YIN(1:3), YIN3)
      IF  ((YIN3.EQ.'QUI') .OR. (YIN3.EQ.'END')) GOTO 600

C*    MERKZELLEN AUF 0 SETZEN
      IEND       = NMAX
      IGLEI      = 0
      IPLUS      = 0
      IPLUSI     = 0
      ISTR       = 0
      ISTRE      = 0
      NCHAR      = 0

C*    ---------------------------------------------------------------

      DO 100  J3 = 1, IEND

      YZ         = YIN (J3:J3)
CTEST PRINT '('' PARLSSC:YZ,J3='',A,I4)',YZ,J3

C*    BEI  (  WERT ALS STRING BEHANDELN
      IF (YZ .EQ. '(') THEN
C*       STRINGANFANG NUR DIREKT NACH =  ERLAUBT
         IF ((IGLEI .NE. 1) .OR. (NCHAR.NE.0)) THEN
            PRINT '('' PARLSSC -  (  NUR DIREKT NACH = BEI CHAR.:'',
     +         I4)',J3
            IRM = 1
            GOTO 700
         ENDIF
         ISTR = 1
         GOTO 80
      ENDIF

C*    BEI STRINGENDE WERT ABSPEICHERN
      IF (YZ .EQ. ')') THEN
         IF (ISTR .EQ. 1) THEN
            ISTRE = 1
            ISTR  = 0
            GOTO 90
         ELSE
            NMAX = J3
            GOTO 90
         ENDIF
      ENDIF

C*    ALLE ZEICHEN EINES STRINGS UNVERAENDERT SPEICHERN
      IF (ISTR .EQ. 1) THEN
         NCHAR = NCHAR + 1
         IF (NCHAR .GT. NWMAX) THEN
            PRINT '('' PARLSSC - WERT ZU LANG BEI KENNG.= '',A)',
     +       YPKENN(IPAR)
            IRM = 1
            GOTO 700
         ENDIF
         YWORT(NCHAR:NCHAR) = YZ
         GOTO 80
      ENDIF

C*    BLANK ODER  ,  ALS TRENNZEICHEN WERTEN
      IF ((YZ .EQ.' ' ) .OR. (YZ.EQ.',')) THEN
         GOTO 90

C*    BEI / AM ANFANG WEITERMACHEN
      ELSE  IF ((J3.EQ.1) .AND.( YZ .EQ. '/'))  THEN
         GOTO 80

C*    YCONC ZEIGT FOLGEKARTE AN
      ELSE  IF  ( YZ .EQ. YCONC) THEN
         IPLUSI = 1
         IPLUS  = 1
         NMAX   = J3
         GOTO 90

C*    BEI = KENNUNG IN YPKENN SUCHEN
      ELSE IF  ( YZ .EQ. '=') THEN
         IF (NCHAR .GT. NKMAX) THEN
            PRINT '('' PARLSSC - KENNUNG GT. 10 CHAR. BEI: '',A)',
     +        YWORT(1:NCHAR)
            IRM = 1
            GOTO 700
         ENDIF
         IGLEI    = 1
         YKENN = ' '
         CALL AKMG (YWORT(1:NCHAR) , YKENN)
         CALL LOCNAM (YKENN, YPKENN, NPAR, IPAR, IRM)
         IF (IRM .EQ. 2) THEN
            PRINT '('' PARLSSC - KENNUNG UNGUELTIG= '',A)',YKENN
            IRM = 2
            GOTO 700
         ELSE IF (IRM .EQ. 1) THEN
            PRINT '('' PARLSSC - KENNUNG NICHT EINDEUTIG: '',A)',YKENN
            IRM = 2
            GOTO 700
         ELSE
            NCHAR = 0
            IF (J3 .EQ. NMAX) THEN
               PRINT '('' PARLSSC - KEIN WERT ZU PARAMETER: '',A)',
     +           YPKENN(IPAR)
               IRM = 1
               GOTO 700
            ELSE
               GOTO 80
            ENDIF
         ENDIF

C*    CHARACTER IN YWORT ZWISCHENSPEICHERN
      ELSE
         NCHAR  = NCHAR + 1
         IF (NCHAR .GT. NWMAXP) THEN
            PRINT '('' PARLSSC - WERT ZU LANG BEI CHAR.= '',I4)',J3
            IRM = 1
            GOTO 700
         ENDIF
         YWORT (NCHAR:NCHAR) = YZ
      END IF

   80 IF (J3 .LT. NMAX)  GOTO 100

C*    BEGRENZER GEFUNDEN
   90 CONTINUE

      IF (IGLEI .EQ. 0) THEN
         NCHAR = 0
         GOTO 95
      ENDIF

      IF (NCHAR .EQ. 0)  THEN
         IF  (IGLEI .EQ. 1)  THEN
            PRINT '('' PARLSSC - KEIN WERT ZU PARAMETER: '',A)',
     +        YPKENN(IPAR)
            IRM = 1
            GOTO 700
         ENDIF
         GOTO 95
      ENDIF

C*    FEHLERABFRAGEN
      IF (ISTR .EQ. 1) THEN
         PRINT '('' PARLSSC - KEIN STRINGENDE GEFUNDEN BEI CHAR.: '',
     +     I4)',J3
         IRM = 1
         GOTO 700
      ENDIF
      IF (YPWERT(IPAR) .NE. ' ') THEN
         PRINT '('' PARLSSC - WERT SCHON GELIEFERT FUER: '',A)',
     +        YPKENN(IPAR)
         IRM = 1
         GOTO 700
      ENDIF
      IF (NCHAR .GT. NWMAX) THEN
         PRINT '('' PARLSSC - WERT ZU LANG BEI CHAR.= '',I4)',J3
         IRM = 1
         GOTO 700
      ENDIF

C*    WERT ABSPEICHERN (NUR WENN KENNUNG VORHANDEN)
      IF (ISTRE .EQ. 1) THEN
         YPWERT(IPAR) = YWORT(1:NCHAR)
         ISTR  = 0
      ELSE
         YPWERT(IPAR) = YWORT(1:NCHAR)
CTTT     CALL AKMG ( YWORT(1:NCHAR), YPWERT(IPAR) )
      ENDIF
      IGLEI = 0
      NCHAR = 0
      IF (YPKENN(IPAR)(1:4) .EQ. 'CONC') YCONC = YPWERT(IPAR)(1:1)

C*    RETURN WENN + ODER ZEILENENDE
   95 IF ((IPLUSI .EQ. 1) .OR. (J3 .EQ. NMAX)) RETURN

  100 CONTINUE

C*    ------------------------------------------------------------------

C*    RETURN WENN 'QUI' ODER 'END' GEFUNDEN
  600 CONTINUE
      IF (IPLUSI .EQ. 1) THEN
         DO 620 J5 = 1, NPAR
  620    YPWERT(J5) = ' '
         PRINT '('' PARLSSC - ENDE ODER LEERZEILE GEFUNDEN NACH '',
     +     ''FORTSETZUNG (+)'')'
         IRM = 101
         IPLUS  = 0
         IPLUSI = 0
      ELSE
         IRM = 102
         IPLUS  = 0
         IPLUSI = 0
      ENDIF
      RETURN

C*    ALLG. FEHLERAUSGANG (ALLE WERTE BLANK SETZEN)
  700 CONTINUE
      DO 710 J5 = 1, NPAR
  710 YPWERT(J5) = ' '
      IPLUS  = 0
      IPLUSI = 0

      END
