      SUBROUTINE PGD1_00 (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT,
     +                    JWERT, JBLE, JX, IRM)

C**** PGD1_00  -   UP ERST. GRID-DEFIN.-SECTION FUER IEDNR=1, IDRTYP=0/10/20/30
C**   AUFRUF     : CALL PGD1_00 (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IWERT,
C**               +              JWERT,JBLE,JX,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DIE DATEN AB IWERT(7) BIS max. IWERT(25) WERDEN FUER DIE
C**                GRID-DEFINITION-SECTION AUFGEBAUT FUER IDRTYP=0/10/20/30,
C**                REGULAR LAT./LONG. GRID
C**   PARAMETER  : INPUT:    IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT
C**                -------------------------------------------------
C**                IANZ      ANZAHL DER ERSTEN, MAX. 25 DATENWERTE IN IWERT
C**                LGDS      BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA     1. BYTE IM GDS (--> IBYTG = IBYTA + 10)
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                NWERT     USER-DIMENSION VON IWERT/JWERT: IWERT(NWERT)
C**                IWERT     626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN PUTGD1, HIER AB IWERT(7)
C**                IWERT:    BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  LA1     GEOGR. BREITE DES 1.GPKT.
C**                   (8)   14 -16  LO1     GEOGR. LAENGE DES 1.GPKT.
C**                   (9)   17      IRFLAG  AUFLOESUNG UND BESTANDTEILE
C**                                         ( CODE TABLE 7 )
C**                   (10)  18 -20  LA2     GEOGR. BREITE DES LTZT. GPKT.
C**                   (11)  21 -23  LO2     GEOGR. LAENGE DES LTZT. GPKT.
C**                   (12)  24 -25  DI      I - RICHTUNGS-INCREMENT
C**                   (13)  26 -27  DJ      J - RICHTUNGS-INCREMENT
C**                   (14)  28      MODSC   RASTERART
C**                                         ( FLAG/CODE TABLE 8 )
C**                   (15)  29      IRES1   )
C**                     :    :      :       ) RESERVIERT (=0)
C**                   (18)  32      IRES4   )
C**                   (19)   -      -       UNBENUTZT
C**                         ES FOLGEN FUER ROT. UND ROT./STR.:
C**                         ----------------------------------
C**                   (20)  33- 35  LARSP   GEOGR. BREITE DES SUEDL. POLS
C**                   (21)  36- 38  LORSP   GEOGR. LAENGE DES SUEDL. POLS
C**                ** (22)  39- 42  IROTWK  ROTATIONSWINKEL (SIEHE 4. HINWEIS)
C**                         ES FOLGEN FUER STR.:
C**                         --------------------
C**                   (20)  33- 35  LARSP   GEOGR. BREITE DES STRETCH. POLS
C**                   (21)  36- 38  LORSP   GEOGR. LAENGE DES STRETCH. POLS
C**                ** (22)  39- 42  ISTRFK  STRETCH. FAKTOR (SIEHE 4. HINWEIS)
C**                         ES FOLGEN FUER ROT./STR.:
C**                         -------------------------
C**                   (23)  43- 45  LARSP   GEOGR. BREITE DES STRETCH. POLS
C**                   (24)  46- 48  LORSP   GEOGR. LAENGE DES STRETCH. POLS
C**                ** (25)  49- 52  ISTRFK  STRETCH. FAKTOR (SIEHE 4. HINWEIS)
C**                .............................................................
C**                OUTPUT:    JWERT, JBLE, JX, IRM
C**                -------------------------------
C**                JWERT      LUECKENLOS UMGESPEICHERTE DATENWERTE AUS IWERT
C**                JBLE       BYTELAENGEN ZU JWERT, DIMENSION WIE JWERT/IWERT
C**                JX         INDEX DES LETZTEN UMGESPEICHERTEN WERTES IN JWERT
C**                IRM        FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES ZU UEBERGEBEN
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) WIRD FUER DIE INTERNE SPEICHERUNG IM GRIB
C**                              CODE DAS OBERSTE BIT VON 3 BYTES GESETZT UND
C**                              DER WERT POSITIV ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN ZU UEBERGEBEN
C**                           4. MIT * GEKENNZEICHNETE WERTE WERDEN IM UP ERMIT-
C**                              TELT UND GESETZT
C**                           5. MIT ** GEKENNZEICHNETE WERTE MUESSEN VOM USER
C**                              MIT DER FUNCTION IREFTS (SIEHE DWDLIB) UMGE-
C**                              RECHNET SEIN
C**
C**   VERFASSER:   A. ZALEWSKY, MAERZ 1995
C     MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
C     GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, OR-> IOR, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT, JWERT, JBLE, JX
      INTEGER IRM
      INTEGER MWERT, IBALL, IBLE, IBLERS, MSK31, IDRTYP, IBYTG, J, JJ
      INTEGER IBLL, IWZW, JANZ, IBYTZW

#include "machconsts.h"

      PARAMETER (MWERT=626)

      DIMENSION IWERT(*),JWERT(MWERT),JBLE(MWERT),IBALL(4),
     +          IBLE(8),IBLERS(6)

      DATA MSK31 / Z'800000'   /
      DATA IBALL / Z'FF'       ,
     +             Z'FFFF'     ,
     +             Z'FFFFFF'   ,
     +             Z'FFFFFFFF' /

C     ...INDEX:      7  8  9 10 11 12 13 14
      DATA IBLE   /  3, 3, 1, 3, 3, 2, 2, 1/

C     ...INDEX:....20 21 22 23 24 25
      DATA IBLERS / 3, 3, 4, 3, 3, 4/

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLE UMGESPEICHERT................
C.....JX WIRD ALS INDEX FUER JWERT/JBLE AB JX=6 HOCHGERECHNET...................
C.....START-BYTE DER GDS  =  11  !!!!!

      IRM       = 0
      JX        = 6
      IDRTYP    = IWERT(4)
C.....IBYTA     = 1.BYTE IN DER GDS, --> IBYTG = IBYTA + 10
      IBYTG     = IBYTA + 10

#if defined(TEST)
      PRINT '('' PGD1_00: IDRTYP, IBYTG='',2I6)', IDRTYP, IBYTG
#endif 
C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C..................IWERT(7..8)
      DO 120 J   = 7, 8
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  120 CONTINUE
C..................IWERT(9)
      J          = 9
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     +    IWZW   = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C..................IWERT(10..11)
      DO 140 J   = 10, 11
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  140 CONTINUE

C..................IWERT(12..14)
      DO 170 J   = 12, 14
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     + IWZW      = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  170 CONTINUE

C.....MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
C     JANZ       = 14
C     IF (JANZ .EQ. IANZ)                   THEN
C........IDRTYP=0; WEITERE DATEN AB JWERT(26); IBYTA = IBYTA + LGDS
C        IBYTG      = IBYTA + LGDS
C        GOTO 215
C     ENDIF
C.......................................................................19.11.97

C..................IWERT(15..18) RESERVIERT (=0);
      DO 171 J   = 15, 18
      JX         = JX + 1
      IBLL       = 1
      JWERT(JX)  = 0
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  171 CONTINUE

C.....MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
      JANZ       = 14
      IF (JANZ .EQ. IANZ)                   THEN
C........IDRTYP=0; WEITERE DATEN AB JWERT(26); IBYTA = IBYTA + LGDS
         IBYTG      = IBYTA + LGDS
         GOTO 215
      ENDIF
C.......................................................................19.11.97

C.....WEITERE DATEN AB IWERT(20)
      IBYTG      = IBYTA + LGDS
C     PRINT '('' PGD1_00: IBYTG ='',I3)', IBYTG

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C...................IWERT(20..21)
      DO 200 J   = 20, 21
      JJ         = J - 19
      JX         = JX + 1
      IBLL       = IBLERS(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  200 CONTINUE
C..................IWERT(22)
      J          = 22
      JJ         = J - 19
      JX         = JX + 1
      IBLL       = IBLERS(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     +   IWZW    = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

      JANZ       = 22
      IF (JANZ .EQ. IANZ)                   THEN
C........IDRTYP=10/20; WEITERE DATEN AB IWERT(26); IBYTG = IBYTA + LGDS
         IBYTG   = IBYTA + LGDS
         GOTO 215
      ENDIF

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C..................IWERT(23..24); IDRTYP=30
      DO 210 J   = 23, 24
      JJ         = J - 19
      JX         = JX + 1
      IBLL       = IBLERS(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)              THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)              THEN
            IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  210 CONTINUE
C..................IWERT(25)
      J          = 25
      JJ         = J - 19
      JX         = JX + 1
      IBLL       = IBLERS(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     +   IWZW    = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

      JANZ       = 25
      IF (JANZ .NE. IANZ)                   THEN
C........IDRTYP=30; WEITERE DATEN AB IWERT(26); IBYTG = IBYTA + LGDS
         PRINT '('' PGD1_00: FEHLER - JANZ#IANZ; JANZ, IANZ='',2I3)',
     +                                           JANZ, IANZ
         IRM     = 1
         RETURN
      ENDIF

  215 CONTINUE
C.....FUER VERGLEICH MUSS IBYTA VON IBYTG SUBTRAHIERT WERDEN
      IBYTZW        = IBYTG - IBYTA
      IF (LGDS .NE. IBYTZW)                 THEN
         PRINT '('' PGD1_00: BERECHN. GDS-LAENGE='',I4,'' # LGDS='',
     +                      I4)',                   IBYTZW, LGDS
         IRM        = 1
         RETURN
      ENDIF

      RETURN
      END

