      SUBROUTINE PGD1_02 (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT,
     +                    JWERT, JBLE, JX, IRM)

C**** PGD1_02   -  UP ERST. GRID-DEFIN.-SECTION FUER IEDNR=1, IDRTYP=2
C**   AUFRUF     : CALL PGD1_02 (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IWERT,
C**               +              JWERT,JBLE,JX,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DIE DATEN AB IWERT(7) BIS max. IWERT(25) WERDEN FUER DIE
C**                GRID-DEFINITION-SECTION AUFGEBAUT FUER IDRTYP=2,
C**                STEREOGR. PROJECTION
C**   PARAMETER  : INPUT:    IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT
C**                -------------------------------------------------
C**                IANZ      ANZAHL DER ERSTEN, MAX. 25 DATENWERTE IN IWERT
C**                LGDS      BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA     1.BYTE IN DER GDS (--> IBYTG = IBYTA + 10 !)
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                NWERT     USER-DIMENSION VON IWERT/JWERT: IWERT(NWERT)
C**                IWERT     626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN PUTGD1, HIER AB IWERT(7)
C**                IWERT:    BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  LA1     GEOGR. BR. DES LINK. UNT. ECKPUNKTES
C**                   (8)   14 -16  LO1     GEOGR. LA. DES LINK. UNT. ECKPUNKTES
C**                   (9)   17      IRFLAG  AUFLOESUNG  ( CODE TABLE 7 )
C**                   (10)  18 -20  LA2     GEOGR. BR. DES RECHT. OB.ECKPUNKTES
C**                   (11)  21 -23  LO2     GEOGR. LA. DES RECHT. OB.ECKPUNKTES
C**                   (12)  24 -25  IDX     GITTERPUNKT-ABSTAENDE IN X-RICHTUNG
C**                   (13)  26 -27  IDY     GITTERPUNKT-ABSTAENDE IN Y-RICHTUNG
C**                   (14)  28      MODSC   RASTERART   ( FLAG/CODE TABLE 8 )
C**                   (15)  29      IPRZ    PROJEKTIONS-ZENTRUM (0 = NORDPOL)
C**                   (16)  30 -32  IRESVA  RESERVIERT (=0)
C**               (17- 25)   -      -       UNBENUTZT
C**               ..............................................................
C**                OUTPUT:    JWERT, JBLE, JX, IRM
C**                -------------------------------
C**                JWERT      LUECKENLOS UMGESPEICHERTE DATENWERTE AUS IWERT
C**                JBLE       BYTELAENGEN ZU JWERT, DIMENSION WIE JWERT/IWERT
C**                JX         INDEX DES LETZTEN UMGESPEICHERTEN WERTES IN JWERT
C**                IRM        FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES ZU UEBERGEBEN
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) WIRD FUER DIE INTERNE SPEICHERUNG IM GRIB
C**                              CODE DAS OBERSTE BIT VON 3 BYTES GESETZT UND
C**                              DER WERT POSITIV ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN ZU UEBERGEBEN
C**                           4. MIT * GEKENNZEICHNETE WERTE WERDEN IM UP ERMIT-
C**                              TELT UND GESETZT
C**                           5. MIT ** GEKENNZEICHNETE WERTE MUESSEN VOM USER
C**                              MIT DER FUNCTION IREFTS (SIEHE DWDLIB) UMGE-
C**                              RECHNET SEIN
C**
C**   VERFASSER:   A. ZALEWSKY, MAERZ 1995
C     MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
C     GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, OR-> IOR, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT, JWERT, JBLE, JX
      INTEGER IRM
      INTEGER MWERT, IBALL, IBLE, MSK31, IDRTYP, IBYTG, J, JJ, IBLL
      INTEGER IWZW, JANZ, IBYTZW

#include "machconsts.h"

      PARAMETER (MWERT=626)

      DIMENSION IWERT(*),JWERT(MWERT),JBLE(MWERT),IBALL(4),
     +          IBLE(9)

      DATA MSK31 / Z'800000' /

      DATA IBALL / Z'FF'       ,
     +             Z'FFFF'     ,
     +             Z'FFFFFF'   ,
     +             Z'FFFFFFFF' /

C     ...INDEX:      7  8  9 10 11 12 13 14 15
      DATA IBLE   /  3, 3, 1, 3, 3, 2, 2, 1, 1/

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLE UMGESPEICHERT................
C.....JX WIRD ALS INDEX FUER JWERT/JBLE AB JX=6 HOCHGERECHNET...................

      IRM       = 0
      JX        = 6
      IDRTYP    = IWERT(4)
      IBYTG     = IBYTA + 10

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C..................IWERT(7..8)
      DO 120 J   = 7, 8
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  120 CONTINUE
C..................IWERT(9)
      J          = 9
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     +   IWZW    = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C..................IWERT(10..11)
      DO 140 J   = 10, 11
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  140 CONTINUE
C..................IWERT(12..15)
      DO 170 J   = 12, 15
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     + IWZW      = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  170 CONTINUE

C.....MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
C     JANZ          = 15
C     IF (JANZ .NE. IANZ)                   THEN
C........IDRTYP=2; WEITERE DATEN AB IWERT(26); IBYTG = IBYTA + LGDS
C        PRINT '('' PGD1_01: FEHLER - JANZ#IANZ; JANZ, IANZ='',2I3)',
C    +                                           JANZ, IANZ
C        IRM     = 1
C        RETURN
C     ENDIF
C...............................................................................

C..................IWERT(16), RESERVIERT (=0)
      J          = 16
      JX         = JX + 1
      IBLL       = 3
      JWERT(JX)  = 0
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

C.....MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
      JANZ          = 15
      IF (JANZ .NE. IANZ)                   THEN
C........IDRTYP=2; WEITERE DATEN AB IWERT(26); IBYTG = IBYTA + LGDS
         PRINT '('' PGD1_01: FEHLER - JANZ#IANZ; JANZ, IANZ='',2I3)',
     +                                           JANZ, IANZ
         IRM     = 1
         RETURN
      ENDIF
C...............................................................................

C.....FUER VERGLEICH MUSS IBYTA VON IBYTG SUBTRAHIERT WERDEN
      IBYTZW        = IBYTG - IBYTA
      IF (LGDS .NE. IBYTZW)                 THEN
         PRINT '('' PGD1_02: BERECHN. GDS-LAENGE='',I4,'' # LGDS='',
     +                      I4)',                   IBYTZW, LGDS
         IRM        = 1
         RETURN
      ENDIF

      RETURN
      END

