      SUBROUTINE PGD1_192 (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT,
     +                     JWERT, JBLE, JX, IRM)
C**** PGD1_192 -   UP ERST. GRID-DEFIN.-SECTION FUER IEDNR=1, IDRTYP=192
C**   AUFRUF     : CALL PGD1_192 (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IWERT,
C**               +               JWERT,JBLE,JX,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DIE DATEN AB IWERT(7) BIS max. IWERT(25) WERDEN FUER DIE
C**                GRID-DEFINITION-SECTION AUFGEBAUT FUER IDRTYP=192,
C**                TRI-ANGULAR-GRID
C**   PARAMETER  : INPUT:    IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT
C**                -------------------------------------------------
C**                IANZ      ANZAHL DER ERSTEN, MAX. 25 DATENWERTE IN IWERT
C**                LGDS      BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA     1.BYTE IN DER GDS (--> IBYTG = IBYTA + 10 !)
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                NWERT     USER-DIMENSION VON IWERT: IWERT(NWERT)
C**                IWERT     626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN PUTGD1, HIER AB IWERT(7)
C**                IWERT:    BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  ND      ANZAHL DER DIAMANTEN (RHOMBEN),
C**                                         ND=10 BESAGT, DASS JEWEILS 2 DER 20
C**                                               DREIECKE DES IKOSAEDERS EINEN
C**                                               DIAMANTEN BILDEN
C**                   (8)   14 -16  NI      ANZAHL DER UNTERTEILUNGEN EINER
C**                                         DREIECKSSEITE DES IKOSAEDERS:
C**                                         NI = 3**n3 * 2**n2
C**                   (9)   17      IAFLAG  FLAG BZGL. DER ANORDNUNG DER DIA-
C**                                         MANTEN;    TABELLE A:
C**                                         ANORDNUNG DER DIAMANTEN (VOM POLPKT.
C**                                         GESEHEN),
C**                                         = 0,   BIT 1 = 0; IM UHRZEIGERSINN
C**                                         = 128, BIT 1 = 1; GEG. UHRZEIGERSINN
C**                   (10)  18 -20  LAPP    GEOGR. BREITE DES POLPUNKTES
C**                                         (LOKATION DES IKOSAEDERS INNERHALB
C**                                         DER KUGEL
C**                   (11)  21 -23  LOPP    GEOGR. LAENGE DES POLPUNKTES
C**                   (12)  24 -26  LOMPL   GEOGR. LAENGE DER MITTELPUNKTLINIE
C**                                         DES 1. DIAMANTEN
C**                                         (AUSRICHTUNG DES IKOSAEDERS IN WEST-
C**                                          OST-RICHTUNG)
C**                   (13)  27      IRES    RESERVIERT (=0)
C**                   (14)  28      IBFLAG  FLAG BZGL. DER REIHENFOLGE DER AB-
C**                                         SPEICHERUNG DER GITTERPUNKTE,
C**                                         TABELLE B:
C**                                         BIT 1: ZUR FESTLEGUNG DER RICHTUNG 
C**                                                DER 1. KOORDINATE i1,
C**                                            =0, +i1, VOM POL ZUM AEQUATOR
C**                                            =1, -i1
C**                                         BIT 2: ZUR FESTLEGUNG DER RICHTUNG
C**                                                DER 2. KOORDINATE i2,
C**                                            =0, +i2, VON WEST NACH OST
C**                                            =1, -i2
C**                                         BIT 3: ZUR FESTLEG. DER REIHENFOLGE,
C**                                            =0, AUFEINANDERFOLGENDE PUNKTE
C**                                                LIEGEN IN +i1 RICHTUNG,
C**                                                ZAEHLWEISE ERST IN i1-, DANN
C**                                                IN i2-RICHTUNG
C**                                            =1, AUFEINANDERFOLGENDE PUNKTE
C**                                                LIEGEN IN +i2 RICHTUNG,
C**                                                ZAEHLWEISE ERST IN i2-, DANN
C**                                                IN i1-RICHTUNG
C**                                         ALLE 3 BITS WERDEN =0 GESETZT
C**                   (15)  29      IRES1   )
C**                     :    :              ) RESERVIERT (=0)
C**                   (18)  32      IRES4   )
C**                   (19)  -       -       )
C**                     :    :              ) UNBENUTZT (=0)
C**                   (25)  -       -       )
C**                .............................................................
C**                OUTPUT:    JWERT, JBLE, JX, IRM
C**                -------------------------------
C**                JWERT      LUECKENLOS UMGESPEICHERTE DATENWERTE AUS IWERT
C**                JBLE       BYTELAENGEN ZU JWERT, DIMENSION WIE JWERT/IWERT
C**                JX         INDEX DES LETZTEN UMGESPEICHERTEN WERTES IN JWERT
C**                IRM        FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES ZU UEBERGEBEN
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) WIRD FUER DIE INTERNE SPEICHERUNG IM GRIB
C**                              CODE DAS OBERSTE BIT VON 3 BYTES GESETZT UND
C**                              DER WERT POSITIV ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN ZU UEBERGEBEN
C**
C**   VERFASSER:   A. ZALEWSKY, TI12, MAERZ 1998
C     MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
C     MODIF.:      IWERT(13) WIRD VOM UP MIT 0 GESPEICHERT;.............20.01.99
C     GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, OR-> IOR, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT, JWERT, JBLE, JX
      INTEGER IRM
      INTEGER MWERT, IBALL, IBLE, IBLERS, MSK31, IDRTYP, IBYTG, J, JJ
      INTEGER IBLL, IWZW, JANZ, IBYTZW

#include "machconsts.h"

      PARAMETER (MWERT=626)

      DIMENSION IWERT(*),JWERT(MWERT),JBLE(MWERT),IBALL(4),
     +          IBLE(8),IBLERS(6)

      DATA MSK31 / Z'800000' /

      DATA IBALL / Z'FF'        ,
     +             Z'FFFF'      ,
     +             Z'FFFFFF'    ,
     +             Z'FFFFFFFF'  /

C     ...INDEX:      7  8  9 10 11 12 13 14
      DATA IBLE   /  3, 3, 1, 3, 3, 3, 1, 1/

C     ...INDEX:....20 21 22 23 24 25
      DATA IBLERS / 3, 3, 4, 3, 3, 4/

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLE UMGESPEICHERT................
C.....JX WIRD ALS INDEX FUER JWERT/JBLE AB JX=6 HOCHGERECHNET...................

      IRM       = 0
      JX        = 6
      IDRTYP    = IWERT(4)
      IBYTG     = IBYTA + 10

C..................IWERT(7..9)
      DO 120 J   = 7, 9
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  120 CONTINUE

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C..................IWERT(10..12)
      DO 140 J   = 10, 12
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  140 CONTINUE

C..................IWERT(13), RESERVIERT (=0)..............20.01.99
      DO 160 J   = 13, 13
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = 0      
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  160 CONTINUE
  
C..................IWERT(14)
      DO 170 J   = 14, 14
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     + IWZW      = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  170 CONTINUE
    

C..................IWERT(15..18), RESERVIERT (=0)
      DO 171 J   = 15, 18
      JX         = JX + 1
      IBLL       = 1
      JWERT(JX)  = 0
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  171 CONTINUE

      JANZ       = 14
      IF (JANZ .EQ. IANZ)                   THEN
C........IDRTYP=4; WEITERE DATEN AB JWERT(26); IBYTG = IBYTA + LGDS
         IBYTG      = IBYTA + LGDS
         GOTO 215
      ENDIF
C...............................................................................

C.....WEITERE DATEN AB IWERT(20)
      IBYTG      = IBYTA + 32

CC     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
CC     (VON 3 BYTES ) GESETZT
CC...................IWERT(20..21)
C      DO 200 J   = 20, 21
C      JJ         = J - 19
C      JX         = JX + 1
C      IBLL       = IBLERS(JJ)
C      IWZW       = IWERT(J)
C      IF (IWZW .EQ. IUNDEF)                 THEN
C         IWZW    = IBALL(IBLL)
C      ELSE IF (IWZW .LT. 0)                 THEN
C         IWZW    = IOR (-IWZW , MSK31)
C      ENDIF
C      JWERT(JX)  = IWZW
C      JBLE(JX)   = IBLL
C      IBYTG      = IBYTG + IBLL
C  200 CONTINUE
CC..................IWERT(22)
C      J          = 22
C      JJ         = J - 19
C      JX         = JX + 1
C      IBLL       = IBLERS(JJ)
C      IWZW       = IWERT(J)
C      IF (IWZW .EQ. IUNDEF)
C     +   IWZW    = IBALL(IBLL)
C      JWERT(JX)  = IWZW
C      JBLE(JX)   = IBLL
C      IBYTG      = IBYTG + IBLL
C
C      JANZ       = 22
C      IF (JANZ .EQ. IANZ)                   THEN
CC.....IDRTYP=     ; WEITERE DATEN AB IWERT(26); IBYTG = IBYTA + LGDS
C         IBYTG   = IBYTA + LGDS
C         GOTO 215
C      ENDIF
C
CC     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
CC     (VON 3 BYTES ) GESETZT
CC..................IWERT(23..24)
C      DO 210 J   = 23, 24
C      JJ         = J - 19
C      JX         = JX + 1
C      IBLL       = IBLERS(JJ)
C      IWZW       = IWERT(J)
C      IF (IWZW .EQ. IUNDEF)              THEN
C         IWZW    = IBALL(IBLL)
C      ELSE IF (IWZW .LT. 0)              THEN
C            IWZW    = IOR (-IWZW , MSK31)
C      ENDIF
C      JWERT(JX)  = IWZW
C      JBLE(JX)   = IBLL
C      IBYTG      = IBYTG + IBLL
C  210 CONTINUE
CC..................IWERT(25)
C      J          = 25
C      JJ         = J - 19
C      JX         = JX + 1
C      IBLL       = IBLERS(JJ)
C      IWZW       = IWERT(J)
C      IF (IWZW .EQ. IUNDEF)
C     +   IWZW    = IBALL(IBLL)
C      JWERT(JX)  = IWZW
C      JBLE(JX)   = IBLL
C      IBYTG      = IBYTG + IBLL
C
C      JANZ       = 25
C      IF (JANZ .NE. IANZ)                   THEN
CC........IDRTYP=34; WEITERE DATEN AB IWERT(26); IBYTG = IBYTA + LGDS
C         PRINT '('' PGD1_192: FEHLER - JANZ#IANZ; JANZ, IANZ='',2I3)',
C     +                                            JANZ, IANZ
C         IRM     = 1
C         RETURN
C      ENDIF

  215 CONTINUE
C.....FUER VERGLEICH MUSS IBYTA VON IBYTG SUBTRAHIERT WERDEN
      IBYTZW        = IBYTG - IBYTA
      IF (LGDS .NE. IBYTZW)                 THEN
         PRINT '('' PGD1_192: BERECHN. GDS-LAENGE='',I4,'' # LGDS='',
     +                       I4)',                   IBYTZW, LGDS
         IRM        = 1
         RETURN
      ENDIF

      RETURN
      END


