      SUBROUTINE PGD1_90 (IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT,
     +                    JWERT, JBLE, JX, IRM)

C**** PGD1_90   -  UP ERST. GRID-DEFIN.-SECTION FUER IEDNR=1, IDRTYP=90
C**   AUFRUF     : CALL PGD1_90 (IANZ,LGDS,IBYTA,IUNDEF,NWERT,IWERT,
C**               +              JWERT,JBLE,JX,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DIE DATEN AB IWERT(7) BIS max. IWERT(25) WERDEN FUER DIE
C**                GRID-DEFINITION-SECTION AUFGEBAUT FUER IDRTYP=90
C**                SPACE VIEW PERSPECTIVE
C**   PARAMETER  : INPUT:    IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT
C**                -------------------------------------------------
C**                IANZ      ANZAHL DER ERSTEN, MAX. 25 DATENWERTE IN IWERT
C**                LGDS      BYTELAENGE DER GDS BIS MAX. IWERT(25)
C**                IBYTA     1.BYTE IN DER GDS (--> IBYTG = IBYTA + 10 !)
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                NWERT     USER-DIMENSION VON IWERT: IWERT(NWERT)
C**                IWERT     626 KENNDATEN FUER DIE GDS;
C**                          IWERT(1..6) IN PUTGD1, HIER AB IWERT(7)
C**                IWERT:    BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (7)   11 -13  LAP     GEOGR. BREITE VOM SUB-SATELLITE-PKT.
C**                   (8)   14 -16  LO1     GEOGR. LAENGE VOM SUB-SATELLITE-PKT.
C**                   (9)   17      IRFLAG  AUFLOESUNG UND BESTANDTEILE
C**                                         ( CODE TABLE 7 )
C**                   (10)  18 -20  DX      SCHEINB. ERDDURCHMESSER IN GRIDLAEN-
C**                                         GEN, IN X-DIRECTION
C**                   (11)  21 -23  DY      SCHEINB. ERDDURCHMESSER IN GRIDLAEN-
C**                                         GEN, IN Y-DIRECTION
C**                   (12)  24 -25  XP      X-KOORDINATE VOM SUB-SATELLITE-PKT.
C**                   (13)  26 -27  YP      Y-KOORDINATE VOM SUB-SATELLITE-PKT.
C**                   (14)  28      MODSC   RASTERART  ( FLAG/CODE TABLE 8 )
C**                   (15)  29 -31  ORIEN   GRID-ORIENTIERUNG,  WINKEL ZWISCHEN
C**                                         ANSTEIG. Y-ACHSE UND DEM MERIDIAN
C**                                         DES SUB-SATELLITE-PKTS. IN RICHTUNG
C**                                         ANSTEIGENDER BREITENGRADE
C**                   (16)  32 -34  NR      KAMERA-HOEHE UEBER'M ERDZENTRUM,
C**                                         GEMESSEN IN EINHEITEN DES ERD-RADIUS
C**                   (17)  35 -36  XO      X-KOORDINATE DER BILD-SEKTOR-QUELLE
C**                   (18)  37 -38  YO      Y-KOORDINATE DER BILD-SEKTOR-QUELLE
C**                   (19)  39      IRES1   )
C**                     :    :      :       ) RESERVIERT (=0)
C**                   (25)  44      IRES2   )
C**               ..............................................................
C**                OUTPUT:    JWERT, JBLE, JX, IRM
C**                -------------------------------
C**                JWERT      LUECKENLOS UMGESPEICHERTE DATENWERTE AUS IWERT
C**                JBLE       BYTELAENGEN ZU JWERT, DIMENSION WIE JWERT/IWERT
C**                JX         INDEX DES LETZTEN UMGESPEICHERTEN WERTES IN JWERT
C**                IRM        FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES ZU UEBERGEBEN
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) WIRD FUER DIE INTERNE SPEICHERUNG IM GRIB
C**                              CODE DAS OBERSTE BIT VON 3 BYTES GESETZT UND
C**                              DER WERT POSITIV ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN ZU UEBERGEBEN
C**                           4. MIT * GEKENNZEICHNETE WERTE WERDEN IM UP ERMIT-
C**                              TELT UND GESETZT
C**
C**   VERFASSER:   A. ZALEWSKY, MAERZ 1995
C     MODIF.:      RESERV. WERTE MUESSEN MIT ABGESPEICHERT WERDEN;......19.11.97
C     GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, OR-> IOR, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, LGDS, IBYTA, IUNDEF, NWERT, IWERT, JWERT, JBLE, JX
      INTEGER IRM
      INTEGER MWERT, JANZ, IBALL, IBLE, MSK21, MSK31, IDRTYP, IBYTG, J
      INTEGER JJ, IBLL, IWZW, IBYTZW

#include "machconsts.h"

      PARAMETER (MWERT=626,JANZ=18)

      DIMENSION IWERT(*),JWERT(MWERT),JBLE(MWERT),IBALL(4),
     +          IBLE(12)

      DATA MSK21 / Z'8000' /
      DATA MSK31 / Z'800000' /

      DATA IBALL / Z'FF'        ,
     +             Z'FFFF'      ,
     +             Z'FFFFFF'    ,
     +             Z'FFFFFFFF'  /

C     ...INDEX:      7  8  9 10 11 12 13 14 15 16 17 18
      DATA IBLE   /  3, 3, 1, 3, 3, 2, 2, 1, 3, 3, 2, 2/

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLE UMGESPEICHERT................
C.....JX WIRD ALS INDEX FUER JWERT/JBLE AB JX=6 HOCHGERECHNET...................

      IRM        = 0
      JX         = 6
      IDRTYP     = IWERT(4)
      IBYTG      = IBYTA + 10

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 3 BYTES ) GESETZT
C..................IWERT(7..8)
      DO 120 J   = 7, 8
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  120 CONTINUE

C..................IWERT( 9..11)
      DO 130 J   =  9, 11
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     + IWZW      = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  130 CONTINUE

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 2 BYTES ) GESETZT
C..................IWERT(12..13)
      DO 150 J   = 12, 13
      JX         = JX + 1
      JJ         = J - 6
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK21)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  150 CONTINUE

C..................IWERT(14)
      J          = 14
      JJ         = J - 6
      JX         = JX + 1
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     + IWZW      = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

C..................IWERT(15)
      J          = 15
      JJ         = J - 6
      JX         = JX + 1
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

C...............IWERT(16)
      J          = 16
      JJ         = J - 6
      JX         = JX + 1
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL

C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE BIT
C     (VON 2 BYTES ) GESETZT
C..................IWERT(17..18)
      DO 190 J   = 17, 18
      JJ         = J - 6
      JX         = JX + 1
      IBLL       = IBLE(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .LT. 0)                 THEN
         IWZW    = IOR (-IWZW , MSK31)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  190 CONTINUE

C..................IWERT(19..24) RESERVIERT (=0)
      DO 191 J   = 19, 24
      JX         = JX + 1
      IBLL       = 1
      JWERT(JX)  = 0
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  191 CONTINUE
C.....WEITERE DATEN AB IWERT(26)

      IF (JANZ .NE. IANZ)                   THEN
C........IDRTYP=90; WEITERE DATEN AB IWERT(26); IBYTG = IBYTA + LGDS
         PRINT '('' PGD1_90: FEHLER - JANZ#IANZ; JANZ, IANZ='',2I3)',
     +                                           JANZ, IANZ
         IRM     = 1
         RETURN
      ENDIF

C.....FUER VERGLEICH MUSS IBYTA VON IBYTG SUBTRAHIERT WERDEN
      IBYTZW        = IBYTG - IBYTA
      IF (LGDS .NE. IBYTZW)                 THEN
         PRINT '('' PGD1_90: BERECHN. GDS-LAENGE='',I4,'' # LGDS='',
     +                      I4)',                   IBYTZW, LGDS
         IRM        = 1
         RETURN
      ENDIF

      RETURN
      END

