      SUBROUTINE PHYKON (YUPABS,IRM,YKONAM,CONST)
C**** PHYKON   -   VERMITTLUNG PHYSIKAL. KONSTANTEN U. FAKTOREN
C**   AUFRUF       CALL PHYKON (YUPNAM,IRM,YKONAM,CONST)
C**   EXTERNAL     LISTB
C**   ZWECK        EINHEITL. VERMITTLUNG PHYSIKAL. KONST. DES MKS-SYSTEM
C**   PARAMETER    YUPNAM  NAME DER RUFENDEN PROGRAMM-EINHEIT (CHAR.*6)
C**                IRM     0 = FEHLERFREI, 1 = FEHLER (GGF. NACHRICHT
C**                        AUF LFN: PROTOK/OUTPUT (S.UP PROTOP)
C**                YKONAM  NAMEN DER GEFRAGTEN KONSTANTEN (TYP.CHAR.)
C**                ------  ZUR VERFUEGUNG STEHEN:
C**                R       UNIVERSELLE GASKONST. (J/K/MOL)                   8.31432
C**                CPW     WAERMEKAPAZITAET WASSERDAMPF (J/KG/K),P=CONST  1858.36
C**                CPL     ................ TROCKENER LUFT..............  1004.82
C**                CW      ................ WASSER (J/KG/K)               4186.74
C**                EISWAS  GEFRIERPUNKT VON WASSER (K)                     273.15
C**                AVOGAD  AVOGADROSCHE ZAHL (MOL ** (-1))                   6.0225   E 23
C**                FMOLVO  MOLVOLUMEN IDEALER GASE (M**3/MOL)                2.2414   E -2
C**                FMOWAS  MOLEKULARGEWICHT V. WASSER (KG/MOL)              18.01534  E -3
C**                FMODRY  ................ TROCKENER LUFT.........         28.9644   E -3
C**                VLICHT  VAKUUM-LICHTGESCHWINDIGKEIT (M/S)                 2.99793  E  8
C**                DICHUS  LUFTDICHTE IN NN NACH U.S.STANDARD-               1.2250
C**                        ATMOSPHAERE,1976 (KG/M**3)
C**                AGRAUS  GRAVITATIONS-BESCHLEUNIGUNG NACH U.S.STANDARD     9.80665
C**                        ATMOSPHAERE,1976 FUER 45 G 32 M 22S
C**                        =45.5425 MIT UP /GRAVIT/ BERECHENBAR.
C**                GRAVIT  GRAVITATIONS-KONSTANTE (M**3/KG/S**2)             6.670    E-11
C**                TERRAD  MITTLERER ERDRADIUS (M)                        6370.       E  3
C**                GRADM   1 GRAD AM [QUATOR IN METER UMRECHNEN           111177.4734
C**                FINCH   METER/INCH        (M,''**(-1))                    2.54     E -2
C**                FUSS    METER/FUSS        (M,FUSS**(-1))                  0.3048
C**                FNMEIL  METER/NAUTISCHE SEEMEILE (M,NM**(-1))          1853.184
C**                VTGHOM  VERTIKALER TEMPERATURGRADIENT EINER               0.0341632
C**                        HOMOGENEN ATMOSPHAERE (K/M)
C**                VTGTAD  VERTIK.TEMP.-GRADIENT,TROCKENADIABATISCH(K/M)     0.00975961
C**                        (ZUR INFO.: FEUCHTADIAB.GRAD. S. FC /VTGFAD/)
C**                RDRY    GASKONSTANTE TROCKENER LUFT (J/KG/K)            287.053
C**                RVAP    GASKONSTANTE FUER WASSERDAMPF  (J/KG/K)         461.513
C**                LH      SPEZIFISCHE VERDAMPFUNGSWAERME (J/KG)              .250078 E  7
C**                        DES WASSERS BEI 0. GRAD CELSIUS
C**                C1EIS   (PSYCHRO-METER-TAFEL-KONSTANTE ZUR)  (HPA)        6.10714
C**                C2EIS   (SAETT.DAMPFDRUCKBERECHNUNG B. EIS)  (   )       22.4429
C**                C3EIS   (WERTEBEREICH(-50.9 =T= 0. CELS.)  (K  )        272.44
C**                C1WNEG  (.................................)  (HPA)        6.10780
C**                C2WNEG  (                         B.WASSER)  (   )       17.8436
C**                C3WNEG  (                                 )  (K  )      245.425
C**                C1WPOS  (WERTEBEREICH(0. T= 100.9 CELS. )  (HPA)          6.10780
C**                C2WPOS  (                         B.WASSER)  (   )       17.0809
C**                C3WPOS  (                                 )  (K  )      234.175
C**                LMELT   SCHMELZWAERME DES EISES (J/KG)                  335.       E  3
C**                LWPROK  LAT. VERDAMPFUNGS-WAERME PRO KELVIN (J/KG/K)      2.32573
C**                PMHPA   MITTLERER LUFTDRUCK IN MEERESHOEHE (HPA)       1013.25
C**                CALORI  MECHAN. WAERME-AEQUIVALENT (1/CAL)                4.18400
C**                CVL     SPEZ.WAERME TROCK. LUFT (V=CONST)(J/KG/K)       715.
C**                KAPPA   DRUCKSKALEN-EXPONENT DES STUEVE-PAPIERS            .285676
C**                        KAPPA = RDRY / CPL
C**                TRIPWA  TRIPELPUNKT DES WASSERS (KELVIN)                273.16
C**                BOGEN1  BOGENMASS FUER 1/360 VOLLKREIS-WINKEL             0.0174533
C**                ------
C**   AUSGABE      CONST   KONSTANTEN-WERT
C**   ZUR INFO.    HP /PHYLST/ AUS LIBRARY: RZ3LIB LISTET ALLE KONST.

C     VERFASSER    U.VOIGT
      EXTERNAL PHYBLK
#include "phycom.h"
#include "phycov.h"
#include "xyzprt.h"
       CHARACTER *6,YUPNAM,YUPABS,YZW*1,YKONAM*(*),YKON1
      DATA YUPNAM /'PHYKON'/
      CONST     = 0.
      IRM = 0
      YZW='I'
      YKON1 = YKONAM
      CALL LISTB (YKON1,YKNAML,LSTDEX,KONANZ,'YKONAM',IRM,YUPNAM)
      IF (IRM .NE. 0) THEN
         YZW='F'
      ELSE
         IF (LSTDEX .GT. KONST) THEN
         GO TO (1,2,3,4,5,6,7,8,9
     +        ),LSTDEX-KONST
C           AUS DEN COMMON-KONSTANTEN ZU BERECHNENDE FAKTOREN:
C           FUSS
1           CONST = FINCH * 12.
            GO TO 999
C           FNMEIL
2           CONST = FINCH * 72960.
            GO TO 999
C           VTGHOM = AGRAUS / RDRY
3           CONST = AGRAUS / (R/FMODRY)
            GO TO 999
C           RDRY
4           CONST = R/FMODRY
            GO TO 999
C           RVAP
5           CONST = R/FMOWAS
            GO TO 999
C           KAPPA
6           CONST = R / FMODRY / CPL
            GO TO 999
C           BOGEN1
7           CONST = ACOS(-1.)/180.
            GO TO 999
C           VTGTAD
8           CONST = AGRAUS / CPL
            GO TO 999
C           GRADM
9           CONST = 2.*ACOS(-1.)*TERRAD/360.
            GO TO 999
         ELSE
C           FERTIG VORLIEGENDE KONSTANTE AUS DEM COMMON VERMITTELN
            CONST = EQUPHY (LSTDEX)
         ENDIF
      ENDIF
999   IF ((NPR.GE.9) .OR. (IRM.NE.0)) THEN
         WRITE (YBOZEL,20000) YUPABS,IRM,LSTDEX,YKONAM,CONST
20000    FORMAT ('/',A6,' IRM=',I6.1,'  YKNAML(',I6.1,')=',A6,'=',G14.6)
         CALL HERMES (YUPNAM,IRM,YZW,UPSTYX)
      ENDIF
      RETURN
      END
