      SUBROUTINE PPD1_78 (IANZ,JXA,IBYTA,NWERT,IUNDEF,IWERT,JWERT,JBLE,
     +                    JXE,IBYTN,IRM)
C**** PPD1_78  -   UP ERZEUGT DEN LOKALEN TEIL DER PDS MIT IDC=78/79
C**   AUFRUF     : CALL PPD1_78 (IANZ,JXA,IBYTA,NWERT,IUNDEF,IWERT,JWERT,JBLE,
C**               +              JXE,IBYTN,IRM)
C**   ZWECK      : LOKALEN PDS-DATEN FUER IDC=78 NACH JWERT (JBLE) UMSPEICHERN,
C**                AUFRUF ERFOLGT AUS UP PUTPD1
C**   PARAMETER  : INPUT:    IANZ, JXA, IBYTA, NWERT, IUNDEF, IWERT,
C**                -------------------------------------------------
C**                IANZ      ANZAHL DER DATEN IN IWERT, DIE UMGESPEICHERT
C**                          WERDEN, BEGINN AB IWERT(37)
C**                JXA       ANFANGS-INDEX VON JWERT
C**                IBYTA     ANFANGS-BYTE VON JWERT
C**                NWERT     USER-DIMENSIONIERUNG VON IWERT   (NWERT=321)
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                IWERT     ENTHAELT ALLE ZUM AUFBAU DER PDS BENOETIGTEN WERTE,
C**                          D.H., 47/54 BIS MAX. 321 WORTE,
C**                          LOKALER NUTZUNGS-BEREICH FUER IDC=78:
C**                   ----------------------------------------------------------
C**                   INDEX: BYTE:         INHALT:
C**                   ..........................................................
C**                   (37)  41              LOKALE DWD-KENNUNG FUER WEITEREN
C**                                         DATENVERLAUF; 
C**                                         = 254
C**                                         NEU AB SEPTEMBER '05:
C**                                         = 253, ab BYTE 55 FOLGEN 7 DATEN
C**                                                FUER ENSEMBLE-VORHERSAGEN
C**                   (38)  42              TAGESNUMMER DES MRZ-BACKUP-FILES
C**                   (39)  43 -45          RECORDNUMMER DES MRZ-BACKUP-FILES
C**                   (40)  46              ENTSCHLUESSELN AUF MFA(=1)/MFB(=0)
C**                   (41)  47              ZUSATZ-ELEMENTNUMMER
C**                   (42)  48              JAHR (OHNE JAHRHUNDERT)
C**                   (43)  49              MONAT
C**                   (44)  50              TAG
C**                   (45)  51              STUNDE
C**                   (46)  52              MINUTE
C**                   (47)  53 -54          IVSN
C**                   ..........................................................
C**                                         NEU AB SEPTEMBER '05:
C**                   (48)  55              USER-IDENTIFICATION
C**                   (49)  56 -57          EXPERIMENT IDENTIFIER
C**                   (50)  58 -59          ENSEMBLE IDENTIFICATION
C**                   (51)  60 -61          NUMBER OF ENSEMBLE MEMBERS
C**                   (52)  62 -63          ACTUAL NUMBER OF ENSEMBLE NUMBER
C**                   (53)  64              MODEL MAJOR VERSION NUMBER         
C**                   (54)  65              MODEL MINOR VERSION NUMBER         
C**                   (--)  66              BLANK (GERADZAHLIGE BLOCKLAENGE !) 
C**
C**                -------------------------------------------------------------
C**                OUTPUT:   JWERT, JBLE, JXE, IBYTN, IRM
C**                --------------------------------------
C**
C**                JWERT     UMGESPEICHERTE DATEN AUS IWERT
C**                JBLE      BYTELAENGEN FUER DIE DATEN IN JWERT
C**                JXE       END-INDEX VON JWERT
C**                IBYTN     END-BYTE+1, DER ABGESPEICHERTEN DATEN (JWERT,JBLE)
C**                IRM       FEHLER-RUECKMELDEZELLE,
C**                          FEHLER, WENN IRM UNGLEICH NULL
C**
C**   VERFASSER:   A. ZALEWSKY, FEBRUAR 1995
C*    GEAENDERT:   B.Loeser,    TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni,   SGI,  09/00, Einfuehrung "machconsts.h"
C*    GEAENDERT:   A.Zalewsky,  TI14, 09/05, ENSEMBLE-VORHERSAGEN
C*                                           MIT IWERT(37)=253
C*                                           UND IANZ     = 54

      IMPLICIT NONE

      INTEGER IANZ, JXA, IBYTA, NWERT, IUNDEF, IWERT, JWERT, JBLE, JXE
      INTEGER IBYTN, IRM
      INTEGER IDWD, MWERT, ILOC, IBALL, IBLA1, JX, IBYTP, J, JJ, IWZW
      INTEGER IBLL
      INTEGER I253, IBL253

#include "machconsts.h"

      PARAMETER (IDWD=47,MWERT=321,ILOC=11)
      PARAMETER (I253=7)

      DIMENSION IWERT(*), JWERT(MWERT), IBALL(4),
     +          IBLA1(ILOC), JBLE(MWERT)
      DIMENSION IBL253(I253)

      DATA IBALL  / Z'FF'        ,
     +              Z'FFFF'      ,
     +              Z'FFFFFF'    ,
     +              Z'FFFFFFFF'  /

C.....IBTA1 ENTHAELT ANFANGSBYTES DER PDS AB IWERT(37)
C....+          IBTA1(ILOC)

C     INDEX:....    37 38 39 40 41 42 43 44 45 46 47
C.... DATA IBTA1  / 41,42,43,46,47,48,49,50,51,52,53/

C.....IBLA1 ENTHAELT DIE BYTE-LAENGEN AB IWERT(37)
C     INDEX:....    37 38 39 40 41 42 43 44 45 46 47
      DATA IBLA1  /  1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 2/
C     INDEX:....    48 49 50 51 52 53 54
      DATA IBL253 /  1, 2, 2, 2, 2, 1, 1 /

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLE UMGESPEICHERT...............
C.....JX WIRD ALS INDEX FUER JWERT/JBLE HOCHGERECHNET..........................

      IF (IANZ .NE. IDWD)                   THEN
C......NEU AB SEPTEMBER '05:
C......ENSEMBLE-VORHERSAGEN, I253 = 7 
       IF (IWERT(37) .EQ. 253)              THEN
        IWZW     = IDWD+I253
        IF (IWZW .NE. IANZ)                 THEN
         PRINT '('' PPD1_78: FEHLER,'',
     +           '' IANZ#IDWD+I253;'',
     +           '' IANZ,IDWD+I253='',2I4)',
     +              IANZ,IWZW
         IRM     = 1
         RETURN
        ENDIF
       ELSE
         PRINT '('' PPD1_78: FEHLER,'',
     +           '' IANZ#IDWD;'',
     +           '' IANZ,IDWD='',2I4)',
     +              IANZ,IDWD
         IRM     = 1
         RETURN
       ENDIF
      ENDIF

      IF (MWERT .LT. NWERT)                 THEN
         PRINT '('' PPD1_78: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
      JX         = JXA
      IBYTP      = IBYTA

C.....IDWD       = 47
      DO  81  J  = 37, IDWD
      JX         = JX + 1
      JJ         = J - 36
      IWZW       = IWERT(J)
      IBLL       = IBLA1(JJ)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE (JX)  = IBLL
      IBYTP      = IBYTP + IBLL
   81 CONTINUE
      JXE        = JX
      IBYTN      = IBYTP

      IF (IWERT(37) .EQ. 253)               THEN
C......NEU AB SEPTEMBER '05;
C......ENSEMBLE-VORHERSAGEN, I253 = 7 
       DO  82  J = IDWD+1, IDWD+I253
       JX        = JX + 1
       JJ        = J - IDWD
       IWZW      = IWERT(J)
       IBLL      = IBL253(JJ)
       IF (IWZW .EQ. IUNDEF)                THEN
          IWZW   = IBALL(IBLL)
       ENDIF
       JWERT(JX) = IWZW
       JBLE (JX) = IBLL
       IBYTP     = IBYTP + IBLL
   82  CONTINUE
       JXE       = JX
       IBYTN     = IBYTP
      ENDIF

      RETURN
      END
