      SUBROUTINE PPD1_98 (IANZ,JXA,IBYTA,NWERT,IUNDEF,IWERT,JWERT,JBLE,
     +                    JXE,IBYTN,IRM)
C**** PPD1_98  -   UP ERZEUGT DEN LOKALEN TEIL DER PDS FUER IDC=98
C**   AUFRUF     : CALL PPD1_98 (IANZ,JXA,IBYTA,NWERT,IUNDEF,IWERT,JWERT,JBLE,
C**               +              JXE,IBYTN,IRM)
C**   ZWECK      : LOKALE PDS-DATEN FUER IDC=98 NACH JWERT (JBLE) UMSPEICHERN,
C**                AUFRUF ERFOLGT AUS UP PUTPD1
C**   PARAMETER  : INPUT:    IANZ, JXA, IBYTA, NWERT, IUNDEF, IWERT,
C**                -------------------------------------------------
C**                IANZ      ANZAHL DER DATEN IN IWERT, DIE UMGESPEICHERT
C**                          WERDEN, BEGINN AB IWERT(37)
C**                JXA       ANFANGS-INDEX VON JWERT
C**                IBYTA     ANFANGS-BYTE VON JWERT
C**                NWERT     USER-DIMENSIONIERUNG VON IWERT   (NWERT=321)
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                IWERT     ENTHAELT ALLE ZUM AUFBAU DER PDS BENOETIGTEN WERTE,
C**                          D.H., 45 BIS MAX. 321 WORTE
C**                   INDEX: BYTE:         INHALT:
C**                   ----------------------------------------------------------
C**                          LOKALER NUTZUNGS-BEREICH FUER IDC=98:
C**                          (EZMW-VERSION IM DWD-FORMAT)
C**                   ----------------------------------------------------------
C**                   (37)  41              LOKALE DWD-KENNUNG FUER WEITEREN
C**                                         DATENVERLAUF, ZUM BEISP.: IWERT(37)
C**                                         = 254, WENN EZMW-ENSEMBLE-DATEN AB
C**                                         BYTE 55 FOLGEN (SIEHE UNTEN)
C**                   (38)  42              TAGESNUMMER DES MRZ-BACKUP-FILES
C**                   (39)  43 -45          RECORDNUMMER DES MRZ-BACKUP-FILES
C**                   (40)  46              ENTSCHLUESSELN AUF MFA(=1)/MFB(=0)
C**                   (41)  47              ZUSATZ-ELEMENTNUMMER
C**                   (42)  48              JAHR
C**                   (43)  49              MONAT
C**                   (44)  50              TAG
C**                   (45)  51              STUNDE
C**                   (46)  52              MINUTE
C**                   (47)  53 -54          VERSIONSNUMMER
C**                   (48)  55      LDEFNR   LOKALE DEFINITIONSNUMMER,
C**                                          LDEFNR=1 oder 2 oder 5
C**                   (49)  56      IKLASS   1 = OPERATIONELL
C**                                          2  =FORSCHUNG
C**                   (50)  57      ITYPE    1 = FIRST GUESS
C**                                          2 = ANALYSIS
C**                                          3 = INIT.ANALYSE
C**                                          9 = VORHERSAGE
C**                                         10 = KONTROLLVORHERSAGE
C**                                         11 = GESTOERTE VORHERSAGE
C**                                         14 = CLUSTER MEAN
C**                                         15 = CLUSTER STANDARD DEVIATION
C**                   (51)  58-59   ISTREAM 1025 = TAEGL. ARCH.
C**                                         1035 = ENSEMBLE-VORHERSAGE
C**                   (52)  60-63   IEXPVS  VERSIONSNUMMER ODER EXPERIMENT-
C**                                         IDENTIFIKATION
C**
C**                   ENTWEDER :            ( LDEFNR = 1 )......................
C**                   ====================================
C**                   (53)  64      INUMB   0 -> KONTROLLVORHERSAGE ODER
C**                                              KEINE ENSEMBLE-VORHERSAGE
C**                                         N -> NUMMER DER GESTOERT.VOHERSAGE
C**                   (54)  65      ITOT    N -> GES.ZAHL DER VORHERSAGEN IM
C**                                              ENSEMBLE, INCL.KONTROLLVORHERS.
C**                                         0 -> KEINE ENSEMBLE-VORHERSAGE
C**                   (55)  66      IRESV   RESERVIERT ( = 0 )
C**                                 ENDE      -> RETURN
C**
C**                   ODER :                ( LDEFNR = 2 )......................
C**                   ====================================
C**                   (53)  64      INUMB   N -> CLUSTER-NUMMER
C**                   (54)  65      ITOT    N -> GESAMTZAHL DER CLUSTER
C**                   (55)  66      IRESV   RESERVIERT ( = 0 )
C**                   ----------------------------------------------------------
C**                   (56)  67      IMETH   METHODE ZUM BILDEN DER CLUSTER,
C**                                         1 = MAXIMUM LINKAGE
C**                                         2 = MIXED
C**                                         3 = SMALL LINKAGE
C**                   (57)  68-69   IATMCL  ANFANGSZEITSCHRITT UM CLUSTER ZU
C**                                         BILDEN ( TAB. 4, WIE IUTIME)
C**                   (58)  70-71   IETMCL  ENDZEITSCHRITT UM CLUSTER ZU BILDEN
C**                                         ( TAB. 4, WIE IUTIME)
C**            *      (59)  72-74   INOBR   NOERDLICHE BREITE ) DES GEBIETES IN
C**            *      (60)  75-77   IWELA   WESTLICHE LAENGE  ) DEM CLUSTER
C**            *      (61)  79-80   ISUBR   SUEDLICHE BREITE  ) GEBILDET WERDEN
C**            *      (62)  81-83   IOELA   OESTLICHE LAENGE  ) IN MILLIGRAD
C**                   (63)  84      INOPCL  NUMMER DES CLUSTERS ZU DEM DIE OPE-
C**                                         RATIONELLE VORHERSAGE GEHOERT
C**                   (64)  85      INKOCL  NUMMER DES CLUSTERS ZU DEM DIE KON-
C**                                         TROLLVORHERSAGE GEHOERT
C**                   (65)  86      INVORH  ANZAHL VORHERSAGEN, DIE ZUM CLUSTER
C**                                         GEHOEREN
C**                   ----------------------------------------------------------
C**                   (66)  87      IN001 ) LISTE VON INVORH -NUMMERN (JEWEILS
C**                     .    .         .  ) 1 BYTE) DER ENSEMBLE-VORHERSAGEN
C**                     .    .         .  ) IM CLUSTER; DIE KONTROLLVORHERSAGE
C**                  (321) 342      IN255 ) ERHAELT DIE NUMMER 0, EBENSO DIE UN-
C**                                         BENUTZTEN BYTES AM ENDE DER LISTE
C**
C**                   ODER :                ( LDEFNR = 5 )......................
C**                   ====================================
C**                   (53)  50/64   INUMB   N -> CLUSTER-NUMMER
C**                   (54)  51/65   ITOT    N -> GESAMTZAHL DER CLUSTER
C**            *      (55)  52/66   ITUSF   THRESHOLD UNITS DECIMAL SCALE FACTOR
C**                                         NEGATIV, OBERSTES BIT = 1 SETZEN
C**                   (56)  53/67   ITHID   THRESHOLD INDICATOR
C**                                         1 = LOWER THRESHOLD ONLY
C**                                         2 = UPPER THRESHOLD ONLY
C**                                         3 = LOWER AND UPPER THRESHOLD
C**                         54-55/
C**                   (57)  68-69   ILWTH   LOWER THRESHOLD
C**                         56-57/
C**                   (58)  70-71   IUPTH   UPPER THRESHOLD
C**                   (59)  58/72   IRESV   = 0, RESERVIERT
C**
C**                -------------------------------------------------------------
C**                OUTPUT:   JWERT, JBLE, JXE, IBYTN, IRM
C**                --------------------------------------
C**
C**                JWERT     UMGESPEICHERTE DATEN AUS IWERT
C**                JBLE      BYTELAENGEN FUER DIE DATEN IN JWERT
C**                JXE       END-INDEX VON JWERT
C**                IBYTN     END-BYTE+1, DER ABGESPEICHERTEN DATEN (JWERT,JBLE)
C**                IRM       FEHLER-RUECKMELDEZELLE,
C**                          FEHLER, WENN IRM UNGLEICH NULL
C**
C**   * HINWEIS:   BEI NEGATIVEM DATENWERT WIRD DAS OBERSTE BIT = 1 GESETZT UND
C**                DER DATENWERT POSITIV ABGESPEICHERT.
C**                (DIES GILT FUER PARAMETER MIT * IN SPALTE 16)
C**
C**   VERFASSER:   A. ZALEWSKY, FEBRUAR 1995
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, OR -> IOR, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IANZ, JXA, IBYTA, NWERT, IUNDEF, IWERT, JWERT, JBLE, JXE
      INTEGER IBYTN, IRM
      INTEGER ILOC, IDWD, IEZM1, IEZM2, IEZM5, MWERT, IBALL, IBLA1
      INTEGER MSKLALO, MSKSF, JX, IBYTP, J, JJ, IWZW, IBLL, JANZ, LDEFNR
      INTEGER IANA, IANE, IBYTL, IGRADE

#include "machconsts.h"

      PARAMETER (ILOC=29,IDWD=47,IEZM1=55,IEZM2=65,IEZM5=59,MWERT=321)

      DIMENSION IWERT(*), JWERT(MWERT), IBALL(4),
     +          IBLA1(ILOC), JBLE(MWERT)

      DATA IBALL / Z'FF'        ,
     +             Z'FFFF'      ,
     +             Z'FFFFFF'    ,
     +             Z'FFFFFFFF'  /

C.....IBLA1 ENTHAELT DIE BYTE-LAENGEN AB DIE IWERT(37)
C     INDEX:....   37 38 39 40 41 42 43 44 45 46 47
      DATA IBLA1 /  1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 2,
C     INDEX:....   48 49 50 51 52 53 54 55 56 57
     2              1, 1, 1, 2, 4, 1, 1, 1, 1, 2,
C     INDEX:....   58 59 60 61 62 63 64 65
     3              2, 3, 3, 3, 3, 1, 1, 1/

      DATA MSKLALO  /Z'800000'/
      DATA MSKSF    /Z'80'/

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLE UMGESPEICHERT...............
C.....JX WIRD ALS INDEX FUER JWERT/JBLE HOCHGERECHNET..........................

      IF (IANZ .GT. MWERT)                  THEN
         PRINT '('' PPD1_98: FEHLER, IANZ>MWERT; IANZ, MWERT='',2I4)',
     +                                           IANZ, MWERT
         IRM     = 1
         RETURN
      ENDIF

      IF (MWERT .LT. NWERT)                 THEN
         PRINT '('' PPD1_98: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IF (IWERT(37) .NE. 254)               THEN
         PRINT '('' PPD1_98: FEHLER, IWERT(37)='',I5,
     +           '' - IST NICHT ZUGELASSEN'')', IWERT(37)
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
      JX         = JXA
      IBYTP      = IBYTA

C.....IDWD       = 47
      DO  81  J  = 37, IDWD
      JX         = JX + 1
      JJ         = J - 36
      IWZW       = IWERT(J)
      IBLL       = IBLA1(JJ)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE (JX)  = IBLL
      IBYTP      = IBYTP + IBLL
   81 CONTINUE
      JANZ       = IDWD
      IF (JANZ .EQ. IANZ)                   GOTO 800

      LDEFNR     = IWERT(48)
CT    PRINT '('' PPD1_98 : LDEFNR, JX='',2I7)', LDEFNR, JX
      IF (LDEFNR.NE.1                       .AND.
     +    LDEFNR.NE.2 .AND. LDEFNR.NE.5)    GOTO 800

C.....WERTE VON IPDB(48) BIS IPDB(55) BZW. IPDB(65)
      DO  90 J   = IDWD+1, IEZM1
      JX         = JX + 1
      JJ         = J - 36
      IWZW       = IWERT(J)
      IBLL       = IBLA1(JJ)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE (JX)  = IBLL
      IBYTP      = IBYTP + IBLL
   90 CONTINUE

C.....LDEFNR     = 1
      JANZ       = IEZM1
      IF (LDEFNR .EQ. 1)                    GOTO 800

C.....LDEFNR     = 5; IWERT(55)=LETZTER SCHLEIFEN-WERT, AUF NEGATIV-WERT ABFRAGEN
      IF (LDEFNR .EQ. 5)                    THEN
         IWZW    = JWERT(JX)
         IF (IWZW .NE. IBALL(IBLL))         THEN
            IF (IWZW .LT. 0)                THEN
               IWZW       = -IWZW
               IWZW       = IOR(IWZW,MSKSF)
               JWERT(JX)  = IWZW
            ENDIF
         ENDIF
      ENDIF

C.....WEITER MIT LDEFNR=2/5 UND IWERT(56)

      DO 100 J   = IEZM1+1, 58
      JX         = JX + 1
      JJ         = J - 36
      IWZW       = IWERT(J)
      IBLL       = IBLA1(JJ)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE (JX)  = IBLL
      IBYTP      = IBYTP + IBLL
  100 CONTINUE

C.....LDEFNR     = 5, LETZTER DATENWERT = IWERT(59); JANZ = IEZM5
      IF (LDEFNR .EQ. 5)                    THEN
         JX      = JX + 1
         IWZW    = IWERT(59)
         IBLL    = 1
         IF (IWZW .EQ. IUNDEF)              THEN
            IWZW = IBALL(IBLL)
         ENDIF
         JWERT(JX)  = IWZW
         JBLE (JX)  = IBLL
         IBYTP      = IBYTP + IBLL
         JANZ       = IEZM5
         GOTO 800
      ENDIF

C.....WEITER MIT LDEFNR = 2  UND IWERT(59)
C     BEI GEOGR. ANGABEN MIT NEG. WERT (WEST/SUED) WIRD DAS OBERSTE
C.....VON 3 BYTES GESETZT
      DO 110 J   = 59, 62
      JX         = JX + 1
      JJ         = J - 36
      IBLL       = IBLA1(JJ)
      IWZW       = IWERT(J)
      IF (IWZW .LT. 0)                      THEN
         IF (IWZW .EQ. IBALL(IBLL))         THEN
         ELSE IF (IWZW .EQ. IUNDEF)         THEN
            IWZW = IBALL(IBLL)
         ELSE
            IWZW = -IWZW
            IWZW = IOR(IWZW,MSKLALO)
         ENDIF
      ENDIF
      JWERT(JX)  = IWZW
      JBLE (JX)  = IBLL
      IBYTP      = IBYTP + IBLL
  110 CONTINUE

      DO 120 J   = 63, IEZM2
      JX         = JX + 1
      JJ         = J - 36
      IWZW       = IWERT(J)
      IBLL       = IBLA1(JJ)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE (JX)  = IBLL
      IBYTP      = IBYTP + IBLL
  120 CONTINUE
      JANZ       = IEZM2
      IF (JANZ .EQ. IANZ)                   GOTO 800

C.....IWERT(65)  = 0    ???,                --> KEINE CLUSTER-VORHERSAGEN
      IF (IWERT(65) .EQ. 0)                 GOTO 800

      IANA       = IEZM2 + 1
      IANE       = IWERT(65) + IEZM2
CT    PRINT '('' PPD1_98 : IANA,IANE='',2I4)',IANA,IANE
      IF (IANE .GT. IANZ)                   THEN
         PRINT '('' PPD1_98: FEHLER, IANE # IANZ;'',
     +           '' IANE, IANZ='',2I5)', IANE, IANZ
         IRM     = 1
         RETURN
      ENDIF

      DO 130 J   = IANA, IANE
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = 1
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLE (JX)  = IBLL
      IBYTP      = IBYTP + IBLL
  130 CONTINUE

C.....GRADE BYTE-ANZAHL IN DER PDS ?
      IBYTL      = IBYTP - 1
      IGRADE     = 0
      IGRADE     = MOD(IBYTL,2)
      IF (IGRADE .NE. 0)                    THEN
         JX      = JX + 1
         JWERT(JX)  = 0
         JBLE (JX)  = 1
         IBYTP   = IBYTP + 1
      ENDIF

  800 CONTINUE
      JXE        = JX
      IBYTN      = IBYTP

      RETURN
      END


