      SUBROUTINE   PUTBD1 (IEDNR, IBYTA, NBLOCK, NWERT, NDSUP, IWERT,
     +                     DSUP, IBLOCK, IANZ, IRM)
C**** PUTBD1   -   BINARY-DATA-SECTION (BDS, GRIB-CODE) AUFBAUEN
C**   AUFRUF     : CALL PUTBD1 (IEDNR,IBYTA,NBLOCK,NWERT,NDSUP,IWERT,
C**               +             DSUP,IBLOCK,IANZ,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DIE IN IWERT UBERGEBENEN KENNDATEN WERDEN FUER DIE BINARY-
C**                DATA-SECTION NACH IBLOCK GESPEICHERT
C**                (GITTERPUNKTE: SP, 2.OP; SPHER.HARM.COEF: SP, CP;
C**                SP=SIMPLE PACKING, 2.OP=2.ORDER-PACKING, CP=COMPLEX PACKING)
C**
C**   PARAMETER  : INPUT:    IEDNR,IBYTA,NBLOCK,NWERT,NDSUP ,IWERT,IANZ
C**                ----------------------------------------------------
C**                IEDNR     EDITIONS-NUMMER, IEDNR=1 AB 11/94
C**                IBYTA     ANFANGSADRESSE DER BDS IM FELD IBLOCK,
C**                          IN BYTES BERECHNET.
C**                NBLOCK    USER-DIMENSIONIERUNG VON IBLOCK
C**                NWERT     USER-DIMENSIONIERUNG VON IWERT
C**                NDSUP     USER-DIMENSIONIERUNG VON DSUP
C**                IANZ      ANZAHL DER ERSTEN 11 EXTR. DATENWERTE AUS DER BDS
C**                IWERT     MAX. 500 INTEGER-WERTE KENNDATEN FUER DIE BDS, UND
C**                          (IWERT(11))-UNGEPACKTE DATEN BEI COMPLEX PACKING
C**
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                    1     1 - 3  LBD1    LAENGE DER BDS IN BYTES, MUSS VORHER
C**                                         MIT FPACK1 ERMITTELT WERDEN
C**                    2     4      FLAG    ART DER DATEN UND PACKEN (BIT: 1-4)
C**                                         BIT 1: 0 -> GITTERPKTE.
C**                                              : 1 -> SPH. HARM. KOEFFIZIENTEN
C**                                         BIT 2: 0 -> SIMPLE PACKING
C**                                              : 1 -> COMPLEX PACKING ODER
C**                                                     PACKEN 2.ORDNUNG
C**                                         BIT 3: 0 -> FLOAT.POINT-DATEN
C**                                              : 1 -> INTEGER-DATEN
C**                                         BIT 4: 0 -> KEINE WEITERE FLAG AB
C**                                                     BYTE 14
C**                                              : 1 -> WEITERE FLAG AB BYTE 14
C**                               + NUNUSB  UNBEN. BITS AM BLOCKENDE  (BIT: 5-8)
C**                                         (MAX. 15 UNBEN. BITS, WIRD IN FPACK1
C**                                          ERMITTELT)
C**                    3     5 - 6  ISCAL   SCALE-FAKTOR, BEI '-'WERT: OBERST.
C**                                         BIT SETZEN UND '+'WERT ABSPEICHERN;
C**                                         IST ISCAL UNDEFINIERT, D.H. ALLE
C**                                         BITS SIND GESETZT, -> IRM = 15 UND
C**                                                               RETURN
C**                 *  R1    7 -10  REFMIN  REFERENZWERT, MINIMUM DER GEP.DATEN,
C**                                         WIRD MIT DER FUNCTION IREFTS(REFMIN)
C**                                         UMGESETZT
C**                    5    11      NRBIT   BIT-ANZAHL PRO GEPACKTEM DATEN-WERT
C**
C**                   ----------------------------------------------------------
C**                   GITTERPUNKTDATEN, SP:
C**                   ---------------------
C**                    6 )
C**                    : )   -              UNBENUTZT
C**                   11 )
C**                    -    12..LBD1        'GEPACKTE' DATEN
C**
C**                   ----------------------------------------------------------
C**                   SPHERICAL HARMONIC COEFFICIENTS, SP:
C**                   ------------------------------------
C**                 * R2    12 -15  RPCOE   REAL PART VOM (0.0) KOEFFIZIENTEN,
C**                                         WIRD MIT DER FUNCTION IREFTS(RPCOE)
C**                                         UMGESETZT
C**                    6 )
C**                    : )   -              UNBENUTZT
C**                   11 )
C**                    -    16..LBD1        'GEPACKTE' DATEN
C**
C**                   ----------------------------------------------------------
C**                   GITTERPUNKTDATEN, 2.OP:
C**                   -----------------------
C**                    6    12 -13  N1      BYTE-ADRESSE AN DER 1.ORDNUNG-GEP.
C**                                         DATEN BEGINNEN
C**                    7    14      IFLGE   ERWEITERTE FLAG (CODE TABLE 11)
C**                    8    15 -16  N2      BYTE-ADRESSE AN DER 2.ORDNUNG-GEP.
C**                                         DATEN BEGINNEN
C**                    9    17 -18  P1      ANZAHL DER 1.ORDNUNG-GEP. DATEN
C**                   10    19 -20  P2      ANZAHL DER 2.ORDNUNG-GEP. DATEN
C**                   11    21      IRESV   RESERVIERT
C**                   -----------------------------------------------
C**                   FOLGENDE DATEN SIND NOCH NICHT DEFINIERT
C**                   -----------------------------------------------
C**                   12    22    )         1 WEITE ODER P1-WEITEN (JE 1 BYTE)
C**                    :     :    ) NWBIT   VON 2.ORDNUNG-GEP. DATEN IN BITS;
C**                   nn    xx-1  )         nn = 11 + P1, xx = 22 + P1
C**                                         ??? MAX.ANZAHL FUER NWBIT ???
C**                                         (16BIT -> MAX.65534 WERTE MOEGLICH!)
C**                   nn+1  xx     )        2. BITMAP; P2-BITS LANG; AUFGEFUELLT
C**                    :     :     ) I2BMP  MIT BINAEREN NULLEN ZUM GANZEN BYTE;
C**                   mm    yy     )        yy = xx + (P2-1)/IBYTE, mm = N1 - xx
C**
C**                   mm+1  N1    )         P1 1.ORDNUNG GEP. DATEN; AUFGEFUELLT
C**                    :     :    )         MIT BINAEREN NULLEN ZUM GANZEN BYTE
C**                   mm+P1 N2-1  )
C**
C**                    -    N2..LBD1        P2 * 2.ORDNUNG 'GEPACKTE' DATEN
C**
C**                   ----------------------------------------------------------
C**                   SPH.HARMONIC COEFF., CP:
C**                   ------------------------
C**                    6    12 -13  N       BYTE-ADRESSE, AN DER GEPACKTE DATEN
C**                                         BEGINNEN;     N = (IUDZ*4) + 19
C**                    7    14 -15  IP      SCALE FACTOR, BEI '-'WERT: OBERST.
C**                                         BIT SETZEN UND '+'WERT ABSPEICHERN,
C**                                         IST IP UNDEFINIERT, D.H. ALLE
C**                                         BITS SIND GESETZT, -> IRM = 17 UND
C**                                                               RETURN;
C**                                         IP = INT(1000 * P)
C**                    8    16      J     )
C**                    9    17      K     ) PENTAGONAL RESOLUTION PARAMETERS
C**                   10    18      M     )
C**                   11     -      IUDZ    ANZAHL DER 'UNGEPACKTEN' DATEN
C**                  (R2    19    )         'UNGEPACKTE' DATEN (a 4 BYTES),
C**                 *( :     :    ) IUD     WERDEN MIT FUNCTION IREFTS(DSUP )
C**                  (IUDZ+1 N-1  )         UMGESETZT, IUDZ=(N-19)/4,
C**                    -    N..LBD1         'GEPACKTE' DATEN
C**
C**                DSUP                     REAL-DATENWERTE
C**                INDEX   : BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                    1     7 -10  REFMIN  SIEHE UNTER R1
C**                        ENTWEDER
C**                    2    12 -15  RPCOE   REAL PART VOM (0.0) KOEFFIZIENTEN,
C**                                         (SIEHE R2, SPHER.HARM.COEFF., SP)
C**                        ODER
C**                    2        19)
C**                    :         :) UD      UNGEPACKTE DATEN
C**                    IUDZ+1  N-1)         (SIEHE R2, SPHER.HARM.COEFF., CP)
C**
C**                -------------------------------------------------------------
C**                OUTPUT:   IBLOCK, IRM
C**                ---------------------
C**                IBLOCK    FELD IM GRIB-CODE
C**                IRM       FEHLER-RUECKMELDEZELLE
C**                          FEHLER, WENN IRM UNGLEICH NULL
C**
C**   HINWEIS: DIE MIT * GEKENNZEICHNETEN DATEN WERDEN ALS REAL-DATEN UNTER DEM
C**            ARRAY DSUP  AN DAS UP UEBERGEBEN,
C**            SIE WERDEN IM UP MIT DER FUNCTION IREFTS UMGESETZT
C**
C**   VERFASSER:   A.ZALEWSKY, TE23C, OKTOBER 1994
C**                            (modif: iscal=-1, 30.04.1997, zal.)
C     GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IEDNR, IBYTA, NBLOCK, NWERT, NDSUP, IWERT, IBLOCK, IANZ
      INTEGER IRM
      INTEGER MXWERT, MXDAT, JWERT, JBLE, IL000, IL064, IL192, MSK4F
      INTEGER MSKSF, M8001, MFLAG, MSK_128, MSKC128, MSK__64, MSK_C64
      INTEGER MSK__32, MSK_C32, MSK__16, MSK_C16, IAW, IEW, JXWERT, IZW
      INTEGER IFLAG, IPACK, IVALU, IFLGE, IZWZ, J, IWZW, IREFTS, JANZ
      INTEGER JJ, IMATR, I2BMP, IWDTH, IAZ1P, IAZ2P, IP2, ILBMP, NRBIT
      INTEGER IBLL, IP1, JA, IUDZ, IBLA, IANF

      REAL    DSUP

#include "machconsts.h"

      PARAMETER (MXWERT=500,MXDAT=73)

      DIMENSION    IWERT(*), DSUP (*), IBLOCK(*), JWERT(MXWERT+MXDAT),
     +             JBLE(MXWERT+MXDAT)
      DIMENSION    IL000(6), IL064(6), IL192(5)

C.....LAENGEN DER EINZELWERTE IN BYTES FUER JEDE PACKUNGSART
C.....GITTERPUNKTWERTE, SP: ILOOO(1..5)
C.....SECTION-AUFBAU BEI SP.HARM COEF., SP: IL000(1..6)
      DATA IL000   / 3, 1, 2, 4, 1, 4/

C.....GITTERPUNKTWERTE,2.OP
      DATA IL064                  / 2, 1, 2, 2, 2, 1/
C.....SECTION-AUFBAU BEI SP.HARM COEF., CP
      DATA IL192                  / 2, 2, 1, 1, 1/

      DATA MSK4F    /Z'FFFF'/
      DATA MSKSF    /Z'8000'/
      DATA M8001    /Z'8001'/
      DATA MFLAG    /Z'C0' /
      DATA MSK_128  /Z'80' /
      DATA MSKC128  /Z'7F' /
      DATA MSK__64  /Z'40' /
      DATA MSK_C64  /Z'3F' /
      DATA MSK__32  /Z'20' /
      DATA MSK_C32  /Z'1F' /
      DATA MSK__16  /Z'10' /
      DATA MSK_C16  /Z'0F' /

      IRM        = 0
      IAW        = 0
      IEW        = 0

C.....DIMENSIONIERUNG UEBER PARAMETER, MXWERT AUSREICHEND
      JXWERT     = IANZ
      IF (IANZ  .GT. MXWERT)                THEN
         PRINT '('' PUTBD1: IANZ='',I5,'', VOM UP WERDEN MAX.'',I4,
     +           '' WERTE NACH IBLOCK GESPEICHERT !'')',NWERT,MXWERT
         PRINT '(///,'' !!! - BITTE TE23C BENACHRICHTIGEN, WENN MEHR'',
     +               '' DATEN NACH IBLOCK GESPEICHERT WERDEN MUESSEN'')'
         JXWERT  = MXWERT
      ENDIF


C.....ABFRAGE:  IF  (IAND(MSK_128,IZW) .EQ. MSK_128)
C.....REST:  IZW = IAND (MSKC128, IZW)
      IZW        = IWERT(2)
      IFLAG      = IAND (MSK_128, IZW)
      IZW        = IAND (MSKC128, IZW)
      IPACK      = IAND (MSK__64, IZW)
      IZW        = IAND (MSK_C64, IZW)
      IVALU      = IAND (MSK__32, IZW)
      IZW        = IAND (MSK_C32, IZW)
      IFLGE      = IAND (MSK__16, IZW)

C.....DIE ERSTEN 5 DATENWERTE SIND GLEICH FUER ALLE PACKUNGSARTEN...............
C.....ISCAL AUF UNDEFINIERT ABFRAGEN,
C.....VORHER ISCAL=-1 ABFRAGEN, WEGEN -1-DARSTELLUNG AUF MFC/MFD (ALLE BITS=1 !)
      IZWZ       = IWERT(3)
      IF (IZWZ .EQ. -1)                     THEN
         IZWZ    = M8001
      ELSE IF (IAND(IZWZ,MSK4F) .EQ. MSK4F)  THEN
         PRINT '('' PUTBD1: FEHLER, ISCAL='',Z17,
     +           '', IRM=15 UND RETURN'')', IWERT(3)
         IRM     = 15
         RETURN
      ENDIF
      DO 10    J = 1, 2
      JBLE(J)    = IL000(J)
   10 JWERT(J)   = IWERT(J)
C.....BEI NEGATIVEM SKALIERUNGSFAKTOR WIRD DAS OBERSTE BIT DER
C.....2 BYTES GESETZT UND DER WERT POSITIV GESPEICHERT.
      JWERT(3)   = IZWZ
      JBLE(3)    = IL000(3)
      IWZW       = IZWZ
      IF (IWZW .LT. -1)                     THEN
         IWZW    = -IWZW
         JWERT(3)=  IOR(IWZW, MSKSF)
      ENDIF
C.....REFMIN AUS DSUP (1) MIT IREFTS UMSETZEN
      J          = 4
      JBLE(J)    = IL000(J)
      IWZW       = IREFTS(DSUP (1))
      JWERT(J)   = IWZW
      J          = 5
      JBLE(J)    = IL000(J)
      JWERT(J)   = IWERT(J)
      JANZ       = 5


C.....GITTERPUNKTE ODER SPHER.HARM.KOEFF.?
      IF (IFLAG .EQ. MSK_128)               GOTO 500

C.....GITTERPUNKTE..............................................................
C.....SIMPLE PACKING ODER PACKEN 2.ORDNUNG ?
      IF (IPACK .EQ. MSK__64)               GOTO 100

C.....SIMPLE PACKING............................................................
C.....BEREITS MIT DEN ERSTEN 5 WERTEN ERLEDIGT
      IF (IANZ .GT. JANZ)                   THEN
         PRINT '('' PUTBD1: ! IANZ > JANZ !;'',2I5)', IANZ, JANZ
      ENDIF
      GOTO 900

  100 CONTINUE
C.....PACKEN 2.ORDNUNG..........................................................

      JANZ       = 11
      DO 110   J = 6, JANZ
      JJ         = J - 5
      JBLE(J)    = IL064(JJ)
  110 JWERT(J)   = IWERT(J)
C.....IWERT(11)  = RESERVIERT, ALLE BITS WERDEN GESETZT (1 BYTE LANG)
      JWERT(11)  = 255

      IZW        = IWERT(7)
      IZW        = IAND (MSKC128, IZW)
      IMATR      = IAND (MSK__64, IZW)
      IZW        = IAND (MSK_C64, IZW)
      I2BMP      = IAND (MSK__32, IZW)
      IZW        = IAND (MSK_C32, IZW)
      IWDTH      = IAND (MSK__16, IZW)

C.....MATRIX FUER JEDEN GITTERPUNKT-WERT ?
      IF (IMATR .NE. MSK__64)               THEN
C........JA, Z. ZT. NOCH NICHT DEFINIERT
         PRINT '('' PUTBD1: MATRIX FUER GPKT.-WERTE NICHT DEFINIERT'')'
         IRM     = 1
         RETURN
      ENDIF

C.....2.ORDNUNG GEPACKTE DATEN MIT VERSCHIEDENER WEITE ?
      IF (IWDTH .EQ. MSK__16)               THEN

C........JA, VERSCHIEDENE WEITEN, PRO WEITE 1 BYTE
         IAW     = 12
         IAZ1P   = IWERT(9)
         IAZ2P   = IWERT(10)
         IEW     = IAW +IAZ1P - 1
C........DIMENSIONIERUNG AUSREICHEND ?
         IF (IEW .GT. NWERT)                THEN
            PRINT '('' PUTBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +              ''  - IEW, NWERT='',2I5)', IEW, NWERT
            IRM  = 1
            RETURN
         ENDIF
         DO 310 J= IAW, IEW
         JBLE(J) = 1
  310    JWERT(J)= IWERT(J)
      ELSE

C........NEIN, 1 WEITE PRO 1 BYTE
         IAW     = 12
         IEW     = 12
C........DIMENSIONIERUNG AUSREICHEND ?
         IF (IEW .GT. NWERT)                THEN
            PRINT '('' PUTBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +              ''  - IEW, NWERT='',2I5)', IEW, NWERT
            IRM  = 1
            RETURN
         ENDIF
         J       = IAW
         JBLE(J) = 1
         JWERT(J)= IWERT(J)
      ENDIF

C.....2.BITMAP ?
      IF (I2BMP .EQ. MSK__32)               THEN
C........JA
         IAW     = IEW + 1
         IP2     = IWERT(10)
         ILBMP   = ((IP2 - 1) / IBMAX) + 1
         IEW     = IAW + ILBMP - 1
C........DIMENSIONIERUNG AUSREICHEND ?
         IF (IEW .GT. NWERT)                THEN
            PRINT '('' PUTBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +              ''  - IEW, NWERT='',2I5)', IEW, NWERT
            IRM  = 1
            RETURN
         ENDIF
         DO 410 J= IAW, IEW
         JBLE(J) = IBYTW
  410    JWERT(J)= IWERT(J)
      ENDIF

C.....P1, 1.ORDNUNG GEPACKTE DATEN
      NRBIT      = IWERT(5)
      IBLL       = NRBIT / IBYTE
      IAW        = IEW + 1
      IP1        = IWERT(9)

C.....DIMENSIONIERUNG AUSREICHEND ?
      IEW        = IANZ + IP1 - 1
      IF (IEW .GT. NWERT)                   THEN
         PRINT '('' PUTBD1: ERRECHNETE DATENMENGE > USER-DIMENSION'',
     +           ''  - IEW, NWERT='',2I5)', IEW, NWERT
         IRM     = 1
         RETURN
      ENDIF

      JA         = IEW
      DO 420 J   = 1, IP1
      JA         = JA + 1
      JJ         = J + 1
      JBLE(JA)   = IBLL
      JWERT(JA)  = INT(DSUP (JJ))
C     IBLA       = IBLA + IBLL
  420 CONTINUE
      IEW        = JA
      GOTO 900

  500 CONTINUE
C.....SPHER.HARM.KOEFF..........................................................
C.....SIMPLE PACKING ODER COMPLEX PACKING ?
      IF (IPACK .EQ. MSK__64)               GOTO 600

C.....SIMPLE PACKING............................................................
      JANZ       = 6
      J          = JANZ
      JBLE(J)    = IL000(J)
      IWZW       = IREFTS(DSUP (2))
      JWERT(J)   = IWZW
C.....BEREITS MIT DEN ERSTEN 6 WERTEN ERLEDIGT
      IF (IANZ .GT. JANZ)                   THEN
         PRINT '('' PUTBD1: ! IANZ > JANZ !;'',2I5)', IANZ, JANZ
      ENDIF
      GOTO 900


  600 CONTINUE
C.....COMPLEX PACKING...........................................................

C.....IP AUF UNDEFINIERT ABFRAGEN
      IZWZ       = IWERT(7)
      IF (IAND(IZWZ,MSK4F)   .EQ. MSK4F)     THEN
         PRINT '('' PUTBD1: FEHLER, COMPL.PCKG., IP='',Z17,
     +           '', IRM=17 UND RETURN'')', IWERT(7)
         IRM     = 17
         RETURN
      ENDIF

      JANZ       = 10
      DO 610   J = 6, JANZ
      JJ         = J - 5
      JBLE(J)    = IL192(JJ)
  610 JWERT(J)   = IWERT(J)
      IWZW       = JWERT(7)
      IF (IWZW .LT. 0)                      THEN
         IWZW    = -IWZW
         JWERT(7)=  IOR(IWZW, MSKSF)
      ENDIF

C.....BEREITS MIT DEN ERSTEN 10 WERTEN ERLEDIGT
      IF (IANZ.GT.JANZ .AND. IANZ.GT.11)    THEN
         PRINT '('' PUTBD1: ! IANZ > JANZ !;'',2I5)', IANZ, JANZ
      ENDIF

C.....UNGEPACKTE DATEN
      IUDZ       = IWERT(11)
      JWERT(6)   = (IUDZ * 4) + 19
C.....ANZAHL DER 'UNGEPACKTEN' DATEN OKAY ?
      IF (IUDZ .GT. MXDAT)                  THEN
         PRINT '('' PUTBD1: ! IUDZ > MXDAT !;'',
     +           '' IUDZ, MZDAT='',2I6)',IUDZ, MXDAT
         IRM     = 1
         RETURN
      ENDIF

C.....BEGINN MIT INDEX=11 FUER WEITERE DATENWERTE VON JWERT
      IAW        = 11
      IEW        = IAW + IUDZ - 1
#if defined(TEST)
      PRINT '('' PUTBD1: IUDZ,JWERT(1),JWERT(6),IAW,IEW='',/,5I10)',
     +                   IUDZ,JWERT(1),JWERT(6),IAW,IEW
#endif 

C.....! UNGEPACKTE DATEN ERST AB DSUP  (2)
      DO 620   J = IAW, IEW
      JBLE(J)    = 4
      JJ         = J - 9
      IWZW       = IREFTS(DSUP (JJ))
  620 JWERT(J)   = IWZW

C.....WERTE NACH IBLOCK SPEICHERN...............................................
  900 CONTINUE
      IBLA       = IBYTA
      DO 910   J = 1, JANZ
      IANF       = IBYTW+1 - JBLE(J)
      CALL SPUMB (JWERT(J),IANF,JBLE(J),IBLA,IBLOCK,IRM)
      IF (IRM .NE. 0)                       RETURN
  910 IBLA       = IBLA + JBLE(J)

C.....LETZTES BYTE IN IBLOCK
      IF (IAW .EQ. 0)                       GOTO 950

C.....UNGEPACKTE DATEN NACH IBLOCK SPEICHERN....................................
      DO 920   J = IAW, IEW
      IANF       = IBYTW+1 - JBLE(J)
      CALL SPUMB (JWERT(J),IANF,JBLE(J),IBLA,IBLOCK,IRM)
      IF (IRM .NE. 0)                       RETURN
  920 IBLA       = IBLA + JBLE(J)

  950 CONTINUE
C     IWERT(1)   = JWERT(1)

      RETURN
      END

