      SUBROUTINE PUTBM1 (IEDNR,IBYTA,NBLOCK,NWERT,NBMAP,IWERT,IBMAP,
     +                   IBLOCK,IANZ,IRM)
C**** PUTBM1   -   BIT-MAP-SECTION (BMS, GRIB-CODE) OHNE BITMAP AUFBAUEN
C**   AUFRUF     : CALL PUTBM1 (IEDNR,IBYTA,NBLOCK,NWERT,NBMAP,IWERT,IBMAP,
C**               +             IBLOCK,IANZ,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : DIE IN IWERT UEBERGEBENEN KENNDATEN NACH IBLOCK SPEICHERN
C**   PARAMETER  : INPUT:    IEDNR,IBYTA,NBLOCK,NWERT,NBMAP,IWERT,IBMAP,IANZ
C**                ---------------------------------------------------------
C**                IEDNR     EDITIONSNUMMER (IEDNR=1 AB 11/94)
C**                IBYTA     ANFANGSADRESSE DER BMS IM FELD IBLOCK, IN BYTES
C**                          BERECHNET
C**                NBLOCK    USER-DIMENSIONIERUNG VON IBLOCK  (81000/162000)
C**                NWERT     USER-DIMENSIONIERUNG VON IWERT        (3)
C**                NBMAP     USER-DIMENSIONIERUNG VON IBMAP    (3500/7000)
C**                IWERT     3 WORTE KENNDATEN FUER DIE BMS
C**                INDEX:    BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (1)    1 - 3  LBMS    LAENGE DER BMS IN BYTES
C**                   (2)    4      NUNUS2  ANZAHL DER UNBENUTZTEN BITS AM ENDE
C**                                         DER BMS
C**                   (3)    5 - 6  NRBMAP  ZEIGT AN, OB EINE BITMAP FOLGT, ODER
C**                                         OB DIESE AUF EINEM FILE ABGELEGT IST
C**                                         =0 : BITMAP FOLGT,
C**                                         >0 : BITMAP LIEGT BEREITS UNTER
C**                                              NRBMAP = BITMAP-CYCLE-NR. VOR
C**                IBMAP     BITMAP, DIMENSION: IBMAP(NBMAP)
C**                IANZ      ANZAHL DER GITTERPUNKTE IN IBMAP
C**
C**                OUTPUT:   IBLOCK, IRM
C**                ---------------------
C**                IBLOCK    FELD IM GRIB-CODE
C**                IRM       FEHLER-RUECKMELDEZELLE
C**                          FEHLER, WENN IRM UNGLEICH NULL
C**
C**   VERFASSER:   A. ZALEWSKY, SEPTEMBER 1994
C.....MODIFICATION: UP-BESCHREIBUNG GEAENDERT, A.ZALEWSKY...............03.11.97
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IEDNR, IBYTA, NBLOCK, NWERT, NBMAP, IWERT, IBMAP, IBLOCK
      INTEGER IANZ, IRM
      INTEGER MWERT, JWERT, IBLE, JBLE, IBYTG, IZW, IBLL, LBMS, NUNUSB
      INTEGER NRBMAP, IGRD, J, IWZW, IANF

#if defined(TEST)
      INTEGER K
#endif
#include "machconsts.h"

      PARAMETER (MWERT=3)

      DIMENSION IWERT(*),IBLOCK(*),IBMAP(*),JWERT(MWERT),
     +          IBLE(MWERT),JBLE(MWERT)

C.....DATA IBTA /1,4,5/
      DATA IBLE /3,1,2/

C.....USER-ANGABE UNTER MINIMUM-ANZAHL..................................03.11.97
      IF (NWERT .LT. MWERT)                 THEN
         PRINT '('' PUTBM1: FEHLER IWERT ZU KLEIN DIMENSIONIERT,'',
     +           '' UP-DIM, USER-DIM='',2I5)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
      IBYTG      = IBYTA

C.....IANZ IST DIE ANZAHL DER GITTERPUNKTE..............................03.11.97
      IZW        = (IANZ + IBMAX - 1) / IBMAX
      IF (IZW .GT. NBMAP)                   THEN
         PRINT '('' PUTBM1: FEHLER IBMAP ZU KLEIN DIMENSIONIERT,'',
     +           '' USER-DIM, BER.DIM='',2I6)', NBMAP, IZW
         IRM     = 1
         RETURN
      ENDIF
      IBLL       = 0
      LBMS       = 6
      NUNUSB     = 0
      NRBMAP     = IWERT(3)
      IF (NRBMAP .EQ. 0)                    THEN
C........BYTE-ANZAHL, NUNUSB BERECHNEN
         IBLL    = (IANZ + IBYTE - 1) / IBYTE
         NUNUSB  = (IBLL*IBYTE) - IANZ
C........GERADE ANZAHL BYTES ERMITTELT? - WENN NICHT, 1 BYTE ADDIEREN
         IGRD    = MOD(IBLL,2)
         IF (IGRD .NE. 0)                   THEN
            IBLL    = IBLL + 1
            NUNUSB  = NUNUSB + IBYTE
         ENDIF
         LBMS       = LBMS + IBLL
      ELSE IF (NRBMAP .LT. 0)               THEN
         PRINT '('' PUTBM1: FEHLER - NRBMAP='',I10)', NRBMAP
         IRM     = 1
         RETURN
      ENDIF
      JWERT(1)   = LBMS
      JWERT(2)   = NUNUSB
      JWERT(3)   = NRBMAP

C..................IBLE UMSPEICHERN
      DO 100 J   = 1 , MWERT
      JBLE(J)    = IBLE(J)
  100 CONTINUE

C..................JWERT NACH IBLOCK SPEICHERN
      DO 110 J   = 1 , MWERT
      IWZW       = JWERT(J)
      IBLL       = JBLE(J)
      IANF       = IBYTW - IBLL + 1
      CALL SPUMB (IWZW, IANF, IBLL, IBYTG, IBLOCK, IRM)
      IF (IRM .NE. 0)                       THEN
         PRINT '('' PUTBM1: FEHLER IN SPUMB - IBYTG,JWERT('',I1,'')='',
     +                               2I7)', J,IBYTG,JWERT(J)
         RETURN
      ENDIF
      IBYTG      = IBYTG + IBLL
  110 CONTINUE

C.....TESTAUSGABEN
#if defined(TEST)
      PRINT '('' PUTBM1: IBYTG,MWERT='',2I5,10X,'' JWERT='',/,3I11)',
     +                   IBYTG,MWERT,             (JWERT(K),K=1,MWERT)
#endif 

      IF (NRBMAP .NE. 0)                    GOTO 500

C.....WENN NRBMAP=0, DANN BITMAP ABSPEICHERN
      IANF       = 1
      IBLL       = LBMS - 6
      IF (IBLL .GT. 0)
     +CALL SPUMB (IBMAP(1),IANF,IBLL,IBYTG,IBLOCK,IRM)
#if defined(TEST)
      PRINT '('' PUTBM1: IBYTA,IBYTG,IBLL='',3I7)',
     +                   IBYTA,IBYTG,IBLL
#endif 

  500 CONTINUE
      IWERT(1)   = JWERT(1)

      RETURN
      END
