      SUBROUTINE PUTGD1 (IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IWERT,
     +                   IBLOCK, IANZ, IRM)

C**** PUTGD1   -   UP ERSTELLT GRID-DEFINITION-SECTION; GDS AB GRIB-EDIT.-NR.=1
C**   AUFRUF     : CALL PUTGD1 (IEDNR,IBYTA,IUNDEF,NBLOCK,NWERT,IWERT,
C**               +             IBLOCK,IANZ,IRM)
C**   EXTERNALS  : SPUMB, PGD1_00, PGD1_01, PGD1_02, PGD1_03, PGD1_04, PGD1_05,
C**                       PGD1_50, PGD1_90, PGD1_192
C**   ZWECK      : ANHAND DER IN IWERT UEBERGEBENEN WERTE WIRD DIE GRID-DEFINI-
C**                TION-SECTION DES GRIBS ERSTELLT UND NACH IBLOCK GESCHRIEBEN
C**   PARAMETER  : INPUT:    IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IWERT, IANZ
C**                ----------------------------------------------------------
C**                IEDNR     GRIB-EDITIONS-NUMMER; IEDNR = 1, GUELTIG AB 11/1994
C**                IBYTA     ANFANGSADRESSE DER GDS IN BYTES IM FELD IBLOCK
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                NBLOCK    USER-DIMENSION VON IBLOCK: IBLOCK(NBLOCK)
C**                NWERT     USER-DIMENSION VON IWERT: IWERT(NWERT)
C**                IWERT     626 KENNDATEN FUER DIE GDS;
C**                          IWERT(  1..  4) - STEUERPARAMETER,
C**                          IWERT(  5.. 25) - GRID-DEFINITIONEN,
C**                          IWERT( 26..225) - MAX. 200 VERTIKALKOORDINATEN,
C**                                            ANZAHL DER VERT.KOOR. STEHT IN NV
C**                          IWERT(226)      - ANZAHL DER FOLG. WERTE (REIHEN)
C**                                            FUER PROGRAMM-INTERNEN ABLAUF,
C**                                            SIEHE PARAMETER NJ BZW. IWERT(6)
C**                          IWERT(227..626) - MAX. 400 WERTE GPKT.ANZAHLEN PRO
C**                                            REIHE
C**                IWERT:    BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                *  (1)    1 - 3  LGD1    GDS-LAENGE IN BYTES;       LGD1 =
C**                                         32/42/44/52 + (4 * NV) + (2 * NJ)
C**                   (2)    4      NV      ANZAHL DER VERTIKAL-KOORDINATEN
C**                                         WENN VERTIKAL-KOORDINATEN, DANN
C**                *  (3)    5      PV      ADRESSE IN BYTES DER VERTIKAL-KOOR-
C**                                         DINATEN-PARAMETER
C**                                    ODER KEINE VERTIKAL-KOORDINATEN, DANN
C**                *  (3)    5      PL      ADRESSE IN BYTES DER LISTE DER GPKT.
C**                                         -ANZAHLEN IN JEDER REIHE
C**                                    ODER WEDER PV NOCH PL, DANN
C**                *  (3)    5      255     ALLE BITS GESETZT
C**                   (4)    6      IDRTYP  PROJEKTIONSART ( CODE-TABLE 6 )
C**                     (   ----------------------------------------------------
C**                     (    7 -  32        GRID-DEFINITION ABHAENGIG VON IDRTYP
C**                     (   33 -  42        EXTENSIONS FOR ROT. OR STRETCH. SYS.
C**                     (   33 -  44        EXTENSIONS FOR SPACE VIEW PERSP.PROJ.
C**                     (   33 -  52        EXTENSIONS FOR ROT. AND STRETCH. SYS.
C**                     (     WENN VORHANDEN,
C**                     (   PV              LISTE DER VERTIKAL-KOORDINATEN
C**                     (                   (LAENGE = NV * 4 BYTES)
C**                     (     WENN VORHANDEN,
C**                     (   PL              LISTE DER GITTERPUNKTANZAHL IN JEDER
C**                     (                   REIHE,  LAENGE = NROWS * 2 BYTES,
C**                     (                    NROWS BZW. NJ = ANZAHL DER REIHEN,
C**                     (                   ADRESSE VON PL = 4 NV + PV
C**                     (   ----------------------------------------------------
C**
C**                -------------------------------------------------------------
C**                E N T W E D E R :        IDRTYP= 0, REGULAR LAT./LONG. GRID :
C**                                                10, ROT.       - " -
C**                                                20, STR.       - " -
C**                                                30, ROT./STR.  - " -
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NI      GPKTE. ENTLANG EINES PARALLELKREISES
C**                   (6)    9 -10  NJ      GPKTE. ENTLANG EINES MERIDIANS
C**               ( 7-25)                   SIEHE UP PGD1_00
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**                         33-832          FUER IDRTYP =  0
C**               (26-225)  43-842  IVKOP   FUER IDRTYP = 10 / 20
C**                         53-852          FUER IDRTYP = 30
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP=1 , MERCATOR-PROJEKTION :
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NI      GPKTE. ENTLANG EINES PARALLELKREISES
C**                   (6)    9 -10  NJ      GPKTE. ENTLANG EINES MERIDIANS
C**               ( 7-25)                   SIEHE UP PGD1_01
C**               (26-225)  43-842  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**   !!!!!        IDRTYP=2, IM NEUEN GRIB-CODE NICHT BESCHRIEBEN; ALTE VERSION:
C**
C**                O D E R :                IDRTYP=2 , STEREOGR. PROJEKTION :
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. IN X-RICHTUNG
C**                   (6)    9 -10  NY      GPKTE. IN Y-RICHTUNG
C**               ( 7-25)                   SIEHE UP PGD1_02
C**               (26-225)  33-832  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP= 3, LAMBERT OD. ALBERS PROJ.:
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. ENTLANG DER X-ACHSE
C**                   (6)    9 -10  NY      GPKTE. ENTLANG DER Y-ACHSE
C**               ( 7-25)                   SIEHE UP PGD1_03
C**               (26-225)  43-842  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP= 4, GAUSSIAN LAT./LONG. GRID:
C**                                                14, ROT.        - " -
C**                                                24, STR.        - " -
C**                                                34, ROT./STR.   - " -
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NI      GPKTE. ENTLANG EINES PARALLELKREISES
C**                   (6)    9 -10  NJ      GPKTE. ENTLANG EINES MERIDIANS
C**               ( 7-25)                   SIEHE UP PGD1_04
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**                         33-832          FUER IDRTYP =  4
C**               (26-225)  43-842  IVKOP   FUER IDRTYP = 14 / 24
C**                         53-852          FUER IDRTYP = 34
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP= 5, POL.STEREOGR.PROJEKTION:
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. ENTLANG DER X-ACHSE
C**                   (6)    9 -10  NY      GPKTE. ENTLANG DER Y-ACHSE
C**               ( 7-25)                   SIEHE UP PGD1_05
C**               (26-225)  33-832  IVCOP   VERTIKAL-KOORDINATEN-PARAMETER
C**
C**                -------------------------------------------------------------
C**                O D E R : IDRTYP=50, SPHERICAL HARMONIC CO-EFFICIENTS :
C**                                 60, ROT.         - " -
C**                                 70, STR.         - " -
C**                                 80, ROT./STR.    - " -
C**                -------------------------------------------------------------
C**                    (5)   7 - 8  JSHC    PENTAGONAL RESOLUTION PARAMETER
C**                    (6)   9 -10  KSHC    PENTAGONAL RESOLUTION PARAMETER
C**               ( 7-25)                   SIEHE UP PGD1_50
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**                         33-832          FUER IDRTYP = 50
C**               (26-225)  43-842  IVKOP   FUER IDRTYP = 60 / 70
C**                         53-852          FUER IDRTYP = 80
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP=90, SPACE VIEW PERSPECTIVE :
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  NX      GPKTE. ENTLANG DER X-ACHSE (SPALTEN)
C**                   (6)    9 -10  NY      GPKTE. ENTLANG DER Y-ACHSE
C**                                         (REIHEN ODER ZEILEN)
C**               ( 7-25)                   SIEHE UP PGD1_90
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**               (26-225)  45-844  IVKOP
C**
C**                -------------------------------------------------------------
C**                O D E R :                IDRTYP=192, TRI-ANGULAR-GRID :
C**                -------------------------------------------------------------
C**                   (5)    7 - 8  N2      FAKTORISRG. DES IKOSAEDERS BZGL. 2
C**                   (6)    9 -10  N3      FAKTORISRG. DES IKOSAEDERS BZGL. 3;
C**                                         N3 KANN NUR 0 ODER 1 SEIN, D.H., ES
C**                                         ERFOLGT -WENN UEBERHAUPT- NUR IM
C**                                         1. TEILUNGSSCHRITT EINE DRITTELUNG
C**                                         DER DREIECKSSEITEN, DANACH NUR HAL-
C**                                         BIERUNGEN
C**               ( 7-25)                   SIEHE UP PGD1_192
C**                         ES FOLGEN VERTIKAL-KOORDINATEN-PARAMETER:
C**                         -----------------------------------------
C**               (26-225)  33-832  IVKOP
C**
C**               --------------------------------------------------------------
C**                         ES FOLGT EINE LISTE DER PUNKTE IN JEDER REIHE:
C**                         ----------------------------------------------
C**                  (226)   -      NLIST   ANZAHL DER NACHFOLGENDEN WERTE,
C**                                         WENN KEIN ILIST, DANN NLIST = 0,
C**                                         NUR FUER PROGRAMM-INTERNEN ABLAUF
C**              (227-626)  PL      ILIST   ANZAHL DER PUNKTE IN JEDER REIHE,
C**                                         ADRESSE: PL = 4NV + PV
C**               ..............................................................
C**                IANZ       ANZAHL DER ERSTEN 25 DATENWERTE NACH GDS
C**
C**                OUTPUT:    IBLOCK, IRM
C**                ----------------------
C**                IBLOCK     GDS IN'S GRIB-FELD IBLOCK SPEICHERN
C**                IRM        FEHLER-RUECKMELDEZELLE;
C**                           FEHLER, WENN IRM UNGLEICH NULL
C**
C**                HINWEISE:  1. ALLE GEOGRAFISCHEN KOORDINATEN SIND IN MILLI-
C**                              DEGREES ZU UEBERGEBEN
C**                           2. BEI NEGATIVEN GEOGRAFISCHEN KOORDINATEN (WEST /
C**                              SUED) WIRD FUER DIE INTERNE SPEICHERUNG IM GRIB
C**                              CODE DAS OBERSTE BIT VON 3 BYTES GESETZT UND
C**                              DER WERT POSITIV ABGESPEICHERT
C**                           3. ALLE LAENGEN SIND IN METERN ZU UEBERGEBEN
C**                           4. MIT * GEKENNZEICHNETE WERTE WERDEN IM UP ERMIT-
C**                              TELT UND GESETZT
C**                           5. MIT ** GEKENNZEICHNETE WERTE MUESSEN VOM USER
C**                              MIT DER FUNCTION IREFTS (SIEHE DWDLIB) UMGE-
C**                              RECHNET SEIN
C**
C**   VERFASSER:   A. ZALEWSKY, SEPTEMBER 1994
C**   MODIF.:      NEU: IDRTYP=192                                  01.04.1998
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"

      IMPLICIT NONE

      INTEGER IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IWERT, IBLOCK, IANZ
      INTEGER IRM
      INTEGER MWERT, NKOOR, NROWS, JWERT, JBLE, IBALL, IBLE, JX, IANZVK
      INTEGER IANZNR, IDRTYP, IBYTG, LGDS, IGDSLB, IWORDS, IGDSWD, J
      INTEGER IBLL, IWZW, JANZ, IBYTH, ITYPE, LWA, LWE, J9, IANF
#if defined (TEST)
      INTEGER JXZW, IP, K
#endif

#include "machconsts.h"

      PARAMETER (MWERT=626,NKOOR=200,NROWS=400)

      DIMENSION IBLOCK(*),IWERT(*),JWERT(MWERT),JBLE(MWERT),IBALL(4),
     +          IBLE(6)

      DATA IBALL / Z'FF'        ,
     +             Z'FFFF'      ,
     +             Z'FFFFFF'    ,
     +             Z'FFFFFFFF'  /

C     ...INDEX:    1 2 3 4 5 6
      DATA IBLE   /3,1,1,1,2,2/

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLA1 UMGESPEICHERT...............
C.....JX WIRD ALS INDEX FUER JWERT/JBLA1 HOCHGERECHNET..........................
C.....AM ENDE DES PROGRAMMS WIRD JWERT MIT SPUMB NACH IBLOCK GESPEICHERT........

C.....NWERT < MWERT WIRD VOR VERTIKALKOORDINATEN-PARAMETER ABGEFRAGT
      IF (MWERT .LT. NWERT)                 THEN
         PRINT '('' PUTGD1: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IRM       = 0
      JX        = 0
      IANZVK    = 0
      IANZNR    = 0
      IDRTYP    = IWERT(4)
      IBYTG     = IBYTA

      LGDS      = IGDSLB(IDRTYP,IEDNR)
      IF (LGDS .LT. 0)                      THEN
C        KEINE GUELTIGE PROJEKTIONSART GEFUNDEN => LGDS=-999999, IDRTYP=UNDEF.
         IRM    = 1
         PRINT '('' PUTGD1: IEDNR, IDRTYP ='',2I4,
     +           '' NICHT DEFINIERT'')', IEDNR, IDRTYP
         RETURN
      ENDIF

      IWORDS    = IGDSWD(IDRTYP,IEDNR)
      IF (IANZ .LT. IWORDS)                 THEN
C        ZU WENIG USER-DATEN FUER IDRTYP/IEDNR
         IRM    = 1
         PRINT '('' PUTGD1: IANZ='',I3,'', ZU WENIG USER-DATEN;'',/,
     +           ''         IANZ='',I3,'', VERLANGT FUER IDRTYP='',I3)',
     +                      IANZ, IWORDS, IDRTYP
         RETURN
      ENDIF

#if defined(TEST)
      PRINT '('' PUTGD1: IEDNR,IDRTYP,LGDS,IWORDS,IANZ,IBYTG='',6I6)',
     +                   IEDNR,IDRTYP,LGDS,IWORDS,IANZ,IBYTG
#endif 

C..................IWERT(1..6); JWERT(1),JWERT(3) WERDEN SPAETER BESETZT
      DO 100 J   = 1, 6
      JX         = JX + 1
      IBLL       = IBLE(J)
      IWZW       = IWERT(J)
      IF (IWZW .EQ. IUNDEF)
     +    IWZW   = IBALL(IBLL)
      JWERT(JX)  = IWZW
      JBLE(JX)   = IBLL
      IBYTG      = IBYTG + IBLL
  100 CONTINUE
      JANZ       = 6

C..................IWERT(7..25)
C              AN DIE UPS WIRD IBYTA UEBERGEBEN, D.H. AM ANFANG EINES JEDEN UPS
C              MUSS "IBYTG = IBYTG + 10" GERECHNET WERDEN, DIE ERSTEN 10 BYTES
C              WURDEN BEREITS IN DIESEM UP BESETZT
               IBYTH   = IBYTA
      IF      (IDRTYP.EQ. 0 .OR. IDRTYP.EQ.10    .OR.
     +         IDRTYP.EQ.20 .OR. IDRTYP.EQ.30)   THEN
         CALL PGD1_00 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 0
      ELSE IF (IDRTYP .EQ.  1)                   THEN
         CALL PGD1_01 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 1
      ELSE IF (IDRTYP .EQ.  2)                   THEN
         CALL PGD1_02 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 2
      ELSE IF (IDRTYP .EQ.  3)                   THEN
         CALL PGD1_03 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 3
      ELSE IF (IDRTYP.EQ. 4 .OR. IDRTYP.EQ.14    .OR.
     +         IDRTYP.EQ.24 .OR. IDRTYP.EQ.34)   THEN
         CALL PGD1_04 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 4
      ELSE IF (IDRTYP .EQ.  5)                   THEN
         CALL PGD1_05 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 5
      ELSE IF (IDRTYP.EQ.50 .OR. IDRTYP.EQ.60    .OR.
     +         IDRTYP.EQ.70 .OR. IDRTYP.EQ.80)   THEN
         CALL PGD1_50 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 50
      ELSE IF (IDRTYP .EQ. 90)              THEN
         CALL PGD1_90 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                 JWERT,JBLE,JX,IRM)
         ITYPE   = 90
      ELSE IF (IDRTYP .EQ.192)              THEN
         CALL PGD1_192 (IWORDS,LGDS,IBYTH,IUNDEF,NWERT,IWERT,
     +                  JWERT,JBLE,JX,IRM)
         ITYPE   = 192
         IF (IRM .NE. 0)                    THEN
            PRINT '('' PUTGD1: FEHLER IN PGD1_'',I3.3,
     +              ''; IDRTYP, IWORDS, LGDS='',3I5)', ITYPE,
     +                  IDRTYP, IWORDS, LGDS
            RETURN
         ENDIF   
      ELSE
         IRM     = 1
         PRINT '('' PUTGD1: IEDNR, IDRTYP='',2I4,
     +           '' NICHT DEFINIERT'')', IEDNR, IDRTYP
         RETURN
      ENDIF
      IBYTG      = IBYTA + LGDS
      IF (IRM .NE. 0)                       THEN
         PRINT '('' PUTGD1: FEHLER IN PGD1_'',I2.2,
     +           ''; IDRTYP, IWORDS, LGDS='',3I5)', ITYPE,
     +               IDRTYP, IWORDS, LGDS
         RETURN
      ENDIF
      JANZ       = IWORDS
#if defined(TEST)
      PRINT '('' PUTGD1: BACK FROM PGD1_'',I2.2,
     +        ''; IDRTYP, IWORDS, LGDS, IBYTG='',4I5)', ITYPE,
     +            IDRTYP, IWORDS, LGDS, IBYTG
      JXZW       = JX
      IF (JXZW .GT. 19)                     JXZW = 19
      PRINT '('' PUTGD1: JWERT(1..'',I2,'')='',5(/,5I10))',
     +           JXZW,  (JWERT(IP),IP=1,JXZW)
      JXZW       = JX
      IF (JXZW .GT. 19)                     THEN
         IF (JXZW .GT. 25)                  JXZW = 25
         PRINT
     +      '('' PUTGD1: JWERT(20..'',I2,'')='',2(/,3Z17))',
     +           JXZW,  (JWERT(IP),IP=20,JXZW)
      ENDIF
#endif 
C...............................................................................

  215 CONTINUE
C.....VERTIKALKOORDINATEN ABSPEICHERN, NUR WENN IWERT(2) >0 ....................
      IANZVK        = IWERT(2)

      IF (IANZVK .EQ. 0)                    THEN
C........OHNE VERTIKALKOORDINATEN
         JWERT(3)   = 255
      ELSE IF (IANZVK .GT. 0)               THEN
C........MIT VERTIKALKOORDINATEN
         IF (IANZVK .GT. NKOOR)             THEN
             PRINT '('' PUTGD1: FEHLER-'',I5,'' VERTIK.KOORD.,'',/,
     +               ''                '',I5,'' SIND ERLAUBT'')',
     +                                    IANZVK, NKOOR
             IRM    = 1
             RETURN
         ENDIF

C........JWERT(3)   = BYTE-ADRESSE DER VERTIKALKOORDINATEN IN DER GDS
         JWERT(3)   = LGDS + 1
         IBLL       = 4
         LWA        = 26
         LWE        = LWA + IANZVK - 1
         DO 220   J = LWA, LWE
         JX         = JX + 1
         IWZW       = IWERT(J)
         IF (IWZW .EQ. IUNDEF)
     +      IWZW    = IBALL(IBLL)
         JWERT(JX)  = IWZW
         JBLE(JX)   = IBLL
         IBYTG      = IBYTG + IBLL
  220    CONTINUE
      ELSE
C........IANZVK     < 0
         IANZVK     = 0
         JWERT(2)   = 0
         JWERT(3)   = 255
      ENDIF

C.....NROWS-LISTING, NUR WENN IWERT(226) > 0 ...................................
      IANZNR        = IWERT(226)

      IF (IANZNR.EQ.0 .OR. IANZNR.EQ. IUNDEF)    THEN
C........OHNE NROWS-LISTING UND OHNE VERTIKAL-KOORDINATEN
         JWERT(226) = 0
      ELSE
C........MIT NROWS-LISTING
         IF (IANZNR .GT. NROWS)             THEN
             PRINT '('' PUTGD1: FEHLER-'',I5,'' NROWS-LISTING,'',/,
     +               ''                '',I5,'' SIND ERLAUBT'')',
     +                                    IANZNR, NROWS
             IRM    = 1
             RETURN
         ENDIF

         IF (IANZVK .EQ. 0)                 THEN
C...........JWERT(3)= BYTE-ADRESSE DES NROWS-LISTING, NUR OHNE VERTIKALKOORD.
            JWERT(3)= LGDS + 1
         ENDIF
         IBLL       = 2
         LWA        = 227
         LWE        = 227 + IANZNR - 1
         DO 230   J = LWA, LWE
         JX         = JX + 1
         IWZW       = IWERT(J)
         IF (IWZW .EQ. IUNDEF)
     +      IWZW    = IBALL(IBLL)
         JWERT(JX)  = IWZW
         JBLE(JX)   = IBLL
         IBYTG      = IBYTG + IBLL
  230    CONTINUE
      ENDIF

C.....DATEN NACH IBLOCK SPEICHERN...............................................
  800 CONTINUE
      JWERT(1)      = IBYTG - IBYTA
      IBYTG         = IBYTA
#if defined(TEST)
      PRINT '('' PUTGD1: JWERT(1),IBYTA,JX='',3I6)',
     +                   JWERT(1),IBYTA,JX
#endif 

      DO 900 J9     = 1, JX
      IWZW          = JWERT(J9)
      IBLL          = JBLE(J9)
      IANF          = IBYTW - IBLL + 1
      CALL SPUMB (IWZW,IANF,IBLL,IBYTG,IBLOCK,IRM)
      IF (IRM .NE. 0)                       RETURN
      IBYTG         = IBYTG + IBLL
  900 CONTINUE

      IWERT(1)      = JWERT(1)
#if defined(TEST)
      PRINT '('' PUTGD1: JBLE(1..'',I3,'')='',/,10I3)', JX,
     +                  (JBLE(K),K=1,JX)
      PRINT '('' PUTGD1: IBYTA,JANZ,JX='',3I5,10X,''JWERT='',
     +                   2(/,1X,10I7),/,1X,I7,Z17,2I7,Z17)',
     +                   IBYTA,JANZ,JX,(JWERT(K),K=1,25)
#endif 

      RETURN
      END

