      SUBROUTINE   PUTPD1   (IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IWERT,
     +                       IBLOCK, IANZ, IRM)

C**** PUTPD1   -   UP ERZEUGT PRODUKT-DEFINIT.-SECTION (PDS) AB GRIB-EDIT.-NR.=1
C**   AUFRUF     : CALL PUTPD1  (IEDNR,IBYTA,IUNDEF,NBLOCK,NWERT,IWERT,
C**               +              IBLOCK,IANZ,IRM)
C**   EXTERNALS  : SPUMB
C**   ZWECK      : ANHAND DER IN IWERT UEBERGEBENEN 45 BIS MAX. 321 WERTE
C**                WIRD DIE PRODUKT-DEFINITION-SECTION DES GRIBS AUFGEBAUT
C**                (LAENGE: 54/66/MAX.342 BYTES)
C**   PARAMETER  : INPUT:    IEDNR, IBYTA, IUNDEF, NWERT, NBLOCK, IWERT, IANZ
C**                ----------------------------------------------------------
C**                IEDNR     EDITIONSNUMMER (IEDNR = 1, GUELTIG AB 11/1994)
C**                IBYTA     ANFANGSADRESSE DER PDS IN BYTES IM FELD IBLOCK
C**                          (FUER IEDNR=1 GILT IBYTA=9)
C**                IUNDEF    INTEGER-WERT FUER UNDEFINIERTE DATEN;
C**                          BEI UNDEFINIERTEN DATEN, IWERT(..)=IUNDEF, WERDEN
C**                          IN IBLOCK IN DEN ENTSPRECHENDEN BYTES ALLE BITS GE-
C**                          SETZT
C**                NBLOCK    USER-DIMENSIONIERUNG VON IBLOCK
C**                NWERT     USER-DIMENSIONIERUNG VON IWERT   (NWERT=321)
C**                IWERT     ENTHAELT ALLE ZUM AUFBAU DER PDS BENOETIGTEN WERTE,
C**                          D.H., 47/54 BIS MAX.321 WORTE
C**                INDEX:    BYTE:  INHALT:
C**                -------------------------------------------------------------
C**                   (1)    1 - 3  LPD1    LAENGE DER PDS IN BYTES
C**                                         NEU AB SEPTEMBER '05:
C**                                         ENSEMBLE-VORHERSAGEN UNTER IDC=78 
C**                                         MIT LPD1=66, IANZ=54, IWERT(37)=253
C**                   (2)    4      GTVSN   GRIB-TABLE-VERSIONNR., GTVSN=2 FUER
C**                                         INTERNAT. AUSTAUSCH (128-254 RESERV.
C**                                          FOR LOCAL USE)
C**                   (3)    5      IDC     IDENTIFIC.-CENTRE (RZ=78)
C**                                         (SEE CODE TABLE 0)
C**                   (4)    6      IGPINR  GENERAT.-PROC.-IDENTTIFIC.-NR.=TYPNR
C**                   (5)    7      ICATNR  KATALOG-NR. DES GRIB'S (GRID-DEF.);
C**                                         BEI NICHT-KATALOGIS. GRIB, IWERT(5)=
C**                                         IUNDEF, WERDEN IN BYTE 7 ALLE BITS
C**                                         GESETZT, DIE GDS MUSS IM BLOCK ENT-
C**                                         HALTEN SEIN
C**                   (6)    8      IBFLAG  BLOCK-FLAG, ZEIGT AN, OB GDS UND BMS
C**                                         FOLGEN (SEE CODE-TABLE 1),
C**                   (7)    9      IEE     ELEMENT-KENNUNG (SEE CODE-TABLE 2 OR
C**                                         GTVSN)
C**                   (8)   10      LVTYP   LEVEL-TYP (SEE CODE-TABL .3),
C**                                         1 ODER 2 FLAECHEN VERSCHLUESSELT
C**                E N T W E D E R FUER:    LVTYP=100,103,105,107,109,111,113,
C**                                               115,117,119,125,160,200,201
C**                   (9)    -      -       NICHT BELEGT
C**                   (10)  11 -12  LEVEL   HOEHE, FLAECHE , TAB.3
C**                O D E R :
C**                   (9)   11      LEVEL   HOEHE, FLAECHE , TAB.3, OBERGRENZE
C**                   (10)  12      LEVEL   HOEHE, FLAECHE , TAB.3, UNTERGRENZE
C**                   (11)  13      IYY     JAHR DES JAHRH., fuer das)
C**                                         JAHR 2000 bzw. 0 gilt:   )
C**                                         IYY = 100                ) REFERENZ-
C**                   (12)  14      IMM     MONAT                    ) ZEIT
C**                   (13)  15      IDD     TAG                      )   DER
C**                   (14)  16      IGG     STUNDEN                  ) DATEN
C**                   (15)  17      IMIN    MINUTEN                  )
C**                                         !! FUER INVARIANTE GRIB-FELDER IST
C**                                         IWERT(11..15) = 0 !!
C**                   (16)  18      IUTIME  ZEITEINHEIT FUER ITIME1/ITIME2
C**                                         (SEE CODE TABLE 4)
C**                E N T W E D E R :        (WENN ITFLAG GLEICH 10)
C**                   (17)   -      -       IST NICHT BELEGT
C**                   (18)  19-20   IT12    EIN VORHERSAGE-ZEITRAUM,
C**                O D E R :                (WENN ITFLAG UNGLEICH 10)
C**                   (17)  19      ITIME1  VORHERSAGE-ZEITRAUM 1
C**                   (18)  20      ITIME2  VORHERSAGE-ZEITRAUM 2
C**                   (19)  21      ITFLAG  TIME-FLAG ZEIGT, WELCHER VORHERSAGE-
C**                                         ZEITRAUM FOLGT (SEE CODE-TABLE 5)
C**                   (20)  22 -23  NARVG   ANZ.GEMITTELTE/AKKUMUL. FAELLE
C**                   (21)  24      NMSSG   ANZAHL DER MITTL./AKKUMUL. FEHLT
C**                   (22)  25      JAHRH   JAHRHUNDERT DER REFERENZZEIT (IYY,
C**                                         IMM, ...),
C**                                         BIS EINSCHLIESSLICH 2000 JAHRH=20,
C**                                                          AB 2001 JAHRH=21
C**                   (23)  26      IDCSUB  SUB-CENTRE zu IDC
C**            *      (24)  27 -28  IUDSCF  UNITS DECIMAL SCALE FACTOR (D)
C**                   ----------------------1.MOEGL.PD1-BYTE-LAENGE-------------
C**                   (25)  29      RES2  )
C**                     :    :      :     ) 12 RESERV. WERTE (1 BYTE) = 0
C**                   (36)  40      RES12 )
C**                   ----------------------2.MOEGL.PD1-BYTE-LAENGE-------------
C**
C**                   LOKALER NUTZUNGS-BEREICH, VERZWEIGUNG IN UPS:
C**                   ---------------------------------------------
C**                   (37)  41              KENNUNG FUER WEITEREN DATENVERLAUF:
C**                                         = 254 UND IDC=78/79,
C**                                         = 253 UND IDC=78,
C**                                         SIEHE UP PPD1_78
C**                                         = 254 UND IDC=98/74,
C**                                         SIEHE UP PPD1_98
C**                                         = -254 UND IDC#78/79/98,
C**                                         UNBEK.DATEN, -> PROGRAMM-ABBRUCH
C**
C**                IANZ      INDEX DES LETZTEN WERTES IN IWERT
C**                -------------------------------------------------------------
C**                OUTPUT:   IBLOCK, IRM
C**                ---------------------
C**                IBLOCK    FELD IM GRIB-CODE
C**                IRM       FEHLER-RUECKMELDEZELLE
C**                          FEHLER, WENN IRM UNGLEICH NULL
C**
C**   * HINWEIS:   NEAGATIV-WERTE, Z.B. SKALIERUNGSFAKTOR,IUDSCF ODER DIE GEOGR.
C**                                KOORDINATEN,INOBR,IWELA,ISUBR,IOELA,
C**                WERDEN POSITIV ABGESPEICHERT UND DAS OBERSTE BIT WIRD MIT '1'
C**                BESETZT.
C**
C**   VERFASSER:   A. ZALEWSKY, SEPTEMBER 1994
C     MODIF. am 07.10.1997; IPDB(11) und IPDB(22) bezueglich WMO-REGULATION fuer
C                           das Jahr 2000; A.Zalewsky
C     GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole
C*    GEAENDERT:   R.Johanni, SGI, 09/00, Fortran 90, Einfuehrung "machconsts.h"
!**                geaend. 03/04 MiSt - Leveltyp-Liste auf Anforderung
!**                                     von FE13 erweitert 
!**                                    (neu: lvtyp=222 - Satellite channel)
!**   Version      Marz 2004
C*    GEAENDERT:   A.Zalewsky, TI14, SEPTEMBER '05;
C*                             ENSEMBLE-VORHERSAGEN UNTER IDC=78
C*                                                    MIT LPDS1=66,IANZ=54
C*                                                    UND IWERT(37)=253

      IMPLICIT NONE

      INTEGER IEDNR, IBYTA, IUNDEF, NBLOCK, NWERT, IWERT, IBLOCK, IANZ
      INTEGER IRM
      INTEGER INTM, INTN, MWERT, ILEVL, JWERT, IBALL, IBLA1, JBLA1, ISLA
      INTEGER LEVEL, MSKLALO, MSKSF, JX, IDC, IBYTP, J, IWZW, IBLL
      INTEGER LVTYP, JJ, IDTV, IW11, JANZ, J9, IANF
#if defined (TEST)
      INTEGER K
#endif

#include "machconsts.h"

      PARAMETER (INTM=24,INTN=36,MWERT=321,ILEVL=15)

      DIMENSION IWERT(*), IBLOCK(*), JWERT(MWERT), IBALL(4),
C....+          IBTA1(INTN),               ISTA(2),
     +          IBLA1(INTN), JBLA1(MWERT), ISLA(2), LEVEL(ILEVL)

      DATA IBALL / Z'FF'        ,
     +             Z'FFFF'      ,
     +             Z'FFFFFF'    ,
     +             Z'FFFFFFFF'  /

C     INDEX:....  1 2 3 4 5 6 7  8  9 10 11 12 13 14 15 16 17 18 19 20
C     DATA IBTA1 /1,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,
C     INDEX:.... 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36
C    1           24,25,26,27,29,30,31,32,33,34,35,36,37,38,39,40/

C.....IBLA1 ENTHAELT DIE BYTE-LAENGEN FUER DIE IWERT-ABSPEICHERUNG
C     INDEX:....  1 2 3 4 5 6 7  8  9 10 11 12 13 14 15 16 17 18 19 20
      DATA IBLA1 /3,1,1,1,1,1,1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2,
C     INDEX:.... 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36
     1            1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/

!     Liste auf Anforderung von FE13 erweitert: neuer level-typ 222
      DATA LEVEL  /100,103,105,107,109,111,113,115,117,119,
     +             125,160,200,201,222/
C     DATA ISTA   /11,19/
      DATA ISLA   / 2, 2/

      DATA MSKLALO  /Z'800000' /
      DATA MSKSF    /Z'8000' /

C.....IWERT WIRD - OHNE LUECKEN - NACH JWERT UMGESPEICHERT......................
C.....DIE BYTE-LAENGEN FUER IWERT WERDEN NACH JBLA1 UMGESPEICHERT...............
C.....JX WIRD ALS INDEX FUER JWERT/JBLA1 HOCHGERECHNET..........................
C.....AM ENDE DES PROGRAMMS WIRD JWERT MIT SPUMB NACH IBLOCK GESPEICHERT........

      IF (MWERT .LT. NWERT)                 THEN
         PRINT '('' PUTPD1: FEHLER IN IWERT-DIMENSION -'',
     +           '' UP-DIM, USER-DIM='',2I7)', MWERT, NWERT
         IRM     = 1
         RETURN
      ENDIF

      IRM        = 0
      JX         = 0
      IDC        = IWERT(3)
      IBYTP      = IBYTA

      DO  10  J  = 1, 8
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = IBLA1(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL
   10 CONTINUE

      LVTYP      = IWERT(8)
      DO  20  J  = 1, ILEVL
      IF         ( LVTYP .EQ. LEVEL(J) )    THEN
         JJ      = 1
         GOTO  30
      ENDIF
   20 CONTINUE
      JJ         = 0

   30 IF         ( JJ .NE. 0)               THEN
C........1 FLAECHE
         J       = 10
         JX      = JX + 1
         IWZW    = IWERT(J)
         IBLL    = ISLA(1)
         IF (IWZW .EQ. IUNDEF)              THEN
            IWZW = IBALL(IBLL)
         ENDIF
         JWERT(JX)  = IWZW
         JBLA1(JX)  = IBLL
         IBYTP      = IBYTP + IBLL
      ELSE
C........2 FLAECHEN
         DO 40 J = 9, 10
         JX      = JX + 1
         IWZW    = IWERT(J)
         IBLL    = IBLA1(J)
         IF (IWZW .EQ. IUNDEF)              THEN
            IWZW = IBALL(IBLL)
         ENDIF
         JWERT(JX)  = IWZW
         JBLA1(JX)  = IBLL
         IBYTP      = IBYTP + IBLL
   40    CONTINUE
      ENDIF

C.....IWERT(11)  = 100 fuer das Jahr 2000; WMO-REGULATION 92.3.4 FUER FM 92 GRIB
C.....FUER INVARIANTE GRIB-FELDER IST IWERT(11..15) = 0...............26.02.1998
      IDTV       = IWERT(11)+IWERT(12)+IWERT(13)+IWERT(14)+IWERT(15)
      J          = 11
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = IBLA1(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ELSE IF (IWZW .EQ. 0)                 THEN
C........INVARIANTES GRIB-FELD, WENN IWERT(11..15)=0..................26.02.1998
         IF (IDTV .EQ. 0)                   THEN
            IWZW = 0
         ELSE             
            IWZW = 100
         ENDIF            
      ENDIF
      IW11       = IWZW
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL


      DO  50  J  = 12, 16
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = IBLA1(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL
   50 CONTINUE

C.....ITFLAG ABFRAGEN
      IF ( IWERT(19) .EQ. 10 )              THEN
C........EIN VORHERSAGEZEITRAUM
         JX      = JX + 1
         J       = 18
         IWZW    = IWERT(J)
         IBLL    = ISLA(2)
         IF (IWZW .EQ. IUNDEF)              THEN
            IWZW = IBALL(IBLL)
         ENDIF
         JWERT(JX)  = IWZW
         JBLA1(JX)  = IBLL
         IBYTP      = IBYTP + IBLL
      ELSE
C........ZWEI VORHERSAGEZEITRAEUME
         DO 60 J = 17, 18
         JX      = JX + 1
         IWZW    = IWERT(J)
         IBLL    = IBLA1(J)
         IF (IWZW .EQ. IUNDEF)              THEN
            IWZW = IBALL(IBLL)
         ENDIF
         JWERT(JX)  = IWZW
         JBLA1(JX)  = IBLL
         IBYTP      = IBYTP + IBLL
   60    CONTINUE
      ENDIF

      DO  70  J  = 19, 21
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = IBLA1(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL
   70 CONTINUE

C.....IWERT(22)  = 20 fuer das Jahr 2000; WMO-REGULATION 92.3.4 FUER FM 92 GRIB
      J          = 22
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = IBLA1(J)
C.....IDTV=0, -> INVARIANTES GRIB-FELD, -> IWERT(22)=0................26.02.1998
C.....           IWERT(22) BEHAELT DEN USER-WERT,              STANEK 30.07.1998
C      IF (IDTV .EQ. 0)
C     +IWZW       = 0      
      IF (IW11 .EQ. 100)                    THEN
         IWZW    = 20         
      ENDIF
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL

      J          = 23
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = IBLA1(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL

C.....SKALIERUNGSFAKTOR, NEGATIV-WERT MOEGLICH
      J          = 24
      JX         = JX + 1
      IBLL       = IBLA1(J)
      IWZW       = IWERT(J)
      IF (IWZW .LT. 0)                      THEN
         IF (IWZW .EQ. IBALL(IBLL))         THEN
         ELSE IF (IWZW .EQ. IUNDEF)         THEN
            IWZW = IBALL(IBLL)
         ELSE
            IWZW = -IWZW
            IWZW = IOR(IWZW,MSKSF)
         ENDIF
      ENDIF
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL
      JANZ       = INTM
      IF (JANZ .EQ. IANZ)                   GOTO 800

C.....INTN       = 36
      DO  80  J  = 25, INTN
      JX         = JX + 1
      IWZW       = IWERT(J)
      IBLL       = IBLA1(J)
      IF (IWZW .EQ. IUNDEF)                 THEN
         IWZW    = IBALL(IBLL)
      ENDIF
      JWERT(JX)  = IWZW
      JBLA1(JX)  = IBLL
      IBYTP      = IBYTP + IBLL
   80 CONTINUE
      JANZ       = INTN
      IF (JANZ .EQ. IANZ)                   GOTO 800

C...........................................AB HIER UP-VERZWEIGUNG..............
      IF (IDC.EQ.78 .OR. IDC.EQ.79)         THEN
C........DWD-ZWEIG
         IF (IWERT(37) .EQ. 253)            THEN
C.........NEU AB SEPTEMBER '05:
C.........ENSEMBLE-VORHERSAGEN, IDC=78,LPDS1=66,IWERT(37)=253,IANZ=54
          IF (IANZ .NE. 54                  .OR.
     +        IWERT(1) .NE. 66)             THEN
           PRINT '('' PUTPD1: IDC=78, ENSEMBLE-VORHERSAGE-FEHLER,'',
     +             '' IANZ,IWERT(1),IWERT(37)= 54, 66,253;'',/,
     +             ''         UEBERGEBEN WURDE:                  '', 
     +             '' IANZ,IWERT(1),IWERT(37)='',3I3)',
     +                IANZ,IWERT(1),IWERT(37)
           IRM    = 1
           RETURN
          ENDIF
         ENDIF 
         CALL PPD1_78 (IANZ,JX,IBYTP,NWERT,IUNDEF,IWERT,JWERT,JBLA1,
     +                 JX,IBYTP,IRM)
         IF (IRM .NE. 0)                    RETURN
      ELSE IF (IDC .EQ. 98                  .OR.
     +         IDC .EQ. 74)                 THEN
C........READING-ZWEIG
         CALL PPD1_98 (IANZ,JX,IBYTP,NWERT,IUNDEF,IWERT,JWERT,JBLA1,
     +                 JX,IBYTP,IRM)
         IF (IRM .NE. 0)                    RETURN
      ELSE
C........ANDERE CENTER PDB<=41, IANZ<=47  WERDEN MIT PPD1_78 UMGESETZT
         IF (IANZ .LE. 47)                  THEN
C...........DWD-ZWEIG
C           PRINT '('' PUTPD1: !!! IDC='',I4,'' - '',I4,
C    +              '' WERTE WERDEN MIT PPD1_78 UMGESETZT'')',
C    +                             IDC, IANZ
            CALL PPD1_78 (IANZ,JX,IBYTP,NWERT,IUNDEF,IWERT,JWERT,
     +                    JBLA1,JX,IBYTP,IRM)
            IF (IRM .NE. 0)                 RETURN
         ELSE
            PRINT '('' PUTPD1: FEHLER, IDC='',I4,
     +              '' BISHER NICHT DEFINIERT'')', IDC
            IRM     = 1
            RETURN
         ENDIF
      ENDIF

C.....DATEN NACH IBLOCK SPEICHERN...............................................
  800 CONTINUE
      JWERT(1)   = IBYTP - IBYTA
      IF (JWERT(1) .GT. 41)                 THEN
C......SECTION GERADZAHLIG ?
       IWZW      = MOD(JWERT(1),2)
       IF (IWZW .NE. 0)
     + JWERT(1)  = JWERT(1)+1
      ENDIF
      
      IBYTP      = IBYTA
      DO 900 J9  = 1, JX
      IWZW       = JWERT(J9)
      IBLL       = JBLA1(J9)
      IANF       = IBYTW - IBLL + 1
      CALL SPUMB (IWZW,IANF,IBLL,IBYTP,IBLOCK,IRM)
      IF (IRM .NE. 0)                       THEN
       PRINT '('' PUTPD1: FEHLER IN SPUMB - IBYTP,JWERT('',I1,'')='',
     +            2I7)', J9,IBYTP,JWERT(J)
       RETURN
      ENDIF
      IBYTP      = IBYTP + IBLL
  900 CONTINUE
      IWERT(1)   = JWERT(1)

#if defined(TEST)
C      PRINT '('' PUTPD1: JBLA1(1..'',I3,'')='',/,10I3)', JX,
C     +                  (JBLA1(K),K=1,JX)

      PRINT '('' PUTPD1: IBYTA,JX='',2I5,10X,''JWERT='',32(/,10I7))', 
     +                   IBYTA,JX,            (JWERT(K),K=1,JX)
#endif 

      RETURN
      END
