      REAL FUNCTION REFSTF (ISEDEM)

C**** REFSTF   -   FC: REFERENZ-WERT (GIB-CODE) HEXADEZ. IN REAL-WERT UMWANDELN
C**   AUFRUF   :   RSED = REFSTF (ISEDEM)
C**   ZWECK    :   REFERENZWERT (GRIB-CODE),SEDEZ. IN FLOAT.POINT UMWANDELN
C**                (REFerenzwert_Sedezimal_To_Floating);
C**                UMGEKEHRT: FUNCTION IREFTS
C**   INPUT    :   ISEDEM    32 BIT RECHTSBUENDIG, DAVON
C**                            EXPONENT HEXADEZ. (8 BIT)
C**                            MANTISSE IN HEXADEZ.DARST. (24 BIT)
C**   OUTPUT   :   RSED      FLOATING-POINT-WERT
C**   HINWEIS:   FUER NOS/VE - VERSION GILT:
C**              REFERENZWERTE BIS 16777216./-16777216. (2**24=16777216)
C**              MIT IREFTS UND UMKEHRFUNKTION REFSTF 1:1 UMSETZBAR
C**              FUER MFC-VERSION GILT:
C**              REFERENZWERTE NUR BIS 16777040./-16777040. MIT IREFTS UND
C**              UMKEHRFUNKTION REFSTF 1:1 UMSETZBAR
C**
C**   VERFASSER: EZMW 1985 /ANGEP.: G.BAGINSKI /MRZ3/ 11/88
C**              LAST MODIF.: 02/1994 (A.ZALEWSKY)
C*    GEAENDERT:   B.Loeser, TI14, 07/00, Anpassung Symbole, SHIFT/SHIFTR --> ISHFT

      IMPLICIT NONE

      INTEGER       ISEDEM, JEXP, IMANT, ISIGN, MASK1, MASK2
      DATA MASK1    / Z'FF' /
      DATA MASK2    / Z'FFFFFF' /
       
      JEXP  = ISHFT (ISEDEM, -24)
      JEXP  = IAND(JEXP, MASK1)

      IMANT = IAND (ISEDEM, MASK2)

      IF (IMANT .EQ. 0) THEN
         REFSTF= 0.0
         RETURN
      ENDIF

      ISIGN = 1
      IF (JEXP .GE. 128) THEN
         JEXP  = JEXP - 128
         ISIGN = -1
      ENDIF

C     WERT ZUSAMMENSTELLEN, OVER-/UNDERFLOW MOEGLICHST VEMEIDEN

      IF ( JEXP .GT. 64) THEN
         REFSTF = IMANT * 16.**(JEXP-70)
      ELSE
         REFSTF = (2.**(-24) * IMANT) * 16.**(JEXP-64)
      ENDIF

      REFSTF = ISIGN*REFSTF

      END
