      SUBROUTINE SCHALT (IYEAR, ISCHAL)

C**** SCHALT     - UP:PRUEFT, OB SCHALTJAHR ODER NICHT
C**   AUFRUF     : CALL SCHALT (IYEAR, ISCHAL )
C**   ZWECK      : DAS UP PRUEFT, OB ES SICH BEI DEM UEBERGEBENEN JAHR
C**                UM EIN SCHALTJAHR HANDELT.
C**   PARAMETER  : IYEAR   = JAHR (INTEGER, MIT ODER OHNE JAHRHUNDERT),
C**                          BEI 2-STELL. JAHRESZAHL WIRD JAHRHUNDERT WIE IM
C**                          ALTEN BANK-PROGRAMM ZUGEWIESEN:
C**                          IYEAR >= 50, -> 1900; IYEAR < 50, -> 2000 !
C**                ISCHAL  = WIRD 1 GESETZT, WENN ES SICH UM EIN
C**                          SCHALTJAHR HANDELT, SONST 0.
C**   QUELLE     : MEYERS HANDBUCH UEBER DAS WELTALL
C**                HERAUSGEGEBEN UND BEARBEITET VON SEBASTIAN VON HOERNER UND
C**                KARL SCHAIFERS
C**                3. NEUBEARBEITETE UND WESENTLICH ERWEITERTTE AUFLAGE, 1963
C**                BIBLIOGRAPHISCHES INSTITUT * MANNHEIM
C**                STICHPUNKT: 8. KALENDER
C**                ...  FUER UNSERE BUERGERLICHE ZEITRECHNUNG WURDE DURCH DIE
C**                GREGORIAN. KALENDERREFORM (1582) DIE LAENGE DES JAHRES AUF
C**                365,2425 MITTL. SONNENTAGE FESTGELEGT.
C**                DER AUSGLEICH DER TAGESBRUCHTEILE ERFOLGT DURCH EINSCHIEBEN
C**                VON SCHALTTAGEN.
C**                SCHALTJAHRE SIND ALLE JAHRE, DEREN 2 LETZTEN ZAHLEN DURCH
C**                4 TEILBAR SIND; Z.B. 1956, 1960, 1964.
C**                DIESE REGEL BESEITIGT ABER DEN FEHLER GEGENUEBER DER WAHREN
C**                LAENGE DES TROP. JAHRES (365,2422 MITTL. SONNENTAGE) NICHT
C**                RESTLOS.
C**                DIES WIRD ERST DURCH DIE BESTIMMUNG ERREICHT, DASS ALLE 400
C**                JAHRE 3 SCHALTJAHRE AUSZUFALLEN HABEN, UND ZWAR DIE SCHALT-
C**                TAGE DER SAEKULARJAHRE, DEREN EINHEIT NICHT DURCH 4 TEILBAR
C**                IST, ALSO DIE JAHRE 1700, 1800, 1900 SIND KEINE SCHALTJAHRE.
C**                AUCH MIT DIESER SCHALTREGEL SIND NOCH NICHT ALLE ABWEICHUNGEN
C**                BESEITIGT, ABER DIE VERBLEIBENDEN FEHLERRESTE WACHSEN ERST IN
C**                3333 JAHREN AUF EINEN TAG AN.
C**
C**   VERFASSER  : A. ZALEWSKY
C**   HINWEIS:     MOEGLICHE FEHLERQUELLE BEI 2-STELLIGER JAHRESANGABE:
C**                DIE JAHRHUNDERT-ZUWEISUNG ERFOLGT WIE IM ALTEN BANK-PROGRAMM;
C**                IYEAR<50 -> IJAHR=2000, IYEAR>=50 -> IJAHR=1900

C     MODIFICATION: BEI 2-STELLIGER JAHRESANGABE, IYEAR=0, DAS JAHR 2000 ABFANGEN 
C                   AZALEWSK, TI12................................30.11.98
C     MODIFICATION: HINWEIS.......................................14.01.99
C                   B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER  IJAHR, IYEAR, ISCHAL

      IJAHR      = IYEAR

C.....JAHRESWERTE, DIE NICHT DURCH 4 TEILBAR SIND, SIND KEINE SCHALTJAHRE
      ISCHAL     = 0
C.....IYEAR=0, --> 1900 KEIN SCHALTJAHR, ABER
C..............--> 2000      SCHALTJAHR............................30.11.98
      IF (IJAHR .NE. 0)                     THEN      
         IF (MOD(IJAHR,4) .NE. 0)           RETURN
      ENDIF
      
C.....JAHRESWERT MIT JAHRHUNDERTANGABE FUER SAEKULARJAHRE
C.....JAHRHUNDERT NUR UEBER IYEAR, NICHT UEBER ICENT................14.01.99
C.....IF (IJAHR .LT. 100)                   IJAHR = ICENT() + IYEAR
      IF (IJAHR .LT. 100)                   THEN
         IF (IJAHR .LT. 50)                 THEN
            IJAHR       = 2000 + IYEAR
         ELSE
            IJAHR       = 1900 + IYEAR
         ENDIF 
      ENDIF                        

C.....SAEKULARJAHRE, DIE DURCH 400 TEILBAR SIND, SIND SCHALTJAHRE
      ISCHAL     = 1
      IF (MOD(IJAHR,400) .EQ. 0)            RETURN

C.....RESTL. SAEKULARJAHRE SIND KEINE SCHALTJAHRE
      ISCHAL     = 0
      IF (MOD(IJAHR,100) .EQ. 0)            RETURN

C.....VERBLEIBENDEN JAHRE SIND SCHALTJAHRE
      ISCHAL     = 1

      RETURN
      END
