      LOGICAL FUNCTION SYNTAX (YSTRNG,YMIN,YMAX,IFCCH,MAXOK)
C**** SYNTAX   -   SYNTAX-PRUEFUNG EINER CHARACTER-GROESSE
C**   AUFRUF:      LOGIC = SYNTAX (YSTRNG,YMIN,YMAX,IFCCH,MAXOK)
C**   ZWECK:       EINE CHARAKTER-GROESSE WIRD AUF FORMALE SYNTAX
C**                GEPRUEFT, DABEI KANN EINE EIGENE CHARAKTER-
C**                WICHTUNGS-FUNKTION /IFCCH/ BENUTZT WERDEN.
C**   METHODE:     JEDE ZEICHENPOSITION AUS /YMIN/ (RANG-NIEDERSTEM
C**                ZEICHEN-WERT) UND /YMAX/(RANG-HOECHSTEM ZEICHEN-
C**                -WERT) BILDEN EIN GRENZWERTE EINSCHLIESSENDES
C**                INTERVALL. JEDE ENTSPRECHENDE ZEICHEN-POSITION
C**                AUS /YSTRNG/ WIRD AUF INTERVALL-ZUGEHOERIGKEIT
C**                UEBERPRUEFT. LIEGT AUCH NUR 1 ZEICHEN AUSSERHALB
C**                DES WERTE-INTERVALLS, RESULTIERT DIE FUNKTION MIT
C**                .FALSE., SOWIE IN /MAXOK/ DAS MAXIMAL NOCH RICH-
C**                TIGE ZEICHEN. UNTERSCHIEDLICHE CHARACTER-STRING-
C**                LAENGEN (YSTRNG,YMIN,YMAX) WERDEN WIE ZUR MAXIMAL
C**                VORKOMMENDEN LAENGE NACH RECHTS MIT LEERZEICHEN GE-
C**                FUELLT BEHANDELT. BEISPIEL:
C**                LWAHR = SYNTAX ('ABC','AAA','CCC',ICHA ,MAXOK)
C**                LWAHR = .TRUE.   ,   MAXOK = 3
C**                ICHA  = ASCCI6-ZEICHEN-WICHTUNGS-FUNCTION, WIE ICHAR
C**   SONDERFALL:  SIND EIN ODER MEHRERE YMIN-ZEICHEN HOEHER-RANGIG,
C**                ALS DIE ENTSPRECHENDEN YMAX-ZEICHEN, SO GILT FUER
C**                EIN WAHRES ERGEBNIS:/YSTRNG/ ZEICHEN-WERT LIEGT
C**                A U S S E R H A L B   DES GRENZWERTE EINSCHLIESSENDEN
C**                INTERVALLS (YMAX-YMIN)
C**   EXTERNALS:   IFCCH  ZEICHEN-WICHTUNGS-FUNKTION
C**   PARAM:       YSTRNG AUF KORREKTE SYNTAX ZU UEBERPRUEFENDE CHAR.-
C**                       GROESSE.
C**                YMIN   EINSCHLIESSLICHE ZEICHEN-WERT-INTERVALL-GRENZE
C**                YMAX   ..............................................
C**                IFCCH  ZEICHEN-WICHTUNGS-FUNKTION
C**                       ICHA  = ZEICHEN-WICHTUNGS-FUNCTION FUER ASCCI6
C**                        BITTE AN EXTERNAL-ANWEISUNG DENKEN...
C**                MAXOK  LETZTE NOCH RICHTIGE SYNTAX-POSITION VON LINKS
C**                       NACH RECHTS MIT 0 BEGINNEND.
C     VERFASSER:   U. VOIGT
C     Geandert:    B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER ILEN, ILENN, ILENX, ILEMAX, J, IMAX, MAXOK
      INTEGER IFCCH, ICH, IMIN
      EXTERNAL IFCCH
      CHARACTER *(*) YSTRNG,YMIN,YMAX
C
C
      SYNTAX = .FALSE.
      ILEN   = LEN (YSTRNG)
      ILENN  = LEN (YMIN)
      ILENX  = LEN (YMAX)
      ILEMAX = MAX0 (ILENN,ILENX,ILEN)
C
C
      DO 100 J = 1 , ILEMAX
C
C     INTERVALL-UNTERGRENZE BILDEN
C
      IF ( J .GT. ILENN ) THEN
         IMIN = IFCCH (' ')
      ELSE
         IMIN = IFCCH (YMIN(J:J))
      ENDIF
C
C     INTERVALL-OBERGRENZE BILDEN
C
      IF ( J .GT. ILENX ) THEN
         IMAX = IFCCH (' ')
      ELSE
         IMAX = IFCCH (YMAX(J:J))
      ENDIF
C
C     ZEICHEN-PRUEFLING EXTRAHIEREN
C
      IF ( J .GT. ILEN ) THEN
         ICH = IFCCH (' ')
      ELSE
         ICH = IFCCH (YSTRNG(J:J))
      ENDIF
C
C     WEICHE FUER NORMALES ODER INVERSES INTERVALL
      IF ( IMIN .GT. IMAX ) THEN
         IF( (ICH .LE. IMIN) .AND. (ICH .GE. IMAX) ) GO TO 999
      ELSE
         IF( (ICH .LT. IMIN) .OR. (ICH .GT. IMAX) ) GO TO 999
      ENDIF
100   CONTINUE
C
      SYNTAX = .TRUE.
C
999   MAXOK = J - 1
      RETURN
      END
