      SUBROUTINE   TYPKD (NTYP, YTYP, YVAR, IWTYP, IWGDB, IRM)

C**** TYPKD    -   UP:KENNDATEN FUER DATENBANKTYP (NR) AUSGEBEN
C**   AUFRUF   :   CALL TYPKD (NTYP, YTYP, YVAR, IWTYP, IWGDB, IRM)
C**   ZWECK    :   KENNDATEN FUER VORGEG. DATENBANKTYP(ODER -NR)  BEREITSTELLEN
C**                (BANK_TYP_KENN_DATEN)
C**
C**   ACHTUNG:     FUER GRIB 1 WIRD MIT AUSNAHME DER FOLGENDEN KENNDATEN DIE
C**                WARTUNG DIESES UNTERPROGRAMMS EINGESTELLT :
C**                YVAR (1), YVAR (2)
C**                IWTYP (1),   IWTYP (3)   ,IWTYP (4)
C**
C**
C**
C**   PARAMETER:   INPUT:
C**                NTYP      NR DES DATENBANKTYPS
C**                          (WENN NTYP=0 WIRD IN YTYP DER TYP-NAME (Z.B. 'BKF')
C**                           ODER DIE TYP-NR.(Z.B.'22') ERWARTET;
C**                YTYP      TYP-NAME (Z.B. 'RBKF'); 1 - 5 CHARAKTER LANG;
C**                          BEI NICHT EINDEUTIGEM TYP-NAMEN (Z.B. 'RBK')
C**                          ERFOLGT FEHLERMELDUNG ;
C**                          ES KANN AUCH DIE TYP-NR.(CHAR.) UEBERGEBEN WERDEN;
C**                          DIE TYP-NR.(INTEGER)  WIRD IN IWTYP(1) GELIEFERT
C**                          (DIMENSIONIERUNG: CHARACTER YTYP*5)
C**                OUTPUT:
C**                YVAR      (1)  VOLLSTAENDIGER TYP-NAME (5 CHARAKTER LANG);
C**                               BEI NICHT BELEGTER TYP-NR WIRD YVAR(1)=' ',
C**                               BEI NICHT ERLAUBTER TYP-NR IRM=1 GESETZT
C**                          (2)  FORMAT-KENNBUCHSTABE (Z.B. 'N')
C**                               (DIMENSIONIERUNG: CHARACTER YVAR(2)*5)
C**
C**                IWTYP     (1)  TYP-NR (FUER PROD.-DEFINITION-BLOCK)
C**                          (2)  BLOCK-FLAG (FUER PDB, NACH GRIB-TAB. 1), 8 BIT
C**                          (3)  BITMAP-NR. (FUER BITMAP-BLOCK)
C**                          (4)  DEFAULT-LAENGE DES GRIB-FELDES IN WORTEN
C**                          (5)  BDB-FLAG (VERSCHL. NACH GRIB-TAB. 11), 4 BIT
C**                IWGDB     EINZELWERTE FUER DEN GRID-DEFINITION-BLOCK (GDB)
C**                          (1)-(3) UNBENUTZT
C**                          (4)     PROJEKTIONS-ART (NACH GRIB-TAB. 6)
C**                          (5)-(16) WIE IM UP GETGDB/PUTGDB BESCHRIEBEN
C**                                   ALLE ANGABEN IN GRAD ODER KM: * 1000
C**                          (5)-(19) BEI ROTIERTEM POL
C**                          (5)-(22) BEI ROTIERTEM POL, GESTRECKT (GEPLANT)
C**                IRM       FEHLER, WENN UNGLEICH 0
C**   HINWEISE:    BEI GEOGR. KOORDINATEN GILT:  + = NORD/OST
C**                                              - = SUED/WEST
C**                ES SIND  800  TYPEN VORGESEHEN, DAVON DIE ERSTEN 20 ALS
C**                Meldungen, ab 500 werden auswaertige BUFR verarbeitet,
C**                EINE AKTUELLE LISTE LIEFERT DAS HP TYPEN
C**   VERFASSER:   G. BAGINSKI/A.ZALEWSKY - LETZTE AEND: FREYBERG-01/94
C*    GEAENDERT:   
C*                 A.Zalewsky, TI14, 11.01.06; i.A. von TI12-Fr.Hechler,
C*                             NEU:
C*                             TYP 'GPEPS' unter NTYP= 36,
C*                             TYP 'LM4MO','LM4AN','LM5MO','LM5AN','LM6MO',
C*                                 'LM6AN','LM7MO','LM7AN','LM8MO','LM8AN',
C*                                 'LM9MO','LM9AN' unter NTYP=213 bis 224;
C*                             geloescht wird:
C*                             TYP 'DXRAD' unter NTYP=301;
C* 
C*                 A.Zalewsky, TI14, 01.04.04; neu: TYP 'LFMOD' unter NTYP=255
C*                                                  TYP 'GRIBS' unter NTYP=300
C*                                                  TYP 'DXRAD' unter NTYP=301
C*                                                  IFZ = 310   
C*                 A.Zalewsky, TI14, 22.10.02; neu: TYP 'KWB03' unter NTYP=124
C*                                                  TYP 'SGBSH' unter NTYP=205
C*                 B.Loeser, 11/00, IMPLICIT NONE, BLEND --> LEN_TRIM
C*                 B.Loeser, TI14, 08/00, Anpassung Symbole

      IMPLICIT NONE
      INTEGER      ICHINT, ID, IFZ, INDE, IPP, IRM, IWGDB, IWGDBI
      INTEGER      IWTYP, IZW, J, J1, J4, J5, K, KENND, LYVAR
      INTEGER      MAXM, MAXTY, NE, NPR, NTYP, NTYPZW, NZW
      INTEGER      IREFTS
      EXTERNAL     IREFTS
      REAL         REF
      CHARACTER    AKMG
      EXTERNAL     AKMG, YAKMG

C     BEI WEITEREN FORMATEN GGF. MELD, IFZ UND MAXTY AENDERN:
C     PARAMETER  ( MAXM=20, IFZ=280, MAXTY=800)
      PARAMETER  ( MAXM=20, IFZ=310, MAXTY=800)

      CHARACTER    YTYLST(MAXTY)*5, YFTLST(IFZ)*2, YVARZ*5, YAKMG*5
      CHARACTER    *(*) YVAR (2), YTYP, YTYLSI(MAXTY)*5

      DIMENSION    IWTYP(*), IWGDB(*)
      DIMENSION    KENND(5,IFZ), IWGDBI(22,IFZ)

C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     HINWEIS: DER INTERNE INDEX FUER ALLE FELD-TABELLEN IST GEGENUEBER
C              DER TYP-NR UM 20 REDUZIERT
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C     TYPEN-MNEMONICS
C     INDEX (MELDUNGEN): 1 - 20
      DATA       ( YTYLST(K),K=1, 50 )
     +/'SYNOP','TEMPS','SATEM','SATOB','AGRAR','CLIMA','RADIO','METAR',
     + 'BASYN','     ','     ','     ','     ','     ','MEDIL','TRABU',
     + 'MEDIA','PSYNO','PBUFR','BUFRS',
C       FELDINDEX: 
C           21 - 30       --> 1  - 10
     +               'BKFMO', 'RBKFM', 'BKNMO', 'RBKNM', 'AN2MO',
     +               'RAN2M', 'ASSMO', 'RASSM', 'MITLM', 'RMITL',
C           31 - 40       -->11  - 20
     +               'IGELM', 'RIGEL', 'ANALY', 'WAMIT', 'GLMIT',
     +               'GPEPS', '     ', '     ', '     ', '     ',
C           41 - 50       -->21  - 30
     +               'B021V', 'B042V', 'B063V', 'B106V', 'G106S',
     +               'S021V', 'S042V', 'S063V', 'S106V', 'G106H'/
      DATA       ( YTYLST(K),K=51,100 )
C           51 - 60       -->31  - 40
     +          /    '     ', '     ', 'AN1MO', 'RAN1M', 'EM4AN',
     +               'EM4MO', '     ', 'EM3AN', 'EM3MO', 'EM3DA',
C           61 - 70       -->41  - 50
     +               'ECMFM', 'ECSMO', 'EGRRM', 'KWBCM', 'LFPWM',
     +               'EGRRS', 'WAFST', 'KWB01', 'SGGLO', 'GLFPW',
C           71 - 80       -->51  - 60
     +               'B021A', 'B042A', 'B063A', 'B106A', 'SGMED',
     +               'S021A', 'S042A', 'S063A', 'S106A', 'ECENS',
C           81 - 90       -->61  - 70
     +               'NORMW', 'DKMIT', 'SAFTA', 'NORM3', 'SGNAT',
     +               'SGESH', 'SGBAL', 'MOMI3', 'EZKLM', 'EWOLF',
C           91 - 100      -->71  - 80
     +               'P021A', 'P042A', 'P063A', 'P106A', 'P106R',
     +               'P021V', 'P042V', 'P063V', 'P106V', '     '/
      DATA       ( YTYLST(K),K=101,150)
C          101 - 110      -->81  - 90
     +           /   'MEEM3', 'ME106', 'MEBKF', 'GLOBA', '     ',
     +               'RMEM3', 'RM106', 'RMBKF', 'GLOBV', 'EMRHM',
C          111 - 120      -->91  - 100
     +               'DM3AN', 'DM3MO', 'BM1AN', 'BM1MO', 'DM4AN',
     +               'DM4MO', 'TFSAN', 'TFSMO', '     ', '     ',
C          121 - 130      -->101 - 110
     +               'WAFTF', 'WAFSZ', 'KWB02', 'KWB03', '     ',
     +               '     ', '     ', '     ', '     ', '     ',
C          131 - 140      -->111 - 120
     +               'LM1AN', 'LM1MO', 'LM1RA', 'LM2AN', 'LM2MO',
     +               'LM2RA', 'LM3AN', 'LM3MO', 'LM3RA', '     ',
C          141 - 150      -->121 - 130
     +               'I032A', 'I032F', 'I048A', 'I048F', 'I064A',
     +               'I064F', 'I096A', 'I096F', 'I128A', 'I128F'/
      DATA       ( YTYLST(K),K=151,200)
C          151 - 160      -->131 - 140
     +           /   'R032A', 'R032F', 'R048A', 'R048F', 'R064A',
     +               'R064F', 'R096A', 'R096F', 'R128A', 'R128F',
C          161 - 170      -->141 - 150
     +               'G032A', 'G032F', 'G048A', 'G048F', 'G064A',
     +               'G064F', 'G096A', 'G096F', 'G128A', 'G128F',
C          171 - 180      -->151 - 160
     +               'I016A', 'I016F', 'I192A', 'I192F', 'I256A',
     +               'I256F', 'G016A', 'G016F', 'G192A', 'G192F',
C          181 - 190      -->161 - 170
     +               'G256A', 'G256F', 'R016A', 'R016F', 'R192A',
     +               'R192F', 'R256A', 'R256F', 'E016A', 'E032A',
C          191 - 200      -->171 - 180
     +               'E048A', 'E064A', 'E096A', 'E128A', 'E192A',
     +               'E256A', 'SGGM0', 'SGGM1', 'SGGM2', 'SGGM3'/
      DATA       ( YTYLST(K),K=201,499)
C          201 - 210      -->181 - 190
     +           /   'SGLM0', 'SGLM1', 'SGLM2', 'SGLM3', 'SGBSH',
     +               '     ', '     ', '     ', '     ', '     ',
C          211 - 220      -->191 - 200
     +               'EGMES', 'LFMES', 'LM4MO', 'LM4AN', 'LM5MO',
     +               'LM5AN', 'LM6MO', 'LM6AN', 'LM7MO', 'LM7AN',
C          221 - 250      -->201 - 230
     +               'LM8MO', 'LM8AN', 'LM9MO', 'LM9AN', '     ',
     +            25*'     ',                                     
C          251 - 290      -->231 - 270
     +               '     ', '     ', '     ', '     ', 'LFMOD',
     +            35*'     ',
C          291 - 300      -->271 - 280
     +               '     ', '     ', '     ', '     ', '     ', 
     +               '     ', '     ', '     ', '     ', 'GRIBS',
C          301 - 499      -->281 - 479
     +               '     ', '     ', '     ', '     ', '     ',                      
     +           194*'     '/


C     INDEX (auswaertige BUFRs) : 500-800
      DATA       ( YTYLST(K),K=500,800)
     +/'SLAND','SUSEA','VSNOS','VSSAT','SLNOS','SLSAT','RADAR',
     +     245*'     ','WEPEC','MEDEC',47*'     '/
C
C     FORMATE (SOWEIT-VORHANDEN)
      DATA       ( YFTLST(ID),ID=1,IFZ) 
     +           / 'N', 'N', '7', '7', 'N',
     +             'N', 'N', 'N', 'N', 'N',
     +             '8', '8', 'F', 'F', ' ',
     +             17*' ', 2*'7', 6*' ',
     +             'P', 'P', 'Q', 'O', 'Q',
     +             15*' ',
     +              2*' ','N', 2*' ',
     +             15*' ',
     +             ' ', ' ', 'N', ' ', ' ',
     +             ' ', ' ', 'N', ' ', ' ',
     +             10*' ',
     +             10*' ',
     +            200*' ' /

C     BLOCK-FLAG (PDB) - 8 BITS -
      DATA       ( KENND(2,ID),ID=1,IFZ)
     +           / Z'C0', Z'C0', Z'80', Z'80', Z'C0',
     +             Z'C0', Z'C0', Z'C0', Z'C0', Z'C0',
     +             Z'80', Z'80', Z'C0', Z'C0', Z'80',
     +             Z'80', Z'C0', Z'80', Z'C0',    0,
     +           4*Z'80',                      Z'C0',
     +           4*Z'80',                      Z'C0',
     +          10*Z'80',
     +             Z'80', Z'80', Z'80', Z'80', Z'80',
     +             Z'80', Z'80', Z'40', Z'80', Z'80',
     +          10*Z'80',
     +             Z'C0', Z'C0', Z'C0', Z'80', Z'C0',
     +             Z'C0', Z'C0', Z'80', Z'80', Z'80',
     +          10*Z'80',
     +             Z'80', Z'80', Z'C0', Z'80', Z'80',
     +             Z'80', Z'80', Z'C0', Z'80', Z'80',
     +          30*Z'80',
     +         190 *  0  /

C     NRBMAP
      DATA       ( KENND(3,ID),ID=1,IFZ)
     +           /    3,      4,      0,      0,      3,
     +                4,      3,      4,      3,      4,
     +                0,      0,      9,      1,      0,
     +                0,      5,      0,      5,      0,
     +                0,      0,      0,      0,      8,
     +                0,      0,      0,      0,      6,
     +             30*0,
     +                0,      0,      0,      0,      7,
     +               10,     11,      0,      0,      0,
     +               10*0,
     +                0,      0,      3,      0,      0,
     +                0,      0,      3,      0,      0,
     +                0,      0,      0,      0,      0,
     +            215*0  /

C.....GRIB-LAENGE  (WORTE) - ALT = GRIB_0 -
CIF $MODIFICATION(CD4) OR $MODIFICATION(IRIS)
C     DATA       ( KENND(4,ID),ID=1,80)
C    +           / 2594, 2594, 1312, 1312, 2594,
C    +             2594, 2594, 2594, 2594, 2594,
C    +              102,  102, 1212, 1212, 9238,
C    +             2540, 2472, 2540, 2472,    0,
C    +             1088, 4160, 9280,38600, 3104,
C    +              444, 1484, 3184, 5864, 5012,
C    +                0,    0, 1312, 1312, 3020,
C    +             3020,    0,11742,11742,  534,
C    +             1000, 3682,  412, 1356,  412,
C    +             2812,  688,  600, 2060,  412,
C    +             1088, 4160, 9280,38600,  600,
C    +              444, 1484, 3184, 5864, 3682,
C    +              332,  332,  520, 7400, 1128,
C    +             1990,  890,14650, 5160, 2000,
C    +              644, 2416, 5320,14584,14584,
C    +              644, 2416, 5320,14584,    0/
C     DATA       ( KENND(4,ID),ID=81,IFZ)
C    +           /11742,14584, 2594, 6616,    0,
C    +            11742,14584, 2594, 6616,  868,
C    +             6008, 6008,11072,11072,13400,
C    +            13400, 6008, 6008,    0,    0,
C    +             2500, 3000,25000,    0,    0,
C    +                0,    0,    0,    0,    0,
C    +             6008, 6008, 6008, 6008, 6008,
C    +             6008, 6008, 6008, 6008,    0,
C    +            190*0 /
CELSE
C     DATA       ( KENND(4,ID),ID=1,80)
C    +           / 1297, 1297,  656,  656, 1297,
C    +             1297, 1297, 1297, 1297, 1297,
C    +               51,   51,  606,  606, 4619,
C    +             1270, 1236, 1270, 1236,    0,
C    +              544, 2080, 4640,19300, 1552,
C    +              222,  742, 1592, 2932, 2506,
C    +                0,    0,  656,  656, 1510,
C    +             1510,    0, 5871, 5871,  267,
C    +              500, 1841,  206,  678,  206,
C    +             1406,  344,  300, 1030,  206,
C    +              544, 2080, 4640,19300,  300,
C    +              222,  742, 1592, 2932, 1841,
C    +              166,  166,  260, 3700,  564,
C    +              995,  445, 7325, 2580, 1000,
C    +              322, 1208, 2660, 7292, 7292,
C    +              322, 1208, 2660, 7292,    0/
C     DATA       ( KENND(4,ID),ID=81,IFZ)
C    +           / 5871, 7292, 1297, 3308,    0,
C    +             5871, 7292, 1297, 3308,  434,
C    +             3014, 3014, 5536, 5536, 6700,
C    +             6700, 3014, 3014,    0,    0,
C    +             1250, 1500,12500,    0,    0,
C    +                0,    0,    0,    0,    0,
C    +             3004, 3004, 3004, 3004, 3004,
C    +             3004, 3004, 3004, 3004,    0,
C    +            190*0 /
CIFEND

C     GRIB-LAENGE  (WORTE)  - NEU = GRIB_1 -
#if defined CRAY
      DATA       ( KENND(4,ID),ID=1,80)
     +           / 1300, 1300,  659,  659, 1300,
     +             1300, 1300, 1300, 1300, 1300,
     +               54,   54,  609,  609, 4622,
     +             1273, 1239, 1273, 1239,    0,
     +              547, 2083, 4643,19303, 1555,
     +              225,  745, 1595, 2935, 2509,
     +                0,    0,  659,  659, 1513,
     +             1513,    0, 5874, 5874,  270,
     +              503, 1844,  209,  681,  209,
     +             1409,  347,  303, 1033,  209,
     +              547, 2083, 4643,19303,  303,
     +              225,  745, 1595, 2935, 1844,
     +              169,  169,  263, 3703,  567,
     +              998,  448, 7328, 2583, 1003,
     +              325, 1211, 2663, 7295, 7295,
     +              325, 1211, 2663, 7295,    0/
      DATA       ( KENND(4,ID),ID=81,120)
     +           / 5874, 7295, 1300, 3311,    0,
     +             5874, 7295, 1300, 3311,  437,
     +             3014, 3014, 5539, 5539, 6700,
     +             6700, 3014, 3014,    0,    0,
     +             1250, 1500,12500,    0,    0,
     +                0,    0,    0,    0,    0,
     +             3007, 3007, 3007, 3007, 3007,
     +             3007, 3007, 3007, 3007,    0/
C Dummy - Werte , damit nichts abstuerzt, vorlaeufig
C bis von FE genaue Zahlen kommen
      DATA       ( KENND(4,ID),ID=121,IFZ)
     +           /  181*                  25000,
     +                9*                      0/
C     DATA       ( KENND(4,ID),ID=121,IFZ)
C    +           /25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,25000,25000,25000,25000,
C    +            25000,    0,    0,    0,    0,
C    +            100*0 /
#else
      DATA       ( KENND(4,ID),ID=1,80)
     +           / 2600, 2600, 1318, 1318, 2600,
     +             2600, 2600, 2600, 2600, 2600,
     +              108,  108, 1218, 1218, 9244,
     +             2546, 2478, 2546, 2478,    0,
     +             1094, 4166, 9286,38606, 3110,
     +              450, 1490, 3190, 5870, 5018,
     +                0,    0, 1318, 1318, 3026,
     +             3026,    0,11748,11748,  540,
     +             1006, 3688,  418, 1362,  418,
     +             2818,  694,  606, 2066,  418,
     +             1094, 4166, 9286,38606,  606,
     +              450, 1490, 3190, 5870, 3688,
     +              338,  338,  526, 7406, 1134,
     +             1996,  896,14656, 5166, 2006,
     +              650, 2422, 5326,14590,14590,
     +              650, 2422, 5326,14590,    0/
      DATA       ( KENND(4,ID),ID=81,120)
     +           /11748,14590, 2600, 6622,    0,
     +            11748,14590, 2600, 6622,  874,
     +             6028, 6028,11078,11078,13400,
     +            13400, 6028, 6028,    0,    0,
     +             2500, 3000,25000,    0,    0,
     +                0,    0,    0,    0,    0,
     +             6014, 6014, 6014, 6014, 6014,
     +             6014, 6014, 6014, 6014,    0/
C Dummy - Werte , damit nichts abstuerzt, vorlaeufig
C bis von FE genaue Zahlen kommen
      DATA       ( KENND(4,ID),ID=121,IFZ)
     +           /  181*                  50000,
     +                9*                      0/
C     DATA       ( KENND(4,ID),ID=121,IFZ)
C    +           /50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,50000,50000,50000,50000,
C    +            50000,    0,    0,    0,    0,
C    +            100*0 /
#endif 


C     BDB-FLAG (4 BITS)
      DATA       ( KENND(5,ID),ID=1,IFZ)
     +           /  25 * 0 , 4 * 8, 0,
     +              20 * 0,
     +               5 * 0,  4 * 8, 0,
     +              20*0,
     +              10*0,
     +             220*0 /

C     PROJEKTIONS-ART  - IWGDBI(4) -
      DATA       ( IWGDBI(4,ID),ID=1,80)
     +           /5,  5,  5,  5,  5,
     +            5,  5,  5,  5,  5,
     +            5,  5,  5,  5,  4,
     +            5,  5,  5,  5,  0,
     +            4,  4,  4,  4,  4,
     +            50, 50, 50, 50, 4,
     +             0,  0, 5,  5, 10,
     +            10, 10, 10, 10,10,
     +             0,  0,  0,  0, 0,
     +             0,  0,  0,  0, 0,
     +             4,  4,  4,  4, 0,
     +            50, 50, 50, 50, 0,
     +            0,  0,  5,  0,  5,
     +            5,  5,  0,  0,  0,
     +            0,  0,  0,  0,  0,
     +            0,  0,  0,  0,  0/
      DATA      ( IWGDBI(4,ID),ID=81,IFZ)
     +          /10,  0,  5,  0,  0,
     +           10,  0,  5,  0, 10,
     +           10, 10, 10, 10, 10,
     +           10, 10, 10,  0,  0,
     +            0,  0,  0,  0,  0,
     +            0,  0,  0,  0,  0,
     +           10, 10, 10, 10, 10,
     +           10, 10, 10, 10,  0,
     +           190 * 0 /

C     IWGDBI(5)
      DATA       ( IWGDBI(5,ID),ID=1,80)
     +        /  79,  79,  57,  57,  79,
     +           79,  79,  79,  79,  79,
     +           12,  12,  54,  54, 192,
     +           4*73,                0,
     +           64, 128, 192, 320, 320,
     +           21,  42,  63, 106, 320,
     +            0,   0,  57,  57,  81,
     +           81,   0, 181, 181,  31,
     +          241, 120,  37,  72,  37,
     +           72,  37,  91, 120,  37,
     +           64, 128, 192, 320,  85,
     +           21,  42,  63, 106, 122,
     +           36,  36,  79, 241,  54,
     +           56,  75, 241, 144,   0,
     +           48,  96, 144, 240, 240,
     +           48,  96, 144, 240,   0/
      DATA     ( IWGDBI(5,ID),ID=81,IFZ)
     +         /181, 240,  79, 144,   0,
     +          181, 240,  79, 144,  40,
     +          109, 109, 121, 121, 163,
     +          163, 109, 109,   0,   0,
     +            0,  72, 360,   0,   0,
     +            0,   0,   0,   0,   0,
     +           51,  51,  51, 100, 100,
     +          100, 200, 200, 200,   0,
     +          190*0 /

C     IWGDBI(6)
      DATA       ( IWGDBI(6,ID),ID=1,80)
     +        /  79,  79,  45,  45,  79,
     +           79,  79,  79,  79,  79,
     +           13,  13,  54,  54,  96,
     +             4* 69,             0,
     +           32,  64,  96, 160,  80,
     +           21,  42,  63, 106,  80,
     +            0,   0,  45,  45,  73,
     +           73,   0, 129, 129,  30,
     +          121,  61,  21,  37,  21,
     +           73,  21,  45,  61,  21,
     +           32,  64,  96, 160,  33,
     +           21,  42,  63, 106,  41,
     +           16,  16,  79,  61,  60,
     +          116,  88, 121,  71,   0,
     +           25,  49,  73, 121, 121,
     +           25,  49,  73, 121,   0/
      DATA       ( IWGDBI(6,ID),ID=81,IFZ)
     +         /129, 121,  79,  91,   0,
     +          129, 121,  79,  91,  40,
     +          109, 109, 181, 181, 163,
     +          163, 109, 109,   0,   0,
     +            0,  73, 180,   0,   0,
     +            0,   0,   0,   0,   0,
     +           51,  51,  51, 100, 100,
     +          100, 200, 200, 200,   0,
     +          190 * 0 /

C     IWGDBI(7)
      DATA       ( IWGDBI(7,ID),ID=1,80)
     +         /  -9372,  -8642,  21246,  21834,  -9372,
     +            -8642,  -9372,  -8642,  -9372,  -8642,
     +            39370,  40638, -10447, -10447,  90000,
     +            29470,  29772,  29470,  29772,      0,
     +           -85761, -87864, -88572, -89142,    561,
     +               21,     42,     63,    106,    561,
     +                0,      0,  21246,  21834, -23500,
     +           -23500,      0, -32000, -32000, -15500,
     +           -90000, -90000,  25000, -90000,  25000,
     +           -90000,      0,      0, -90000,  25000,
     +           -85761, -87864, -88572, -89142,  30000,
     +               21,     42,     63,    106,  90000,
     +            90000,  90000,  -9372,      0,   4790,
     +            50570,  53960, -90000, -87500,      0,
     +           -90000, -90000, -90000, -90000, -90000,
     +           -90000, -90000, -90000, -90000,      0/
      DATA       ( IWGDBI(7,ID),ID=81,IFZ)
     +         / -32000, -90000,  -9372, -90000,      0,
     +           -32000, -90000,  -9372, -90000, -19500,
     +           -14500, -14500, -14000, -14000, -17000,
     +           -17000, -17000, -17000,      0,      0,
     +                0, -90000,  89500,      0,      0,
     +                0,      0,      0,      0,      0,
     +             7972,   7972,   7972,   7972,   7972,
     +             7972,   7972,   7972,   7972,      0,
     +           190 *0  /

C     IWGDBI(8)
      DATA       ( IWGDBI(8,ID),ID=1,80)
     +         / -35000, -35000, -28660, -28590, -35000,
     +           -35000, -35000, -35000, -35000, -35000,
     +            -8435,  -7593, -35000, -35000,      0,
     +           -13749, -13614, -13749, -13614,      0,
     +                0,      0,      0,      0,      0,
     +                1,      1,      1,      1,      0,
     +                0,      0, -28660, -28590, -28000,
     +           -28000,      0, -57000, -57000,  -7500,
     +          -180000,-180000, -45000,-180000, -45000,
     +          -180000,      0,      0,-180000, -45000,
     +                0,      0,      0,      0,  -6000,
     +                1,      1,      1,      1, -81000,
     +                0,      0, -35000,-180000, -63350,
     +           -20470,   8710,-180000,-180000,      0,
     +                0,      0,      0,      0,      0,
     +                0,      0,      0,      0,      0/
      DATA       ( IWGDBI(8,ID),ID=81,IFZ)
     +         / -57000,      0, -35000,      0,      0,
     +           -57000,      0, -35000,      0, -12500,
     +            -7000,  -7000,  -5000,  -5000, -12500,
     +           -12500, -12500, -12500,      0,      0,
     +                0,-180000,    500,      0,      0,
     +                0,      0,      0,      0,      0,
     +             1252,   1252,   1252,   1252,   1252,
     +             1252,   1252,   1252,   1252,      0,
     +           190 *0  /

C     IWGDBI(9)
      DATA       ( IWGDBI(9,ID),ID=1,80)
     +           / 14*0,                       Z'80',
     +              5*0,
     +          4* Z'80',                      Z'80',
     +          4*    1,                       Z'80',
     +         10*    0,
     +         10* Z'80',
     +          4* Z'80',                         0,
     +          4*    1,                       Z'80',
     +          3*    0,                Z'80',    0,
     +          2*    0,         Z'80', Z'80', Z'80',
     +          5* Z'80',
     +          4* Z'80',                         0/
      DATA       ( IWGDBI(9,ID),ID=81,IFZ)
     +            /   0,  Z'80',    0,  Z'80',    0,
     +                0,  Z'80',    0,  Z'80', Z'80',
     +             Z'80', Z'80',    0,     0,  Z'80',
     +             Z'80',    0,     0,     0,     0,
     +             Z'80', Z'80', Z'80',    0,     0,
     +                0,     0,     0,     0,     0,
     +           5*Z'80',
     +           4*Z'80',                         0,
     +         190*   0        /

C     IWGDBI(10)
      DATA       ( IWGDBI(10,ID),ID=1,80)
     +       /14* 10000,                              0,
     +         4* 10000,                              0,
     +            85761,  87864,  88572,  89142,  89142,
     +              4*0,                          89142,
     +                0,      0,  10000,  10000,  12500,
     +            12500,      0,  32000,  32000,  -1000,
     +            90000,  90000,  75000,  90000,  75000,
     +            90000,      0,  88000,  90000,  75000,
     +            85761,  87864,  88572,  89142,  46000,
     +                0,      0,      0,      0,  30000,
     +            15000,  15000,  10000,  90000, -35000,
     +           -35000,  10000,  90000,  87500,      0,
     +            90000,  90000,  90000,  90000,  90000,
     +            90000,  90000,  90000,  90000,      0/
      DATA       ( IWGDBI(10,ID),ID=81,IFZ)
     +           /32000,  90000,  10000,  90000,      0,
     +            32000,  90000,  10000,  90000,      0,
     +            -1000,  -1000,  16000,  16000,   3250,
     +             3250,   3250,   3250,      0,      0,
     +                0,  90000, -89500,      0,      0,
     +                0,      0,      0,      0,      0,
     +                0,      0,      0,      0,      0,
     +                0,      0,      0,      0,      0,
     +           190 *0  /

C     IWGDBI(11)
      DATA       ( IWGDBI(11,ID),ID=1,80)
     +         /  254000, 254000, 127000, 127000, 254000,
     +          5*254000,
     +            254000, 254000, 254000, 254000, 254000,
     +             63500,  63500,  63500,  63500,      0,
     +            354375, 357188, 358125, 358875, 358875,
     +                 0,      0,      0,      0, 358875,
     +                 0,      0, 127000, 127000,  12000,
     +             12000,      0,  33000,  33000,   7500,
     +            180000, 177000,  45000, 175000,  45000,
     +            175000,      0, 180000, 177000,  45000,
     +            354375, 357188, 358125, 358875,  36000,
     +                 0,      0,      0,      0, 100500,
     +             10000,  10000, 254000, 180000, 150000,
     +             30000,  15875, 180000, 177500,      0,
     +            352500, 356250, 357500, 358500, 358500,
     +            352500, 356250, 357500, 358500,      0/
      DATA       ( IWGDBI(11,ID),ID=81,IFZ)
     +           / 33000, 358500, 254000, 357500,      0,
     +             33000, 358500, 254000, 357500,   7000,
     +              6500,   6500,  15000,  15000,   7750,
     +              7750,   7750,   7750,      0,      0,
     +                 0, 175000,   -500,      0,      0,
     +                 0,      0,      0,      0,      0,
     +                 0,      0,      0,      0,      0,
     +                 0,      0,      0,      0,      0,
     +            190 *0  /

C     IWGDBI(12)
      DATA       ( IWGDBI(12,ID),ID=1,80)
     +         /  254000, 254000, 127000, 127000, 254000,
     +            254000, 254000, 254000, 254000, 254000,
     +            254000, 254000, 381000, 381000,      0,
     +             63500,  63500,  63500,  63500,      0,
     +              5625,   2813,   1875,   1125,   1125,
     +                 0,      0,      0,      0,   1125,
     +                 0,      0, 127000, 127000,    500,
     +               500,      0,    500,    500,    500,
     +              1500,   3000,   2500,   5000,   2500,
     +              5000,   5000,   2000,   3000,   2500,
     +              5625,   2813,   1875,   1125,    500,
     +                 0,      0,      0,      0,   1500,
     +             10000,  10000, 254000,   1500, 150000,
     +             30000,  15875,   1500,   2500,      0,
     +              7500,   3750,   2500,   1500,   1500,
     +              7500,   3750,   2500,   1500,      0/
      DATA       ( IWGDBI(12,ID),ID=81,IFZ)
     +            /  500,   1500, 254000,   2500,      0,
     +               500,   1500, 254000,   2500,    500,
     +               125,    125,      0,      0,    125,
     +               125,      0,      0,      0,      0,
     +                 0,   5000,   1000,      0,      0,
     +                 0,      0,      0,      0,      0,
     +                 8,      8,      8,      8,      8,
     +                 8,      8,      8,      8,      0,
     +            190 *0  /

C     IWGDBI(13)
      DATA       ( IWGDBI(13,ID),ID=1,80)
     +         /  14*0  ,  48000,
     +                 0,      0,      0,      0,      0,
     +                16,     32,     48,     80,     80,
     +                 0,      0,      0,      0,     80,
     +                 0,      0,      0,      0,    500,
     +               500,      0,    500,    500,    500,
     +              1500,   3000,   2500,   2500,   2500,
     +              2500,   2500,   2000,   3000,   2500,
     +                16,     32,     48,     80,      0,
     +                 0,      0,      0,      0,   1500,
     +              5000,   5000,      0,   1500,      0,
     +                 0,      0,   1500,   2500,    500,
     +              7500,   3750,   2500,   1500,   1500,
     +              7500,   3750,   2500,   1500,      0/
      DATA       ( IWGDBI(13,ID),ID=81,IFZ)
     +            /  500,   1500,      0,   2000,      0,
     +               500,   1500,      0,   2000,    500,
     +               125,    125,      0,      0,    125,
     +               125,      0,      0,      0,      0,
     +                 0,   2500,   1000,      0,      0,
     +                 0,      0,      0,      0,      0,
     +                 8,      8,      8,      8,      8,
     +                 8,      8,      8,      8,      0,
     +            190 *0  /

C     IWGDBI(14)
      DATA       ( IWGDBI(14,ID),ID=1,80)
     +         / 14 *  64,          0,
     +             64, 64, 64, 64,  0,
     +             64, 64, 64, 64, 64,
     +              0,  0,  0,  0, 64,
     +              0,  0, 64, 64,  0,
     +              0,  0,  0,  0,  0,
     +             64, 64, 64, 64,  0,
     +             64, 64, 64, 64, 64,
     +             64, 64, 64, 64, 64,
     +              0,  0,  0,  0,  0,
     +            160,160, 64, 64, 64,
     +             32, 32, 64, 64,  0,
     +             64, 64, 64, 64, 64,
     +             64, 64, 64, 64,  0/
      DATA       ( IWGDBI(14,ID),ID=81,IFZ)
     +            / 0, 64, 64, 64,  0,
     +              0, 64, 64, 64,  0,
     +             64, 64, 64, 64, 64,
     +             64, 64, 64,  0,  0,
     +             64, 64,  0,  0,  0,
     +              0,  0,  0,  0,  0,
     +             64, 64, 64, 64, 64,
     +             64, 64, 64, 64,  0,
     +           190*   0           /

C     IWGDBI(15)
      DATA       ( IWGDBI(15,ID),ID=1,IFZ)
     +        / 14*60000,                        0,
     +           4*60000,                        0,
     +              10*0,
     +               2*0,    2*60000,            0,
     +              25*0,
     +               0,     0, 60000,     0, 56787,
     +           56787, 60000,     0,     0,     0,
     +              10*0,
     +                 0,   0, 60000,     0,     0,
     +                 0,   0, 60000,     0,     0,
     +             220*0 /

C     IWGDBI(16)
      DATA       ( IWGDBI(16,ID),ID=1,IFZ)
     +          / 310* 0 /

C     IWGDBI(17)
      DATA       ( IWGDBI(17,ID),ID=1,IFZ)
     +          /    30*0,
     +                0,     0,     0,     0,-32500,
     +           -32500,     0,-32500,-32500,-32500,
     +           40*0,
     +           -32500,     0,     0,     0,     0,
     +           -32500,     0,     0,     0,-32500,
     +           -32500,-32500,-32500,-32500,-32500,
     +           -32500,-32500,-32500,     0,     0,
     +           10*0,
     +            32500, 32500, 32500, 32500, 32500,
     +            32500, 32500, 32500, 32500,     0,
     +           190*0       /

C     IWGDBI(18)
      DATA (IWGDBI(18,ID),ID=1,IFZ)
     +          /    30*0,
     +                0,     0,     0,    0,  10000,
     +            10000,     0, 10000, 10000, 10000,
     +           40*0,
     +            10000,     0,     0,     0,     0,
     +            10000,     0,     0,     0, 10000,
     +            10000, 10000, 10000, 10000, 10000,
     +            10000, 10000, 10000,     0,     0,
     +           10*0,
     +          -170000,-170000,-170000,-170000,-170000,
     +          -170000,-170000,-170000,-170000,      0,
     +           190*0       /

C     IWGDBI(19)
      DATA (IWGDBI(19,ID),ID=1,IFZ)
     +          /    30*0,
     +                5*0,
     +              275*0       /


C     IWGDBI(20)
      DATA (IWGDBI(20,ID),ID=1,IFZ)
     +          / 310* 0 /

C     IWGDBI(21)
      DATA (IWGDBI(21,ID),ID=1,IFZ)
     +          / 310* 0 /

C     IWGDBI(22)
      DATA (IWGDBI(22,ID),ID=1,IFZ)
     +          / 310* 0 /
C*    ------------------------------------------------------------------

C*    PRINTPARAMETER: ABSCHALTEN, FALLS IRM NEGATIV
      NPR        = 1
      IF         ( IRM.LT.0 ) NPR = 0
C     INITIALISIEREN
      NTYPZW     = NTYP
      IRM        = 0
      YVAR(2)    = ' '
C*    ------------------------------------------------------------------

C     ABFRAGE, OB TYP-NR. GELIEFERT
      IF         ( NTYP .NE. 0) THEN
C        FEHLER-ABFRAGE
         IF      ((NTYP.LT.0) .OR. (NTYP.GT.MAXTY)) THEN
            IF   ( NPR.GT.0 ) PRINT 1600,NTYP
 1600       FORMAT(' UP TYPKD:  UNZUL.TYP-NR.=',I5)
                                       GOTO 300
                                       ENDIF
         IF      ( YTYLST(NTYP) .EQ. ' ') GOTO 306
                                       ELSE
         IF      ( YTYP .EQ. ' ')      THEN
            IF   ( NPR.GT.0 )          PRINT 1000
 1000       FORMAT(' UP TYPKD, FEHLER: TYP-ANGABE IN NTYP/YTYP FEHLT')
                                       GOTO 300
         ENDIF
C*    ------------------------------------------------------------------
C        ABFRAGE, OB ZIFFERN IN YTYP GELIEFERT
         NTYPZW  = ICHINT(YTYP)
#if defined CRAY
#else
         IF      ( NTYPZW .GE. 1999999999 ) GOTO 20
#endif 
         IF      ( NTYPZW .GT. 0)      THEN
            IF   ( NTYPZW .GT. MAXTY)  THEN
            IF   ( NPR.GT.0 )          PRINT 1600,NTYPZW
                                       GOTO 300
                                       ENDIF
            IF   ( YTYLST(NTYPZW) .EQ. ' ')      GOTO 306
                                       GOTO 90
         ENDIF
C*    ------------------------------------------------------------------
  20     CONTINUE

C        LAENGE VON YTYP ERMITTELN (OHNE BLANKS) UND IN GROSS UMSETZEN
         LYVAR   = LEN_TRIM(YTYP)
         IF      ( LYVAR .GT. 5) LYVAR = 5
         YVARZ   = YAKMG (YTYP(1:LYVAR))
C*    ------------------------------------------------------------------
C        TYP AUS LISTE SUCHEN
         NTYPZW  = 0
         DO 30 J1= 1, MAXTY
         IF      ( YVARZ(1:LYVAR) .EQ. YTYLST(J1)(1:LYVAR)) THEN
            IF   ( NTYPZW .NE. 0)      THEN
            IF   ( NPR.GT.0 )
     +         PRINT '('' ///UP TYPKD : TYP-NAME NICHT EINDEUTIG: '',
     +                A)',YTYP
                                       GOTO 300
                                       ENDIF
            NTYPZW = J1
CT       PRINT '('' NTYPZW,LYVAR,YVARZ='',2I3,1X,A,''*'')',NTYPZW,LYVAR,
CT   +          YVARZ(1:LYVAR)
                                                            ENDIF
   30    CONTINUE
C*    ------------------------------------------------------------------
         IF      ( NTYPZW .GT. 0)      GO TO 90
C*    ------------------------------------------------------------------
C        TYP NICHT GEFUNDEN
         IF      ( NPR.GT.0 )   PRINT 1100,YTYP
 1100    FORMAT  (' UP TYPKD, TYP UNBEKANNT=',A )
                                       GOTO 300
      ENDIF
C*    ------------------------------------------------------------------
C     TYP-NR GELIEFERT
C     ================

C     BEI MELDUNGEN NUR TYP LIEFERN
   90 YVAR(1)    = YTYLST(NTYPZW)
      IWTYP(1)   = NTYPZW
      IF         (NTYPZW .LE. MAXM)   RETURN
      IF         (NTYPZW .GE. 500)  RETURN
C*    ------------------------------------------------------------------
C     FELDER-KENNGROESSEN LIEFERN
  100 NZW        = NTYPZW - MAXM
      YVAR(2)    = YFTLST(NZW)

      DO 110 J5  = 2, 5
  110 IWTYP(J5)  = KENND(J5,NZW)
C*    ------------------------------------------------------------------
C     GDB-WERTE (4) - (19) LIEFERN - SPEZIALFALL: ROTIERTER POL  -
      IZW        = IWGDBI(4,NZW)
      IF         ((IZW.EQ.10).OR.(IZW.EQ.14).OR.(IZW.EQ.60)) THEN
         INDE    = 18
         REF     = FLOAT(IWGDBI(19,NZW)/1000)
         IWGDB(19) = IREFTS(REF)
      ELSE
         INDE    = 19
      ENDIF

      DO 200 J4  = 4, INDE
  200 IWGDB(J4)  = IWGDBI(J4,NZW)
C*    ------------------------------------------------------------------
C     REST VORLAEUFIG =0 SETZEN
      DO 210 J   = 20, 22
  210 IWGDB(J)   = 0
C*    ------------------------------------------------------------------
C     ACHTUNG: 211 = DUMMY-LABEL WG. FEHLER BEI OPT=HIGH (RZ2 VERSTAENDIGT)!!!!
  211 RETURN
C*    ------------------------------------------------------------------
C     FEHLERAUSGANG
C==================
  300 NE         = 0
      DO 302 J1  = 1, MAXTY
      IF         ( YTYLST(J1) .EQ. ' ') GOTO 302
      NE         = NE + 1
      YTYLSI(NE) = YTYLST(J1)
  302 CONTINUE
      IF         ( NPR.GT.0 )  PRINT 1300, (YTYLSI(IPP),IPP=1,NE)
 1300 FORMAT     (' UP TYPKD -> STANDARD-TYPEN:',/,
     +            10(10(2X,A),/))
  305 IRM        = 1
  306 YVAR(1)    = ' '
      YVAR(2)    = ' '
      IWTYP(1)   = 0

      END
