      SUBROUTINE VNDAT (IJAHR, IMONAT, ITAG, IDIFF, NJAHR, NMONAT, NTAG,
     +                  IRM)

C**** VNDAT    -   UP:AUS DATUM UND DIFFERENZTAGEN NEUES DATUM BERECHNEN
C**   AUFRUF:      CALL VNDAT (IJAHR, IMONAT, ITAG, IDIFF,
C**                            NJAHR, NMONAT, NTAG, IRM)
C**   ZWECK      : AUS EINEM DATUM WIRD MIT HILFE DER
C**                DIFFERENZTAGE EIN NEUES DATUM BERECHNET
C**   EXTERNALS  : DATJUL,DATPR,JULDAT,SCHALT
C**   PARAMETER:   IJAHR,IMONAT,ITAG   EINGABEDATUM (INTEGER-WERTE)
C**                IDIFF     DIFFERENZTAGE (INTEGER)
C**                NJAHR,NMONAT,NTAG   AUSGABEDATUM (INTEGER-WERTE)
C**                IRM   FEHLER-RUECKMELDEZELLE,IM FEHLERFALL
C**                      IRM UNGLEICH 0 - NTAG,NMONAT,NJAHR GLEICH 0
C**   VERFASSER:   A. ZALEWSKY
C**
C**   HINWEIS:     UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DAS JAHR 4-STELLIG
C**                UEBERGEBEN;
C**                BEI 2-STELLIGER JAHRESANGABE WIRD DAS JAHRHUNDERT WIE
C**                IM ALTEN BANK-PROGRAMM ZUGEWIESEN, ->
C**                IJAHR >= 50, -> 1900; IJAHR < 50, -> 2000 !
C.....MODIF.:      HINWEIS; A.ZALEWSKY.........................14.01.1999
C                  B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER IJAHR, IMONAT, ITAG, IDIFF, NJAHR, NMONAT, NTAG, IRM
      INTEGER IYEAR, IMONTH, IDAY, NDAY, ID, ITGANZ, IADD
      INTEGER ISCHAL, ITAZ, IZW, J100, J150
C.....EINGABEDATEN SICHERN
      IYEAR            = IJAHR
      IMONTH           = IMONAT
      IDAY             = ITAG
      
C.....JAHRHUNDERT NUR UEBER IJAHR, NICHT UEBER ICENT...........14.01.1999
      IF (IYEAR .LT. 100)                                 THEN
         IF (IYEAR .LT. 50)                               THEN
            IYEAR      = 2000 + IJAHR
         ELSE
            IYEAR      = 1900 + IJAHR
         ENDIF
      ENDIF

C.....RUECKGABEDATEN VORBESETZEN                                 
      ID               = IDIFF
      NTAG             = 0
      NMONAT           = 0
      NJAHR            = 0
      ITGANZ           = 365
      IADD             = 1
      IRM              = 0

C.....DATUM PRUEFEN
      CALL DATPR (IYEAR, IMONTH, IDAY, ISCHAL, IRM)
      IF (IRM .NE. 0)                                     RETURN

C.....JULIANISCHES DATUM DES EINGABEDATUMS BESTIMMEN
      CALL DATJUL (IYEAR, IMONTH, IDAY, NDAY, IRM)
      IF (IRM .NE. 0)                                     RETURN
      CALL SCHALT (IYEAR,ISCHAL)
      ITAZ             = ITGANZ + ISCHAL
      IZW              = NDAY + ID   

      IF (IZW .GT. 0)                                     THEN
C........ZUKUENFTIGES DATUM WIRD BERECHNET

C........NEUES DATUM IMSELBEN JAHR
         IF (IZW .LE. ITAZ)                               GOTO 250
         DO 100   J100 = 1, 1000
         IZW           = IZW - ITAZ
         IYEAR         = IYEAR + IADD
         CALL SCHALT (IYEAR,ISCHAL)
         ITAZ          = ITGANZ + ISCHAL
         IF (IZW .LE. ITAZ)                               GOTO 250
  100    CONTINUE

C........FEHLER, MEHR ALS 100 JAHRE DIFFERENZ
         IRM           = 1
         RETURN

      ELSE IF (IZW .LT. 0)                                THEN
C........VERGANGENES DATUM WIRD BERECHNET
         DO 150   J150 = 1, 1000
         IYEAR         = IYEAR - IADD
         CALL SCHALT (IYEAR,ISCHAL)
         ITAZ          = ITGANZ + ISCHAL
         IZW           = IZW + ITAZ
         IF (IZW .GE. 0)                                  GOTO 200
  150    CONTINUE

C........FEHLER, MEHR ALS 100 JAHRE DIFFERENZ
         IRM           = 1
         RETURN
      ENDIF

  200 CONTINUE

C.....BERECHNETES DATUM GLEICH SYLVESTER DES VORJAHRES
      IF (IZW .EQ. 0)                                     THEN
         IYEAR         = IYEAR - IADD
         CALL SCHALT (IYEAR,ISCHAL)
         IZW           = ITGANZ +ISCHAL
      ENDIF

C.....AUS DEM JULIANISCHEN DATUM DAS RUECKGABEDATUM BESTIMMEN
  250 NDAY             = IZW
      CALL JULDAT (NDAY,IYEAR,NMONAT,NTAG,IRM)
      IF (IRM .NE. 0)                                     RETURN
      NJAHR            = IYEAR

C.....IJAHR 2-STELLIG, -> NJAHR 2-STELLIG
      IF (IJAHR .LT. 100)                                 THEN
         NJAHR         = MOD(IYEAR,100)
      ENDIF
          
      END
