      SUBROUTINE VNMIN (IJAHR, IMONAT, ITAG, ISTUND, IMINUT, IDIFF,
     +                   NJAHR, NMONAT, NTAG, NSTUND, NMINUT, IRM )

C**** VNMIN    -   UP:AUS DATUM/UHRZEIT UND ZEITDIFFERENZ (MINUTEN)
C****              NEUEN ZEITPUNKT BERECHNEN
C**   AUFRUF     : CALL VNMIN (IJAHR,IMONAT,ITAG,ISTUND,IMINUT,IDIFF,
C**                             NJAHR,NMONAT,NTAG,NSTUND,NMINUT,IRM )
C**   ZWECK      : AUS DATUM,UHRZEIT (IJAHR,IMONAT,ITAG,ISTUND,IMINUT)
C**                WIRD DURCH ANGABE DER DIFFERENZMINUTEN (IDIFF)
C**                    DATUM,UHRZEIT (NJAHR,NMONAT,NTAG,NSTUND,NMINUT)
C**                NEU BERECHNET
C**   EXTERNALS  : VNDAT
C**   PARAMETER  : IJAHR ,NJAHR , EIN-,AUSGABEJAHR   (INTEGER)
C**                IMONAT,NMONAT, EIN-,AUSGABEMONAT  (INTEGER)
C**                ITAG  ,NTAG  , EIN-,AUSGABETAG    (INTEGER)
C**                ISTUND,NSTUND, EIN-,AUSGABESTUNDE (INTEGER)
C**                IMINUT,NMINUT, EIN-,AUSGABEMINUTE (INTEGER)
C**                IDIFF        , ANZAHL DER DIFFERENZMINUTEN (INTEGER)
C**                IRM          , FEHLER-RUECKMELDEZELLE, IM FEHLERFALL
C**                               IRM UNGLEICH 0
C**                               NJAHR,NMONAT,NTAG,NSTUND,NMINUT GLEICH 0
C**
C**   HINWEIS:     UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DAS JAHR 4-STELLIG
C**                UEBERGEBEN;
C**                BEI 2-STELLIGER JAHRESANGABE WIRD DAS JAHRHUNDERT WIE
C**                IM ALTEN BANK-PROGRAMM ZUGEWIESEN, ->
C**                IJAHR >= 50, -> 1900; IJAHR < 50, -> 2000 !
C.... MODIF.:      HINWEIS; A.ZALEWSKY.........................14.01.1999
C                  B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER IDT, IDIFF, IDM, IMZW, NMZW, IRM
      INTEGER IJAHR, IMONAT, ITAG, ISTUND, IMINUT
      INTEGER NJAHR, NMONAT, NTAG, NSTUND, NMINUT
C.....DIFFERENZMINUTEN IN TAGE,MINUTEN UMRECHNEN
      IDT              = IDIFF / 1440
      IDM              = MOD (IDIFF,1440)

C.....EINGABESTUNDE,-MINUTE IN MINUTEN UMRECHNEN
      IMZW             = ISTUND * 60 + IMINUT

C.....RUECKGABEMINUTEN  RECHNEN
      NMZW             = IMZW + IDM

C.....RUECKGABEMINUTEN MIT TAGESWECHSEL
      IF (NMZW .LT. 0)                                     THEN 
         IDT           = IDT  - 1
         NMZW          = 1440 + NMZW
      ELSEIF (NMZW .GE. 1440)                              THEN
         NMZW          = NMZW - 1440
         IDT           = IDT  + 1
      ENDIF

C.....RUECKGABEDATUM MIT UP VNDAT RECHNEN
      CALL VNDAT (IJAHR,IMONAT,ITAG,IDT,NJAHR,NMONAT,NTAG,IRM)
      IF (IRM .NE. 0)                                      THEN  
         NJAHR         = 0
         NMONAT        = 0
         NTAG          = 0
         NSTUND        = 0
         NMINUT        = 0
         RETURN
      ENDIF

C*    RUECKGABEMINUTEN IN STUNDEN,MINUTEN UMRECHNEN
      NSTUND           = NMZW / 60
      NMINUT           = MOD (NMZW,60)

      END
