      SUBROUTINE VNSTD (IJAHR, IMONAT, ITAG, ISTUND, IDIFF,
     +                   NJAHR, NMONAT, NTAG, NSTUND, IRM )

C**** VNSTD - ZEITPUNKT AUS DATUM UND ZEITDIFFERENZ BERECHNEN
C**   AUFRUF     : CALL VNSTD (IJAHR,IMONAT,ITAG,ISTUND,IDIFF,
C**                             NJAHR,NMONAT,NTAG,NSTUND,IRM)
C**   ZWECK      : AUS DATUM UND STUNDE WIRD DURCH ANGABE DER STUNDEN-
C**                DIFFERENZ (IDIFF) EIN NEUES DATUM/STUNDE BERECHNET
C**   EXTERNALS  : VNDAT
C**   PARAMETER  : IJAHR ,NJAHR , EIN-,AUSGABEJAHR   (INTEGER)
C**                IMONAT,NMONAT, EIN-,AUSGABEMONAT  (INTEGER)
C**                ITAG  ,NTAG  , EIN-,AUSGABETAG    (INTEGER)
C**                ISTUND,NSTUND, EIN-,AUSGABESTUNDE (INTEGER)
C**                IDIFF     STUNDENDIFFERENZ (INTEGER)
C**                IRM       UNGLEICH 0 BEI FEHLER IN DATUM/STUNDE
C**   VERFASSER:   G. BAGINSKI
C**
C**   HINWEIS:     UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DAS JAHR 4-STELLIG
C**                UEBERGEBEN;
C**                BEI 2-STELLIGER JAHRESANGABE WIRD DAS JAHRHUNDERT WIE
C**                IM ALTEN BANK-PROGRAMM ZUGEWIESEN, ->
C**                IJAHR >= 50, -> 1900; IJAHR < 50, -> 2000 !
C.....MODIF.:      HINWEIS; A.ZALEWSKY.........................14.01.1999
C                  B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER IJAHR, IMONAT, ITAG, ISTUND, IDIFF, IDT, IDS
      INTEGER NJAHR, NMONAT, NTAG, NSTUND, IRM
C.....DIFFERENZSTUNDEN IN TAGE/STUNDEN UMRECHNEN
      IDT              = IDIFF / 24
      IDS              = MOD (IDIFF, 24)

C.....FEHLER IN STUNDE
      IF (ISTUND .GE. 24)                                  THEN
         IRM           = 1
         RETURN
      ENDIF

C.....RUECKGABESTUNDEN BERECHNEN
      NSTUND           = ISTUND + IDS

C.....RUECKGABESTUNDEN MIT TAGESWECHSEL
      IF (NSTUND .LT. 0)                                   THEN
         IDT           = IDT  - 1
         NSTUND        = NSTUND + 24
      ELSEIF (NSTUND .GE. 24)                              THEN
         IDT           = IDT  + 1
         NSTUND        = NSTUND - 24
      ENDIF

C.....RUECKGABEDATUM MIT UP VNDAT RECHNEN
      CALL VNDAT (IJAHR,IMONAT,ITAG,IDT,NJAHR,NMONAT,NTAG,IRM)

      END
