      SUBROUTINE WAFS1T1 (IBLOCK1,IBLOCK2,IVKOOR,IANZVK,
     +                    IPD1,IGD1,IRM)
C**** WAFS1T1  -   UP: AUS WAFS-DATEN (IEDNR=1) KOMPL. PDS UND GDS ERSTELLEN
C**   AUFRUF     : CALL WAFS1T1 (IBLOCK1,IBLOCK2,IVKOOR,IANZVK,
C**               +              IPD1,IGD1,IRM)
C**   ZWECK      : WAFS-DATEN IN NEUEN KOMPL. GRIB-CODE UMSETZEN, GILT NUR
C**                FUER DATEN MIT IEDNR=1, IDC=74, IDMOD=45, GID=37..44
C**   PARAMETER  : INPUT:    IBLOCK1, IBLOCK2, IVKOOR
C**                ----------------------------------
C**                IBLOCK1:  KENNDATEN AUS SECTION 1 DES NEUEN GRIB ) NICHT
C**                IBLOCK2:  KENNDATEN AUS SECTION 2 DES NEUEN GRIB ) KOMPLETT
C**                IVKOOR:   VERTIKAL-KOORDINATEN (OPTIONAL)
C**
C**                OUTPUT:   IANZVK, IPD1, IGD1, IRM
C**                ---------------------------------
C**                IANZVK:   ANZAHL DER VERTIKAL-KOORDINATEN
C**                IPD1:     DATEN DER PRODUCT-DEFINITION-SECTION   )
C**                IGD1:     DATEN DER GRID-DESCRIPTION-SECTION     ) KOMPLETT
C**                IRM:      FEHLER-RUECKMELDEZELLE,
C**                          FEHLER, WENN IRM UNGLEICH NULL
C**
C**   HINWEISE: NACHFOLGEND WERDEN DIE WERTE IN IBLOCK1 UND IBLOCK2 ERLAEUTERT;
C**             BYTE 4 DES PD1 (IPD1(2)) WIRD NICHT UEBER IBLOCK1 WEITERGEGEBEN,
C**             TABELLEN-NUMMER IPD1(2) = 2  UND  BYTE 6 = IPD1(4) = 122 = WAFSZ
C**             WERDEN VOM UP GESETZT;                               ---
C**
C**             ARRAY IBLOCK1 ENTHAELT DATEN DER PDS
C**             INDEX:  BYTE:   ERLAEUTERUNG:
C**             -----------------------------
C**                 1      5    IDC, KENNUNG DES ZENTRUMS (74=BRACKNELL)
C**                 2      6    IDMOD, MODEL IDENT.(45=GLOBAL FORECAST MODEL)
C**                 3      7    IGRDT, GRID IDENT.:
C**
C**                               330 E   60 E  150 E  240 E  330 E
C**                             90 N I------I------I------I------I
C**                                  I  37  I  38  I  39  I  40  I
C**                                  I   I  I   J  I   K  I   L  I
C**                              0   I------I------I------I------I
C**                                  I  41  I  42  I  43  I  44  I
C**                                  I   M  I   N  I   O  I   P  I
C**                             90 S I------I------I------I------I
C**
C**                 4      8    IBFLAG, BLOCKFLAG  (=128, -> GDS, KEINE BMS)
C**                 5      9    IEE, ELEMENTKENNUNG (GRIB-CODE-TABLE 2)
C**                 6     10    LVTYP, LEVELTYP (GRIB-CODE-TABLE 3)
C**                 7  11-12    LEVEL
C**                 8      -    = 0
C**                 9     13    YEAR OF CENTURY
C**                10     14    MONTH
C**                11     15    DAY
C**                12     16    GG
C**                13     17    MIN
C**                14     18    IUTIME, FORECAST TIME UNIT (=1, HOURS)
C**                15     19    TIME-RANGE (T+12)
C**                16     20    TIME-INTERVAL (=0, FOR WAFS)
C**                17     21    ITFLAG (=10, SINGLE REFERENCE TIME)
C**                18  22-24    = 0
C**                19     25    CENTURY (=20)
C**                 -     26    RESERVED
C**                20  27-28    IDSCAL, DECIMAL SCALE FACTOR
C**                21   1- 3    LPDS, BYTE-LAENGE DER PDS
C**
C**             ARRAY IBLOCK2 ENTHAELT DATEN DER GDS
C**             INDEX:  BYTE:   ERLAEUTERUNG:
C**             -----------------------------
C**                 1      4    IANZVK, ANZAHL DER VERTIKAL-KOORDINATEN
C**                 2      5    IBYTADR, ADRESSE DER VERTIKAL-KOORDINATEN (=33)
C**                 3      6    IDRTYP, (=0, LATITUDE/LONGITUDE GRID)
C**                 4   7- 8    NUMBER OF COLUMNS (=FFFF)
C**                 5   9-10    NUMBER OF ROWS (=73)
C**                 6  11-13    LATITUDE OF FIRST GRID POINT (-90000)
C**                 7  14-16    LONGITUDE OF FIRST GRID POINT (-30000)
C**                 8     17    IRFLAG (=128)
C**                 9  18-20    LATITUDE OF LAST GRID POINT (00000)
C**                10  21-23    LONGITUDE OF LAST GRID POINT (60000)
C**                11  24-25    I-DIRECTION INCREMENT (=FFFF)
C**                12  26-27    J-DIRECTION INCREMENT (=1250)
C**                13     28    MODSC (=64)
C**                14  29-32    = 0
C**             15-20      -    = 0
C**
C**             ARRAY IPD1 ENTHAELT DATEN DES PDB (IEDNR=0)
C**             INDEX:          ERLAEUTERUNG:
C**             -----------------------------
C**                 1           LPDB   = IBLOCK1(21)
C**                 2           IGTVSN = 2
C**                 3           IDC    = IBLOCK1( 1)
C**                 4           IDMOD  = 122    ( DATENBANKTYP )
C**                 5           ICATNR = 255    ( UNDEFINIERT )
C**                 6           IBFLAG = IBLOCK1( 4)
C**                 7           IEE    = IBLOCK1( 5)
C**                 8           LVTYP  = IBLOCK1( 6)
C**                             FUER LVTYP=100/103/105/107/109/111/113/125/160:
C**                 9           ---    = NICHT BELEGT
C**                10           LVT1   = IBLOCK1( 7)
C**                             FUER ALLE ANDEREN LVTYPS:
C**                 9           LVT1   = IBLOCK1( 7)
C**                10           LVT2   = IBLOCK1( 8)
C**
C**                11)                 = IBLOCK1( 9)
C**                 :)          DATUM  =          :
C**                16)                 = IBLOCK1(14)
C**
C**                             FUER ITFLAG=10:
C**                17           ---    = NICHT BELEGT
C**                18           IT1    = IBLOCK1(15)
C**                             FUER ITFLAG#10:
C**                17           IT1    = IBLOCK1(15)
C**                18           IT2    = IBLOCK1(16)
C**
C**                19           ITFLAG = IBLOCK1(17)
C**                20           NAVRG  = 0
C**                21           NMSSG  = 0
C**                22           JAHRH. = IBLOCK1(19)
C**                23           RESV   = 0
C**                24           IUDSCF = IBLOCK1(20)
C**
C**             ARRAY IGD1 ENTHAELT DATEN DES GDB (IEDNR=0)
C**             INDEX:          ERLAEUTERUNG:
C**             -----------------------------
C**                 1           LGDB   = 32 (+ IANZVK*4)
C**                 2           IANZVK = IBLOCK2( 1)
C**                 3           IBADRVK= IBLOCK2( 2)
C**                 4           IDRTYP = 0
C**                 5           NI     = 72
C**                 6           NJ     = 73
C**                 7           LA1    = -90000
C**                 8           LO1    = -30000
C**                 9           IRFLAG = 10
C**                10           LA2    =  90000
C**                11           LO2    = 330000
C**                12           DI     = 5000
C**                13           DJ     = 2500
C**                14           MODSC  = 64
C**                15           IRESVA = 0
C**                16           IRESVB = 0
C**             17-25           UNBENUTZT
C**           (26-225)          VERTKAL-KOORDINATEN (OPTIONAL)
C**
C**   VERFASSER:   A.ZALEWSKY, APRIL 1995
!**                geaend. 03/04 MiSt - Leveltyp-Liste auf Anforderung
!**                                     von FE13 erweitert
!**                              (neu: lvtyp=222 - Satellite channel,
!**                                     weitere Typnummern ergaenzt)
!**   Version      Marz 2004

      IMPLICIT NONE

      INTEGER IBLOCK1, IBLOCK2, IVKOOR, IANZVK, IPD1, IGD1, IRM
      INTEGER LVTZ, IEEZ, LVT, IG122, MODSC, IDC, IDMOD, LVTYP, J, IZW
      INTEGER JJ, ITFLAG, IZVK, IBTVK

      PARAMETER (LVTZ=15, IEEZ=5)

      DIMENSION IBLOCK1(*), IBLOCK2(*), IVKOOR(*), IPD1(*), IGD1(*),
     +          LVT(LVTZ), IG122(12)

!      DATA LVT   /  100, 103, 105, 107, 109, 111, 113, 125, 160 /
!     Liste auf Anforderung von FE13 erweitert: neuer level-typ 222
      DATA LVT   /  100, 103, 105, 107, 109, 111, 113, 115, 117,
     +              119, 125, 160, 200, 201, 222 /
      DATA IG122 /    0,    72,     73,
     +                  -90000, -30000,
     +               10, 90000, 330000,
     +                    5000,   2500,
     +                      64,      0 /

      DATA MODSC / Z'40' /

C.....PRODUCT-DEFINITION-SECTION................................................

C.....LPDB, IEDNR, IDC
      IPD1( 1)   = IBLOCK1(21)
      IPD1( 2)   =  2
      IPD1( 3)   = IBLOCK1(1)
      IDC        = IBLOCK1(1)
      IF (IDC .NE. 74)                      THEN
         IRM     = 1
         PRINT '('' WAFS1T1: NUR WAFS-DATEN DER KENNUNG IDC='',I3,
     +           '' WERDEN UMGESETZT'')', IDC
         RETURN
      ENDIF

C.....IDMOD, TYP-KENNUNG
      IDMOD      = 122
      IPD1( 4)   = 122

C.....ICATNR, IBFLAG, IEE
      IPD1( 5)   = 255
      IPD1( 6)   = IBLOCK1(4)
      IPD1( 7)   = IBLOCK1(5)

C.....LVTYP, LEVEL1/2
      IPD1( 8)   = IBLOCK1(6)
      LVTYP      = IPD1(8)

      DO 20    J = 1, LVTZ
      IZW        = LVT(J)
      IF (LVTYP .EQ. IZW)                   THEN
         IPD1( 9)= IBLOCK1( 8)
         IPD1(10)= IBLOCK1( 7)
         GOTO 21
      ENDIF
   20 CONTINUE
      IPD1( 9)   = IBLOCK1( 7)
      IPD1(10)   = IBLOCK1( 8)

   21 CONTINUE
C.....IYY, IMM, IDD, IGG, IMIN, IUTIME
      DO 15    J = 11, 16
      JJ         = J - 2
   15 IPD1(J)    = IBLOCK1(JJ)

C.....ITFLAG, ITIME1/2
      IPD1(19)   = IBLOCK1(17)
      ITFLAG     = IPD1(19)
C.....IF (ITFLAG .NE. 10)                   falsch, geaendert am 26.09.1996 ZAL.
      IF (ITFLAG .EQ. 10)                   THEN
C........NUR 1 ZEITANGABE IN IBLOCK1(15)
         IPD1(18)= IBLOCK1(15)
         IPD1(17)= 0
      ELSE
C........2 ZEITANGABEN
         IPD1(17)= IBLOCK1(15)
         IPD1(18)= IBLOCK1(16)
      ENDIF

C.....NARVG, NMSSG: AUS IBLOCK1 NICHT AUSWERTBAR
      IPD1(20)   = 0
      IPD1(21)   = 0
C.....JAHRHUNDERT-ANGABE (=20)
      IPD1(22)   = IBLOCK1(19)
      IPD1(23)   = 0
C.....SCALE-FAKTOR
      IPD1(24)   = IBLOCK1(20)

C.....GRID-DESCRIPTION-SECTION..................................................

C.....LGDB, IANZVK, IBADRVK
      IGD1( 1)   = 32
      IGD1( 2)   = IBLOCK2( 1)
      IGD1( 3)   = IBLOCK2( 2)

C.....IDRTYP, NI, NJ, LA1, LO1, IRFLAG, LA2, LO2, DI, DJ, MODSC
C     IDRTYP     = IBLOCK2(3)
C     NI         = IBLOCK2(4)
C     NJ         = IBLOCK2(5)
C     IGD1( 9)   = IBLOCK2(8)
C     IGD1(12)   = IBLOCK2(11)
C     IGD1(13)   = IBLOCK2(12)
C     IGD1(14)   = IBLOCK2(13)

C.....DWD-DATEN WERDEN BENUTZT
      DO 30   J  = 1, 12
      JJ         = J + 3
   30 IGD1(JJ)   = IG122(J)

C.....LETZTEN WERTE 0 SETZEN
      DO 40    J = 16, 25
   40 IGD1(J)    = 0

C.....VERTIKALKOORDINATEN
      IANZVK     = IBLOCK2(1)
      IZVK       = IBLOCK2(1)
      IF (IZVK .GT. 200)                    THEN
         PRINT '('' WAFS1T1: !!! '',I5,'' IVKOOR,'',
     +           '' NUR 200 WERDEN UMGESETZT'')', IANZVK
         IZVK    = 200
      ENDIF
      DO 50    J = 26, 225
   50 IGD1(J)    = 0
      IF (IANZVK .GT. 0)                    THEN
         DO 60 J = 1, IZVK
         JJ      = J + 25
   60    IGD1(JJ)= IVKOOR(J)
C........4 BYTES / VERT.KOORD.
         IBTVK   = IZVK * 4
         IGD1(1) = IGD1(1) + IBTVK
      ENDIF

      RETURN
      END
