      SUBROUTINE WOTAN (YWOTA, NWOTA, IJAHR, IMONAT, ITAG, IRM)

C**** WOTAN    -   UP:WOCHENTAG AUS DEM DATUM ERMITTELN
C**   AUFRUF:      CALL WOTAN ( YWOTA, NWOTA, IJAHR, IMONAT, ITAG, IRM)
C**   ZWECK:       WOCHENTAG AUS DEM DATUM ERMITTELN
C**   EXTERNALS  : DATPR,ICENT
C**   PARAMETER:   YWOTA     WOCHENTAG (CHARACTER,10 ZEICHEN),Z.B. 'MONTAG    '
C**                          IM HP MIT 'CHARACTER YWOTA*10' DIMENSIONIEREN
C**                NWOTA     WOCHENTAG (1=MONTAG,.....,7=SONNTAG)
C**                IJAHR     JAHR (INTEGER) MIT ODER OHNE JAHRHUNDERT
C**                IMONAT    MONAT (INTEGER)
C**                ITAG      TAG(INTEGER)
C**                IRM       FEHLER -RUECKMELDEZELLE
C**                          YWOTA GLEICH '**********'
C**                          NWOTA GLEICH 0
C**                          IRM UNGLEICH 0
C**   VERFASSER:   A. ZALEWSKY
C**   HINWEIS:     UM FEHLER ZU VERMEIDEN, SOLLTEN SIE DAS JAHR 4-STELLIG
C**                UEBERGEBEN;
C**                MOEGLICHE FEHLERQUELLE BEI 2-STELLIGER JAHRESANGABE,
C**                DIE JAHRHUNDERT-ZUWEISUNG ERFOLGT WIE IM ALTEN BANK-
C**                PROGRAMM:
C**                IJAHR >= 50, -> 1900; IJAHR<50, -> 2000  !

C.....MODIF::      HINWEIS, A.ZALEWSKY...........................14.01.1999 
C                  B.Loeser, 11/00, IMPLICIT NONE

      IMPLICIT NONE
      INTEGER NWOTA, IJAHR, IMONAT, ITAG, IRM, IJJ, ISCHAL, IDD
      INTEGER IMM, IC, IA, IE, MKOR, NTAG
      CHARACTER YWOTA*(*),YLIST*70
      DATA YLIST /'MONTAG    DIENSTAG  MITTWOCH  DONNERSTAGFREITAG   SAM
     +STAG   SONNTAG   '/

C.....JAHRHUNDERT WIE IM ALTEN BANK-PROGRAMM.....................14.01.1999
C.....NICHT UEBER ICENT !
      IJJ              = IJAHR
      IF (IJJ .LT. 100)                                    THEN
         IF (IJJ .LT. 50)                                  THEN
            IJJ        = 2000 + IJAHR
         ELSE
            IJJ        = 1900 + IJAHR
         ENDIF
      ENDIF

C.....DATUM PRUEFEN     
C.....CALL DATPR (IJAHR, IMONAT, ITAG, ISCHAL, IRM)..............14.01.1999
      CALL DATPR (IJJ,   IMONAT, ITAG, ISCHAL, IRM)
      IF (IRM .EQ. 0)                                      GOTO 100
      YWOTA            = '**********'
      NWOTA            = 0
      RETURN

  100 IDD              = ITAG
      IMM              = IMONAT
C.....IJJ     =    IJAHR.........................................14.01.1999
C.....IF (IJJ .LT. 100) IJJ = ICENT()  + IJJ.....................14.01.1999

C.....BEI MONAT LE 2, MONAT UND JAHR KORRIGIEREN
      IMM              = IMM - 2
      IF (IMM .GT. 0)                                      GOTO 200
      IMM              = IMM + 12
      IJJ              = IJJ - 1
  200 IC               = IJJ / 100
      IJJ              = IJJ - IC * 100

C.....TAGES-ZIFFER BERECHNEN
      MKOR             = (26*IMM-2) / 10
      NTAG             = MKOR + IDD + IJJ + IJJ/4 + IC/4 - 2*IC

C.....WOCHENTAG BESTIMMEN
      NWOTA             = MOD(NTAG, 7)
      IF (NWOTA .EQ. 0) 
     +   NWOTA          = 7
      IF (NWOTA .LT. 0) 
     +   NWOTA          = 7 + NWOTA

      IA                = (NWOTA-1)*10 + 1
      IE                = IA + 9
      YWOTA             = YLIST(IA:IE)

      END
