#!/bin/bash

set -e

# dependencies
module purge
case $machine in
  'genius' )
  case $toolchain in 
    '2018a' )
       echo "Error: The machine/toolchain combination ($machine/$toolchain) are undeveloped"
       exit 11
       ;;
    '2015a' )
       module unuse /apps/leuven/skylake/2018a/modules/all
       module use /apps/leuven/skylake/2015a/modules/all
       module load intel/2015a
       module load netCDF-Fortran/4.4.0-intel-2015a
       ;;
    '2018b' )
       module unuse /apps/leuven/skylake/2018a/modules/all
       module use /apps/leuven/skylake/2018b/modules/all
       module load intel/2018b
       module load netCDF-Fortran/4.4.4-intel-2018b
       ;;
    '2019b' )
       module unuse /apps/leuven/skylake/2018a/modules/all
       module use /apps/leuven/skylake/2019b/modules/all
       module load intel/2019b
       module load netCDF-Fortran/4.5.3-iimpi-2019b
       ;;
    * )
       echo "Error: unsupported toolchain for Genius"
       exit 11
       ;;
  esac
    ;;
  'breniac' )
   #  [[ $arch == 'broadwell' ]] && { echo "Error: Broadwell partition not supported"; exit 10; }

    case $toolchain in 
      '2016a' )
         module unuse /apps/leuven/broadwell/2016a/modules/all
         module use /apps/leuven/${arch}/2016a/modules/all
         module load netCDF-Fortran/4.4.4-intel-2016a
         ;;
      '2018a' )
         echo "Error: The machine/toolchain combination ($machine/$toolchain) are undeveloped"
         exit 11
         ;;
      '2019b' )
         module unuse /apps/leuven/broadwell/2019b/modules/all
         module use /apps/leuven/${arch}/2019b/modules/all
         module load intel/2019b
         # module load netCDF-Fortran/4.5.3-iimpi-2019b
         module load netCDF-Fortran/4.4.4-iimpi-2019b
         ;;
      '2021a' )
         module use /apps/leuven/${arch}/2021a/modules/all
         module load intel/2021a
         # module load netCDF-Fortran/4.5.3-iimpi-2021a
         module load netCDF-Fortran/4.4.4-iimpi-2019b
         ;;
       * )
         echo "Error: Unsupported toolchain for Breniac"
         exit 11
         ;;
    esac
    ;;
  'hortense' )
    echo 'Error: Hortense is not supported yet!'
    exit 11
    ;;
  * )
    echo "Error: non-VSC clusters are not supported"
    exit 12
    ;;
esac

