   SUBROUTINE oas_clm_init 

!**** *INIOASIS*  - Initialize coupled mode communication
!
!     Purpose.
!     --------
!     Initialize coupler to get the MPI communicator
!
!**   Interface.
!     ----------
!       *CALL*  *oas_clm_init*
!
!     Input:
!     -----
!
!     Output:
!     ------
!       MPLUSERCOMM in MPL_MODULE is updated.
!
!     Method:
!     ------
!       OASIS usage is controlled by environment variables
!
!     Externals:
!     ---------
!       GETENV - Get enviroment variables
!       prism_init, prism_init_comp, prism_get_localcomm, prism_abort : prism library
!
!     Author:
!     -------
!       E. Maisonnave : adapted to CLM
!
      USE oas_clm_vardef
      USE mod_prism

      IMPLICIT NONE
   
      CHARACTER(LEN=6)   :: CLMODNAME = 'clmxxx'  ! Name of the mode

      !------------------------------------------------------------------
      ! 1st Initialize the PRISM system for the application
      !------------------------------------------------------------------
      CALL prism_init_comp_proto ( ncomp_id, CLMODNAME, nerror )
      IF ( nerror /= PRISM_Ok ) &
         CALL prism_abort_proto (ncomp_id, 'oas_clm_init', 'Failure in prism_init_comp_proto')

      !------------------------------------------------------------------
      ! 2nd Get an MPI communicator fr CLM local communication
      !------------------------------------------------------------------
      CALL prism_get_localcomm_proto ( kl_comm, nerror )
      IF ( nerror /= PRISM_Ok ) &
         CALL prism_abort_proto (ncomp_id, 'oas_clm_init','Failure in prism_get_localcomm_proto' )

   END SUBROUTINE oas_clm_init
