   SUBROUTINE oas_clm_snd( kid, kstep, pdata, kinfo )

      !!---------------------------------------------------------------------
      !!              ***  ROUTINE oas_clm_snd  ***
      !!
      !! ** Purpose : - At each coupling time-step,this routine sends fields
      !!                to the coupler or remote application.
      !!----------------------------------------------------------------------

      use shr_kind_mod , only : r8 => shr_kind_r8
      USE oas_clm_vardef
      USE mod_prism

      IMPLICIT NONE

      !! * Arguments
      !!
      INTEGER,                 INTENT( IN    )   :: kid    ! variable index in the array
      INTEGER,                 INTENT(   OUT )   :: kinfo  ! OASIS4 info argument
      INTEGER,                 INTENT( IN    )   :: kstep  ! CLM time-step in seconds
      REAL(r8), DIMENSION(grid_size), INTENT( IN    )   :: pdata
      !!--------------------------------------------------------------------
      !
      ! Call OASIS at each time step but field sent to other model only at coupling time step
      ! (accumulation otherwise, if asked in the SMIOC configuration file)
      !
      CALL prism_put_proto( ssnd(kid)%nid, kstep, pdata, kinfo )

    END SUBROUTINE oas_clm_snd

