function [COSMOsmb]=convertCosmoSMB(COSMOinput,fETIShFile,n_month_isfcpl)

load([fETIShFile '_toto'],'ctr','par','MASKo');
    
Li=(ctr.imax-1)*ctr.delta;
Lj=(ctr.jmax-1)*ctr.delta;
[X,Y] = meshgrid(-Lj/2:ctr.delta:Lj/2,-Li/2:ctr.delta:Li/2);

lat=double(ncread(COSMOinput,'lat'));
lon=double(ncread(COSMOinput,'lon'));
SMBorig=double(ncread(COSMOinput,'SMB')); %SMB in 'kg  m-2 a-1'

[x,y]=polarstereo_fwd(lat,lon,6378137.0,0.08181919,-71,0);

COSMOsmb=zeros(ctr.imax,ctr.jmax,n_month_isfcpl);
    
warning('off','all')
for i=1:n_month_isfcpl
    Mborig=SMBorig(:,:,i);
    % linear interpolation and nearest neighbor extrapolation
    MbIn=scatteredInterpolant(x(~isnan(Mborig)),y(~isnan(Mborig)),Mborig(~isnan(Mborig)),'linear','nearest');
    Mb=zeros(ctr.imax,ctr.jmax);
    Mb(MASKo~=0)=MbIn(X(MASKo~=0),Y(MASKo~=0)); 
    % 'kg m-2 per yr' to 'm ice equiv per yr' and limits for Mb
    COSMOsmb(:,:,i)=min(50,max(-25,Mb/par.rho));
end
warning('on','all')
    
end