function [NEMOmelt]=convertNemoMelt(NEMOinput,fETIShFile,n_month_isfcpl)

load([fETIShFile '_toto'],'ctr','par');
    
Li=(ctr.imax-1)*ctr.delta;
Lj=(ctr.jmax-1)*ctr.delta;
[X,Y] = meshgrid(-Lj/2:ctr.delta:Lj/2,-Li/2:ctr.delta:Li/2);

lat=double(ncread(NEMOinput,'nav_lat'));
lon=double(ncread(NEMOinput,'nav_lon'));
Meltorig=double(ncread(NEMOinput,'fwfisf')); %sub-shelf melt

[x,y]=polarstereo_fwd(lat,lon,6378137.0,0.08181919,-71,0);

NEMOmelt=zeros(ctr.imax,ctr.jmax,n_month_isfcpl);
    
warning('off','all')
for i=1:n_month_isfcpl
    Melt=Meltorig(:,:,i);
    Melt(Melt==0)=NaN;
    F=scatteredInterpolant(x(:),y(:),Melt(:),'linear');
    linMelt=-par.secperyear/par.rho*F(X,Y);
    G=scatteredInterpolant(x(:),y(:),Melt(:),'nearest');
    nnMelt=-par.secperyear/par.rho*G(X,Y);
    fMelt=nnMelt;
    fMelt(~isnan(linMelt))=linMelt(~isnan(linMelt));
    NEMOmelt(:,:,i)=fMelt;
end
warning('on','all')

NEMOmelt(NEMOmelt>500)=NaN;
    
end