function [ctr,fc,infile,outfile]=createRelaxedStartFile(fETIShDef,trackDef,NEMOmelt,COSMOsmb)

load([fETIShDef.fETIShRelaxFile '_toto']);

infile=fETIShDef.fETIShRelaxFile;
outfile=[trackDef.run_name '_fETIShRun_' num2str(trackDef.DateIn)];
outputname=[outfile '_toto'];

ctr.snapshot=trackDef.n_month_isfcpl*trackDef.n_isfcpl_window; %duration in month
ctr.nsteps=(ctr.snapshot*5)+1;
plotstep=5;
ctr.dt=1/60; % just to be sure that correct dt is used (corresponding to plotstep and calculation of nsteps)
ctr.snapshot=floor(ctr.nsteps/plotstep)+1;
ctr.restart=1;
ctr.runmode=5;
ctr.meltfunc=4;

fc.DeltaT=zeros(ctr.nsteps,1); 
fc.DeltaSL=zeros(ctr.nsteps,1); 
fc.butfac=ones(ctr.nsteps,1);
fc.MeltIn=NEMOmelt;

par.intT=1;

VAF=zeros(ctr.nsteps,1);
VA0=zeros(ctr.nsteps,1);
POV=zeros(ctr.nsteps,1);
DENScorr=zeros(ctr.nsteps,1);
SLC=zeros(ctr.nsteps,1);
VarRem=IntMelt(end);
IntMelt=zeros(ctr.nsteps,1);
IntMelt(1)=VarRem;
VarRem=Ag(end);
Ag=zeros(ctr.nsteps,1);
Ag(1)=VarRem;
VarRem=Af(end);
Af=zeros(ctr.nsteps,1);
Af(1)=VarRem;
VarRem=IVg(end);
IVg=zeros(ctr.nsteps,1);
IVg(1)=VarRem;
VarRem=IVf(end);
IVf=zeros(ctr.nsteps,1);
IVf(1)=VarRem;
VarRem=glflux(end);
glflux=zeros(ctr.nsteps,1);
glflux(1)=VarRem;
dHdt=zeros(ctr.nsteps,1);
time=(0:ctr.dt:(ctr.nsteps-1)*ctr.dt)';
VarRem=InvVol(end,1:2);
InvVol=zeros(ctr.nsteps,4);
InvVol(1,1:2)=VarRem;
VarRem=VelCheck(end,:);
VelCheck=zeros(ctr.nsteps,4);
VelCheck(1,:)=VarRem;
MeltTot=zeros(ctr.imax,ctr.jmax);

if ctr.timeslice==1
    ctr.timeslice=0;
    clear EVmask EVH EVB EVMelt EVUx EVUy EVbeta2 EVflux maskcount
    if exist('EVT','var')
        clear EVT
    end
    if exist('EVSLR','var')
        clear EVSLR
    end
    if exist('EVUd','var')
        clear EVUd
    end
end

MASK0=MASK;
H0=H;
B0=B;
HB0=HB;
oldMASK=MASK;
S0=sn;

SLR=dSLR+fc.DeltaSL(1);
SLR0=SLR;
VAF0=max(0,H0+min(B0-SLR,0)*(par.rhow/par.rho));
POV0=max(0,par.SLref-B0);
if exist('Pg0','var')
    Pg0=zeros(ctr.imax,ctr.jmax);
    Pg0(MASK==1)=par.rho*H0(MASK==1)*ctr.delta^2.;
    Pg0(MASK==0)=(-par.rhow)*(B(MASK==0)-SLR(MASK==0))*ctr.delta^2.;
    Pg0=Pg0+par.rhoL*B0*ctr.delta^2.;
end
ushelfexist=1;
MeltInexist=1;
MeltIn=scatteredInterpolant(X(~isnan(fc.MeltIn)),Y(~isnan(fc.MeltIn)),fc.MeltIn(~isnan(fc.MeltIn)),'nearest');

if trackDef.ice_atm_cpl==1
    ctr.MbType=0;
    Mb0=COSMOsmb;
    Mb=Mb0;
end

cnt=1;
cntT=0;

clear fETIShDef trackDef NEMOmelt COSMOsmb VarRem

save(outputname);

end