function [trackDef]=read_trackVars(tracking_file)

% read in text file 'tracking_file'
fid  = fopen(tracking_file,'r');
text = textscan(fid,'%s','Delimiter','');
text = text{1};
fclose(fid);

% extract run_name
run_name=regexp(text,'run_name[=]+(\S+)','tokens');
run_name=[run_name{:}]; run_name=run_name{:}; 
trackDef.run_name=run_name{:};

% extract initial_date
initial_date=regexp(text,'initial_date[=]+(\d+)','tokens');
initial_date=[initial_date{:}]; 
trackDef.initial_date=str2double([initial_date{:}]);

% extract n_month_isfcpl
n_month_isfcpl=regexp(text,'n_month_isfcpl[=]+(\d+)','tokens');
n_month_isfcpl=[n_month_isfcpl{:}]; 
trackDef.n_month_isfcpl=str2double([n_month_isfcpl{:}]);

% extract n_isfcpl_window
n_isfcpl_window=regexp(text,'n_isfcpl_window[=]+(\d+)','tokens');
n_isfcpl_window=[n_isfcpl_window{:}]; 
trackDef.n_isfcpl_window=str2double([n_isfcpl_window{:}]);

% extract date_beg_isfcpl
date_beg_isfcpl=regexp(text,'date_beg_isfcpl[=]+(\d+)','tokens');
date_beg_isfcpl=[date_beg_isfcpl{:}]; 
trackDef.date_beg_isfcpl=str2double([date_beg_isfcpl{:}]);

% extract date_end_isfcpl
date_end_isfcpl=regexp(text,'date_end_isfcpl[=]+(\d+)','tokens');
date_end_isfcpl=[date_end_isfcpl{:}]; 
trackDef.date_end_isfcpl=str2double([date_end_isfcpl{:}]);

% extract ice_atm_cpl
ice_atm_cpl=regexp(text,'ice_atm_cpl[=]+(\d+)','tokens');
ice_atm_cpl=[ice_atm_cpl{:}]; 
trackDef.ice_atm_cpl=str2double([ice_atm_cpl{:}]);

end